//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.ComponentModel;
using System.Workflow.ComponentModel;
using Microsoft.Research.ScientificWorkflow;

namespace TridentBasicActivities.Activities
{
    [Name("Activity for comapring two integers for equality", "Integer Equal", "==")]
    [Description("Takes two int and returns TRUE if FIRST equal to SECOND.")]
    [WorkflowCategory("Condition")]
    public class CondIntEQ : CondBase
    {
        public static System.Workflow.ComponentModel.DependencyProperty Input2Property =
            System.Workflow.ComponentModel.DependencyProperty.Register("Input2", typeof(int),
            typeof(CondIntEQ));

        [RequiredInputParam]
        [Name("Input2")]
        [Description("Second Integer value for doing the comparison.")]
        public int Input2
        {
            get { return (int)GetValue(CondIntEQ.Input2Property); }
            set { SetValue(CondIntEQ.Input2Property, value); }
        }


        public static System.Workflow.ComponentModel.DependencyProperty Input1Property =
            System.Workflow.ComponentModel.DependencyProperty.Register("Input1", typeof(int),
            typeof(CondIntEQ));

        [RequiredInputParam]
        [Name("Input1")]
        [Description("First Integer value for doing the comparison.")]
        public int Input1
        {
            get { return (int)GetValue(CondIntEQ.Input1Property); }
            set { SetValue(CondIntEQ.Input1Property, value); }
        }


        public static System.Workflow.ComponentModel.DependencyProperty ResultProperty =
            System.Workflow.ComponentModel.DependencyProperty.Register("Result", typeof(bool),
            typeof(CondIntEQ));

        [OutputParam]
        [Name("Result")]
        [Description("Result of the greater than operation.")]
        public bool Result
        {
            get { return (bool)GetValue(CondIntEQ.ResultProperty); }
            set { SetValue(CondIntEQ.ResultProperty, value); }
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            this.Result = (Input1 == Input2);
            return ActivityExecutionStatus.Closed;
        }
    }
}

