//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;
using Microsoft.Research.ScientificWorkflow;
using System.ComponentModel;

namespace TridentBasicActivities.Activities
{
    [WorkflowCategory("Control Flow")]
    [HideActivity(true)]
    public class IfCondition : SequenceActivity
    {
        /// <summary>
        /// Property used to set both Input and output
        /// </summary>
        public static System.Workflow.ComponentModel.DependencyProperty Input1Property =
           System.Workflow.ComponentModel.DependencyProperty.Register("Input1", typeof(bool),
           typeof(IfCondition));

        [RequiredInOutParam]
        [Name("Input1")]
        [Description("First boolean value for doing the AND operation.")]
        public bool Input1
        {
            get { return (bool)GetValue(IfCondition.Input1Property); }
            set { SetValue(IfCondition.Input1Property, value); }
        }
    }
}
