//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace TridentBasicActivities.Activities
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Workflow.Activities;
    using Microsoft.Research.ScientificWorkflow;
    using System.ComponentModel;

    [Name("SubSection", "SubSection")]
    [Description("Creates the Subsection.")]
    [WorkflowCategory("Control Flow")]
    [HideActivity(true)]
    public class SubSection : SequenceActivity
    {
        public static System.Workflow.ComponentModel.DependencyProperty LabelProperty =
    System.Workflow.ComponentModel.DependencyProperty.Register("Label", typeof(string),
    typeof(SubSection));

        public static System.Workflow.ComponentModel.DependencyProperty DescriptionProperty =
   System.Workflow.ComponentModel.DependencyProperty.Register("Description", typeof(string),
   typeof(SubSection));

        public static System.Workflow.ComponentModel.DependencyProperty IsCollapsedProperty =
    System.Workflow.ComponentModel.DependencyProperty.Register("IsCollapsed", typeof(bool),
    typeof(SubSection));

        [InputParam]
        [Name("Label")]
        [Description("Label of the Sub Section")]
        public string Label
        {
            get { return (string)GetValue(SubSection.LabelProperty); }
            set { SetValue(SubSection.LabelProperty, value); }
        }

        [InputParam]
        [Name("Description")]
        [Description("Description of the Sub Section")]
        public new string Description
        {
            get { return (string)GetValue(SubSection.DescriptionProperty); }
            set { SetValue(SubSection.DescriptionProperty, value); }
        }

        [InputParam]
        [Name("IsCollapsed")]
        [Description("Visiblity state of the Sub Section")]
        public bool IsCollapsed
        {
            get { return (bool)GetValue(SubSection.IsCollapsedProperty); }
            set { SetValue(SubSection.IsCollapsedProperty, value); }
        }
    }
}
