//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Records user and data of modification/creation
    /// </summary>
    public class EntryChange
    {
        private string user;
        private DateTime when;

        /// <summary>
        /// User account that performed the operation
        /// </summary>
        public string User
        {
            get { return user; }
        }

        /// <summary>
        /// Date operation was performed
        /// </summary>
        public DateTime When
        {
            get { return when; }
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="user">User account that performed the operation</param>
        /// <param name="when">Date operation was performed</param>
        public EntryChange(string user, DateTime when)
        {
            this.user = user;
            this.when = when;
        }
    }
}
