//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents the query to run
    /// </summary>
    [Serializable]
    public abstract class SearchQuery
    {
        /// <summary>
        /// Retrieves query graph
        /// </summary>
        /// <returns></returns>
        public abstract ER.ISearchClause GetQuery();

        /// <summary>
        /// Container for storage of provider specific data
        /// </summary>
        public object ProviderContext { get; set; }
    }


    /// <summary>
    /// Base field for search clauses
    /// </summary>
    [Serializable]
    public abstract class BaseField
    {
        private string myName;

        internal BaseField(string myName)
        {
            this.myName = myName;
        }

        /// <summary>
        /// Name of the field
        /// </summary>
        public string Name
        {
            get { return myName; }
        }
    }
}
