//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Security Action.
    /// </summary>
    public enum SecurityAction
    {
        /// <summary>
        /// Allow.
        /// </summary>
        Allow,
        /// <summary>
        /// Deny.
        /// </summary>
        Deny,
    }

    /// <summary>
    /// Interface for implementing teh filter for the data layer security.
    /// </summary>
    public interface IDataLayerSecurityFilter
    {
        /// <summary>
        /// Gets the actions.
        /// </summary>
        /// <value>The actions.</value>
        IDataLayerSecurityActionCalls Actions { get; }

        /// <summary>
        /// Gets the before.
        /// </summary>
        /// <value>The before.</value>
        IDataLayerSecurityBeforeCalls Before { get; }

        /// <summary>
        /// Gets the after.
        /// </summary>
        /// <value>The after.</value>
        IDataLayerSecurityAfterCalls After { get; }
    }
}
