//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.Research.DataLayer
{
    public static class ProviderInfo
    {
        public static ProviderPkgInfo[] Providers
        {
            get
            {
                ProviderPkgInfo sqlProvider = new ProviderPkgInfo(Properties.Resources.TargetTypeSQL, "sqlserver",
                        new ConnectionManagerDialog_SQL(),
                        new ConnMgrDlg_Button(Properties.Resources.TargetTypeSQL,
                            Properties.Resources.SQLLogo),
                        new SQLConnectionParameters.Helper());
                sqlProvider.Dialog.Provider = sqlProvider;

                //ProviderPkgInfo wsProvider = new ProviderPkgInfo(Properties.Resources.TargetTypeWebService, "webservice",
                //      new ConnectionManagerDialog_WebService(),
                //      new ConnMgrDlg_Button(Properties.Resources.TargetTypeWebService,
                //          Properties.Resources.WebService),
                //      new WSConnectionParameters.Helper());
                //wsProvider.Dialog.Provider = wsProvider;

                ////This was the original return statement
                //return new ProviderPkgInfo[] { sqlProvider, wsProvider };

                return new ProviderPkgInfo[] { sqlProvider };
            }
        }
    }
}
