//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Context class for passing data between different classes
    /// </summary>
    class SQLSearchProviderContext : System.Object
    {
        /// <summary>
        /// first object in relation
        /// </summary>
        public Connection.Storage Object { get; set; }
        
        /// <summary>
        /// Private 
        /// </summary>
        private List<string> joinList = new List<string>();

        public SQLSearchProviderContext(Connection.Storage storage)
        {
            Object = storage;
        }
        /// <summary>
        /// Access the join list publically
        /// </summary>
        /// <returns></returns>
        public List<string> JoinList
        {
            get
            {
                return joinList;
            }
        }
    }
}
