//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Research.DataLayer.Properties;

namespace Microsoft.Research.DataLayer
{
    public static class ProviderInfo
    {
        public static ProviderPkgInfo[] Providers
        {
            get
            {
                ProviderPkgInfo opcprovider = new ProviderPkgInfo(Properties.Resources.TargetTypeOPC, "opcstore",
                    new ConnMgrDlg_OPC(), 
                    new ConnMgrDlg_Button(Resources.TargetTypeOPC, 
                            Resources.xps_icon),
                    new OPCConnectionParameters.Helper());

                opcprovider.Dialog.Provider = opcprovider;

                return new ProviderPkgInfo[] { opcprovider };
                //return new ProviderPkgInfo[] {
                //    new ProviderPkgInfo(Resources.TargetTypeOPC, "xmlstore", 
                //        new ConnMgrDlg_OPC(), 
                //        new ConnMgrDlg_Button(Resources.TargetTypeOPC, 
                //            Resources.xps_icon)),
                //};
            }
        }
    }
}
