//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// 
    /// </summary>
    public static class BlobHandlerInfoProvider
    {
        /// <summary>
        /// 
        /// </summary>
        public static BlobHandlerBase[] Providers
        {
            get
            {
                BlobHandlerBase blobHandler = new BlobHandlerBase();
                blobHandler.ObjectName = "AssemblyImageContentsBlobKind";
                blobHandler.fetchContents = OCPAssemblyImageHandler.GetAssemblyImageContents;
                blobHandler.saveContents = OCPAssemblyImageHandler.SaveAssemblyImageContents;

                BlobHandlerBase blobHandler1 = new BlobHandlerBase();
                blobHandler1.ObjectName = "DataProductContentsBlobKind";
                blobHandler1.fetchContents = OCPDataProductHandler.GetDataProductContents;
                blobHandler1.saveContents = OCPDataProductHandler.SaveDataProductContents;

                return new BlobHandlerBase[] { blobHandler, blobHandler1 };
            }
        }

    }
}
