//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.TridentExecutionService
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.ServiceProcess;
    using System.Text;
    using Microsoft.Research.eResearch.WFServiceLibrary;
    using System.Configuration;
    using System.Threading;

    /// <summary>
    /// This is the Entry point for the Service.
    /// </summary>
    public static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        public static void Main()
        {
            ServiceBase[] servicesToRun;
            servicesToRun = new ServiceBase[] 
            { 
                new ExecutionService(
                    Environment.MachineName,
                    ConfigurationManager.AppSettings["WFApp"],
                    ConfigurationManager.AppSettings["SchedulerEXE"])                
            };

            ServiceBase.Run(servicesToRun);
        }
    }
}
