//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.Common
{
    /// <summary>
    /// Provides the information to be shown in the table view.
    /// </summary>
    public interface IListPresenter
    {
        ObservableCollection<Object> Items { get; }

        string ListViewTitle { get; set; }

        void DisplayItems(string queryString);

        int SelectedIndex { get; set; }

        UIElement SearchView { get; }

        UIElement ListView { get; }

        Collection<MenuItem> MenuItemCollection { get; }
    }
}
