//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.Windows.Controls;

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.Common
{
    /// <summary>
    /// Interaction logic for StatusMessageControl.xaml
    /// </summary>
    public sealed partial class StatusMessageControl : UserControl, IStatusMessageControl
    {
        public StatusMessageControl()
        {
            InitializeComponent();
        }

        #region IStatusMessageControl Members

        /// <summary>
        /// Set the message as the text of the status textblock
        /// </summary>
        /// <param name="message"></param>
        public void SetText(string message)
        {
            this.StatusText.Text = message;
        }

        #endregion
    }
}
