//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.HealthCheck
{
    using Microsoft.Research.DataLayer;

    public abstract class HealthCheckBase
    {
        /// <summary>
        /// Gets Handle to talk to the registry.
        /// </summary>
        protected Connection RegistryHandle { get; set; }

        /// <summary>
        /// Performs the health check.
        /// </summary>
        public abstract void PerformHealthCheck(Connection registryHandle);
    }
}
