//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.HealthCheck
{
    using System;
    using System.Collections;
    
    /// <summary>
    /// 
    /// </summary>
    public class HealthCheckEventArgs : EventArgs
    {
        internal Hashtable healthCheckData = new Hashtable();
    }

    /// <summary>
    /// 
    /// </summary>
    public class ExecutionServiceHealthCheckEventArgs : HealthCheckEventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExecutionServiceHealthCheckEventArgs"/> class.
        /// </summary>
        /// <param name="faultyNodes">The faulty nodes.</param>
        public ExecutionServiceHealthCheckEventArgs(Hashtable faultyNodes)
        {
            this.healthCheckData = faultyNodes;
        }
    }
}
