//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.Windows.Controls;

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls
{
    /// <summary>
    /// Interaction logic for LeftPaneView.xaml. This Controls the modules which get inserted into the left pane.
    /// </summary>
    public sealed partial class LeftPaneView : UserControl
    {
        /// <summary>
        /// The constructor.
        /// </summary>
        public LeftPaneView()
        {
            InitializeComponent();
        }

        /// <summary>
        /// The presentation model for the left pane.
        /// </summary>
        public LeftPanePresenter Presenter { get; set; }

        /// <summary>
        /// The panel where the module buttons are placed.
        /// </summary>
        public Panel ButtonStack 
        {
            get
            {
                return this.buttonStack;
            }
        }

        /// <summary>
        /// The panel where the left pane controls are placed.
        /// </summary>
        public Panel LeftPaneContent
        {
            get
            {
                return this.LeftPaneContentHolder;
            }
        }
        
    }
}
