//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity;

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls
{
    /// <summary>
    /// The registry manager content presenter.
    /// </summary>
    public class RegistryManagerContentPresenter
    {
        /// <summary>
        /// The unity container.
        /// </summary>
        IUnityContainer container;

        /// <summary>
        /// Initializes a new instance of the <see cref="RegistryManagerContentPresenter"/> class.
        /// </summary>
        /// <param name="container">The container.</param>
        /// <param name="view">The view.</param>
        public RegistryManagerContentPresenter(IUnityContainer container, RegistryManagerContentView view)
        {
            this.container = container;
            this.View = view;

            this.container.RegisterInstance(typeof(RegistryManagerContentView), view);
        }

        /// <summary>
        /// Gets or sets the view.
        /// </summary>
        /// <value>The view.</value>
        public RegistryManagerContentView View { get; set; }
    }
}
