//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Research.ScientificWorkflow.ManagementStudioModels;

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.RegistryManagerModule
{
	/// <summary>
	/// Interaction logic for SelectUser.xaml
	/// </summary>
	public partial class SelectUser : Window
	{
		public SelectUser()
		{
            this.InitializeComponent();
            this.brdrHeader.MouseLeftButtonDown += (sender, e) => { this.DragMove(); };
			
			// Insert code required on object creation below this point.
		}

        private void OnUserChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            SelectUserPresenter presenter = this.DataContext as SelectUserPresenter;
            if (presenter != null)
            {
                TreeView usersList = sender as TreeView;
                if (usersList != null)
                {
                    presenter.SelectUserModel = usersList.SelectedItem as SelectUserModel;
                    presenter.OkCommand.RaiseCanExecuteChanged();
                }
            }
        }
	}
}