//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.ManagementStudioControls.RegistryManagerModule
{
    using System.Windows.Controls;
    using Microsoft.Research.ScientificWorkflow.ManagementStudioModels;

    /// <summary>
    /// Interaction logic for UserCatalogCenterPane.xaml
    /// </summary>
    public partial class UserCatalogCenterPane : UserControl
    {
        public UserCatalogCenterPane()
        {
            InitializeComponent();
        }

        private void OnCredentialsSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            UserCenterPanePresenter presenter = this.DataContext as UserCenterPanePresenter;
            if (presenter != null)
            {
                ListBox credentilaListBox = sender as ListBox;
                if (credentilaListBox != null)
                {
                    presenter.SelectedCredentials = credentilaListBox.SelectedItem as LogOnCredentialModel;
                }
            }
        }
    }
}
