/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Activitys that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Activity collection</typeparam>
    public class ActivityCollection<O> : SyncCollection<O, Activity>
        where O : IObject
    {
        public ActivityCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Activity>.DelayLoadCallback(ActivityCollection_OnDelayLoad);
        }

        public ActivityCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Activity>.DelayLoadCallback(ActivityCollection_OnDelayLoadRef);
        }

        List<Activity> ActivityCollection_OnDelayLoad(Connection c)
        {
            return Activity.LoadAll(this.Owner, c);
        }

        List<Activity> ActivityCollection_OnDelayLoadRef(Connection c)
        {
            return Activity.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivityCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivityCollection<O> objList = new ActivityCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivityCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            ActivityCollection<O> objList = new ActivityCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Activity
    /// </summary>
    [Serializable]
    public partial class Activity : NamedObject<Activity>
    {
        private System.String label;
        private System.String versionlabel;
        private System.String description;
        private System.String xomlcontents;
        private System.String activityclass;
        private System.String fullname;
        private System.Boolean isbuiltin;
        private System.Boolean isdeleted;
        private System.Boolean ishidden;
        private System.Boolean isblackbox;
        private System.Drawing.Image icon;
        private bool iconLoaded = false;
        private bool iconChanged = false;
        private System.Int32 iconsize;
        private System.String keywords;
        private System.String contacts;
        private System.String comments;
        private System.String author;
        private System.Boolean isinteractive;
        private System.String source;
        private System.String displaylabel;
        private System.Boolean iscondition;
        private System.Int32 version;
        private VisualPlacement placement;
        private ActivityType type;
        private Guid owneruserprincipalID;
        private User owneruserprincipal;
        private Guid ownergroupprincipalID;
        private Group ownergroupprincipal;
        private Guid safeparentversionID;
        private Activity safeparentversion;
        
        private AssemblyPackageCollection<Activity> assemblypackages;
        private NamespaceCollection<Activity> m_namespaces;
        private TagCollection<Activity> tags;
        private ActivityVersionCollection<Activity> newerversions;
        private ActivityVersionCollection<Activity> olderversions;
        private ActivityCollection<Activity> safechildversions;
        private ActivityACLCollection<Activity> activityacls;
        private ActivityIconBlobCollection<Activity> iconstores;
        private ActivityInstanceCollection<Activity> instances;
        private ActivityParameterCollection<Activity> activityparameters;
        private ActivitySequenceCollection<Activity> activitysequences;

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Label
        {
            get { return label; }
            set
            {
                label = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String VersionLabel
        {
            get { return versionlabel; }
            set
            {
                versionlabel = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String XomlContents
        {
            get { return xomlcontents; }
            set
            {
                xomlcontents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String ActivityClass
        {
            get { return activityclass; }
            set
            {
                activityclass = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String FullName
        {
            get { return fullname; }
            set
            {
                fullname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsBuiltIn
        {
            get { return isbuiltin; }
            set
            {
                isbuiltin = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsHidden
        {
            get { return ishidden; }
            set
            {
                ishidden = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsBlackbox
        {
            get { return isblackbox; }
            set
            {
                isblackbox = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public BlobBase.TransferProgressHandler OnIconTransfer;

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public BlobBase.BeginClearStoreProgressHandler OnIconClearBegin;

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public BlobBase.EndClearStoreProgressHandler OnIconClearEnd;

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Drawing.Image Icon
        {
            get 
            { 
                if (iconLoaded)
                {
                    // Uses cached version
                    return icon;
                }
                
                System.IO.Stream bStream = null;
				
				//
                // Load from BLOB storage
                //
                icon = null;
                iconLoaded = true;

                int count = this.IconStores.Count;

                if (count == 0)
                    return null;

                List<IBlob> list = new List<IBlob>();
                foreach (ActivityIconBlob blob in this.IconStores)
                {
                    list.Add(blob);
                }
                
                bStream = BlobBase.FetchBlobs<ActivityIconBlob, List<IBlob>>(list);

                icon = System.Drawing.Image.FromStream(bStream);

                bStream.Close();
                
                return icon;
            }
            set
            {
				icon = value;
                iconLoaded = true;
                iconChanged = true;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Int32 IconSize
        {
            get { return iconsize; }
            set
            {
                iconsize = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Keywords
        {
            get { return keywords; }
            set
            {
                keywords = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Contacts
        {
            get { return contacts; }
            set
            {
                contacts = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Comments
        {
            get { return comments; }
            set
            {
                comments = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Author
        {
            get { return author; }
            set
            {
                author = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsInteractive
        {
            get { return isinteractive; }
            set
            {
                isinteractive = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String Source
        {
            get { return source; }
            set
            {
                source = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.String DisplayLabel
        {
            get { return displaylabel; }
            set
            {
                displaylabel = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Boolean IsCondition
        {
            get { return iscondition; }
            set
            {
                iscondition = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public System.Int32 Version
        {
            get { return version; }
            set
            {
                version = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public VisualPlacement Placement
        {
            get { return placement; }
            set
            {
                placement = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Activity
        /// </summary>
        public ActivityType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User OwnerUserPrincipal
        {
            get
            {
                lock (this)
                {
                    if (owneruserprincipal == null && owneruserprincipalID != Guid.Empty)
                        owneruserprincipal = User.Load(owneruserprincipalID, Conn);
                }
                return owneruserprincipal;
            }

            set
            {
                lock (this)
                {
                    owneruserprincipal = value;                   
                    owneruserprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Group OwnerGroupPrincipal
        {
            get
            {
                lock (this)
                {
                    if (ownergroupprincipal == null && ownergroupprincipalID != Guid.Empty)
                        ownergroupprincipal = Group.Load(ownergroupprincipalID, Conn);
                }
                return ownergroupprincipal;
            }

            set
            {
                lock (this)
                {
                    ownergroupprincipal = value;                   
                    ownergroupprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        protected Activity SafeParentVersion
        {
            get
            {
                lock (this)
                {
                    if (safeparentversion == null && safeparentversionID != Guid.Empty)
                        safeparentversion = Activity.Load(safeparentversionID, Conn);
                }
                return safeparentversion;
            }

            set
            {
                lock (this)
                {
                    safeparentversion = value;                   
                    safeparentversionID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public AssemblyPackageCollection<Activity> AssemblyPackages { get { return assemblypackages; } }
        public NamespaceCollection<Activity> Namespaces { get { return m_namespaces; } }
        public TagCollection<Activity> Tags { get { return tags; } }
        public ActivityVersionCollection<Activity> NewerVersions { get { return newerversions; } }
        public ActivityVersionCollection<Activity> OlderVersions { get { return olderversions; } }
        protected ActivityCollection<Activity> SafeChildVersions { get { return safechildversions; } }
        protected ActivityACLCollection<Activity> ActivityACLs { get { return activityacls; } }
        protected ActivityIconBlobCollection<Activity> IconStores { get { return iconstores; } }
        public ActivityInstanceCollection<Activity> Instances { get { return instances; } }
        public ActivityParameterCollection<Activity> ActivityParameters { get { return activityparameters; } }
        public ActivitySequenceCollection<Activity> ActivitySequences { get { return activitysequences; } }

		/// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public  Activity CreateNewVersion(Connection c)
        {
            foreach (ActivityVersion ver in this.NewerVersions)
            {
                if(ver.Type == VersionRelationshipType.Concrete)
                    throw new BindVersionViolation("You cannot have branches in the 'concrete' tree. To have more than 1 child use 'contributions' instead");
            }

            Activity newObj = new Activity(Conn);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            // Version binding
            newObj.safeparentversion = this;
            
            // Copying the older version to the new
            newObj.label = this.label;
            newObj.versionlabel = this.versionlabel;
            newObj.description = this.description;
            newObj.xomlcontents = this.xomlcontents;
            newObj.activityclass = this.activityclass;
            newObj.fullname = this.fullname;
            newObj.isbuiltin = this.isbuiltin;
            newObj.isdeleted = this.isdeleted;
            newObj.ishidden = this.ishidden;
            newObj.isblackbox = this.isblackbox;
            newObj.iconsize = this.iconsize;
            newObj.keywords = this.keywords;
            newObj.contacts = this.contacts;
            newObj.comments = this.comments;
            newObj.author = this.author;
            newObj.isinteractive = this.isinteractive;
            newObj.source = this.source;
            newObj.displaylabel = this.displaylabel;
            newObj.iscondition = this.iscondition;
            newObj.version = this.version;
            newObj.placement = this.placement;
            newObj.type = this.type;
            newObj.Owner = this.Owner;
            newObj.security = new Activity.ISecurity(newObj, c);
            
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<Activity>(newObj, c);
            newObj.m_namespaces = new NamespaceCollection<Activity>(newObj, c);
            newObj.tags = new TagCollection<Activity>(newObj, c);
            newObj.newerversions = new ActivityVersionCollection<Activity>(newObj, "NewerVersion", "OlderVersion", "Activity_1", c);
            newObj.olderversions = new ActivityVersionCollection<Activity>(newObj, "OlderVersion", "NewerVersion", "Activity_2", c);
            newObj.safechildversions = new ActivityCollection<Activity>(newObj, "SafeParentVersion", "SafeChildVersion", c);
            newObj.activityacls = new ActivityACLCollection<Activity>(newObj, "Activity", "ActivityACL", c);
            newObj.iconstores = new ActivityIconBlobCollection<Activity>(newObj, "Activity", "IconStore", c);
            newObj.instances = new ActivityInstanceCollection<Activity>(newObj, "Activity", "Instance", c);
            newObj.activityparameters = new ActivityParameterCollection<Activity>(newObj, "Activity", "ActivityParameter", c);
            newObj.activitysequences = new ActivitySequenceCollection<Activity>(newObj, "Activity", "ActivitySequence", c);
			
			if(this is INamedObject)
			{
				newObj.Name = this.Name;
			}
			
            newObj.version += 1;
            newObj.OnConstructor();

            if (Conn.AutoSave)
            {
                newObj.Save();
                
	            // Version binding
		        ActivityVersion versionInfo = ActivityVersion.Create(this, newObj, VersionRelationshipType.Concrete, Conn);
			    this.NewerVersions.Add(versionInfo);
			}

            return newObj;
        }

        /// <summary>
        /// Binds an object with another
        /// </summary>
        public void BindVersion(Activity other, VersionRelationshipType kind)
        {
            if (kind == VersionRelationshipType.Concrete)
                throw new BindVersionViolation("The only way to bind a concrete version is to call Activity.CreateNewVersion(...) method");

            ActivityVersion versionInfo = ActivityVersion.Create(this, other, kind, this.Conn);
            this.NewerVersions.Add(versionInfo);
        }
        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Activity(Connection c)
            : base(SRStorage.Activity, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static Activity Create(string name, ActivityType type, ISecurityPrincipal owner, Connection c)
        {
            Activity newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;
			if (owner is User)
            {
                 newObj.owneruserprincipal = (User)owner;
            }
                     else 			if (owner is Group)
            {
                 newObj.ownergroupprincipal = (Group)owner;
            }
            newObj.security = new Activity.ISecurity(newObj, c);

			
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<Activity>(newObj, c);
            newObj.m_namespaces = new NamespaceCollection<Activity>(newObj, c);
            newObj.tags = new TagCollection<Activity>(newObj, c);
            newObj.newerversions = new ActivityVersionCollection<Activity>(newObj, "NewerVersion", "OlderVersion", "Activity_1", c);
            newObj.olderversions = new ActivityVersionCollection<Activity>(newObj, "OlderVersion", "NewerVersion", "Activity_2", c);
            newObj.safechildversions = new ActivityCollection<Activity>(newObj, "SafeParentVersion", "SafeChildVersion", c);
            newObj.activityacls = new ActivityACLCollection<Activity>(newObj, "Activity", "ActivityACL", c);
            newObj.iconstores = new ActivityIconBlobCollection<Activity>(newObj, "Activity", "IconStore", c);
            newObj.instances = new ActivityInstanceCollection<Activity>(newObj, "Activity", "Instance", c);
            newObj.activityparameters = new ActivityParameterCollection<Activity>(newObj, "Activity", "ActivityParameter", c);
            newObj.activitysequences = new ActivitySequenceCollection<Activity>(newObj, "Activity", "ActivitySequence", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Activity Load(string name, Connection c)
        {
            return NamedObject<Activity>.Load(name, c, Activity.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Activity object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Activity object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Activity loadObj = (Activity)NamedObject<Activity>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Activity loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Activity>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Label");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.label = val;
            }

            index = reader.GetOrdinal("VersionLabel");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.versionlabel = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("XomlContents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.xomlcontents = val;
            }

            index = reader.GetOrdinal("ActivityClass");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.activityclass = val;
            }

            index = reader.GetOrdinal("FullName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.fullname = val;
            }

            index = reader.GetOrdinal("IsBuiltIn");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isbuiltin = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("IsHidden");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.ishidden = val;
            }

            index = reader.GetOrdinal("IsBlackbox");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isblackbox = val;
            }

            index = reader.GetOrdinal("IconSize");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.iconsize = val;
            }

            index = reader.GetOrdinal("Keywords");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.keywords = val;
            }

            index = reader.GetOrdinal("Contacts");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.contacts = val;
            }

            index = reader.GetOrdinal("Comments");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.comments = val;
            }

            index = reader.GetOrdinal("Author");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.author = val;
            }

            index = reader.GetOrdinal("IsInteractive");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isinteractive = val;
            }

            index = reader.GetOrdinal("Source");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.source = val;
            }

            index = reader.GetOrdinal("DisplayLabel");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.displaylabel = val;
            }

            index = reader.GetOrdinal("IsCondition");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.iscondition = val;
            }

            index = reader.GetOrdinal("Version");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.version = val;
            }

            index = reader.GetOrdinal("Placement");
            if (!reader.IsDBNull(index))
                loadObj.placement = (VisualPlacement)Enum.Parse(typeof(VisualPlacement), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (ActivityType)Enum.Parse(typeof(ActivityType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("OwnerUserPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.owneruserprincipalID = val;
            }

            index = reader.GetOrdinal("OwnerGroupPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.ownergroupprincipalID = val;
            }

            index = reader.GetOrdinal("SafeParentVersionID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.safeparentversionID = val;
            }

            loadObj.security = new Activity.ISecurity(loadObj, c);

            //
            // Object connections
            //

            // AssemblyPackages
            loadObj.assemblypackages = AssemblyPackageCollection<Activity>.CreateFromReader(loadObj, reader, c);
            // Namespaces
            loadObj.m_namespaces = NamespaceCollection<Activity>.CreateFromReader(loadObj, reader, c);
            // Tags
            loadObj.tags = TagCollection<Activity>.CreateFromReader(loadObj, reader, c);
            // NewerVersions
            loadObj.newerversions = ActivityVersionCollection<Activity>.CreateFromReader(loadObj, "NewerVersion", "OlderVersion", "Activity_1", reader, c);
            // OlderVersions
            loadObj.olderversions = ActivityVersionCollection<Activity>.CreateFromReader(loadObj, "OlderVersion", "NewerVersion", "Activity_2", reader, c);
            // SafeChildVersions
            loadObj.safechildversions = ActivityCollection<Activity>.CreateFromReader(loadObj, "SafeParentVersion", "SafeChildVersion", reader, c);
            // ActivityACLs
            loadObj.activityacls = ActivityACLCollection<Activity>.CreateFromReader(loadObj, "Activity", "ActivityACL", reader, c);
            // IconStores
            loadObj.iconstores = ActivityIconBlobCollection<Activity>.CreateFromReader(loadObj, "Activity", "IconStore", reader, c);
            // Instances
            loadObj.instances = ActivityInstanceCollection<Activity>.CreateFromReader(loadObj, "Activity", "Instance", reader, c);
            // ActivityParameters
            loadObj.activityparameters = ActivityParameterCollection<Activity>.CreateFromReader(loadObj, "Activity", "ActivityParameter", reader, c);
            // ActivitySequences
            loadObj.activitysequences = ActivitySequenceCollection<Activity>.CreateFromReader(loadObj, "Activity", "ActivitySequence", reader, c);
        }

        public static Activity Load(Guid id, Connection c)
        {
            return Load<Activity>(id, c, Activity.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Activitys from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Activitys in the system</returns>
        public static List<Activity> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Activity>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Activity)], 
                Activity.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Activitys that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Activitys</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Activity> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Activity>(owner, Activity.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Activitys that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Activitys</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Activity> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Activity>(owner, src, Activity.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Activitys by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Activitys that match the criteria</returns>
        public static List<Activity> Search(string text, Connection c)
        {
            return LoadAll<Activity>(Connection.Action.Search, text, Activity.CreateFromDataStore, c);
        }

        private void SaveIconBlob(Connection c)
        {
            if (!this.iconChanged)
			   return;
			   
            // Clear previous version
            foreach (ActivityIconBlob b in this.IconStores)
            {
                b.Delete();
            }

			// Notify begin of store clear
			BlobBase.FireOnAnyBeginClearStore(this, "Icon", c);
			if (OnIconClearBegin != null)
				OnIconClearBegin(this, "Icon", c);

            this.IconStores.Refresh();
            this.IconStores.Clear();

			// Notify end of store clear
			if (OnIconClearEnd != null)
				OnIconClearEnd(this, "Icon", c);
			BlobBase.FireOnAnyEndClearStore(this, "Icon", c);

            // Reset changed bit
            this.iconChanged = false;
            
            // Save the size (starts with 0)
            this.iconsize = 0;
            
            if (icon == null)
                return;

            // Serialize image and save to store
            System.IO.MemoryStream saveStore = new System.IO.MemoryStream();
            icon.Save(saveStore, System.Drawing.Imaging.ImageFormat.Png);
            byte[] __cnv_contents = saveStore.GetBuffer();
            this.iconsize = __cnv_contents.Length;
            List<ActivityIconBlob> iconBlobs = BlobBase.SaveBlobs<ActivityIconBlob, Activity>(this, icon, "Icon", __cnv_contents, 
				CreateIconBlob, OnIconTransfer, c);
            this.IconStores.Load(iconBlobs);
            
            // Update cache size
            Save();
        }

        public static ActivityIconBlob CreateIconBlob(Guid streamId, int index, int total, Guid revisionId, Activity src, Connection c)
        {
            return ActivityIconBlob.Create(streamId, index, total, revisionId, src, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationObjectField<T> : ER.RelationObjectField<T>
                    where T : IObject
                {
                    internal  RelationObjectField(string myName, string objectName, RelationshipType relType)
					: base(myName, objectName,  relType)
        
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Label = new FieldDefs.StringField("Label");
                public static FieldDefs.StringField VersionLabel = new FieldDefs.StringField("VersionLabel");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.StringField XomlContents = new FieldDefs.StringField("XomlContents");
                public static FieldDefs.StringField ActivityClass = new FieldDefs.StringField("ActivityClass");
                public static FieldDefs.StringField FullName = new FieldDefs.StringField("FullName");
                public static FieldDefs.BooleanField IsBuiltIn = new FieldDefs.BooleanField("IsBuiltIn");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.BooleanField IsHidden = new FieldDefs.BooleanField("IsHidden");
                public static FieldDefs.BooleanField IsBlackbox = new FieldDefs.BooleanField("IsBlackbox");
                public static FieldDefs.IntegerField IconSize = new FieldDefs.IntegerField("IconSize");
                public static FieldDefs.StringField Keywords = new FieldDefs.StringField("Keywords");
                public static FieldDefs.StringField Contacts = new FieldDefs.StringField("Contacts");
                public static FieldDefs.StringField Comments = new FieldDefs.StringField("Comments");
                public static FieldDefs.StringField Author = new FieldDefs.StringField("Author");
                public static FieldDefs.BooleanField IsInteractive = new FieldDefs.BooleanField("IsInteractive");
                public static FieldDefs.StringField Source = new FieldDefs.StringField("Source");
                public static FieldDefs.StringField DisplayLabel = new FieldDefs.StringField("DisplayLabel");
                public static FieldDefs.BooleanField IsCondition = new FieldDefs.BooleanField("IsCondition");
                public static FieldDefs.IntegerField Version = new FieldDefs.IntegerField("Version");
                public static FieldDefs.EnumField<VisualPlacement> Placement = new FieldDefs.EnumField<VisualPlacement>("Placement");
                public static FieldDefs.EnumField<ActivityType> Type = new FieldDefs.EnumField<ActivityType>("Type");
                public static FieldDefs.ObjectField<User> OwnerUserPrincipal = new FieldDefs.ObjectField<User>("OwnerUserPrincipal");
                public static FieldDefs.ObjectField<Group> OwnerGroupPrincipal = new FieldDefs.ObjectField<Group>("OwnerGroupPrincipal");
                public static FieldDefs.ObjectField<Activity> SafeParentVersion = new FieldDefs.ObjectField<Activity>("SafeParentVersion");
                public static FieldDefs.RelationSimpleField<AssemblyPackage> AssemblyPackage = new FieldDefs.RelationSimpleField<AssemblyPackage>("AssemblyPackage", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Namespace> Namespace = new FieldDefs.RelationSimpleField<Namespace>("Namespace", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Tag> Tag = new FieldDefs.RelationSimpleField<Tag>("Tag", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationObjectField<Activity> NewerVersion = new FieldDefs.RelationObjectField<Activity>("NewerVersion", "ActivityActivityVersions", RelationFieldBase.RelationshipType.Parent);
                public static FieldDefs.RelationObjectField<Activity> OlderVersion = new FieldDefs.RelationObjectField<Activity>("OlderVersion", "ActivityActivityVersions", RelationFieldBase.RelationshipType.Child);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Label(StringField.Condition op, System.String value) { return Fields.Label.CreateSearchClause(op, value); }
            public static ISearchClause VersionLabel(StringField.Condition op, System.String value) { return Fields.VersionLabel.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause XomlContents(StringField.Condition op, System.String value) { return Fields.XomlContents.CreateSearchClause(op, value); }
            public static ISearchClause ActivityClass(StringField.Condition op, System.String value) { return Fields.ActivityClass.CreateSearchClause(op, value); }
            public static ISearchClause FullName(StringField.Condition op, System.String value) { return Fields.FullName.CreateSearchClause(op, value); }
            public static ISearchClause IsBuiltIn(BooleanField.Condition op, System.Boolean value) { return Fields.IsBuiltIn.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause IsHidden(BooleanField.Condition op, System.Boolean value) { return Fields.IsHidden.CreateSearchClause(op, value); }
            public static ISearchClause IsBlackbox(BooleanField.Condition op, System.Boolean value) { return Fields.IsBlackbox.CreateSearchClause(op, value); }
            public static ISearchClause IconSize(IntegerField.Condition op, System.Int32 value) { return Fields.IconSize.CreateSearchClause(op, value); }
            public static ISearchClause Keywords(StringField.Condition op, System.String value) { return Fields.Keywords.CreateSearchClause(op, value); }
            public static ISearchClause Contacts(StringField.Condition op, System.String value) { return Fields.Contacts.CreateSearchClause(op, value); }
            public static ISearchClause Comments(StringField.Condition op, System.String value) { return Fields.Comments.CreateSearchClause(op, value); }
            public static ISearchClause Author(StringField.Condition op, System.String value) { return Fields.Author.CreateSearchClause(op, value); }
            public static ISearchClause IsInteractive(BooleanField.Condition op, System.Boolean value) { return Fields.IsInteractive.CreateSearchClause(op, value); }
            public static ISearchClause Source(StringField.Condition op, System.String value) { return Fields.Source.CreateSearchClause(op, value); }
            public static ISearchClause DisplayLabel(StringField.Condition op, System.String value) { return Fields.DisplayLabel.CreateSearchClause(op, value); }
            public static ISearchClause IsCondition(BooleanField.Condition op, System.Boolean value) { return Fields.IsCondition.CreateSearchClause(op, value); }
            public static ISearchClause Version(IntegerField.Condition op, System.Int32 value) { return Fields.Version.CreateSearchClause(op, value); }
            public static ISearchClause Placement(EnumField<VisualPlacement>.Condition op, VisualPlacement value) { return Fields.Placement.CreateSearchClause(op, value); }
            public static ISearchClause Type(EnumField<ActivityType>.Condition op, ActivityType value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause OwnerUserPrincipal(ObjectField<User>.Condition op, User value) { return Fields.OwnerUserPrincipal.CreateSearchClause(op, value); }
            public static ISearchClause OwnerGroupPrincipal(ObjectField<Group>.Condition op, Group value) { return Fields.OwnerGroupPrincipal.CreateSearchClause(op, value); }
            public static ISearchClause SafeParentVersion(ObjectField<Activity>.Condition op, Activity value) { return Fields.SafeParentVersion.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyPackage(RelationSimpleField<AssemblyPackage>.Condition op, AssemblyPackage value) { return Fields.AssemblyPackage.CreateSearchClause(op, value); }
            public static ISearchClause Namespace(RelationSimpleField<Namespace>.Condition op, Namespace value) { return Fields.Namespace.CreateSearchClause(op, value); }
            public static ISearchClause Tag(RelationSimpleField<Tag>.Condition op, Tag value) { return Fields.Tag.CreateSearchClause(op, value); }
            public static ISearchClause NewerVersion (RelationObjectField<Activity>.Condition op, Activity value) { return Fields.NewerVersion.CreateSearchClause(op, value); }
            public static ISearchClause OlderVersion (RelationObjectField<Activity>.Condition op, Activity value) { return Fields.OlderVersion.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Activity> Search(Activity.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Activity, Connection.Action.Search, ref paramList, Activity.CreateFromDataStore, out results);
            return results.ConvertAll<Activity>(BasicObject.ConvertFromIObject<Activity>);
        }
		

        /// <summary>
        /// Saves the Activity object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, this.label));

            mydata.Add(new Parameter("VersionLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, this.versionlabel));

            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("XomlContents", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.xomlcontents));

            mydata.Add(new Parameter("ActivityClass", Parameter.ParamType.String, Parameter.ParamDirection.In, this.activityclass));

            mydata.Add(new Parameter("FullName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.fullname));

            mydata.Add(new Parameter("IsBuiltIn", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isbuiltin));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("IsHidden", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.ishidden));

            mydata.Add(new Parameter("IsBlackbox", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isblackbox));

            mydata.Add(new Parameter("IconSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.iconsize));

            mydata.Add(new Parameter("Keywords", Parameter.ParamType.String, Parameter.ParamDirection.In, this.keywords));

            mydata.Add(new Parameter("Contacts", Parameter.ParamType.String, Parameter.ParamDirection.In, this.contacts));

            mydata.Add(new Parameter("Comments", Parameter.ParamType.String, Parameter.ParamDirection.In, this.comments));

            mydata.Add(new Parameter("Author", Parameter.ParamType.String, Parameter.ParamDirection.In, this.author));

            mydata.Add(new Parameter("IsInteractive", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isinteractive));

            mydata.Add(new Parameter("Source", Parameter.ParamType.String, Parameter.ParamDirection.In, this.source));

            mydata.Add(new Parameter("DisplayLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, this.displaylabel));

            mydata.Add(new Parameter("IsCondition", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.iscondition));

            mydata.Add(new Parameter("Version", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.version));

            mydata.Add(new Parameter("Placement", Parameter.ParamType.String, Parameter.ParamDirection.In, this.placement.ToString()));
            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
            mydata.Add(new Parameter("OwnerUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.owneruserprincipalID == Guid.Empty ?
                (this.OwnerUserPrincipal == null ? Guid.Empty : ((IObject)this.OwnerUserPrincipal).ID)
                : this.owneruserprincipalID)));
            mydata.Add(new Parameter("OwnerGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.ownergroupprincipalID == Guid.Empty ?
                (this.OwnerGroupPrincipal == null ? Guid.Empty : ((IObject)this.OwnerGroupPrincipal).ID)
                : this.ownergroupprincipalID)));
            mydata.Add(new Parameter("SafeParentVersionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.safeparentversionID == Guid.Empty ?
                (this.SafeParentVersion == null ? Guid.Empty : ((IObject)this.SafeParentVersion).ID)
                : this.safeparentversionID)));
            
            Save(mydata);
            
            SaveIconBlob(store);

        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Activity and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Activity> updPipe = new PipelineParameter<Activity>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.assemblypackages.Refresh();
            this.m_namespaces.Refresh();
            this.tags.Refresh();
            this.newerversions.Refresh();
            this.olderversions.Refresh();
            this.safechildversions.Refresh();
            this.activityacls.Refresh();
            this.iconstores.Refresh();
            this.instances.Refresh();
            this.activityparameters.Refresh();
            this.activitysequences.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.assemblypackages.Clear();
            this.m_namespaces.Clear();
            this.tags.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User owneruserprincipal,Group ownergroupprincipal,Activity safeparentversion)
            {
                this.owneruserprincipal=owneruserprincipal;
                this.ownergroupprincipal=ownergroupprincipal;
                this.safeparentversion=safeparentversion;

            }

            public IObject CopyTo(Connection target, Activity activity)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.label));
                 mydata.Add(new Parameter("VersionLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.versionlabel));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, activity.description));
                 mydata.Add(new Parameter("XomlContents", Parameter.ParamType.Text, Parameter.ParamDirection.In, activity.xomlcontents));
                 mydata.Add(new Parameter("ActivityClass", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.activityclass));
                 mydata.Add(new Parameter("FullName", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.fullname));
                 mydata.Add(new Parameter("IsBuiltIn", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.isbuiltin));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.isdeleted));
                 mydata.Add(new Parameter("IsHidden", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.ishidden));
                 mydata.Add(new Parameter("IsBlackbox", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.isblackbox));
                 mydata.Add(new Parameter("IconSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, activity.iconsize));
                 mydata.Add(new Parameter("Keywords", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.keywords));
                 mydata.Add(new Parameter("Contacts", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.contacts));
                 mydata.Add(new Parameter("Comments", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.comments));
                 mydata.Add(new Parameter("Author", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.author));
                 mydata.Add(new Parameter("IsInteractive", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.isinteractive));
                 mydata.Add(new Parameter("Source", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.source));
                 mydata.Add(new Parameter("DisplayLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.displaylabel));
                 mydata.Add(new Parameter("IsCondition", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activity.iscondition));
                 mydata.Add(new Parameter("Version", Parameter.ParamType.Int, Parameter.ParamDirection.In, activity.version));
                 mydata.Add(new Parameter("Placement", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.placement.ToString()));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, activity.type.ToString()));
			     mydata.Add(new Parameter("OwnerUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.owneruserprincipal == null ? Guid.Empty : ((IObject)this.owneruserprincipal).ID)));
			     mydata.Add(new Parameter("OwnerGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.ownergroupprincipal == null ? Guid.Empty : ((IObject)this.ownergroupprincipal).ID)));
			     mydata.Add(new Parameter("SafeParentVersionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.safeparentversion == null ? Guid.Empty : ((IObject)this.safeparentversion).ID)));

                PipelineParameter<Activity> pipe = new PipelineParameter<Activity>(CreateFromDataStore);
                IObject newObj = activity.SaveTo(mydata, store, pipe);
                 activity.SaveIconBlob(store);

                return newObj;
            }

            User owneruserprincipal;
            Group ownergroupprincipal;
            Activity safeparentversion;

        } 
        
              
    }
}
