/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ActivityACLs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ActivityACL collection</typeparam>
    public class ActivityACLCollection<O> : SyncCollection<O, ActivityACL>
        where O : IObject
    {
        public ActivityACLCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityACL>.DelayLoadCallback(ActivityACLCollection_OnDelayLoad);
        }

        public ActivityACLCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityACL>.DelayLoadCallback(ActivityACLCollection_OnDelayLoadRef);
        }

        List<ActivityACL> ActivityACLCollection_OnDelayLoad(Connection c)
        {
            return ActivityACL.LoadAll(this.Owner, c);
        }

        List<ActivityACL> ActivityACLCollection_OnDelayLoadRef(Connection c)
        {
            return ActivityACL.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivityACLCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivityACLCollection<O> objList = new ActivityACLCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivityACLCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ActivityACLCollection<O> objList = new ActivityACLCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ActivityACL
    /// </summary>
    [Serializable]
    public partial class ActivityACL : BasicObject
    {
        private ActivityAuthorWorkflowPriv authorworkflowpriv;
        private ActivityRunWorkflowPriv runworkflowpriv;
        private ActivityPermissionType permission;
        private Guid activityID;
        private Activity activity;
        private Guid privowneruserprincipalID;
        private User privowneruserprincipal;
        private Guid privownergroupprincipalID;
        private Group privownergroupprincipal;
        

        /// <summary>
        /// Description of the ActivityACL
        /// </summary>
        public ActivityAuthorWorkflowPriv AuthorWorkflowPriv
        {
            get { return authorworkflowpriv; }
            set
            {
                authorworkflowpriv = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityACL
        /// </summary>
        public ActivityRunWorkflowPriv RunWorkflowPriv
        {
            get { return runworkflowpriv; }
            set
            {
                runworkflowpriv = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityACL
        /// </summary>
        public ActivityPermissionType Permission
        {
            get { return permission; }
            set
            {
                permission = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Activity Activity
        {
            get
            {
                lock (this)
                {
                    if (activity == null && activityID != Guid.Empty)
                        activity = Activity.Load(activityID, Conn);
                }
                return activity;
            }

            set
            {
                lock (this)
                {
                    activity = value;                   
                    activityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public User PrivOwnerUserPrincipal
        {
            get
            {
                lock (this)
                {
                    if (privowneruserprincipal == null && privowneruserprincipalID != Guid.Empty)
                        privowneruserprincipal = User.Load(privowneruserprincipalID, Conn);
                }
                return privowneruserprincipal;
            }

            set
            {
                lock (this)
                {
                    privowneruserprincipal = value;                   
                    privowneruserprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Group PrivOwnerGroupPrincipal
        {
            get
            {
                lock (this)
                {
                    if (privownergroupprincipal == null && privownergroupprincipalID != Guid.Empty)
                        privownergroupprincipal = Group.Load(privownergroupprincipalID, Conn);
                }
                return privownergroupprincipal;
            }

            set
            {
                lock (this)
                {
                    privownergroupprincipal = value;                   
                    privownergroupprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ActivityACL(Connection c)
            : base(SRStorage.ActivityACL, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivityACL Create(ISecurityPrincipal privowner, IPrivilege priv, Activity activity, Connection c)
        {
            ActivityACL newObj = new ActivityACL(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

			if (privowner is User)
            {
                 newObj.privowneruserprincipal = (User)privowner;
            }
                     else 			if (privowner is Group)
            {
                 newObj.privownergroupprincipal = (Group)privowner;
            }
			if (priv is Activity.ISecurity.Allow)
            {
                if (priv.Permission is Activity.ISecurity.AuthorWorkflowPermission)
                {
                    newObj.authorworkflowpriv = ActivityAuthorWorkflowPriv.Allow;
                    newObj.permission = ActivityPermissionType.AuthorWorkflow;
                }           
if (priv.Permission is Activity.ISecurity.RunWorkflowPermission)
                {
                    newObj.runworkflowpriv = ActivityRunWorkflowPriv.Allow;
                    newObj.permission = ActivityPermissionType.RunWorkflow;
                }           
     
            }
            
			if (priv is Activity.ISecurity.Deny)
            {
                if (priv.Permission is Activity.ISecurity.AuthorWorkflowPermission)
                {
                    newObj.authorworkflowpriv = ActivityAuthorWorkflowPriv.Deny;
                    newObj.permission = ActivityPermissionType.AuthorWorkflow;
                }           
if (priv.Permission is Activity.ISecurity.RunWorkflowPermission)
                {
                    newObj.runworkflowpriv = ActivityRunWorkflowPriv.Deny;
                    newObj.permission = ActivityPermissionType.RunWorkflow;
                }           
     
            }
            
            newObj.activity = activity;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ActivityACL object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ActivityACL object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ActivityACL loadObj = new ActivityACL(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ActivityACL loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("AuthorWorkflowPriv");
            if (!reader.IsDBNull(index))
                loadObj.authorworkflowpriv = (ActivityAuthorWorkflowPriv)Enum.Parse(typeof(ActivityAuthorWorkflowPriv), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("RunWorkflowPriv");
            if (!reader.IsDBNull(index))
                loadObj.runworkflowpriv = (ActivityRunWorkflowPriv)Enum.Parse(typeof(ActivityRunWorkflowPriv), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Permission");
            if (!reader.IsDBNull(index))
                loadObj.permission = (ActivityPermissionType)Enum.Parse(typeof(ActivityPermissionType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityID = val;
            }

            index = reader.GetOrdinal("PrivOwnerUserPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.privowneruserprincipalID = val;
            }

            index = reader.GetOrdinal("PrivOwnerGroupPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.privownergroupprincipalID = val;
            }


            //
            // Object connections
            //

        }

        public static ActivityACL Load(Guid id, Connection c)
        {
            return Load<ActivityACL>(id, c, ActivityACL.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ActivityACLs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ActivityACLs in the system</returns>
        public static List<ActivityACL> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ActivityACL>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ActivityACL)], 
                ActivityACL.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ActivityACLs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityACLs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ActivityACL> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ActivityACL>(owner, ActivityACL.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ActivityACLs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityACLs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ActivityACL> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ActivityACL>(owner, src, ActivityACL.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ActivityACLs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ActivityACLs that match the criteria</returns>
        public static List<ActivityACL> Search(string text, Connection c)
        {
            return LoadAll<ActivityACL>(Connection.Action.Search, text, ActivityACL.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.EnumField<ActivityAuthorWorkflowPriv> AuthorWorkflowPriv = new FieldDefs.EnumField<ActivityAuthorWorkflowPriv>("AuthorWorkflowPriv");
                public static FieldDefs.EnumField<ActivityRunWorkflowPriv> RunWorkflowPriv = new FieldDefs.EnumField<ActivityRunWorkflowPriv>("RunWorkflowPriv");
                public static FieldDefs.EnumField<ActivityPermissionType> Permission = new FieldDefs.EnumField<ActivityPermissionType>("Permission");
                public static FieldDefs.ObjectField<Activity> Activity = new FieldDefs.ObjectField<Activity>("Activity");
                public static FieldDefs.ObjectField<User> PrivOwnerUserPrincipal = new FieldDefs.ObjectField<User>("PrivOwnerUserPrincipal");
                public static FieldDefs.ObjectField<Group> PrivOwnerGroupPrincipal = new FieldDefs.ObjectField<Group>("PrivOwnerGroupPrincipal");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause AuthorWorkflowPriv(EnumField<ActivityAuthorWorkflowPriv>.Condition op, ActivityAuthorWorkflowPriv value) { return Fields.AuthorWorkflowPriv.CreateSearchClause(op, value); }
            public static ISearchClause RunWorkflowPriv(EnumField<ActivityRunWorkflowPriv>.Condition op, ActivityRunWorkflowPriv value) { return Fields.RunWorkflowPriv.CreateSearchClause(op, value); }
            public static ISearchClause Permission(EnumField<ActivityPermissionType>.Condition op, ActivityPermissionType value) { return Fields.Permission.CreateSearchClause(op, value); }
            public static ISearchClause Activity(ObjectField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            public static ISearchClause PrivOwnerUserPrincipal(ObjectField<User>.Condition op, User value) { return Fields.PrivOwnerUserPrincipal.CreateSearchClause(op, value); }
            public static ISearchClause PrivOwnerGroupPrincipal(ObjectField<Group>.Condition op, Group value) { return Fields.PrivOwnerGroupPrincipal.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ActivityACL> Search(ActivityACL.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ActivityACL, Connection.Action.Search, ref paramList, ActivityACL.CreateFromDataStore, out results);
            return results.ConvertAll<ActivityACL>(BasicObject.ConvertFromIObject<ActivityACL>);
        }
		

        /// <summary>
        /// Saves the ActivityACL object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("AuthorWorkflowPriv", Parameter.ParamType.String, Parameter.ParamDirection.In, this.authorworkflowpriv.ToString()));
            mydata.Add(new Parameter("RunWorkflowPriv", Parameter.ParamType.String, Parameter.ParamDirection.In, this.runworkflowpriv.ToString()));
            mydata.Add(new Parameter("Permission", Parameter.ParamType.String, Parameter.ParamDirection.In, this.permission.ToString()));
            mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityID == Guid.Empty ?
                (this.Activity == null ? Guid.Empty : ((IObject)this.Activity).ID)
                : this.activityID)));
            mydata.Add(new Parameter("PrivOwnerUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.privowneruserprincipalID == Guid.Empty ?
                (this.PrivOwnerUserPrincipal == null ? Guid.Empty : ((IObject)this.PrivOwnerUserPrincipal).ID)
                : this.privowneruserprincipalID)));
            mydata.Add(new Parameter("PrivOwnerGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.privownergroupprincipalID == Guid.Empty ?
                (this.PrivOwnerGroupPrincipal == null ? Guid.Empty : ((IObject)this.PrivOwnerGroupPrincipal).ID)
                : this.privownergroupprincipalID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ActivityACL and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ActivityACL> updPipe = new PipelineParameter<ActivityACL>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Activity activity,User privowneruserprincipal,Group privownergroupprincipal)
            {
                this.activity=activity;
                this.privowneruserprincipal=privowneruserprincipal;
                this.privownergroupprincipal=privownergroupprincipal;

            }

            public IObject CopyTo(Connection target, ActivityACL activityacl)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("AuthorWorkflowPriv", Parameter.ParamType.String, Parameter.ParamDirection.In, activityacl.authorworkflowpriv.ToString()));
                 mydata.Add(new Parameter("RunWorkflowPriv", Parameter.ParamType.String, Parameter.ParamDirection.In, activityacl.runworkflowpriv.ToString()));
                 mydata.Add(new Parameter("Permission", Parameter.ParamType.String, Parameter.ParamDirection.In, activityacl.permission.ToString()));
			     mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activity == null ? Guid.Empty : ((IObject)this.activity).ID)));
			     mydata.Add(new Parameter("PrivOwnerUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.privowneruserprincipal == null ? Guid.Empty : ((IObject)this.privowneruserprincipal).ID)));
			     mydata.Add(new Parameter("PrivOwnerGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.privownergroupprincipal == null ? Guid.Empty : ((IObject)this.privownergroupprincipal).ID)));

                PipelineParameter<ActivityACL> pipe = new PipelineParameter<ActivityACL>(CreateFromDataStore);
                IObject newObj = activityacl.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Activity activity;
            User privowneruserprincipal;
            Group privownergroupprincipal;

        }
        
       
    }
}
