/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ActivityIconBlobs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ActivityIconBlob collection</typeparam>
    public class ActivityIconBlobCollection<O> : SyncCollection<O, ActivityIconBlob>
        where O : IObject
    {
        public ActivityIconBlobCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityIconBlob>.DelayLoadCallback(ActivityIconBlobCollection_OnDelayLoad);
        }

        public ActivityIconBlobCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityIconBlob>.DelayLoadCallback(ActivityIconBlobCollection_OnDelayLoadRef);
        }

        List<ActivityIconBlob> ActivityIconBlobCollection_OnDelayLoad(Connection c)
        {
            return ActivityIconBlob.LoadAll(this.Owner, c);
        }

        List<ActivityIconBlob> ActivityIconBlobCollection_OnDelayLoadRef(Connection c)
        {
            return ActivityIconBlob.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivityIconBlobCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivityIconBlobCollection<O> objList = new ActivityIconBlobCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivityIconBlobCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ActivityIconBlobCollection<O> objList = new ActivityIconBlobCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ActivityIconBlob
    /// </summary>
    [Serializable]
    public partial class ActivityIconBlob : BasicObject, IBlob
    {
        private System.Guid packageid;
        private System.Int32 index;
        private System.Int32 chunks;
        private System.String contents;
        private System.Guid revisionid;
        private Guid activityID;
        private Activity activity;
        private Guid previousID;
        private ActivityIconBlob previous;
        private Guid nextID;
        private ActivityIconBlob next;
        

        /// <summary>
        /// Description of the ActivityIconBlob
        /// </summary>
        public System.Guid PackageID
        {
            get { return packageid; }
            set
            {
                packageid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityIconBlob
        /// </summary>
        public System.Int32 Index
        {
            get { return index; }
            set
            {
                index = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityIconBlob
        /// </summary>
        public System.Int32 Chunks
        {
            get { return chunks; }
            set
            {
                chunks = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityIconBlob
        /// </summary>
        public System.String Contents
        {
            get { return contents; }
            set
            {
                contents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityIconBlob
        /// </summary>
        public System.Guid RevisionID
        {
            get { return revisionid; }
            set
            {
                revisionid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Activity Activity
        {
            get
            {
                lock (this)
                {
                    if (activity == null && activityID != Guid.Empty)
                        activity = Activity.Load(activityID, Conn);
                }
                return activity;
            }

            set
            {
                lock (this)
                {
                    activity = value;                   
                    activityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ActivityIconBlob Previous
        {
            get
            {
                lock (this)
                {
                    if (previous == null && previousID != Guid.Empty)
                        previous = ActivityIconBlob.Load(previousID, Conn);
                }
                return previous;
            }

            set
            {
                lock (this)
                {
                    previous = value;                   
                    previousID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ActivityIconBlob Next
        {
            get
            {
                lock (this)
                {
                    if (next == null && nextID != Guid.Empty)
                        next = ActivityIconBlob.Load(nextID, Conn);
                }
                return next;
            }

            set
            {
                lock (this)
                {
                    next = value;                   
                    nextID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ActivityIconBlob(Connection c)
            : base(SRStorage.ActivityIconBlob, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivityIconBlob Create(System.Guid packageid, System.Int32 index, System.Int32 chunks, System.Guid revisionid, Activity activity, Connection c)
        {
            ActivityIconBlob newObj = new ActivityIconBlob(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.packageid = packageid;
            newObj.index = index;
            newObj.chunks = chunks;
            newObj.revisionid = revisionid;
            newObj.activity = activity;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ActivityIconBlob object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ActivityIconBlob object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ActivityIconBlob loadObj = new ActivityIconBlob(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ActivityIconBlob loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("PackageID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.packageid = val;
            }

            index = reader.GetOrdinal("Index");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.index = val;
            }

            index = reader.GetOrdinal("Chunks");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.chunks = val;
            }

            index = reader.GetOrdinal("Contents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.contents = val;
            }

            index = reader.GetOrdinal("RevisionID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.revisionid = val;
            }

            index = reader.GetOrdinal("ActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityID = val;
            }

            index = reader.GetOrdinal("PreviousID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.previousID = val;
            }

            index = reader.GetOrdinal("NextID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.nextID = val;
            }


            //
            // Object connections
            //

        }

        public static ActivityIconBlob Load(Guid id, Connection c)
        {
            return Load<ActivityIconBlob>(id, c, ActivityIconBlob.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ActivityIconBlobs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ActivityIconBlobs in the system</returns>
        public static List<ActivityIconBlob> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ActivityIconBlob>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ActivityIconBlob)], 
                ActivityIconBlob.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ActivityIconBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityIconBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ActivityIconBlob> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ActivityIconBlob>(owner, ActivityIconBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ActivityIconBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityIconBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ActivityIconBlob> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ActivityIconBlob>(owner, src, ActivityIconBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ActivityIconBlobs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ActivityIconBlobs that match the criteria</returns>
        public static List<ActivityIconBlob> Search(string text, Connection c)
        {
            return LoadAll<ActivityIconBlob>(Connection.Action.Search, text, ActivityIconBlob.CreateFromDataStore, c);
        }



		

        /// <summary>
        /// Saves the ActivityIconBlob object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.packageid));

            mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.index));

            mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.chunks));

            mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, this.contents));

            mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.revisionid));

            mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityID == Guid.Empty ?
                (this.Activity == null ? Guid.Empty : ((IObject)this.Activity).ID)
                : this.activityID)));
            mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.previousID == Guid.Empty ?
                (this.Previous == null ? Guid.Empty : ((IObject)this.Previous).ID)
                : this.previousID)));
            mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.nextID == Guid.Empty ?
                (this.Next == null ? Guid.Empty : ((IObject)this.Next).ID)
                : this.nextID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ActivityIconBlob and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ActivityIconBlob> updPipe = new PipelineParameter<ActivityIconBlob>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Activity activity,ActivityIconBlob previous,ActivityIconBlob next)
            {
                this.activity=activity;
                this.previous=previous;
                this.next=next;

            }

            public IObject CopyTo(Connection target, ActivityIconBlob activityiconblob)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, activityiconblob.packageid));
                 mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, activityiconblob.index));
                 mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, activityiconblob.chunks));
                 mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, activityiconblob.contents));
                 mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, activityiconblob.revisionid));
			     mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activity == null ? Guid.Empty : ((IObject)this.activity).ID)));
			     mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.previous == null ? Guid.Empty : ((IObject)this.previous).ID)));
			     mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.next == null ? Guid.Empty : ((IObject)this.next).ID)));

                PipelineParameter<ActivityIconBlob> pipe = new PipelineParameter<ActivityIconBlob>(CreateFromDataStore);
                IObject newObj = activityiconblob.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Activity activity;
            ActivityIconBlob previous;
            ActivityIconBlob next;

        }
        
       
    }
}
