/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ActivityInstances that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ActivityInstance collection</typeparam>
    public class ActivityInstanceCollection<O> : SyncCollection<O, ActivityInstance>
        where O : IObject
    {
        public ActivityInstanceCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityInstance>.DelayLoadCallback(ActivityInstanceCollection_OnDelayLoad);
        }

        public ActivityInstanceCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityInstance>.DelayLoadCallback(ActivityInstanceCollection_OnDelayLoadRef);
        }

        List<ActivityInstance> ActivityInstanceCollection_OnDelayLoad(Connection c)
        {
            return ActivityInstance.LoadAll(this.Owner, c);
        }

        List<ActivityInstance> ActivityInstanceCollection_OnDelayLoadRef(Connection c)
        {
            return ActivityInstance.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivityInstanceCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivityInstanceCollection<O> objList = new ActivityInstanceCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivityInstanceCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ActivityInstanceCollection<O> objList = new ActivityInstanceCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ActivityInstance
    /// </summary>
    [Serializable]
    public partial class ActivityInstance : BasicObject
    {
        private System.String parameterxml;
        private System.String xomlcontents;
        private Guid activityID;
        private Activity activity;
        
        private JobCollection<ActivityInstance> jobs;
        private ActivityInstanceParameterCollection<ActivityInstance> activityinstanceparameters;
        private DataProductCollection<ActivityInstance> outputs;

        /// <summary>
        /// Description of the ActivityInstance
        /// </summary>
        public System.String ParameterXml
        {
            get { return parameterxml; }
            set
            {
                parameterxml = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityInstance
        /// </summary>
        public System.String XomlContents
        {
            get { return xomlcontents; }
            set
            {
                xomlcontents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Activity Activity
        {
            get
            {
                lock (this)
                {
                    if (activity == null && activityID != Guid.Empty)
                        activity = Activity.Load(activityID, Conn);
                }
                return activity;
            }

            set
            {
                lock (this)
                {
                    activity = value;                   
                    activityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }


        public JobCollection<ActivityInstance> Jobs { get { return jobs; } }
        public ActivityInstanceParameterCollection<ActivityInstance> ActivityInstanceParameters { get { return activityinstanceparameters; } }
        public DataProductCollection<ActivityInstance> Outputs { get { return outputs; } }

		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ActivityInstance(Connection c)
            : base(SRStorage.ActivityInstance, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivityInstance Create(Activity activity, Connection c)
        {
            ActivityInstance newObj = new ActivityInstance(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.activity = activity;
	
            // Empty collections
            newObj.jobs = new JobCollection<ActivityInstance>(newObj, c);
            newObj.activityinstanceparameters = new ActivityInstanceParameterCollection<ActivityInstance>(newObj, "ActivityInstance", "ActivityInstanceParameter", c);
            newObj.outputs = new DataProductCollection<ActivityInstance>(newObj, "ProducedBy", "Output", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ActivityInstance object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ActivityInstance object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ActivityInstance loadObj = new ActivityInstance(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ActivityInstance loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("ParameterXml");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.parameterxml = val;
            }

            index = reader.GetOrdinal("XomlContents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.xomlcontents = val;
            }

            index = reader.GetOrdinal("ActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityID = val;
            }


            //
            // Object connections
            //

            // Jobs
            loadObj.jobs = JobCollection<ActivityInstance>.CreateFromReader(loadObj, reader, c);
            // ActivityInstanceParameters
            loadObj.activityinstanceparameters = ActivityInstanceParameterCollection<ActivityInstance>.CreateFromReader(loadObj, "ActivityInstance", "ActivityInstanceParameter", reader, c);
            // Outputs
            loadObj.outputs = DataProductCollection<ActivityInstance>.CreateFromReader(loadObj, "ProducedBy", "Output", reader, c);
        }

        public static ActivityInstance Load(Guid id, Connection c)
        {
            return Load<ActivityInstance>(id, c, ActivityInstance.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ActivityInstances from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ActivityInstances in the system</returns>
        public static List<ActivityInstance> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ActivityInstance>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ActivityInstance)], 
                ActivityInstance.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ActivityInstances that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityInstances</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ActivityInstance> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ActivityInstance>(owner, ActivityInstance.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ActivityInstances that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityInstances</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ActivityInstance> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ActivityInstance>(owner, src, ActivityInstance.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ActivityInstances by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ActivityInstances that match the criteria</returns>
        public static List<ActivityInstance> Search(string text, Connection c)
        {
            return LoadAll<ActivityInstance>(Connection.Action.Search, text, ActivityInstance.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField ParameterXml = new FieldDefs.StringField("ParameterXml");
                public static FieldDefs.StringField XomlContents = new FieldDefs.StringField("XomlContents");
                public static FieldDefs.ObjectField<Activity> Activity = new FieldDefs.ObjectField<Activity>("Activity");
                public static FieldDefs.RelationSimpleField<Job> Job = new FieldDefs.RelationSimpleField<Job>("Job", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause ParameterXml(StringField.Condition op, System.String value) { return Fields.ParameterXml.CreateSearchClause(op, value); }
            public static ISearchClause XomlContents(StringField.Condition op, System.String value) { return Fields.XomlContents.CreateSearchClause(op, value); }
            public static ISearchClause Activity(ObjectField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            public static ISearchClause Job(RelationSimpleField<Job>.Condition op, Job value) { return Fields.Job.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ActivityInstance> Search(ActivityInstance.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ActivityInstance, Connection.Action.Search, ref paramList, ActivityInstance.CreateFromDataStore, out results);
            return results.ConvertAll<ActivityInstance>(BasicObject.ConvertFromIObject<ActivityInstance>);
        }
		

        /// <summary>
        /// Saves the ActivityInstance object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("ParameterXml", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.parameterxml));

            mydata.Add(new Parameter("XomlContents", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.xomlcontents));

            mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityID == Guid.Empty ?
                (this.Activity == null ? Guid.Empty : ((IObject)this.Activity).ID)
                : this.activityID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ActivityInstance and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ActivityInstance> updPipe = new PipelineParameter<ActivityInstance>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.jobs.Refresh();
            this.activityinstanceparameters.Refresh();
            this.outputs.Refresh();
        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.jobs.Clear();

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Activity activity)
            {
                this.activity=activity;

            }

            public IObject CopyTo(Connection target, ActivityInstance activityinstance)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("ParameterXml", Parameter.ParamType.Text, Parameter.ParamDirection.In, activityinstance.parameterxml));
                 mydata.Add(new Parameter("XomlContents", Parameter.ParamType.Text, Parameter.ParamDirection.In, activityinstance.xomlcontents));
			     mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activity == null ? Guid.Empty : ((IObject)this.activity).ID)));

                PipelineParameter<ActivityInstance> pipe = new PipelineParameter<ActivityInstance>(CreateFromDataStore);
                IObject newObj = activityinstance.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Activity activity;

        }
        
       
    }
}
