/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ActivityParameters that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ActivityParameter collection</typeparam>
    public class ActivityParameterCollection<O> : SyncCollection<O, ActivityParameter>
        where O : IObject
    {
        public ActivityParameterCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityParameter>.DelayLoadCallback(ActivityParameterCollection_OnDelayLoad);
        }

        public ActivityParameterCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivityParameter>.DelayLoadCallback(ActivityParameterCollection_OnDelayLoadRef);
        }

        List<ActivityParameter> ActivityParameterCollection_OnDelayLoad(Connection c)
        {
            return ActivityParameter.LoadAll(this.Owner, c);
        }

        List<ActivityParameter> ActivityParameterCollection_OnDelayLoadRef(Connection c)
        {
            return ActivityParameter.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivityParameterCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivityParameterCollection<O> objList = new ActivityParameterCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivityParameterCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            ActivityParameterCollection<O> objList = new ActivityParameterCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// ActivityParameter
    /// </summary>
    [Serializable]
    public partial class ActivityParameter : NamedObject<ActivityParameter>
    {
        private System.String type;
        private System.String label;
        private System.Boolean required;
        private System.String description;
        private System.String parameterclass;
        private System.String defaultvalue;
        private System.Boolean defaulttoproduct;
        private System.Boolean isfilereference;
        private System.String defaultproducttype;
        private System.String defaultproductname;
        private System.Boolean defaultoverwrite;
        private DirectionType direction;
        private Guid activityID;
        private Activity activity;
        
        private TagCollection<ActivityParameter> tags;

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String Label
        {
            get { return label; }
            set
            {
                label = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.Boolean Required
        {
            get { return required; }
            set
            {
                required = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String ParameterClass
        {
            get { return parameterclass; }
            set
            {
                parameterclass = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String DefaultValue
        {
            get { return defaultvalue; }
            set
            {
                defaultvalue = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.Boolean DefaultToProduct
        {
            get { return defaulttoproduct; }
            set
            {
                defaulttoproduct = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.Boolean IsFileReference
        {
            get { return isfilereference; }
            set
            {
                isfilereference = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String DefaultProductType
        {
            get { return defaultproducttype; }
            set
            {
                defaultproducttype = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.String DefaultProductName
        {
            get { return defaultproductname; }
            set
            {
                defaultproductname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public System.Boolean DefaultOverwrite
        {
            get { return defaultoverwrite; }
            set
            {
                defaultoverwrite = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivityParameter
        /// </summary>
        public DirectionType Direction
        {
            get { return direction; }
            set
            {
                direction = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Activity Activity
        {
            get
            {
                lock (this)
                {
                    if (activity == null && activityID != Guid.Empty)
                        activity = Activity.Load(activityID, Conn);
                }
                return activity;
            }

            set
            {
                lock (this)
                {
                    activity = value;                   
                    activityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public TagCollection<ActivityParameter> Tags { get { return tags; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ActivityParameter(Connection c)
            : base(SRStorage.ActivityParameter, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivityParameter Create(string name, System.String type, DirectionType direction, Activity activity, Connection c)
        {
            ActivityParameter newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;
            newObj.direction = direction;
            newObj.activity = activity;

			
            // Empty collections
            newObj.tags = new TagCollection<ActivityParameter>(newObj, c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static ActivityParameter Load(string name, Connection c)
        {
            return NamedObject<ActivityParameter>.Load(name, c, ActivityParameter.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a ActivityParameter object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ActivityParameter object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ActivityParameter loadObj = (ActivityParameter)NamedObject<ActivityParameter>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(ActivityParameter loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<ActivityParameter>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.type = val;
            }

            index = reader.GetOrdinal("Label");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.label = val;
            }

            index = reader.GetOrdinal("Required");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.required = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("ParameterClass");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.parameterclass = val;
            }

            index = reader.GetOrdinal("DefaultValue");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.defaultvalue = val;
            }

            index = reader.GetOrdinal("DefaultToProduct");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.defaulttoproduct = val;
            }

            index = reader.GetOrdinal("IsFileReference");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isfilereference = val;
            }

            index = reader.GetOrdinal("DefaultProductType");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.defaultproducttype = val;
            }

            index = reader.GetOrdinal("DefaultProductName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.defaultproductname = val;
            }

            index = reader.GetOrdinal("DefaultOverwrite");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.defaultoverwrite = val;
            }

            index = reader.GetOrdinal("Direction");
            if (!reader.IsDBNull(index))
                loadObj.direction = (DirectionType)Enum.Parse(typeof(DirectionType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityID = val;
            }


            //
            // Object connections
            //

            // Tags
            loadObj.tags = TagCollection<ActivityParameter>.CreateFromReader(loadObj, reader, c);
        }

        public static ActivityParameter Load(Guid id, Connection c)
        {
            return Load<ActivityParameter>(id, c, ActivityParameter.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ActivityParameters from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ActivityParameters in the system</returns>
        public static List<ActivityParameter> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ActivityParameter>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ActivityParameter)], 
                ActivityParameter.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ActivityParameters that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityParameters</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ActivityParameter> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ActivityParameter>(owner, ActivityParameter.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ActivityParameters that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivityParameters</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ActivityParameter> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ActivityParameter>(owner, src, ActivityParameter.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ActivityParameters by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ActivityParameters that match the criteria</returns>
        public static List<ActivityParameter> Search(string text, Connection c)
        {
            return LoadAll<ActivityParameter>(Connection.Action.Search, text, ActivityParameter.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Type = new FieldDefs.StringField("Type");
                public static FieldDefs.StringField Label = new FieldDefs.StringField("Label");
                public static FieldDefs.BooleanField Required = new FieldDefs.BooleanField("Required");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.StringField ParameterClass = new FieldDefs.StringField("ParameterClass");
                public static FieldDefs.StringField DefaultValue = new FieldDefs.StringField("DefaultValue");
                public static FieldDefs.BooleanField DefaultToProduct = new FieldDefs.BooleanField("DefaultToProduct");
                public static FieldDefs.BooleanField IsFileReference = new FieldDefs.BooleanField("IsFileReference");
                public static FieldDefs.StringField DefaultProductType = new FieldDefs.StringField("DefaultProductType");
                public static FieldDefs.StringField DefaultProductName = new FieldDefs.StringField("DefaultProductName");
                public static FieldDefs.BooleanField DefaultOverwrite = new FieldDefs.BooleanField("DefaultOverwrite");
                public static FieldDefs.EnumField<DirectionType> Direction = new FieldDefs.EnumField<DirectionType>("Direction");
                public static FieldDefs.ObjectField<Activity> Activity = new FieldDefs.ObjectField<Activity>("Activity");
                public static FieldDefs.RelationSimpleField<Tag> Tag = new FieldDefs.RelationSimpleField<Tag>("Tag", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Type(StringField.Condition op, System.String value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause Label(StringField.Condition op, System.String value) { return Fields.Label.CreateSearchClause(op, value); }
            public static ISearchClause Required(BooleanField.Condition op, System.Boolean value) { return Fields.Required.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause ParameterClass(StringField.Condition op, System.String value) { return Fields.ParameterClass.CreateSearchClause(op, value); }
            public static ISearchClause DefaultValue(StringField.Condition op, System.String value) { return Fields.DefaultValue.CreateSearchClause(op, value); }
            public static ISearchClause DefaultToProduct(BooleanField.Condition op, System.Boolean value) { return Fields.DefaultToProduct.CreateSearchClause(op, value); }
            public static ISearchClause IsFileReference(BooleanField.Condition op, System.Boolean value) { return Fields.IsFileReference.CreateSearchClause(op, value); }
            public static ISearchClause DefaultProductType(StringField.Condition op, System.String value) { return Fields.DefaultProductType.CreateSearchClause(op, value); }
            public static ISearchClause DefaultProductName(StringField.Condition op, System.String value) { return Fields.DefaultProductName.CreateSearchClause(op, value); }
            public static ISearchClause DefaultOverwrite(BooleanField.Condition op, System.Boolean value) { return Fields.DefaultOverwrite.CreateSearchClause(op, value); }
            public static ISearchClause Direction(EnumField<DirectionType>.Condition op, DirectionType value) { return Fields.Direction.CreateSearchClause(op, value); }
            public static ISearchClause Activity(ObjectField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            public static ISearchClause Tag(RelationSimpleField<Tag>.Condition op, Tag value) { return Fields.Tag.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ActivityParameter> Search(ActivityParameter.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ActivityParameter, Connection.Action.Search, ref paramList, ActivityParameter.CreateFromDataStore, out results);
            return results.ConvertAll<ActivityParameter>(BasicObject.ConvertFromIObject<ActivityParameter>);
        }
		

        /// <summary>
        /// Saves the ActivityParameter object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type));

            mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, this.label));

            mydata.Add(new Parameter("Required", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.required));

            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("ParameterClass", Parameter.ParamType.String, Parameter.ParamDirection.In, this.parameterclass));

            mydata.Add(new Parameter("DefaultValue", Parameter.ParamType.String, Parameter.ParamDirection.In, this.defaultvalue));

            mydata.Add(new Parameter("DefaultToProduct", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.defaulttoproduct));

            mydata.Add(new Parameter("IsFileReference", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isfilereference));

            mydata.Add(new Parameter("DefaultProductType", Parameter.ParamType.String, Parameter.ParamDirection.In, this.defaultproducttype));

            mydata.Add(new Parameter("DefaultProductName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.defaultproductname));

            mydata.Add(new Parameter("DefaultOverwrite", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.defaultoverwrite));

            mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, this.direction.ToString()));
            mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityID == Guid.Empty ?
                (this.Activity == null ? Guid.Empty : ((IObject)this.Activity).ID)
                : this.activityID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ActivityParameter and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ActivityParameter> updPipe = new PipelineParameter<ActivityParameter>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.tags.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.tags.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Activity activity)
            {
                this.activity=activity;

            }

            public IObject CopyTo(Connection target, ActivityParameter activityparameter)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.type));
                 mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.label));
                 mydata.Add(new Parameter("Required", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activityparameter.required));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, activityparameter.description));
                 mydata.Add(new Parameter("ParameterClass", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.parameterclass));
                 mydata.Add(new Parameter("DefaultValue", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.defaultvalue));
                 mydata.Add(new Parameter("DefaultToProduct", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activityparameter.defaulttoproduct));
                 mydata.Add(new Parameter("IsFileReference", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activityparameter.isfilereference));
                 mydata.Add(new Parameter("DefaultProductType", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.defaultproducttype));
                 mydata.Add(new Parameter("DefaultProductName", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.defaultproductname));
                 mydata.Add(new Parameter("DefaultOverwrite", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activityparameter.defaultoverwrite));
                 mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, activityparameter.direction.ToString()));
			     mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activity == null ? Guid.Empty : ((IObject)this.activity).ID)));

                PipelineParameter<ActivityParameter> pipe = new PipelineParameter<ActivityParameter>(CreateFromDataStore);
                IObject newObj = activityparameter.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Activity activity;

        } 
        
              
    }
}
