/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ActivitySequences that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ActivitySequence collection</typeparam>
    public class ActivitySequenceCollection<O> : SyncCollection<O, ActivitySequence>
        where O : IObject
    {
        public ActivitySequenceCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivitySequence>.DelayLoadCallback(ActivitySequenceCollection_OnDelayLoad);
        }

        public ActivitySequenceCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ActivitySequence>.DelayLoadCallback(ActivitySequenceCollection_OnDelayLoadRef);
        }

        List<ActivitySequence> ActivitySequenceCollection_OnDelayLoad(Connection c)
        {
            return ActivitySequence.LoadAll(this.Owner, c);
        }

        List<ActivitySequence> ActivitySequenceCollection_OnDelayLoadRef(Connection c)
        {
            return ActivitySequence.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ActivitySequenceCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ActivitySequenceCollection<O> objList = new ActivitySequenceCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ActivitySequenceCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ActivitySequenceCollection<O> objList = new ActivitySequenceCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ActivitySequence
    /// </summary>
    [Serializable]
    public partial class ActivitySequence : BasicObject
    {
        private System.Int32 position;
        private System.String name;
        private System.Boolean isbase;
        private Guid parentID;
        private ActivitySequence parent;
        private Guid activityID;
        private Activity activity;
        
        private DataProductCollection<ActivitySequence> dataproducts;
        private ParameterAssignmentCollection<ActivitySequence> parameterassignments;
        private ActivitySequenceCollection<ActivitySequence> activitysequences;

        /// <summary>
        /// Description of the ActivitySequence
        /// </summary>
        public System.Int32 Position
        {
            get { return position; }
            set
            {
                position = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivitySequence
        /// </summary>
        public System.String Name
        {
            get { return name; }
            set
            {
                name = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ActivitySequence
        /// </summary>
        public System.Boolean IsBase
        {
            get { return isbase; }
            set
            {
                isbase = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public ActivitySequence Parent
        {
            get
            {
                lock (this)
                {
                    if (parent == null && parentID != Guid.Empty)
                        parent = ActivitySequence.Load(parentID, Conn);
                }
                return parent;
            }

            set
            {
                lock (this)
                {
                    parent = value;                   
                    parentID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Activity Activity
        {
            get
            {
                lock (this)
                {
                    if (activity == null && activityID != Guid.Empty)
                        activity = Activity.Load(activityID, Conn);
                }
                return activity;
            }

            set
            {
                lock (this)
                {
                    activity = value;                   
                    activityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }


        public DataProductCollection<ActivitySequence> DataProducts { get { return dataproducts; } }
        public ParameterAssignmentCollection<ActivitySequence> ParameterAssignments { get { return parameterassignments; } }
        public ActivitySequenceCollection<ActivitySequence> ActivitySequences { get { return activitysequences; } }

		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ActivitySequence(Connection c)
            : base(SRStorage.ActivitySequence, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivitySequence Create(ActivitySequence parent, Activity activity, Connection c)
        {
            ActivitySequence newObj = new ActivitySequence(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.parent = parent;
            newObj.activity = activity;
	
            newObj.dataproducts = new DataProductCollection<ActivitySequence>(newObj, "CreatorActivity", "DataProduct", c);
            newObj.parameterassignments = new ParameterAssignmentCollection<ActivitySequence>(newObj, "Instance", "ParameterAssignment", c);
            newObj.activitysequences = new ActivitySequenceCollection<ActivitySequence>(newObj, "Parent", "ActivitySequence", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ActivitySequence object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ActivitySequence object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ActivitySequence loadObj = new ActivitySequence(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ActivitySequence loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Position");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.position = val;
            }

            index = reader.GetOrdinal("Name");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.name = val;
            }

            index = reader.GetOrdinal("IsBase");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isbase = val;
            }

            index = reader.GetOrdinal("ParentID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.parentID = val;
            }

            index = reader.GetOrdinal("ActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityID = val;
            }


            //
            // Object connections
            //

            // DataProducts
            loadObj.dataproducts = DataProductCollection<ActivitySequence>.CreateFromReader(loadObj, "CreatorActivity", "DataProduct", reader, c);
            // ParameterAssignments
            loadObj.parameterassignments = ParameterAssignmentCollection<ActivitySequence>.CreateFromReader(loadObj, "Instance", "ParameterAssignment", reader, c);
            // ActivitySequences
            loadObj.activitysequences = ActivitySequenceCollection<ActivitySequence>.CreateFromReader(loadObj, "Parent", "ActivitySequence", reader, c);
        }

        public static ActivitySequence Load(Guid id, Connection c)
        {
            return Load<ActivitySequence>(id, c, ActivitySequence.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ActivitySequences from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ActivitySequences in the system</returns>
        public static List<ActivitySequence> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ActivitySequence>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ActivitySequence)], 
                ActivitySequence.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ActivitySequences that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivitySequences</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ActivitySequence> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ActivitySequence>(owner, ActivitySequence.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ActivitySequences that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ActivitySequences</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ActivitySequence> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ActivitySequence>(owner, src, ActivitySequence.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ActivitySequences by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ActivitySequences that match the criteria</returns>
        public static List<ActivitySequence> Search(string text, Connection c)
        {
            return LoadAll<ActivitySequence>(Connection.Action.Search, text, ActivitySequence.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.IntegerField Position = new FieldDefs.IntegerField("Position");
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.BooleanField IsBase = new FieldDefs.BooleanField("IsBase");
                public static FieldDefs.ObjectField<ActivitySequence> Parent = new FieldDefs.ObjectField<ActivitySequence>("Parent");
                public static FieldDefs.ObjectField<Activity> Activity = new FieldDefs.ObjectField<Activity>("Activity");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Position(IntegerField.Condition op, System.Int32 value) { return Fields.Position.CreateSearchClause(op, value); }
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause IsBase(BooleanField.Condition op, System.Boolean value) { return Fields.IsBase.CreateSearchClause(op, value); }
            public static ISearchClause Parent(ObjectField<ActivitySequence>.Condition op, ActivitySequence value) { return Fields.Parent.CreateSearchClause(op, value); }
            public static ISearchClause Activity(ObjectField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ActivitySequence> Search(ActivitySequence.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ActivitySequence, Connection.Action.Search, ref paramList, ActivitySequence.CreateFromDataStore, out results);
            return results.ConvertAll<ActivitySequence>(BasicObject.ConvertFromIObject<ActivitySequence>);
        }
		

        /// <summary>
        /// Saves the ActivitySequence object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.position));

            mydata.Add(new Parameter("Name", Parameter.ParamType.String, Parameter.ParamDirection.In, this.name));

            mydata.Add(new Parameter("IsBase", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isbase));

            mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.parentID == Guid.Empty ?
                (this.Parent == null ? Guid.Empty : ((IObject)this.Parent).ID)
                : this.parentID)));
            mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityID == Guid.Empty ?
                (this.Activity == null ? Guid.Empty : ((IObject)this.Activity).ID)
                : this.activityID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ActivitySequence and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ActivitySequence> updPipe = new PipelineParameter<ActivitySequence>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.dataproducts.Refresh();
            this.parameterassignments.Refresh();
            this.activitysequences.Refresh();
        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ActivitySequence parent,Activity activity)
            {
                this.parent=parent;
                this.activity=activity;

            }

            public IObject CopyTo(Connection target, ActivitySequence activitysequence)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, activitysequence.position));
                 mydata.Add(new Parameter("Name", Parameter.ParamType.String, Parameter.ParamDirection.In, activitysequence.name));
                 mydata.Add(new Parameter("IsBase", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, activitysequence.isbase));
			     mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.parent == null ? Guid.Empty : ((IObject)this.parent).ID)));
			     mydata.Add(new Parameter("ActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activity == null ? Guid.Empty : ((IObject)this.activity).ID)));

                PipelineParameter<ActivitySequence> pipe = new PipelineParameter<ActivitySequence>(CreateFromDataStore);
                IObject newObj = activitysequence.SaveTo(mydata, store, pipe);

                return newObj;
            }

            ActivitySequence parent;
            Activity activity;

        }
        
       
    }
}
