/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the AdditionalParameters that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the AdditionalParameter collection</typeparam>
    public class AdditionalParameterCollection<O> : SyncCollection<O, AdditionalParameter>
        where O : IObject
    {
        public AdditionalParameterCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AdditionalParameter>.DelayLoadCallback(AdditionalParameterCollection_OnDelayLoad);
        }

        public AdditionalParameterCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AdditionalParameter>.DelayLoadCallback(AdditionalParameterCollection_OnDelayLoadRef);
        }

        List<AdditionalParameter> AdditionalParameterCollection_OnDelayLoad(Connection c)
        {
            return AdditionalParameter.LoadAll(this.Owner, c);
        }

        List<AdditionalParameter> AdditionalParameterCollection_OnDelayLoadRef(Connection c)
        {
            return AdditionalParameter.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static AdditionalParameterCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            AdditionalParameterCollection<O> objList = new AdditionalParameterCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static AdditionalParameterCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            AdditionalParameterCollection<O> objList = new AdditionalParameterCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// AdditionalParameter
    /// </summary>
    [Serializable]
    public partial class AdditionalParameter : BasicObject
    {
        private System.String domain;
        private System.String paramname;
        private System.String paramvalue;
        private Guid jobID;
        private Job job;
        

        /// <summary>
        /// Description of the AdditionalParameter
        /// </summary>
        public System.String Domain
        {
            get { return domain; }
            set
            {
                domain = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AdditionalParameter
        /// </summary>
        public System.String ParamName
        {
            get { return paramname; }
            set
            {
                paramname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AdditionalParameter
        /// </summary>
        public System.String ParamValue
        {
            get { return paramvalue; }
            set
            {
                paramvalue = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Job Job
        {
            get
            {
                lock (this)
                {
                    if (job == null && jobID != Guid.Empty)
                        job = Job.Load(jobID, Conn);
                }
                return job;
            }

            set
            {
                lock (this)
                {
                    job = value;                   
                    jobID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public AdditionalParameter(Connection c)
            : base(SRStorage.AdditionalParameter, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static AdditionalParameter Create(Job job, Connection c)
        {
            AdditionalParameter newObj = new AdditionalParameter(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.job = job;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a AdditionalParameter object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>AdditionalParameter object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            AdditionalParameter loadObj = new AdditionalParameter(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(AdditionalParameter loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Domain");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.domain = val;
            }

            index = reader.GetOrdinal("ParamName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.paramname = val;
            }

            index = reader.GetOrdinal("ParamValue");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.paramvalue = val;
            }

            index = reader.GetOrdinal("JobID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.jobID = val;
            }


            //
            // Object connections
            //

        }

        public static AdditionalParameter Load(Guid id, Connection c)
        {
            return Load<AdditionalParameter>(id, c, AdditionalParameter.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL AdditionalParameters from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all AdditionalParameters in the system</returns>
        public static List<AdditionalParameter> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<AdditionalParameter>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(AdditionalParameter)], 
                AdditionalParameter.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all AdditionalParameters that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AdditionalParameters</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<AdditionalParameter> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<AdditionalParameter>(owner, AdditionalParameter.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all AdditionalParameters that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AdditionalParameters</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<AdditionalParameter> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<AdditionalParameter>(owner, src, AdditionalParameter.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches AdditionalParameters by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of AdditionalParameters that match the criteria</returns>
        public static List<AdditionalParameter> Search(string text, Connection c)
        {
            return LoadAll<AdditionalParameter>(Connection.Action.Search, text, AdditionalParameter.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Domain = new FieldDefs.StringField("Domain");
                public static FieldDefs.StringField ParamName = new FieldDefs.StringField("ParamName");
                public static FieldDefs.StringField ParamValue = new FieldDefs.StringField("ParamValue");
                public static FieldDefs.ObjectField<Job> Job = new FieldDefs.ObjectField<Job>("Job");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Domain(StringField.Condition op, System.String value) { return Fields.Domain.CreateSearchClause(op, value); }
            public static ISearchClause ParamName(StringField.Condition op, System.String value) { return Fields.ParamName.CreateSearchClause(op, value); }
            public static ISearchClause ParamValue(StringField.Condition op, System.String value) { return Fields.ParamValue.CreateSearchClause(op, value); }
            public static ISearchClause Job(ObjectField<Job>.Condition op, Job value) { return Fields.Job.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<AdditionalParameter> Search(AdditionalParameter.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.AdditionalParameter, Connection.Action.Search, ref paramList, AdditionalParameter.CreateFromDataStore, out results);
            return results.ConvertAll<AdditionalParameter>(BasicObject.ConvertFromIObject<AdditionalParameter>);
        }
		

        /// <summary>
        /// Saves the AdditionalParameter object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Domain", Parameter.ParamType.String, Parameter.ParamDirection.In, this.domain));

            mydata.Add(new Parameter("ParamName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.paramname));

            mydata.Add(new Parameter("ParamValue", Parameter.ParamType.String, Parameter.ParamDirection.In, this.paramvalue));

            mydata.Add(new Parameter("JobID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.jobID == Guid.Empty ?
                (this.Job == null ? Guid.Empty : ((IObject)this.Job).ID)
                : this.jobID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the AdditionalParameter and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<AdditionalParameter> updPipe = new PipelineParameter<AdditionalParameter>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Job job)
            {
                this.job=job;

            }

            public IObject CopyTo(Connection target, AdditionalParameter additionalparameter)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Domain", Parameter.ParamType.String, Parameter.ParamDirection.In, additionalparameter.domain));
                 mydata.Add(new Parameter("ParamName", Parameter.ParamType.String, Parameter.ParamDirection.In, additionalparameter.paramname));
                 mydata.Add(new Parameter("ParamValue", Parameter.ParamType.String, Parameter.ParamDirection.In, additionalparameter.paramvalue));
			     mydata.Add(new Parameter("JobID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.job == null ? Guid.Empty : ((IObject)this.job).ID)));

                PipelineParameter<AdditionalParameter> pipe = new PipelineParameter<AdditionalParameter>(CreateFromDataStore);
                IObject newObj = additionalparameter.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Job job;

        }
        
       
    }
}
