/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Artifacts that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Artifact collection</typeparam>
    public class ArtifactCollection<O> : SyncCollection<O, Artifact>
        where O : IObject
    {
        public ArtifactCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Artifact>.DelayLoadCallback(ArtifactCollection_OnDelayLoad);
        }

        public ArtifactCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Artifact>.DelayLoadCallback(ArtifactCollection_OnDelayLoadRef);
        }

        List<Artifact> ArtifactCollection_OnDelayLoad(Connection c)
        {
            return Artifact.LoadAll(this.Owner, c);
        }

        List<Artifact> ArtifactCollection_OnDelayLoadRef(Connection c)
        {
            return Artifact.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ArtifactCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ArtifactCollection<O> objList = new ArtifactCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ArtifactCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            ArtifactCollection<O> objList = new ArtifactCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Artifact
    /// </summary>
    [Serializable]
    public partial class Artifact : NamedObject<Artifact>
    {
        private System.Int32 position;
        private RegistryDataType fieldtype;
        private Direction direction;
        private Guid methodID;
        private Method method;
        

        /// <summary>
        /// Description of the Artifact
        /// </summary>
        public System.Int32 Position
        {
            get { return position; }
            set
            {
                position = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Artifact
        /// </summary>
        public RegistryDataType FieldType
        {
            get { return fieldtype; }
            set
            {
                fieldtype = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Artifact
        /// </summary>
        public Direction Direction
        {
            get { return direction; }
            set
            {
                direction = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Method Method
        {
            get
            {
                lock (this)
                {
                    if (method == null && methodID != Guid.Empty)
                        method = Method.Load(methodID, Conn);
                }
                return method;
            }

            set
            {
                lock (this)
                {
                    method = value;                   
                    methodID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Artifact(Connection c)
            : base(SRStorage.Artifact, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static Artifact Create(string name, System.Int32 position, RegistryDataType fieldtype, Direction direction, Method method, Connection c)
        {
            Artifact newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.position = position;
            newObj.fieldtype = fieldtype;
            newObj.direction = direction;
            newObj.method = method;

			

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Artifact Load(string name, Connection c)
        {
            return NamedObject<Artifact>.Load(name, c, Artifact.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Artifact object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Artifact object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Artifact loadObj = (Artifact)NamedObject<Artifact>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Artifact loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Artifact>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Position");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.position = val;
            }

            index = reader.GetOrdinal("FieldType");
            if (!reader.IsDBNull(index))
                loadObj.fieldtype = (RegistryDataType)Enum.Parse(typeof(RegistryDataType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Direction");
            if (!reader.IsDBNull(index))
                loadObj.direction = (Direction)Enum.Parse(typeof(Direction), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("MethodID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.methodID = val;
            }


            //
            // Object connections
            //

        }

        public static Artifact Load(Guid id, Connection c)
        {
            return Load<Artifact>(id, c, Artifact.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Artifacts from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Artifacts in the system</returns>
        public static List<Artifact> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Artifact>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Artifact)], 
                Artifact.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Artifacts that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Artifacts</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Artifact> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Artifact>(owner, Artifact.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Artifacts that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Artifacts</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Artifact> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Artifact>(owner, src, Artifact.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Artifacts by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Artifacts that match the criteria</returns>
        public static List<Artifact> Search(string text, Connection c)
        {
            return LoadAll<Artifact>(Connection.Action.Search, text, Artifact.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.IntegerField Position = new FieldDefs.IntegerField("Position");
                public static FieldDefs.EnumField<RegistryDataType> FieldType = new FieldDefs.EnumField<RegistryDataType>("FieldType");
                public static FieldDefs.EnumField<Direction> Direction = new FieldDefs.EnumField<Direction>("Direction");
                public static FieldDefs.ObjectField<Method> Method = new FieldDefs.ObjectField<Method>("Method");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Position(IntegerField.Condition op, System.Int32 value) { return Fields.Position.CreateSearchClause(op, value); }
            public static ISearchClause FieldType(EnumField<RegistryDataType>.Condition op, RegistryDataType value) { return Fields.FieldType.CreateSearchClause(op, value); }
            public static ISearchClause Direction(EnumField<Direction>.Condition op, Direction value) { return Fields.Direction.CreateSearchClause(op, value); }
            public static ISearchClause Method(ObjectField<Method>.Condition op, Method value) { return Fields.Method.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Artifact> Search(Artifact.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Artifact, Connection.Action.Search, ref paramList, Artifact.CreateFromDataStore, out results);
            return results.ConvertAll<Artifact>(BasicObject.ConvertFromIObject<Artifact>);
        }
		

        /// <summary>
        /// Saves the Artifact object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.position));

            mydata.Add(new Parameter("FieldType", Parameter.ParamType.String, Parameter.ParamDirection.In, this.fieldtype.ToString()));
            mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, this.direction.ToString()));
            mydata.Add(new Parameter("MethodID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.methodID == Guid.Empty ?
                (this.Method == null ? Guid.Empty : ((IObject)this.Method).ID)
                : this.methodID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Artifact and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Artifact> updPipe = new PipelineParameter<Artifact>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Method method)
            {
                this.method=method;

            }

            public IObject CopyTo(Connection target, Artifact artifact)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, artifact.position));
                 mydata.Add(new Parameter("FieldType", Parameter.ParamType.String, Parameter.ParamDirection.In, artifact.fieldtype.ToString()));
                 mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, artifact.direction.ToString()));
			     mydata.Add(new Parameter("MethodID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.method == null ? Guid.Empty : ((IObject)this.method).ID)));

                PipelineParameter<Artifact> pipe = new PipelineParameter<Artifact>(CreateFromDataStore);
                IObject newObj = artifact.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Method method;

        } 
        
              
    }
}
