/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the AssemblyDeployActions that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the AssemblyDeployAction collection</typeparam>
    public class AssemblyDeployActionCollection<O> : SyncCollection<O, AssemblyDeployAction>
        where O : IObject
    {
        public AssemblyDeployActionCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyDeployAction>.DelayLoadCallback(AssemblyDeployActionCollection_OnDelayLoad);
        }

        public AssemblyDeployActionCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyDeployAction>.DelayLoadCallback(AssemblyDeployActionCollection_OnDelayLoadRef);
        }

        List<AssemblyDeployAction> AssemblyDeployActionCollection_OnDelayLoad(Connection c)
        {
            return AssemblyDeployAction.LoadAll(this.Owner, c);
        }

        List<AssemblyDeployAction> AssemblyDeployActionCollection_OnDelayLoadRef(Connection c)
        {
            return AssemblyDeployAction.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static AssemblyDeployActionCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            AssemblyDeployActionCollection<O> objList = new AssemblyDeployActionCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static AssemblyDeployActionCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            AssemblyDeployActionCollection<O> objList = new AssemblyDeployActionCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// AssemblyDeployAction
    /// </summary>
    [Serializable]
    public partial class AssemblyDeployAction : BasicObject
    {
        private System.String foldertocopy;
        private Action deployaction;
        private Guid assemblyID;
        private AssemblyImage assembly;
        

        /// <summary>
        /// Description of the AssemblyDeployAction
        /// </summary>
        public System.String FolderToCopy
        {
            get { return foldertocopy; }
            set
            {
                foldertocopy = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyDeployAction
        /// </summary>
        public Action DeployAction
        {
            get { return deployaction; }
            set
            {
                deployaction = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public AssemblyImage Assembly
        {
            get
            {
                lock (this)
                {
                    if (assembly == null && assemblyID != Guid.Empty)
                        assembly = AssemblyImage.Load(assemblyID, Conn);
                }
                return assembly;
            }

            set
            {
                lock (this)
                {
                    assembly = value;                   
                    assemblyID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public AssemblyDeployAction(Connection c)
            : base(SRStorage.AssemblyDeployAction, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static AssemblyDeployAction Create(AssemblyImage assembly, Connection c)
        {
            AssemblyDeployAction newObj = new AssemblyDeployAction(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.assembly = assembly;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a AssemblyDeployAction object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>AssemblyDeployAction object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            AssemblyDeployAction loadObj = new AssemblyDeployAction(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(AssemblyDeployAction loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("FolderToCopy");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.foldertocopy = val;
            }

            index = reader.GetOrdinal("DeployAction");
            if (!reader.IsDBNull(index))
                loadObj.deployaction = (Action)Enum.Parse(typeof(Action), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("AssemblyID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.assemblyID = val;
            }


            //
            // Object connections
            //

        }

        public static AssemblyDeployAction Load(Guid id, Connection c)
        {
            return Load<AssemblyDeployAction>(id, c, AssemblyDeployAction.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL AssemblyDeployActions from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all AssemblyDeployActions in the system</returns>
        public static List<AssemblyDeployAction> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<AssemblyDeployAction>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(AssemblyDeployAction)], 
                AssemblyDeployAction.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all AssemblyDeployActions that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyDeployActions</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<AssemblyDeployAction> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<AssemblyDeployAction>(owner, AssemblyDeployAction.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all AssemblyDeployActions that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyDeployActions</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<AssemblyDeployAction> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<AssemblyDeployAction>(owner, src, AssemblyDeployAction.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches AssemblyDeployActions by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of AssemblyDeployActions that match the criteria</returns>
        public static List<AssemblyDeployAction> Search(string text, Connection c)
        {
            return LoadAll<AssemblyDeployAction>(Connection.Action.Search, text, AssemblyDeployAction.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField FolderToCopy = new FieldDefs.StringField("FolderToCopy");
                public static FieldDefs.EnumField<Action> DeployAction = new FieldDefs.EnumField<Action>("DeployAction");
                public static FieldDefs.ObjectField<AssemblyImage> Assembly = new FieldDefs.ObjectField<AssemblyImage>("Assembly");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause FolderToCopy(StringField.Condition op, System.String value) { return Fields.FolderToCopy.CreateSearchClause(op, value); }
            public static ISearchClause DeployAction(EnumField<Action>.Condition op, Action value) { return Fields.DeployAction.CreateSearchClause(op, value); }
            public static ISearchClause Assembly(ObjectField<AssemblyImage>.Condition op, AssemblyImage value) { return Fields.Assembly.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<AssemblyDeployAction> Search(AssemblyDeployAction.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.AssemblyDeployAction, Connection.Action.Search, ref paramList, AssemblyDeployAction.CreateFromDataStore, out results);
            return results.ConvertAll<AssemblyDeployAction>(BasicObject.ConvertFromIObject<AssemblyDeployAction>);
        }
		

        /// <summary>
        /// Saves the AssemblyDeployAction object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("FolderToCopy", Parameter.ParamType.String, Parameter.ParamDirection.In, this.foldertocopy));

            mydata.Add(new Parameter("DeployAction", Parameter.ParamType.String, Parameter.ParamDirection.In, this.deployaction.ToString()));
            mydata.Add(new Parameter("AssemblyID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.assemblyID == Guid.Empty ?
                (this.Assembly == null ? Guid.Empty : ((IObject)this.Assembly).ID)
                : this.assemblyID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the AssemblyDeployAction and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<AssemblyDeployAction> updPipe = new PipelineParameter<AssemblyDeployAction>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(AssemblyImage assembly)
            {
                this.assembly=assembly;

            }

            public IObject CopyTo(Connection target, AssemblyDeployAction assemblydeployaction)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("FolderToCopy", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblydeployaction.foldertocopy));
                 mydata.Add(new Parameter("DeployAction", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblydeployaction.deployaction.ToString()));
			     mydata.Add(new Parameter("AssemblyID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.assembly == null ? Guid.Empty : ((IObject)this.assembly).ID)));

                PipelineParameter<AssemblyDeployAction> pipe = new PipelineParameter<AssemblyDeployAction>(CreateFromDataStore);
                IObject newObj = assemblydeployaction.SaveTo(mydata, store, pipe);

                return newObj;
            }

            AssemblyImage assembly;

        }
        
       
    }
}
