/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the AssemblyImages that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the AssemblyImage collection</typeparam>
    public class AssemblyImageCollection<O> : SyncCollection<O, AssemblyImage>
        where O : IObject
    {
        public AssemblyImageCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyImage>.DelayLoadCallback(AssemblyImageCollection_OnDelayLoad);
        }

        public AssemblyImageCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyImage>.DelayLoadCallback(AssemblyImageCollection_OnDelayLoadRef);
        }

        List<AssemblyImage> AssemblyImageCollection_OnDelayLoad(Connection c)
        {
            return AssemblyImage.LoadAll(this.Owner, c);
        }

        List<AssemblyImage> AssemblyImageCollection_OnDelayLoadRef(Connection c)
        {
            return AssemblyImage.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static AssemblyImageCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            AssemblyImageCollection<O> objList = new AssemblyImageCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static AssemblyImageCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            AssemblyImageCollection<O> objList = new AssemblyImageCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// AssemblyImage
    /// </summary>
    [Serializable]
    public partial class AssemblyImage : NamedObject<AssemblyImage>
    {
        private System.String filename;
        private System.DateTime filecreatedate;
        private System.DateTime filemodifydate;
        private System.String fileextension;
        private System.String checksum;
        private System.Boolean isdeleted;
        private System.Boolean isactivitydll;
        private System.Byte[] contents;
        private bool contentsLoaded = false;
        private bool contentsChanged = false;
        private System.Int32 contentssize;
        private System.Int32 version;
        private AssemblyType type;
        private Guid safeparentversionID;
        private AssemblyImage safeparentversion;
        
        private AssemblyPackageCollection<AssemblyImage> assemblypackages;
        private AssemblyImageVersionCollection<AssemblyImage> newerversions;
        private AssemblyImageVersionCollection<AssemblyImage> olderversions;
        private AssemblyImageCollection<AssemblyImage> safechildversions;
        private AssemblyImageContentsBlobCollection<AssemblyImage> contentsstores;
        private AssemblyDeployActionCollection<AssemblyImage> deployactions;

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.String Filename
        {
            get { return filename; }
            set
            {
                filename = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.DateTime FileCreateDate
        {
            get { return filecreatedate; }
            set
            {
                filecreatedate = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.DateTime FileModifyDate
        {
            get { return filemodifydate; }
            set
            {
                filemodifydate = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.String FileExtension
        {
            get { return fileextension; }
            set
            {
                fileextension = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.String Checksum
        {
            get { return checksum; }
            set
            {
                checksum = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.Boolean IsActivityDll
        {
            get { return isactivitydll; }
            set
            {
                isactivitydll = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public BlobBase.TransferProgressHandler OnContentsTransfer;

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public BlobBase.BeginClearStoreProgressHandler OnContentsClearBegin;

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public BlobBase.EndClearStoreProgressHandler OnContentsClearEnd;

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.Byte[] Contents
        {
            get 
            { 
                if (contentsLoaded)
                {
                    // Uses cached version
                    return contents;
                }
                
                System.IO.Stream bStream = null;
				
				//
                // Load from BLOB storage
                //
                contents = null;
                contentsLoaded = true;

                int count = this.ContentsStores.Count;

                if (count == 0)
                    return null;

                List<IBlob> list = new List<IBlob>();
                foreach (AssemblyImageContentsBlob blob in this.ContentsStores)
                {
                    list.Add(blob);
                }
                
                bStream = BlobBase.FetchBlobs<AssemblyImageContentsBlob, List<IBlob>>(list);

                contents = BlobBase.StreamToByteArray(bStream);

                bStream.Close();
                
                return contents;
            }
            set
            {
				contents = value;
                contentsLoaded = true;
                contentsChanged = true;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.Int32 ContentsSize
        {
            get { return contentssize; }
            set
            {
                contentssize = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public System.Int32 Version
        {
            get { return version; }
            set
            {
                version = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImage
        /// </summary>
        public AssemblyType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        protected AssemblyImage SafeParentVersion
        {
            get
            {
                lock (this)
                {
                    if (safeparentversion == null && safeparentversionID != Guid.Empty)
                        safeparentversion = AssemblyImage.Load(safeparentversionID, Conn);
                }
                return safeparentversion;
            }

            set
            {
                lock (this)
                {
                    safeparentversion = value;                   
                    safeparentversionID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public AssemblyPackageCollection<AssemblyImage> AssemblyPackages { get { return assemblypackages; } }
        public AssemblyImageVersionCollection<AssemblyImage> NewerVersions { get { return newerversions; } }
        public AssemblyImageVersionCollection<AssemblyImage> OlderVersions { get { return olderversions; } }
        protected AssemblyImageCollection<AssemblyImage> SafeChildVersions { get { return safechildversions; } }
        protected AssemblyImageContentsBlobCollection<AssemblyImage> ContentsStores { get { return contentsstores; } }
        public AssemblyDeployActionCollection<AssemblyImage> DeployActions { get { return deployactions; } }

		/// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public  AssemblyImage CreateNewVersion(Connection c)
        {
            foreach (AssemblyImageVersion ver in this.NewerVersions)
            {
                if(ver.Type == VersionRelationshipType.Concrete)
                    throw new BindVersionViolation("You cannot have branches in the 'concrete' tree. To have more than 1 child use 'contributions' instead");
            }

            AssemblyImage newObj = new AssemblyImage(Conn);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            // Version binding
            newObj.safeparentversion = this;
            
            // Copying the older version to the new
            newObj.filename = this.filename;
            newObj.filecreatedate = this.filecreatedate;
            newObj.filemodifydate = this.filemodifydate;
            newObj.fileextension = this.fileextension;
            newObj.checksum = this.checksum;
            newObj.isdeleted = this.isdeleted;
            newObj.isactivitydll = this.isactivitydll;
            newObj.contentssize = this.contentssize;
            newObj.version = this.version;
            newObj.type = this.type;
            
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<AssemblyImage>(newObj, c);
            newObj.newerversions = new AssemblyImageVersionCollection<AssemblyImage>(newObj, "NewerVersion", "OlderVersion", "AssemblyImage_1", c);
            newObj.olderversions = new AssemblyImageVersionCollection<AssemblyImage>(newObj, "OlderVersion", "NewerVersion", "AssemblyImage_2", c);
            newObj.safechildversions = new AssemblyImageCollection<AssemblyImage>(newObj, "SafeParentVersion", "SafeChildVersion", c);
            newObj.contentsstores = new AssemblyImageContentsBlobCollection<AssemblyImage>(newObj, "AssemblyImage", "ContentsStore", c);
            newObj.deployactions = new AssemblyDeployActionCollection<AssemblyImage>(newObj, "Assembly", "DeployAction", c);
			
			if(this is INamedObject)
			{
				newObj.Name = this.Name;
			}
			
            newObj.version += 1;
            newObj.OnConstructor();

            if (Conn.AutoSave)
            {
                newObj.Save();
                
	            // Version binding
		        AssemblyImageVersion versionInfo = AssemblyImageVersion.Create(this, newObj, VersionRelationshipType.Concrete, Conn);
			    this.NewerVersions.Add(versionInfo);
			}

            return newObj;
        }

        /// <summary>
        /// Binds an object with another
        /// </summary>
        public void BindVersion(AssemblyImage other, VersionRelationshipType kind)
        {
            if (kind == VersionRelationshipType.Concrete)
                throw new BindVersionViolation("The only way to bind a concrete version is to call AssemblyImage.CreateNewVersion(...) method");

            AssemblyImageVersion versionInfo = AssemblyImageVersion.Create(this, other, kind, this.Conn);
            this.NewerVersions.Add(versionInfo);
        }
        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public AssemblyImage(Connection c)
            : base(SRStorage.AssemblyImage, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static AssemblyImage Create(string name, AssemblyType type, Connection c)
        {
            AssemblyImage newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;

			
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<AssemblyImage>(newObj, c);
            newObj.newerversions = new AssemblyImageVersionCollection<AssemblyImage>(newObj, "NewerVersion", "OlderVersion", "AssemblyImage_1", c);
            newObj.olderversions = new AssemblyImageVersionCollection<AssemblyImage>(newObj, "OlderVersion", "NewerVersion", "AssemblyImage_2", c);
            newObj.safechildversions = new AssemblyImageCollection<AssemblyImage>(newObj, "SafeParentVersion", "SafeChildVersion", c);
            newObj.contentsstores = new AssemblyImageContentsBlobCollection<AssemblyImage>(newObj, "AssemblyImage", "ContentsStore", c);
            newObj.deployactions = new AssemblyDeployActionCollection<AssemblyImage>(newObj, "Assembly", "DeployAction", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static AssemblyImage Load(string name, Connection c)
        {
            return NamedObject<AssemblyImage>.Load(name, c, AssemblyImage.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a AssemblyImage object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>AssemblyImage object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            AssemblyImage loadObj = (AssemblyImage)NamedObject<AssemblyImage>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(AssemblyImage loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<AssemblyImage>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Filename");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.filename = val;
            }

            index = reader.GetOrdinal("FileCreateDate");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.filecreatedate = val;
            }

            index = reader.GetOrdinal("FileModifyDate");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.filemodifydate = val;
            }

            index = reader.GetOrdinal("FileExtension");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.fileextension = val;
            }

            index = reader.GetOrdinal("Checksum");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.checksum = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("IsActivityDll");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isactivitydll = val;
            }

            index = reader.GetOrdinal("ContentsSize");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.contentssize = val;
            }

            index = reader.GetOrdinal("Version");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.version = val;
            }

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (AssemblyType)Enum.Parse(typeof(AssemblyType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("SafeParentVersionID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.safeparentversionID = val;
            }


            //
            // Object connections
            //

            // AssemblyPackages
            loadObj.assemblypackages = AssemblyPackageCollection<AssemblyImage>.CreateFromReader(loadObj, reader, c);
            // NewerVersions
            loadObj.newerversions = AssemblyImageVersionCollection<AssemblyImage>.CreateFromReader(loadObj, "NewerVersion", "OlderVersion", "AssemblyImage_1", reader, c);
            // OlderVersions
            loadObj.olderversions = AssemblyImageVersionCollection<AssemblyImage>.CreateFromReader(loadObj, "OlderVersion", "NewerVersion", "AssemblyImage_2", reader, c);
            // SafeChildVersions
            loadObj.safechildversions = AssemblyImageCollection<AssemblyImage>.CreateFromReader(loadObj, "SafeParentVersion", "SafeChildVersion", reader, c);
            // ContentsStores
            loadObj.contentsstores = AssemblyImageContentsBlobCollection<AssemblyImage>.CreateFromReader(loadObj, "AssemblyImage", "ContentsStore", reader, c);
            // DeployActions
            loadObj.deployactions = AssemblyDeployActionCollection<AssemblyImage>.CreateFromReader(loadObj, "Assembly", "DeployAction", reader, c);
        }

        public static AssemblyImage Load(Guid id, Connection c)
        {
            return Load<AssemblyImage>(id, c, AssemblyImage.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL AssemblyImages from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all AssemblyImages in the system</returns>
        public static List<AssemblyImage> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<AssemblyImage>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(AssemblyImage)], 
                AssemblyImage.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all AssemblyImages that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyImages</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<AssemblyImage> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<AssemblyImage>(owner, AssemblyImage.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all AssemblyImages that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyImages</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<AssemblyImage> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<AssemblyImage>(owner, src, AssemblyImage.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches AssemblyImages by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of AssemblyImages that match the criteria</returns>
        public static List<AssemblyImage> Search(string text, Connection c)
        {
            return LoadAll<AssemblyImage>(Connection.Action.Search, text, AssemblyImage.CreateFromDataStore, c);
        }

        private void SaveContentsBlob(Connection c)
        {
            if (!this.contentsChanged)
			   return;
			   
            // Clear previous version
            foreach (AssemblyImageContentsBlob b in this.ContentsStores)
            {
                b.Delete();
            }

			// Notify begin of store clear
			BlobBase.FireOnAnyBeginClearStore(this, "Contents", c);
			if (OnContentsClearBegin != null)
				OnContentsClearBegin(this, "Contents", c);

            this.ContentsStores.Refresh();
            this.ContentsStores.Clear();

			// Notify end of store clear
			if (OnContentsClearEnd != null)
				OnContentsClearEnd(this, "Contents", c);
			BlobBase.FireOnAnyEndClearStore(this, "Contents", c);

            // Reset changed bit
            this.contentsChanged = false;
            
            // Save the size (starts with 0)
            this.contentssize = 0;
            
            if (contents == null)
                return;

            // Serialize image and save to store
            byte[] __cnv_contents = contents;
            this.contentssize = __cnv_contents.Length;
            List<AssemblyImageContentsBlob> contentsBlobs = BlobBase.SaveBlobs<AssemblyImageContentsBlob, AssemblyImage>(this, contents, "Contents", __cnv_contents, 
				CreateContentsBlob, OnContentsTransfer, c);
            this.ContentsStores.Load(contentsBlobs);
            
            // Update cache size
            Save();
        }

        public static AssemblyImageContentsBlob CreateContentsBlob(Guid streamId, int index, int total, Guid revisionId, AssemblyImage src, Connection c)
        {
            return AssemblyImageContentsBlob.Create(streamId, index, total, revisionId, src, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationObjectField<T> : ER.RelationObjectField<T>
                    where T : IObject
                {
                    internal  RelationObjectField(string myName, string objectName, RelationshipType relType)
					: base(myName, objectName,  relType)
        
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Filename = new FieldDefs.StringField("Filename");
                public static FieldDefs.DateTimeField FileCreateDate = new FieldDefs.DateTimeField("FileCreateDate");
                public static FieldDefs.DateTimeField FileModifyDate = new FieldDefs.DateTimeField("FileModifyDate");
                public static FieldDefs.StringField FileExtension = new FieldDefs.StringField("FileExtension");
                public static FieldDefs.StringField Checksum = new FieldDefs.StringField("Checksum");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.BooleanField IsActivityDll = new FieldDefs.BooleanField("IsActivityDll");
                public static FieldDefs.IntegerField ContentsSize = new FieldDefs.IntegerField("ContentsSize");
                public static FieldDefs.IntegerField Version = new FieldDefs.IntegerField("Version");
                public static FieldDefs.EnumField<AssemblyType> Type = new FieldDefs.EnumField<AssemblyType>("Type");
                public static FieldDefs.ObjectField<AssemblyImage> SafeParentVersion = new FieldDefs.ObjectField<AssemblyImage>("SafeParentVersion");
                public static FieldDefs.RelationSimpleField<AssemblyPackage> AssemblyPackage = new FieldDefs.RelationSimpleField<AssemblyPackage>("AssemblyPackage", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationObjectField<AssemblyImage> NewerVersion = new FieldDefs.RelationObjectField<AssemblyImage>("NewerVersion", "AssemblyImageAssemblyImageVersions", RelationFieldBase.RelationshipType.Parent);
                public static FieldDefs.RelationObjectField<AssemblyImage> OlderVersion = new FieldDefs.RelationObjectField<AssemblyImage>("OlderVersion", "AssemblyImageAssemblyImageVersions", RelationFieldBase.RelationshipType.Child);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Filename(StringField.Condition op, System.String value) { return Fields.Filename.CreateSearchClause(op, value); }
            public static ISearchClause FileCreateDate(DateTimeField.Condition op, System.DateTime value) { return Fields.FileCreateDate.CreateSearchClause(op, value); }
            public static ISearchClause FileModifyDate(DateTimeField.Condition op, System.DateTime value) { return Fields.FileModifyDate.CreateSearchClause(op, value); }
            public static ISearchClause FileExtension(StringField.Condition op, System.String value) { return Fields.FileExtension.CreateSearchClause(op, value); }
            public static ISearchClause Checksum(StringField.Condition op, System.String value) { return Fields.Checksum.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause IsActivityDll(BooleanField.Condition op, System.Boolean value) { return Fields.IsActivityDll.CreateSearchClause(op, value); }
            public static ISearchClause ContentsSize(IntegerField.Condition op, System.Int32 value) { return Fields.ContentsSize.CreateSearchClause(op, value); }
            public static ISearchClause Version(IntegerField.Condition op, System.Int32 value) { return Fields.Version.CreateSearchClause(op, value); }
            public static ISearchClause Type(EnumField<AssemblyType>.Condition op, AssemblyType value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause SafeParentVersion(ObjectField<AssemblyImage>.Condition op, AssemblyImage value) { return Fields.SafeParentVersion.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyPackage(RelationSimpleField<AssemblyPackage>.Condition op, AssemblyPackage value) { return Fields.AssemblyPackage.CreateSearchClause(op, value); }
            public static ISearchClause NewerVersion (RelationObjectField<AssemblyImage>.Condition op, AssemblyImage value) { return Fields.NewerVersion.CreateSearchClause(op, value); }
            public static ISearchClause OlderVersion (RelationObjectField<AssemblyImage>.Condition op, AssemblyImage value) { return Fields.OlderVersion.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<AssemblyImage> Search(AssemblyImage.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.AssemblyImage, Connection.Action.Search, ref paramList, AssemblyImage.CreateFromDataStore, out results);
            return results.ConvertAll<AssemblyImage>(BasicObject.ConvertFromIObject<AssemblyImage>);
        }
		

        /// <summary>
        /// Saves the AssemblyImage object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Filename", Parameter.ParamType.String, Parameter.ParamDirection.In, this.filename));

            mydata.Add(new Parameter("FileCreateDate", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.filecreatedate));

            mydata.Add(new Parameter("FileModifyDate", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.filemodifydate));

            mydata.Add(new Parameter("FileExtension", Parameter.ParamType.String, Parameter.ParamDirection.In, this.fileextension));

            mydata.Add(new Parameter("Checksum", Parameter.ParamType.String, Parameter.ParamDirection.In, this.checksum));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("IsActivityDll", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isactivitydll));

            mydata.Add(new Parameter("ContentsSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.contentssize));

            mydata.Add(new Parameter("Version", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.version));

            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
            mydata.Add(new Parameter("SafeParentVersionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.safeparentversionID == Guid.Empty ?
                (this.SafeParentVersion == null ? Guid.Empty : ((IObject)this.SafeParentVersion).ID)
                : this.safeparentversionID)));
            
            Save(mydata);
            
            SaveContentsBlob(store);

        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the AssemblyImage and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<AssemblyImage> updPipe = new PipelineParameter<AssemblyImage>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.assemblypackages.Refresh();
            this.newerversions.Refresh();
            this.olderversions.Refresh();
            this.safechildversions.Refresh();
            this.contentsstores.Refresh();
            this.deployactions.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.assemblypackages.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(AssemblyImage safeparentversion)
            {
                this.safeparentversion=safeparentversion;

            }

            public IObject CopyTo(Connection target, AssemblyImage assemblyimage)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Filename", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblyimage.filename));
                 mydata.Add(new Parameter("FileCreateDate", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, assemblyimage.filecreatedate));
                 mydata.Add(new Parameter("FileModifyDate", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, assemblyimage.filemodifydate));
                 mydata.Add(new Parameter("FileExtension", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblyimage.fileextension));
                 mydata.Add(new Parameter("Checksum", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblyimage.checksum));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, assemblyimage.isdeleted));
                 mydata.Add(new Parameter("IsActivityDll", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, assemblyimage.isactivitydll));
                 mydata.Add(new Parameter("ContentsSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, assemblyimage.contentssize));
                 mydata.Add(new Parameter("Version", Parameter.ParamType.Int, Parameter.ParamDirection.In, assemblyimage.version));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblyimage.type.ToString()));
			     mydata.Add(new Parameter("SafeParentVersionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.safeparentversion == null ? Guid.Empty : ((IObject)this.safeparentversion).ID)));

                PipelineParameter<AssemblyImage> pipe = new PipelineParameter<AssemblyImage>(CreateFromDataStore);
                IObject newObj = assemblyimage.SaveTo(mydata, store, pipe);
                 assemblyimage.SaveContentsBlob(store);

                return newObj;
            }

            AssemblyImage safeparentversion;

        } 
        
              
    }
}
