/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the AssemblyImageContentsBlobs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the AssemblyImageContentsBlob collection</typeparam>
    public class AssemblyImageContentsBlobCollection<O> : SyncCollection<O, AssemblyImageContentsBlob>
        where O : IObject
    {
        public AssemblyImageContentsBlobCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyImageContentsBlob>.DelayLoadCallback(AssemblyImageContentsBlobCollection_OnDelayLoad);
        }

        public AssemblyImageContentsBlobCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyImageContentsBlob>.DelayLoadCallback(AssemblyImageContentsBlobCollection_OnDelayLoadRef);
        }

        List<AssemblyImageContentsBlob> AssemblyImageContentsBlobCollection_OnDelayLoad(Connection c)
        {
            return AssemblyImageContentsBlob.LoadAll(this.Owner, c);
        }

        List<AssemblyImageContentsBlob> AssemblyImageContentsBlobCollection_OnDelayLoadRef(Connection c)
        {
            return AssemblyImageContentsBlob.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static AssemblyImageContentsBlobCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            AssemblyImageContentsBlobCollection<O> objList = new AssemblyImageContentsBlobCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static AssemblyImageContentsBlobCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            AssemblyImageContentsBlobCollection<O> objList = new AssemblyImageContentsBlobCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// AssemblyImageContentsBlob
    /// </summary>
    [Serializable]
    public partial class AssemblyImageContentsBlob : BasicObject, IBlob
    {
        private System.Guid packageid;
        private System.Int32 index;
        private System.Int32 chunks;
        private System.String contents;
        private System.Guid revisionid;
        private Guid assemblyimageID;
        private AssemblyImage assemblyimage;
        private Guid previousID;
        private AssemblyImageContentsBlob previous;
        private Guid nextID;
        private AssemblyImageContentsBlob next;
        

        /// <summary>
        /// Description of the AssemblyImageContentsBlob
        /// </summary>
        public System.Guid PackageID
        {
            get { return packageid; }
            set
            {
                packageid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImageContentsBlob
        /// </summary>
        public System.Int32 Index
        {
            get { return index; }
            set
            {
                index = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImageContentsBlob
        /// </summary>
        public System.Int32 Chunks
        {
            get { return chunks; }
            set
            {
                chunks = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImageContentsBlob
        /// </summary>
        public System.String Contents
        {
            get { return contents; }
            set
            {
                contents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyImageContentsBlob
        /// </summary>
        public System.Guid RevisionID
        {
            get { return revisionid; }
            set
            {
                revisionid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public AssemblyImage AssemblyImage
        {
            get
            {
                lock (this)
                {
                    if (assemblyimage == null && assemblyimageID != Guid.Empty)
                        assemblyimage = AssemblyImage.Load(assemblyimageID, Conn);
                }
                return assemblyimage;
            }

            set
            {
                lock (this)
                {
                    assemblyimage = value;                   
                    assemblyimageID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public AssemblyImageContentsBlob Previous
        {
            get
            {
                lock (this)
                {
                    if (previous == null && previousID != Guid.Empty)
                        previous = AssemblyImageContentsBlob.Load(previousID, Conn);
                }
                return previous;
            }

            set
            {
                lock (this)
                {
                    previous = value;                   
                    previousID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public AssemblyImageContentsBlob Next
        {
            get
            {
                lock (this)
                {
                    if (next == null && nextID != Guid.Empty)
                        next = AssemblyImageContentsBlob.Load(nextID, Conn);
                }
                return next;
            }

            set
            {
                lock (this)
                {
                    next = value;                   
                    nextID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public AssemblyImageContentsBlob(Connection c)
            : base(SRStorage.AssemblyImageContentsBlob, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static AssemblyImageContentsBlob Create(System.Guid packageid, System.Int32 index, System.Int32 chunks, System.Guid revisionid, AssemblyImage assemblyimage, Connection c)
        {
            AssemblyImageContentsBlob newObj = new AssemblyImageContentsBlob(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.packageid = packageid;
            newObj.index = index;
            newObj.chunks = chunks;
            newObj.revisionid = revisionid;
            newObj.assemblyimage = assemblyimage;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a AssemblyImageContentsBlob object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>AssemblyImageContentsBlob object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            AssemblyImageContentsBlob loadObj = new AssemblyImageContentsBlob(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(AssemblyImageContentsBlob loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("PackageID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.packageid = val;
            }

            index = reader.GetOrdinal("Index");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.index = val;
            }

            index = reader.GetOrdinal("Chunks");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.chunks = val;
            }

            index = reader.GetOrdinal("Contents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.contents = val;
            }

            index = reader.GetOrdinal("RevisionID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.revisionid = val;
            }

            index = reader.GetOrdinal("AssemblyImageID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.assemblyimageID = val;
            }

            index = reader.GetOrdinal("PreviousID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.previousID = val;
            }

            index = reader.GetOrdinal("NextID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.nextID = val;
            }


            //
            // Object connections
            //

        }

        public static AssemblyImageContentsBlob Load(Guid id, Connection c)
        {
            return Load<AssemblyImageContentsBlob>(id, c, AssemblyImageContentsBlob.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL AssemblyImageContentsBlobs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all AssemblyImageContentsBlobs in the system</returns>
        public static List<AssemblyImageContentsBlob> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<AssemblyImageContentsBlob>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(AssemblyImageContentsBlob)], 
                AssemblyImageContentsBlob.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all AssemblyImageContentsBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyImageContentsBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<AssemblyImageContentsBlob> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<AssemblyImageContentsBlob>(owner, AssemblyImageContentsBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all AssemblyImageContentsBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyImageContentsBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<AssemblyImageContentsBlob> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<AssemblyImageContentsBlob>(owner, src, AssemblyImageContentsBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches AssemblyImageContentsBlobs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of AssemblyImageContentsBlobs that match the criteria</returns>
        public static List<AssemblyImageContentsBlob> Search(string text, Connection c)
        {
            return LoadAll<AssemblyImageContentsBlob>(Connection.Action.Search, text, AssemblyImageContentsBlob.CreateFromDataStore, c);
        }



		

        /// <summary>
        /// Saves the AssemblyImageContentsBlob object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.packageid));

            mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.index));

            mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.chunks));

            mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, this.contents));

            mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.revisionid));

            mydata.Add(new Parameter("AssemblyImageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.assemblyimageID == Guid.Empty ?
                (this.AssemblyImage == null ? Guid.Empty : ((IObject)this.AssemblyImage).ID)
                : this.assemblyimageID)));
            mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.previousID == Guid.Empty ?
                (this.Previous == null ? Guid.Empty : ((IObject)this.Previous).ID)
                : this.previousID)));
            mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.nextID == Guid.Empty ?
                (this.Next == null ? Guid.Empty : ((IObject)this.Next).ID)
                : this.nextID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the AssemblyImageContentsBlob and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<AssemblyImageContentsBlob> updPipe = new PipelineParameter<AssemblyImageContentsBlob>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(AssemblyImage assemblyimage,AssemblyImageContentsBlob previous,AssemblyImageContentsBlob next)
            {
                this.assemblyimage=assemblyimage;
                this.previous=previous;
                this.next=next;

            }

            public IObject CopyTo(Connection target, AssemblyImageContentsBlob assemblyimagecontentsblob)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, assemblyimagecontentsblob.packageid));
                 mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, assemblyimagecontentsblob.index));
                 mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, assemblyimagecontentsblob.chunks));
                 mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblyimagecontentsblob.contents));
                 mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, assemblyimagecontentsblob.revisionid));
			     mydata.Add(new Parameter("AssemblyImageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.assemblyimage == null ? Guid.Empty : ((IObject)this.assemblyimage).ID)));
			     mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.previous == null ? Guid.Empty : ((IObject)this.previous).ID)));
			     mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.next == null ? Guid.Empty : ((IObject)this.next).ID)));

                PipelineParameter<AssemblyImageContentsBlob> pipe = new PipelineParameter<AssemblyImageContentsBlob>(CreateFromDataStore);
                IObject newObj = assemblyimagecontentsblob.SaveTo(mydata, store, pipe);

                return newObj;
            }

            AssemblyImage assemblyimage;
            AssemblyImageContentsBlob previous;
            AssemblyImageContentsBlob next;

        }
        
       
    }
}
