/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the AssemblyPackages that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the AssemblyPackage collection</typeparam>
    public class AssemblyPackageCollection<O> : SyncCollection<O, AssemblyPackage>
        where O : IObject
    {
        public AssemblyPackageCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyPackage>.DelayLoadCallback(AssemblyPackageCollection_OnDelayLoad);
        }

        public AssemblyPackageCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, AssemblyPackage>.DelayLoadCallback(AssemblyPackageCollection_OnDelayLoadRef);
        }

        List<AssemblyPackage> AssemblyPackageCollection_OnDelayLoad(Connection c)
        {
            return AssemblyPackage.LoadAll(this.Owner, c);
        }

        List<AssemblyPackage> AssemblyPackageCollection_OnDelayLoadRef(Connection c)
        {
            return AssemblyPackage.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static AssemblyPackageCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            AssemblyPackageCollection<O> objList = new AssemblyPackageCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static AssemblyPackageCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            AssemblyPackageCollection<O> objList = new AssemblyPackageCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// AssemblyPackage
    /// </summary>
    [Serializable]
    public partial class AssemblyPackage : NamedObject<AssemblyPackage>
    {
        private System.String label;
        private System.String description;
        private System.Boolean isdeleted;
        
        private ActivityCollection<AssemblyPackage> activitys;
        private TypeInitializerCollection<AssemblyPackage> typeinitializers;
        private AssemblyImageCollection<AssemblyPackage> assemblyimages;
        private DataReferenceProviderCollection<AssemblyPackage> datareferenceproviders;

        /// <summary>
        /// Description of the AssemblyPackage
        /// </summary>
        public System.String Label
        {
            get { return label; }
            set
            {
                label = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyPackage
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the AssemblyPackage
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public ActivityCollection<AssemblyPackage> Activitys { get { return activitys; } }
        public TypeInitializerCollection<AssemblyPackage> TypeInitializers { get { return typeinitializers; } }
        public AssemblyImageCollection<AssemblyPackage> AssemblyImages { get { return assemblyimages; } }
        public DataReferenceProviderCollection<AssemblyPackage> DataReferenceProviders { get { return datareferenceproviders; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public AssemblyPackage(Connection c)
            : base(SRStorage.AssemblyPackage, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new AssemblyPackage Create(string name, Connection c)
        {
            AssemblyPackage newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.activitys = new ActivityCollection<AssemblyPackage>(newObj, c);
            newObj.typeinitializers = new TypeInitializerCollection<AssemblyPackage>(newObj, c);
            newObj.assemblyimages = new AssemblyImageCollection<AssemblyPackage>(newObj, c);
            newObj.datareferenceproviders = new DataReferenceProviderCollection<AssemblyPackage>(newObj, c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static AssemblyPackage Load(string name, Connection c)
        {
            return NamedObject<AssemblyPackage>.Load(name, c, AssemblyPackage.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a AssemblyPackage object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>AssemblyPackage object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            AssemblyPackage loadObj = (AssemblyPackage)NamedObject<AssemblyPackage>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(AssemblyPackage loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<AssemblyPackage>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Label");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.label = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }


            //
            // Object connections
            //

            // Activitys
            loadObj.activitys = ActivityCollection<AssemblyPackage>.CreateFromReader(loadObj, reader, c);
            // TypeInitializers
            loadObj.typeinitializers = TypeInitializerCollection<AssemblyPackage>.CreateFromReader(loadObj, reader, c);
            // AssemblyImages
            loadObj.assemblyimages = AssemblyImageCollection<AssemblyPackage>.CreateFromReader(loadObj, reader, c);
            // DataReferenceProviders
            loadObj.datareferenceproviders = DataReferenceProviderCollection<AssemblyPackage>.CreateFromReader(loadObj, reader, c);
        }

        public static AssemblyPackage Load(Guid id, Connection c)
        {
            return Load<AssemblyPackage>(id, c, AssemblyPackage.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL AssemblyPackages from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all AssemblyPackages in the system</returns>
        public static List<AssemblyPackage> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<AssemblyPackage>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(AssemblyPackage)], 
                AssemblyPackage.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all AssemblyPackages that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyPackages</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<AssemblyPackage> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<AssemblyPackage>(owner, AssemblyPackage.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all AssemblyPackages that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the AssemblyPackages</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<AssemblyPackage> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<AssemblyPackage>(owner, src, AssemblyPackage.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches AssemblyPackages by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of AssemblyPackages that match the criteria</returns>
        public static List<AssemblyPackage> Search(string text, Connection c)
        {
            return LoadAll<AssemblyPackage>(Connection.Action.Search, text, AssemblyPackage.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Label = new FieldDefs.StringField("Label");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.RelationSimpleField<Activity> Activity = new FieldDefs.RelationSimpleField<Activity>("Activity", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<TypeInitializer> TypeInitializer = new FieldDefs.RelationSimpleField<TypeInitializer>("TypeInitializer", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<AssemblyImage> AssemblyImage = new FieldDefs.RelationSimpleField<AssemblyImage>("AssemblyImage", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<DataReferenceProvider> DataReferenceProvider = new FieldDefs.RelationSimpleField<DataReferenceProvider>("DataReferenceProvider", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Label(StringField.Condition op, System.String value) { return Fields.Label.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause Activity(RelationSimpleField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            public static ISearchClause TypeInitializer(RelationSimpleField<TypeInitializer>.Condition op, TypeInitializer value) { return Fields.TypeInitializer.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyImage(RelationSimpleField<AssemblyImage>.Condition op, AssemblyImage value) { return Fields.AssemblyImage.CreateSearchClause(op, value); }
            public static ISearchClause DataReferenceProvider(RelationSimpleField<DataReferenceProvider>.Condition op, DataReferenceProvider value) { return Fields.DataReferenceProvider.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<AssemblyPackage> Search(AssemblyPackage.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.AssemblyPackage, Connection.Action.Search, ref paramList, AssemblyPackage.CreateFromDataStore, out results);
            return results.ConvertAll<AssemblyPackage>(BasicObject.ConvertFromIObject<AssemblyPackage>);
        }
		

        /// <summary>
        /// Saves the AssemblyPackage object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, this.label));

            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the AssemblyPackage and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<AssemblyPackage> updPipe = new PipelineParameter<AssemblyPackage>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.activitys.Refresh();
            this.typeinitializers.Refresh();
            this.assemblyimages.Refresh();
            this.datareferenceproviders.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.activitys.Clear();
            this.typeinitializers.Clear();
            this.assemblyimages.Clear();
            this.datareferenceproviders.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, AssemblyPackage assemblypackage)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, assemblypackage.label));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, assemblypackage.description));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, assemblypackage.isdeleted));

                PipelineParameter<AssemblyPackage> pipe = new PipelineParameter<AssemblyPackage>(CreateFromDataStore);
                IObject newObj = assemblypackage.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
