/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the DataProducts that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the DataProduct collection</typeparam>
    public class DataProductCollection<O> : SyncCollection<O, DataProduct>
        where O : IObject
    {
        public DataProductCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProduct>.DelayLoadCallback(DataProductCollection_OnDelayLoad);
        }

        public DataProductCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProduct>.DelayLoadCallback(DataProductCollection_OnDelayLoadRef);
        }

        List<DataProduct> DataProductCollection_OnDelayLoad(Connection c)
        {
            return DataProduct.LoadAll(this.Owner, c);
        }

        List<DataProduct> DataProductCollection_OnDelayLoadRef(Connection c)
        {
            return DataProduct.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static DataProductCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            DataProductCollection<O> objList = new DataProductCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static DataProductCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            DataProductCollection<O> objList = new DataProductCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// DataProduct
    /// </summary>
    [Serializable]
    public partial class DataProduct : NamedObject<DataProduct>
    {
        private System.String type;
        private System.Drawing.Image preview;
        private bool previewLoaded = false;
        private bool previewChanged = false;
        private System.Int32 previewsize;
        private System.Byte[] contents;
        private bool contentsLoaded = false;
        private bool contentsChanged = false;
        private System.Int32 contentssize;
        private Guid producedbyID;
        private ActivityInstance producedby;
        private Guid creatoractivityID;
        private ActivitySequence creatoractivity;
        private Guid creatorparameterID;
        private ParameterAssignment creatorparameter;
        
        private DataProductPreviewBlobCollection<DataProduct> previewstores;
        private DataProductContentsBlobCollection<DataProduct> contentsstores;
        private DataProductDetailCollection<DataProduct> dataproductdetails;
        private DataProductBindingCollection<DataProduct> dataproductbindings;

        /// <summary>
        /// Description of the DataProduct.
        /// </summary>
        public System.String Type
        {
            get
            {
                DataProductBinding binding = GetBinding(DataProduct.IBindable.Fields.Type);
                if (binding != null)
                {
					//
					// Load from External storage.
					//
                    DataObject dataObject = binding.LoadData();
                    type = DataConverter.convertToString(dataObject);
                    
                    dataObject.Dispose();
                }
                
                return type;
            }
            set
            {
				type = value;

				if (Conn.AutoSave)
					Save();
            }
        }
           
           
        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.TransferProgressHandler OnPreviewTransfer;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.BeginClearStoreProgressHandler OnPreviewClearBegin;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.EndClearStoreProgressHandler OnPreviewClearEnd;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public System.Drawing.Image Preview
        {
            get 
            { 
                if (previewLoaded)
                {
                    // Uses cached version
                    return preview;
                }
                
                System.IO.Stream bStream = null;
				
				DataProductBinding binding = GetBinding(DataProduct.IBindable.Fields.Preview);
                if (binding != null)
                {
					//
					// Load from External storage.
					//
                    DataObject dataObject = binding.LoadData();
                    if (dataObject.Data == null)
                    {
                        bStream = new System.IO.MemoryStream(dataObject.DataBytes);
                    }
                    else
                    {
                        bStream = dataObject.Data;
                    }
                }
                else
                {
				//
                // Load from BLOB storage
                //
                preview = null;
                previewLoaded = true;

                int count = this.PreviewStores.Count;

                if (count == 0)
                    return null;

                List<IBlob> list = new List<IBlob>();
                foreach (DataProductPreviewBlob blob in this.PreviewStores)
                {
                    list.Add(blob);
                }
                
                bStream = BlobBase.FetchBlobs<DataProductPreviewBlob, List<IBlob>>(list);
				}

                preview = System.Drawing.Image.FromStream(bStream);

                bStream.Close();
                
                return preview;
            }
            set
            {
				preview = value;
                previewLoaded = true;
                previewChanged = true;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProduct.
        /// </summary>
        public System.Int32 PreviewSize
        {
            get
            {
                DataProductBinding binding = GetBinding(DataProduct.IBindable.Fields.PreviewSize);
                if (binding != null)
                {
					//
					// Load from External storage.
					//
                    DataObject dataObject = binding.LoadData();
                    previewsize = DataConverter.convertToInt32(dataObject);
                    
                    dataObject.Dispose();
                }
                
                return previewsize;
            }
            set
            {
				previewsize = value;

				if (Conn.AutoSave)
					Save();
            }
        }
           
           
        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.TransferProgressHandler OnContentsTransfer;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.BeginClearStoreProgressHandler OnContentsClearBegin;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public BlobBase.EndClearStoreProgressHandler OnContentsClearEnd;

        /// <summary>
        /// Description of the DataProduct
        /// </summary>
        public System.Byte[] Contents
        {
            get 
            { 
                if (contentsLoaded)
                {
                    // Uses cached version
                    return contents;
                }
                
                System.IO.Stream bStream = null;
				
				DataProductBinding binding = GetBinding(DataProduct.IBindable.Fields.Contents);
                if (binding != null)
                {
					//
					// Load from External storage.
					//
                    DataObject dataObject = binding.LoadData();
                    if (dataObject.Data == null)
                    {
                        bStream = new System.IO.MemoryStream(dataObject.DataBytes);
                    }
                    else
                    {
                        bStream = dataObject.Data;
                    }
                }
                else
                {
				//
                // Load from BLOB storage
                //
                contents = null;
                contentsLoaded = true;

                int count = this.ContentsStores.Count;

                if (count == 0)
                    return null;

                List<IBlob> list = new List<IBlob>();
                foreach (DataProductContentsBlob blob in this.ContentsStores)
                {
                    list.Add(blob);
                }
                
                bStream = BlobBase.FetchBlobs<DataProductContentsBlob, List<IBlob>>(list);
				}

                contents = BlobBase.StreamToByteArray(bStream);

                bStream.Close();
                
                return contents;
            }
            set
            {
				contents = value;
                contentsLoaded = true;
                contentsChanged = true;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProduct.
        /// </summary>
        public System.Int32 ContentsSize
        {
            get
            {
                DataProductBinding binding = GetBinding(DataProduct.IBindable.Fields.ContentsSize);
                if (binding != null)
                {
					//
					// Load from External storage.
					//
                    DataObject dataObject = binding.LoadData();
                    contentssize = DataConverter.convertToInt32(dataObject);
                    
                    dataObject.Dispose();
                }
                
                return contentssize;
            }
            set
            {
				contentssize = value;

				if (Conn.AutoSave)
					Save();
            }
        }
           
           
        public ActivityInstance ProducedBy
        {
            get
            {
                lock (this)
                {
                    if (producedby == null && producedbyID != Guid.Empty)
                        producedby = ActivityInstance.Load(producedbyID, Conn);
                }
                return producedby;
            }

            set
            {
                lock (this)
                {
                    producedby = value;                   
                    producedbyID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ActivitySequence CreatorActivity
        {
            get
            {
                lock (this)
                {
                    if (creatoractivity == null && creatoractivityID != Guid.Empty)
                        creatoractivity = ActivitySequence.Load(creatoractivityID, Conn);
                }
                return creatoractivity;
            }

            set
            {
                lock (this)
                {
                    creatoractivity = value;                   
                    creatoractivityID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ParameterAssignment CreatorParameter
        {
            get
            {
                lock (this)
                {
                    if (creatorparameter == null && creatorparameterID != Guid.Empty)
                        creatorparameter = ParameterAssignment.Load(creatorparameterID, Conn);
                }
                return creatorparameter;
            }

            set
            {
                lock (this)
                {
                    creatorparameter = value;                   
                    creatorparameterID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        protected DataProductPreviewBlobCollection<DataProduct> PreviewStores { get { return previewstores; } }
        protected DataProductContentsBlobCollection<DataProduct> ContentsStores { get { return contentsstores; } }
        public DataProductDetailCollection<DataProduct> DataProductDetails { get { return dataproductdetails; } }
        public DataProductBindingCollection<DataProduct> DataProductBindings { get { return dataproductbindings; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public DataProduct(Connection c)
            : base(SRStorage.DataProduct, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static DataProduct Create(string name, System.String type, Connection c)
        {
            DataProduct newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;

			
            newObj.previewstores = new DataProductPreviewBlobCollection<DataProduct>(newObj, "DataProduct", "PreviewStore", c);
            newObj.contentsstores = new DataProductContentsBlobCollection<DataProduct>(newObj, "DataProduct", "ContentsStore", c);
            newObj.dataproductdetails = new DataProductDetailCollection<DataProduct>(newObj, "DataProduct", "DataProductDetail", c);
            newObj.dataproductbindings = new DataProductBindingCollection<DataProduct>(newObj, "DataProduct", "DataProductBinding", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static DataProduct Load(string name, Connection c)
        {
            return NamedObject<DataProduct>.Load(name, c, DataProduct.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a DataProduct object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>DataProduct object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            DataProduct loadObj = (DataProduct)NamedObject<DataProduct>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(DataProduct loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<DataProduct>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.type = val;
            }

            index = reader.GetOrdinal("PreviewSize");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.previewsize = val;
            }

            index = reader.GetOrdinal("ContentsSize");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.contentssize = val;
            }

            index = reader.GetOrdinal("ProducedByID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.producedbyID = val;
            }

            index = reader.GetOrdinal("CreatorActivityID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.creatoractivityID = val;
            }

            index = reader.GetOrdinal("CreatorParameterID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.creatorparameterID = val;
            }


            //
            // Object connections
            //

            // PreviewStores
            loadObj.previewstores = DataProductPreviewBlobCollection<DataProduct>.CreateFromReader(loadObj, "DataProduct", "PreviewStore", reader, c);
            // ContentsStores
            loadObj.contentsstores = DataProductContentsBlobCollection<DataProduct>.CreateFromReader(loadObj, "DataProduct", "ContentsStore", reader, c);
            // DataProductDetails
            loadObj.dataproductdetails = DataProductDetailCollection<DataProduct>.CreateFromReader(loadObj, "DataProduct", "DataProductDetail", reader, c);
            // DataProductBindings
            loadObj.dataproductbindings = DataProductBindingCollection<DataProduct>.CreateFromReader(loadObj, "DataProduct", "DataProductBinding", reader, c);
        }

        public static DataProduct Load(Guid id, Connection c)
        {
            return Load<DataProduct>(id, c, DataProduct.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL DataProducts from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all DataProducts in the system</returns>
        public static List<DataProduct> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<DataProduct>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(DataProduct)], 
                DataProduct.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all DataProducts that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProducts</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<DataProduct> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<DataProduct>(owner, DataProduct.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all DataProducts that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProducts</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<DataProduct> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<DataProduct>(owner, src, DataProduct.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches DataProducts by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of DataProducts that match the criteria</returns>
        public static List<DataProduct> Search(string text, Connection c)
        {
            return LoadAll<DataProduct>(Connection.Action.Search, text, DataProduct.CreateFromDataStore, c);
        }

        private void SavePreviewBlob(Connection c)
        {
            if (!this.previewChanged)
			   return;
			   
            // Clear previous version
            foreach (DataProductPreviewBlob b in this.PreviewStores)
            {
                b.Delete();
            }

			// Notify begin of store clear
			BlobBase.FireOnAnyBeginClearStore(this, "Preview", c);
			if (OnPreviewClearBegin != null)
				OnPreviewClearBegin(this, "Preview", c);

            this.PreviewStores.Refresh();
            this.PreviewStores.Clear();

			// Notify end of store clear
			if (OnPreviewClearEnd != null)
				OnPreviewClearEnd(this, "Preview", c);
			BlobBase.FireOnAnyEndClearStore(this, "Preview", c);

            // Reset changed bit
            this.previewChanged = false;
            
            // Save the size (starts with 0)
            this.previewsize = 0;
            
            if (preview == null)
                return;

            // Serialize image and save to store
            System.IO.MemoryStream saveStore = new System.IO.MemoryStream();
            preview.Save(saveStore, System.Drawing.Imaging.ImageFormat.Png);
            byte[] __cnv_contents = saveStore.GetBuffer();
            this.previewsize = __cnv_contents.Length;
            List<DataProductPreviewBlob> previewBlobs = BlobBase.SaveBlobs<DataProductPreviewBlob, DataProduct>(this, preview, "Preview", __cnv_contents, 
				CreatePreviewBlob, OnPreviewTransfer, c);
            this.PreviewStores.Load(previewBlobs);
            
            // Update cache size
            Save();
        }

        public static DataProductPreviewBlob CreatePreviewBlob(Guid streamId, int index, int total, Guid revisionId, DataProduct src, Connection c)
        {
            return DataProductPreviewBlob.Create(streamId, index, total, revisionId, src, c);
        }

        private void SaveContentsBlob(Connection c)
        {
            if (!this.contentsChanged)
			   return;
			   
            // Clear previous version
            foreach (DataProductContentsBlob b in this.ContentsStores)
            {
                b.Delete();
            }

			// Notify begin of store clear
			BlobBase.FireOnAnyBeginClearStore(this, "Contents", c);
			if (OnContentsClearBegin != null)
				OnContentsClearBegin(this, "Contents", c);

            this.ContentsStores.Refresh();
            this.ContentsStores.Clear();

			// Notify end of store clear
			if (OnContentsClearEnd != null)
				OnContentsClearEnd(this, "Contents", c);
			BlobBase.FireOnAnyEndClearStore(this, "Contents", c);

            // Reset changed bit
            this.contentsChanged = false;
            
            // Save the size (starts with 0)
            this.contentssize = 0;
            
            if (contents == null)
                return;

            // Serialize image and save to store
            byte[] __cnv_contents = contents;
            this.contentssize = __cnv_contents.Length;
            List<DataProductContentsBlob> contentsBlobs = BlobBase.SaveBlobs<DataProductContentsBlob, DataProduct>(this, contents, "Contents", __cnv_contents, 
				CreateContentsBlob, OnContentsTransfer, c);
            this.ContentsStores.Load(contentsBlobs);
            
            // Update cache size
            Save();
        }

        public static DataProductContentsBlob CreateContentsBlob(Guid streamId, int index, int total, Guid revisionId, DataProduct src, Connection c)
        {
            return DataProductContentsBlob.Create(streamId, index, total, revisionId, src, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Type = new FieldDefs.StringField("Type");
                public static FieldDefs.IntegerField PreviewSize = new FieldDefs.IntegerField("PreviewSize");
                public static FieldDefs.IntegerField ContentsSize = new FieldDefs.IntegerField("ContentsSize");
                public static FieldDefs.ObjectField<ActivityInstance> ProducedBy = new FieldDefs.ObjectField<ActivityInstance>("ProducedBy");
                public static FieldDefs.ObjectField<ActivitySequence> CreatorActivity = new FieldDefs.ObjectField<ActivitySequence>("CreatorActivity");
                public static FieldDefs.ObjectField<ParameterAssignment> CreatorParameter = new FieldDefs.ObjectField<ParameterAssignment>("CreatorParameter");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Type(StringField.Condition op, System.String value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause PreviewSize(IntegerField.Condition op, System.Int32 value) { return Fields.PreviewSize.CreateSearchClause(op, value); }
            public static ISearchClause ContentsSize(IntegerField.Condition op, System.Int32 value) { return Fields.ContentsSize.CreateSearchClause(op, value); }
            public static ISearchClause ProducedBy(ObjectField<ActivityInstance>.Condition op, ActivityInstance value) { return Fields.ProducedBy.CreateSearchClause(op, value); }
            public static ISearchClause CreatorActivity(ObjectField<ActivitySequence>.Condition op, ActivitySequence value) { return Fields.CreatorActivity.CreateSearchClause(op, value); }
            public static ISearchClause CreatorParameter(ObjectField<ParameterAssignment>.Condition op, ParameterAssignment value) { return Fields.CreatorParameter.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<DataProduct> Search(DataProduct.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.DataProduct, Connection.Action.Search, ref paramList, DataProduct.CreateFromDataStore, out results);
            return results.ConvertAll<DataProduct>(BasicObject.ConvertFromIObject<DataProduct>);
        }
		
		#region Binding

        #region IBindable

        [Serializable]
        public class IBindable
        {
            #region Field Declarations
            public enum Fields
            {
                Type,
                Preview,
                PreviewSize,
                Contents,
                ContentsSize,
                Name
            }
            #endregion
        }

        /// <summary>
        /// This is a helper method to find the proper binding for the given field.
        /// We are searching within bindings for the highest priority binding.
        /// </summary>
        /// <param name="field">The field.</param>
        /// <returns>DataProductBinding.</returns>
        DataProductBinding GetBinding(DataProduct.IBindable.Fields field)
        {
            int currentMinPosition = int.MaxValue;
            DataProductBinding priorityBinding = null;
            foreach (DataProductBinding fieldBinding in DataProductBindings)
            {
                if (fieldBinding.Field == field && currentMinPosition > fieldBinding.Position)
                {
                    currentMinPosition = fieldBinding.Position;
                    priorityBinding = fieldBinding;
                }
            }

            return priorityBinding;
        }

        #endregion

        private Binding bindings = null;

        /// <summary>
        /// Gets the bindings.
        /// </summary>
        /// <value>The bindings.</value>
        public Binding Bindings
        {
            get
            {
                if (bindings == null)
                {
                    bindings = new Binding(this, this.Conn);
                }
                return bindings;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public class Binding : IEnumerable<DataProductBinding>
        {
            DataProduct owner;
            Connection conn;

            /// <summary>
            /// Initializes a new instance of the <see cref="Binding"/> class.
            /// </summary>
            /// <param name="owner">The owner.</param>
            /// <param name="conn">The conn.</param>
            public Binding(DataProduct owner, Connection conn)
            {
                this.owner = owner;
                this.conn = conn;
            }

            /// <summary>
            /// Create DataProductBinding for specified field.
            /// </summary>
            /// <param name="field">The field.</param>
            /// <param name="store">The store.</param>
            public void Add(DataProduct.IBindable.Fields field, DataReferenceStore store)
            {
                DataProductBinding binding = DataProductBinding.Create(field, this.owner, store, this.conn);
                binding.Position = this.GetLatestPosition(field);

                if (!conn.AutoSave)
                    binding.Save();

                this.owner.Refresh();
            }

            /// <summary>
            /// Create DataProductBinding for specified field.
            /// </summary>
            /// <param name="field">The field.</param>
            /// <param name="store">The store.</param>
            /// <param name="param">The param.</param>
            public void Add(DataProduct.IBindable.Fields field, DataReferenceStore store, string param)
            {
                DataProductBinding binding = DataProductBinding.Create(field, this.owner, store, this.conn);
                binding.Position = this.GetLatestPosition(field);
                binding.Key = param;

                if (!conn.AutoSave)
                    binding.Save();

                this.owner.Refresh();
            }

            /// <summary>
            /// Removes the bindings of the specified field.
            /// </summary>
            /// <param name="field">The field.</param>
            public void RemoveAll(DataProduct.IBindable.Fields field)
            {
                foreach (DataProductBinding fieldBinding in this.owner.DataProductBindings)
                {
                    if (fieldBinding.Field == field)
                    {
                        fieldBinding.Delete();
                    }
                }
            }

            /// <summary>
            /// Removes the specified binding from the DataProductBinding collection.
            /// </summary>
            /// <param name="binding">The binding.</param>
            public void Remove(DataProductBinding binding)
            {
                if (binding != null)
                {
                    binding.Delete();
                }
            }

            /// <summary>
            /// Gets the latest position of the DataProductBinding for specified field.
            /// </summary>
            /// <returns></returns>
            private int GetLatestPosition(DataProduct.IBindable.Fields field)
            {
                int currentMinPosition = int.MaxValue;
                foreach (DataProductBinding fieldBinding in this.owner.DataProductBindings)
                {
                    if (fieldBinding.Field == field && currentMinPosition > fieldBinding.Position)
                    {
                        currentMinPosition = fieldBinding.Position;
                    }
                }

                return currentMinPosition == int.MaxValue ? 0 : currentMinPosition + 1;
            }

            #region IEnumerable Members

            /// <summary>
            /// Returns an enumerator that iterates through a collection.
            /// </summary>
            /// <returns>
            /// An <see cref="T:System.Collections.IEnumerator"/> object that can be used to iterate through the collection.
            /// </returns>
            System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
            {
                return owner.DataProductBindings.GetEnumerator();
            }

            #endregion

            #region IEnumerable<DataProductBinding> Members

            /// <summary>
            /// Returns an enumerator that iterates through the collection.
            /// </summary>
            /// <returns>
            /// A <see cref="T:System.Collections.Generic.IEnumerator`1"/> that can be used to iterate through the collection.
            /// </returns>
            IEnumerator<DataProductBinding> IEnumerable<DataProductBinding>.GetEnumerator()
            {
                return owner.DataProductBindings.GetEnumerator();
            }

            #endregion
        }

        #endregion


        /// <summary>
        /// Saves the DataProduct object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            DataProductBinding binding = null;

            
			if (!this.isNew)
			{
				binding = GetBinding(DataProduct.IBindable.Fields.Type);
			}
			
            if (binding != null)
            {
				//
                // Save to External storage.
                //
                DataObject dataObject = new DataObject(this.type);
                binding.Save(dataObject);
            }
            else
            {
				            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type));
			}

			if (!this.isNew)
			{
				binding = GetBinding(DataProduct.IBindable.Fields.PreviewSize);
			}
			
            if (binding != null)
            {
				//
                // Save to External storage.
                //
                DataObject dataObject = new DataObject(this.previewsize);
                binding.Save(dataObject);
            }
            else
            {
				            mydata.Add(new Parameter("PreviewSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.previewsize));
			}

			if (!this.isNew)
			{
				binding = GetBinding(DataProduct.IBindable.Fields.ContentsSize);
			}
			
            if (binding != null)
            {
				//
                // Save to External storage.
                //
                DataObject dataObject = new DataObject(this.contentssize);
                binding.Save(dataObject);
            }
            else
            {
				            mydata.Add(new Parameter("ContentsSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.contentssize));
			}

            mydata.Add(new Parameter("ProducedByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.producedbyID == Guid.Empty ?
                (this.ProducedBy == null ? Guid.Empty : ((IObject)this.ProducedBy).ID)
                : this.producedbyID)));
            mydata.Add(new Parameter("CreatorActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.creatoractivityID == Guid.Empty ?
                (this.CreatorActivity == null ? Guid.Empty : ((IObject)this.CreatorActivity).ID)
                : this.creatoractivityID)));
            mydata.Add(new Parameter("CreatorParameterID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.creatorparameterID == Guid.Empty ?
                (this.CreatorParameter == null ? Guid.Empty : ((IObject)this.CreatorParameter).ID)
                : this.creatorparameterID)));
            
            Save(mydata);
            
			if (!this.isNew)
			{
				binding = GetBinding(DataProduct.IBindable.Fields.Preview);
			}
			
            if (binding != null)
            {
				//
                // Save to External storage.
                //
                DataObject dataObject = new DataObject(this.preview);
                binding.Save(dataObject);
            }
            else
            {
				            SavePreviewBlob(store);
			}

			if (!this.isNew)
			{
				binding = GetBinding(DataProduct.IBindable.Fields.Contents);
			}
			
            if (binding != null)
            {
				//
                // Save to External storage.
                //
                DataObject dataObject = new DataObject(this.contents);
                binding.Save(dataObject);
            }
            else
            {
				            SaveContentsBlob(store);
			}

        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the DataProduct and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<DataProduct> updPipe = new PipelineParameter<DataProduct>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.previewstores.Refresh();
            this.contentsstores.Refresh();
            this.dataproductdetails.Refresh();
            this.dataproductbindings.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ActivityInstance producedby,ActivitySequence creatoractivity,ParameterAssignment creatorparameter)
            {
                this.producedby=producedby;
                this.creatoractivity=creatoractivity;
                this.creatorparameter=creatorparameter;

            }

            public IObject CopyTo(Connection target, DataProduct dataproduct)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, dataproduct.type));
                 mydata.Add(new Parameter("PreviewSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproduct.previewsize));
                 mydata.Add(new Parameter("ContentsSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproduct.contentssize));
			     mydata.Add(new Parameter("ProducedByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.producedby == null ? Guid.Empty : ((IObject)this.producedby).ID)));
			     mydata.Add(new Parameter("CreatorActivityID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.creatoractivity == null ? Guid.Empty : ((IObject)this.creatoractivity).ID)));
			     mydata.Add(new Parameter("CreatorParameterID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.creatorparameter == null ? Guid.Empty : ((IObject)this.creatorparameter).ID)));

                PipelineParameter<DataProduct> pipe = new PipelineParameter<DataProduct>(CreateFromDataStore);
                IObject newObj = dataproduct.SaveTo(mydata, store, pipe);
                 dataproduct.SavePreviewBlob(store);
                 dataproduct.SaveContentsBlob(store);

                return newObj;
            }

            ActivityInstance producedby;
            ActivitySequence creatoractivity;
            ParameterAssignment creatorparameter;

        } 
        
              
    }
}
