/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the DataProductBindings that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the DataProductBinding collection</typeparam>
    public class DataProductBindingCollection<O> : SyncCollection<O, DataProductBinding>
        where O : IObject
    {
        public DataProductBindingCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductBinding>.DelayLoadCallback(DataProductBindingCollection_OnDelayLoad);
        }

        public DataProductBindingCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductBinding>.DelayLoadCallback(DataProductBindingCollection_OnDelayLoadRef);
        }

        List<DataProductBinding> DataProductBindingCollection_OnDelayLoad(Connection c)
        {
            return DataProductBinding.LoadAll(this.Owner, c);
        }

        List<DataProductBinding> DataProductBindingCollection_OnDelayLoadRef(Connection c)
        {
            return DataProductBinding.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static DataProductBindingCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            DataProductBindingCollection<O> objList = new DataProductBindingCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static DataProductBindingCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            DataProductBindingCollection<O> objList = new DataProductBindingCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// DataProductBinding
    /// </summary>
    [Serializable]
    public partial class DataProductBinding : BasicObject
    {
        private System.String key;
        private System.Int32 position;
        private DataProduct.IBindable.Fields field;
        private Guid dataproductID;
        private DataProduct dataproduct;
        private Guid datareferencestoreID;
        private DataReferenceStore datareferencestore;
        

        /// <summary>
        /// Description of the DataProductBinding
        /// </summary>
        public System.String Key
        {
            get { return key; }
            set
            {
                key = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductBinding
        /// </summary>
        public System.Int32 Position
        {
            get { return position; }
            set
            {
                position = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductBinding
        /// </summary>
        public DataProduct.IBindable.Fields Field
        {
            get { return field; }
            set
            {
                field = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public DataProduct DataProduct
        {
            get
            {
                lock (this)
                {
                    if (dataproduct == null && dataproductID != Guid.Empty)
                        dataproduct = DataProduct.Load(dataproductID, Conn);
                }
                return dataproduct;
            }

            set
            {
                lock (this)
                {
                    dataproduct = value;                   
                    dataproductID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public DataReferenceStore DataReferenceStore
        {
            get
            {
                lock (this)
                {
                    if (datareferencestore == null && datareferencestoreID != Guid.Empty)
                        datareferencestore = DataReferenceStore.Load(datareferencestoreID, Conn);
                }
                return datareferencestore;
            }

            set
            {
                lock (this)
                {
                    datareferencestore = value;                   
                    datareferencestoreID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public DataProductBinding(Connection c)
            : base(SRStorage.DataProductBinding, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static DataProductBinding Create(DataProduct.IBindable.Fields field, DataProduct dataproduct, DataReferenceStore datareferencestore, Connection c)
        {
            DataProductBinding newObj = new DataProductBinding(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.field = field;
            newObj.dataproduct = dataproduct;
            newObj.datareferencestore = datareferencestore;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a DataProductBinding object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>DataProductBinding object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            DataProductBinding loadObj = new DataProductBinding(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(DataProductBinding loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Key");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.key = val;
            }

            index = reader.GetOrdinal("Position");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.position = val;
            }

            index = reader.GetOrdinal("Field");
            if (!reader.IsDBNull(index))
                loadObj.field = (DataProduct.IBindable.Fields)Enum.Parse(typeof(DataProduct.IBindable.Fields), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("DataProductID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.dataproductID = val;
            }

            index = reader.GetOrdinal("DataReferenceStoreID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.datareferencestoreID = val;
            }


            //
            // Object connections
            //

        }

        public static DataProductBinding Load(Guid id, Connection c)
        {
            return Load<DataProductBinding>(id, c, DataProductBinding.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL DataProductBindings from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all DataProductBindings in the system</returns>
        public static List<DataProductBinding> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<DataProductBinding>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(DataProductBinding)], 
                DataProductBinding.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all DataProductBindings that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductBindings</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<DataProductBinding> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<DataProductBinding>(owner, DataProductBinding.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all DataProductBindings that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductBindings</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<DataProductBinding> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<DataProductBinding>(owner, src, DataProductBinding.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches DataProductBindings by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of DataProductBindings that match the criteria</returns>
        public static List<DataProductBinding> Search(string text, Connection c)
        {
            return LoadAll<DataProductBinding>(Connection.Action.Search, text, DataProductBinding.CreateFromDataStore, c);
        }

		#region External providers related functions.

        /// <summary>
        /// Loads the data based on the unique identifier.
        /// </summary>
        /// <returns></returns>
        public DataObject LoadData()
        {
            return ExternalRegistryHelperProxy.Retrieve(this.DataReferenceStore, this.Key);
        }

        /// <summary>
        /// Saves the specified data object in the specified store and 
        /// sets the unique identifier of the saved data.
        /// </summary>
        /// <param name="dataObject">The data object.</param>
        public void Save(DataObject dataObject)
        {
            if (string.IsNullOrEmpty(this.Key))
            {
                // Store data in external registry and set the unique identifier.
                this.Key = ExternalRegistryHelperProxy.Store(this.DataReferenceStore, dataObject);
            }
            else
            {
                this.Key = ExternalRegistryHelperProxy.Store(this.DataReferenceStore, dataObject, this.Key);
            }
            
            dataObject.Dispose();
            this.Save();
        }

        #endregion


        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Key = new FieldDefs.StringField("Key");
                public static FieldDefs.IntegerField Position = new FieldDefs.IntegerField("Position");
                public static FieldDefs.EnumField<DataProduct.IBindable.Fields> Field = new FieldDefs.EnumField<DataProduct.IBindable.Fields>("Field");
                public static FieldDefs.ObjectField<DataProduct> DataProduct = new FieldDefs.ObjectField<DataProduct>("DataProduct");
                public static FieldDefs.ObjectField<DataReferenceStore> DataReferenceStore = new FieldDefs.ObjectField<DataReferenceStore>("DataReferenceStore");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Key(StringField.Condition op, System.String value) { return Fields.Key.CreateSearchClause(op, value); }
            public static ISearchClause Position(IntegerField.Condition op, System.Int32 value) { return Fields.Position.CreateSearchClause(op, value); }
            public static ISearchClause Field(EnumField<DataProduct.IBindable.Fields>.Condition op, DataProduct.IBindable.Fields value) { return Fields.Field.CreateSearchClause(op, value); }
            public static ISearchClause DataProduct(ObjectField<DataProduct>.Condition op, DataProduct value) { return Fields.DataProduct.CreateSearchClause(op, value); }
            public static ISearchClause DataReferenceStore(ObjectField<DataReferenceStore>.Condition op, DataReferenceStore value) { return Fields.DataReferenceStore.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<DataProductBinding> Search(DataProductBinding.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.DataProductBinding, Connection.Action.Search, ref paramList, DataProductBinding.CreateFromDataStore, out results);
            return results.ConvertAll<DataProductBinding>(BasicObject.ConvertFromIObject<DataProductBinding>);
        }
		

        /// <summary>
        /// Saves the DataProductBinding object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Key", Parameter.ParamType.String, Parameter.ParamDirection.In, this.key));

            mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.position));

            mydata.Add(new Parameter("Field", Parameter.ParamType.String, Parameter.ParamDirection.In, this.field.ToString()));
            mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.dataproductID == Guid.Empty ?
                (this.DataProduct == null ? Guid.Empty : ((IObject)this.DataProduct).ID)
                : this.dataproductID)));
            mydata.Add(new Parameter("DataReferenceStoreID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.datareferencestoreID == Guid.Empty ?
                (this.DataReferenceStore == null ? Guid.Empty : ((IObject)this.DataReferenceStore).ID)
                : this.datareferencestoreID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the DataProductBinding and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<DataProductBinding> updPipe = new PipelineParameter<DataProductBinding>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(DataProduct dataproduct,DataReferenceStore datareferencestore)
            {
                this.dataproduct=dataproduct;
                this.datareferencestore=datareferencestore;

            }

            public IObject CopyTo(Connection target, DataProductBinding dataproductbinding)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Key", Parameter.ParamType.String, Parameter.ParamDirection.In, dataproductbinding.key));
                 mydata.Add(new Parameter("Position", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproductbinding.position));
                 mydata.Add(new Parameter("Field", Parameter.ParamType.String, Parameter.ParamDirection.In, dataproductbinding.field.ToString()));
			     mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.dataproduct == null ? Guid.Empty : ((IObject)this.dataproduct).ID)));
			     mydata.Add(new Parameter("DataReferenceStoreID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.datareferencestore == null ? Guid.Empty : ((IObject)this.datareferencestore).ID)));

                PipelineParameter<DataProductBinding> pipe = new PipelineParameter<DataProductBinding>(CreateFromDataStore);
                IObject newObj = dataproductbinding.SaveTo(mydata, store, pipe);

                return newObj;
            }

            DataProduct dataproduct;
            DataReferenceStore datareferencestore;

        }
        
       
    }
}
