/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the DataProductContentsBlobs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the DataProductContentsBlob collection</typeparam>
    public class DataProductContentsBlobCollection<O> : SyncCollection<O, DataProductContentsBlob>
        where O : IObject
    {
        public DataProductContentsBlobCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductContentsBlob>.DelayLoadCallback(DataProductContentsBlobCollection_OnDelayLoad);
        }

        public DataProductContentsBlobCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductContentsBlob>.DelayLoadCallback(DataProductContentsBlobCollection_OnDelayLoadRef);
        }

        List<DataProductContentsBlob> DataProductContentsBlobCollection_OnDelayLoad(Connection c)
        {
            return DataProductContentsBlob.LoadAll(this.Owner, c);
        }

        List<DataProductContentsBlob> DataProductContentsBlobCollection_OnDelayLoadRef(Connection c)
        {
            return DataProductContentsBlob.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static DataProductContentsBlobCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            DataProductContentsBlobCollection<O> objList = new DataProductContentsBlobCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static DataProductContentsBlobCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            DataProductContentsBlobCollection<O> objList = new DataProductContentsBlobCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// DataProductContentsBlob
    /// </summary>
    [Serializable]
    public partial class DataProductContentsBlob : BasicObject, IBlob
    {
        private System.Guid packageid;
        private System.Int32 index;
        private System.Int32 chunks;
        private System.String contents;
        private System.Guid revisionid;
        private Guid dataproductID;
        private DataProduct dataproduct;
        private Guid previousID;
        private DataProductContentsBlob previous;
        private Guid nextID;
        private DataProductContentsBlob next;
        

        /// <summary>
        /// Description of the DataProductContentsBlob
        /// </summary>
        public System.Guid PackageID
        {
            get { return packageid; }
            set
            {
                packageid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductContentsBlob
        /// </summary>
        public System.Int32 Index
        {
            get { return index; }
            set
            {
                index = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductContentsBlob
        /// </summary>
        public System.Int32 Chunks
        {
            get { return chunks; }
            set
            {
                chunks = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductContentsBlob
        /// </summary>
        public System.String Contents
        {
            get { return contents; }
            set
            {
                contents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataProductContentsBlob
        /// </summary>
        public System.Guid RevisionID
        {
            get { return revisionid; }
            set
            {
                revisionid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public DataProduct DataProduct
        {
            get
            {
                lock (this)
                {
                    if (dataproduct == null && dataproductID != Guid.Empty)
                        dataproduct = DataProduct.Load(dataproductID, Conn);
                }
                return dataproduct;
            }

            set
            {
                lock (this)
                {
                    dataproduct = value;                   
                    dataproductID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public DataProductContentsBlob Previous
        {
            get
            {
                lock (this)
                {
                    if (previous == null && previousID != Guid.Empty)
                        previous = DataProductContentsBlob.Load(previousID, Conn);
                }
                return previous;
            }

            set
            {
                lock (this)
                {
                    previous = value;                   
                    previousID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public DataProductContentsBlob Next
        {
            get
            {
                lock (this)
                {
                    if (next == null && nextID != Guid.Empty)
                        next = DataProductContentsBlob.Load(nextID, Conn);
                }
                return next;
            }

            set
            {
                lock (this)
                {
                    next = value;                   
                    nextID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public DataProductContentsBlob(Connection c)
            : base(SRStorage.DataProductContentsBlob, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static DataProductContentsBlob Create(System.Guid packageid, System.Int32 index, System.Int32 chunks, System.Guid revisionid, DataProduct dataproduct, Connection c)
        {
            DataProductContentsBlob newObj = new DataProductContentsBlob(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.packageid = packageid;
            newObj.index = index;
            newObj.chunks = chunks;
            newObj.revisionid = revisionid;
            newObj.dataproduct = dataproduct;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a DataProductContentsBlob object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>DataProductContentsBlob object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            DataProductContentsBlob loadObj = new DataProductContentsBlob(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(DataProductContentsBlob loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("PackageID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.packageid = val;
            }

            index = reader.GetOrdinal("Index");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.index = val;
            }

            index = reader.GetOrdinal("Chunks");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.chunks = val;
            }

            index = reader.GetOrdinal("Contents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.contents = val;
            }

            index = reader.GetOrdinal("RevisionID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.revisionid = val;
            }

            index = reader.GetOrdinal("DataProductID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.dataproductID = val;
            }

            index = reader.GetOrdinal("PreviousID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.previousID = val;
            }

            index = reader.GetOrdinal("NextID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.nextID = val;
            }


            //
            // Object connections
            //

        }

        public static DataProductContentsBlob Load(Guid id, Connection c)
        {
            return Load<DataProductContentsBlob>(id, c, DataProductContentsBlob.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL DataProductContentsBlobs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all DataProductContentsBlobs in the system</returns>
        public static List<DataProductContentsBlob> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<DataProductContentsBlob>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(DataProductContentsBlob)], 
                DataProductContentsBlob.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all DataProductContentsBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductContentsBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<DataProductContentsBlob> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<DataProductContentsBlob>(owner, DataProductContentsBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all DataProductContentsBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductContentsBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<DataProductContentsBlob> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<DataProductContentsBlob>(owner, src, DataProductContentsBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches DataProductContentsBlobs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of DataProductContentsBlobs that match the criteria</returns>
        public static List<DataProductContentsBlob> Search(string text, Connection c)
        {
            return LoadAll<DataProductContentsBlob>(Connection.Action.Search, text, DataProductContentsBlob.CreateFromDataStore, c);
        }



		

        /// <summary>
        /// Saves the DataProductContentsBlob object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.packageid));

            mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.index));

            mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.chunks));

            mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, this.contents));

            mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.revisionid));

            mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.dataproductID == Guid.Empty ?
                (this.DataProduct == null ? Guid.Empty : ((IObject)this.DataProduct).ID)
                : this.dataproductID)));
            mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.previousID == Guid.Empty ?
                (this.Previous == null ? Guid.Empty : ((IObject)this.Previous).ID)
                : this.previousID)));
            mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.nextID == Guid.Empty ?
                (this.Next == null ? Guid.Empty : ((IObject)this.Next).ID)
                : this.nextID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the DataProductContentsBlob and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<DataProductContentsBlob> updPipe = new PipelineParameter<DataProductContentsBlob>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(DataProduct dataproduct,DataProductContentsBlob previous,DataProductContentsBlob next)
            {
                this.dataproduct=dataproduct;
                this.previous=previous;
                this.next=next;

            }

            public IObject CopyTo(Connection target, DataProductContentsBlob dataproductcontentsblob)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, dataproductcontentsblob.packageid));
                 mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproductcontentsblob.index));
                 mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproductcontentsblob.chunks));
                 mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, dataproductcontentsblob.contents));
                 mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, dataproductcontentsblob.revisionid));
			     mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.dataproduct == null ? Guid.Empty : ((IObject)this.dataproduct).ID)));
			     mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.previous == null ? Guid.Empty : ((IObject)this.previous).ID)));
			     mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.next == null ? Guid.Empty : ((IObject)this.next).ID)));

                PipelineParameter<DataProductContentsBlob> pipe = new PipelineParameter<DataProductContentsBlob>(CreateFromDataStore);
                IObject newObj = dataproductcontentsblob.SaveTo(mydata, store, pipe);

                return newObj;
            }

            DataProduct dataproduct;
            DataProductContentsBlob previous;
            DataProductContentsBlob next;

        }
        
       
    }
}
