/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the DataProductDetails that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the DataProductDetail collection</typeparam>
    public class DataProductDetailCollection<O> : SyncCollection<O, DataProductDetail>
        where O : IObject
    {
        public DataProductDetailCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductDetail>.DelayLoadCallback(DataProductDetailCollection_OnDelayLoad);
        }

        public DataProductDetailCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataProductDetail>.DelayLoadCallback(DataProductDetailCollection_OnDelayLoadRef);
        }

        List<DataProductDetail> DataProductDetailCollection_OnDelayLoad(Connection c)
        {
            return DataProductDetail.LoadAll(this.Owner, c);
        }

        List<DataProductDetail> DataProductDetailCollection_OnDelayLoadRef(Connection c)
        {
            return DataProductDetail.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static DataProductDetailCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            DataProductDetailCollection<O> objList = new DataProductDetailCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static DataProductDetailCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            DataProductDetailCollection<O> objList = new DataProductDetailCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// DataProductDetail
    /// </summary>
    [Serializable]
    public partial class DataProductDetail : BasicObject
    {
        private System.Int32 eventorder;
        private Guid dataproductID;
        private DataProduct dataproduct;
        private Guid provenancedetailID;
        private ProvenanceDetail provenancedetail;
        

        /// <summary>
        /// Description of the DataProductDetail
        /// </summary>
        public System.Int32 EventOrder
        {
            get { return eventorder; }
            set
            {
                eventorder = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public DataProduct DataProduct
        {
            get
            {
                lock (this)
                {
                    if (dataproduct == null && dataproductID != Guid.Empty)
                        dataproduct = DataProduct.Load(dataproductID, Conn);
                }
                return dataproduct;
            }

            set
            {
                lock (this)
                {
                    dataproduct = value;                   
                    dataproductID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ProvenanceDetail ProvenanceDetail
        {
            get
            {
                lock (this)
                {
                    if (provenancedetail == null && provenancedetailID != Guid.Empty)
                        provenancedetail = ProvenanceDetail.Load(provenancedetailID, Conn);
                }
                return provenancedetail;
            }

            set
            {
                lock (this)
                {
                    provenancedetail = value;                   
                    provenancedetailID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public DataProductDetail(Connection c)
            : base(SRStorage.DataProductDetail, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static DataProductDetail Create(DataProduct dataproduct, ProvenanceDetail provenancedetail, Connection c)
        {
            DataProductDetail newObj = new DataProductDetail(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.dataproduct = dataproduct;
            newObj.provenancedetail = provenancedetail;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a DataProductDetail object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>DataProductDetail object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            DataProductDetail loadObj = new DataProductDetail(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(DataProductDetail loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("EventOrder");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.eventorder = val;
            }

            index = reader.GetOrdinal("DataProductID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.dataproductID = val;
            }

            index = reader.GetOrdinal("ProvenanceDetailID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.provenancedetailID = val;
            }


            //
            // Object connections
            //

        }

        public static DataProductDetail Load(Guid id, Connection c)
        {
            return Load<DataProductDetail>(id, c, DataProductDetail.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL DataProductDetails from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all DataProductDetails in the system</returns>
        public static List<DataProductDetail> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<DataProductDetail>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(DataProductDetail)], 
                DataProductDetail.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all DataProductDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<DataProductDetail> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<DataProductDetail>(owner, DataProductDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all DataProductDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataProductDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<DataProductDetail> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<DataProductDetail>(owner, src, DataProductDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches DataProductDetails by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of DataProductDetails that match the criteria</returns>
        public static List<DataProductDetail> Search(string text, Connection c)
        {
            return LoadAll<DataProductDetail>(Connection.Action.Search, text, DataProductDetail.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.IntegerField EventOrder = new FieldDefs.IntegerField("EventOrder");
                public static FieldDefs.ObjectField<DataProduct> DataProduct = new FieldDefs.ObjectField<DataProduct>("DataProduct");
                public static FieldDefs.ObjectField<ProvenanceDetail> ProvenanceDetail = new FieldDefs.ObjectField<ProvenanceDetail>("ProvenanceDetail");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause EventOrder(IntegerField.Condition op, System.Int32 value) { return Fields.EventOrder.CreateSearchClause(op, value); }
            public static ISearchClause DataProduct(ObjectField<DataProduct>.Condition op, DataProduct value) { return Fields.DataProduct.CreateSearchClause(op, value); }
            public static ISearchClause ProvenanceDetail(ObjectField<ProvenanceDetail>.Condition op, ProvenanceDetail value) { return Fields.ProvenanceDetail.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<DataProductDetail> Search(DataProductDetail.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.DataProductDetail, Connection.Action.Search, ref paramList, DataProductDetail.CreateFromDataStore, out results);
            return results.ConvertAll<DataProductDetail>(BasicObject.ConvertFromIObject<DataProductDetail>);
        }
		

        /// <summary>
        /// Saves the DataProductDetail object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("EventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.eventorder));

            mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.dataproductID == Guid.Empty ?
                (this.DataProduct == null ? Guid.Empty : ((IObject)this.DataProduct).ID)
                : this.dataproductID)));
            mydata.Add(new Parameter("ProvenanceDetailID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.provenancedetailID == Guid.Empty ?
                (this.ProvenanceDetail == null ? Guid.Empty : ((IObject)this.ProvenanceDetail).ID)
                : this.provenancedetailID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the DataProductDetail and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<DataProductDetail> updPipe = new PipelineParameter<DataProductDetail>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(DataProduct dataproduct,ProvenanceDetail provenancedetail)
            {
                this.dataproduct=dataproduct;
                this.provenancedetail=provenancedetail;

            }

            public IObject CopyTo(Connection target, DataProductDetail dataproductdetail)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("EventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, dataproductdetail.eventorder));
			     mydata.Add(new Parameter("DataProductID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.dataproduct == null ? Guid.Empty : ((IObject)this.dataproduct).ID)));
			     mydata.Add(new Parameter("ProvenanceDetailID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.provenancedetail == null ? Guid.Empty : ((IObject)this.provenancedetail).ID)));

                PipelineParameter<DataProductDetail> pipe = new PipelineParameter<DataProductDetail>(CreateFromDataStore);
                IObject newObj = dataproductdetail.SaveTo(mydata, store, pipe);

                return newObj;
            }

            DataProduct dataproduct;
            ProvenanceDetail provenancedetail;

        }
        
       
    }
}
