/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the DataReferenceProviders that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the DataReferenceProvider collection</typeparam>
    public class DataReferenceProviderCollection<O> : SyncCollection<O, DataReferenceProvider>
        where O : IObject
    {
        public DataReferenceProviderCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataReferenceProvider>.DelayLoadCallback(DataReferenceProviderCollection_OnDelayLoad);
        }

        public DataReferenceProviderCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, DataReferenceProvider>.DelayLoadCallback(DataReferenceProviderCollection_OnDelayLoadRef);
        }

        List<DataReferenceProvider> DataReferenceProviderCollection_OnDelayLoad(Connection c)
        {
            return DataReferenceProvider.LoadAll(this.Owner, c);
        }

        List<DataReferenceProvider> DataReferenceProviderCollection_OnDelayLoadRef(Connection c)
        {
            return DataReferenceProvider.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static DataReferenceProviderCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            DataReferenceProviderCollection<O> objList = new DataReferenceProviderCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static DataReferenceProviderCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            DataReferenceProviderCollection<O> objList = new DataReferenceProviderCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// DataReferenceProvider
    /// </summary>
    [Serializable]
    public partial class DataReferenceProvider : NamedObject<DataReferenceProvider>
    {
        private System.String description;
        private System.String classname;
        
        private AssemblyPackageCollection<DataReferenceProvider> assemblypackages;
        private DataReferenceStoreCollection<DataReferenceProvider> datareferencestores;

        /// <summary>
        /// Description of the DataReferenceProvider
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the DataReferenceProvider
        /// </summary>
        public System.String ClassName
        {
            get { return classname; }
            set
            {
                classname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public AssemblyPackageCollection<DataReferenceProvider> AssemblyPackages { get { return assemblypackages; } }
        public DataReferenceStoreCollection<DataReferenceProvider> DataReferenceStores { get { return datareferencestores; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public DataReferenceProvider(Connection c)
            : base(SRStorage.DataReferenceProvider, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new DataReferenceProvider Create(string name, Connection c)
        {
            DataReferenceProvider newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<DataReferenceProvider>(newObj, c);
            newObj.datareferencestores = new DataReferenceStoreCollection<DataReferenceProvider>(newObj, "Provider", "DataReferenceStore", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static DataReferenceProvider Load(string name, Connection c)
        {
            return NamedObject<DataReferenceProvider>.Load(name, c, DataReferenceProvider.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a DataReferenceProvider object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>DataReferenceProvider object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            DataReferenceProvider loadObj = (DataReferenceProvider)NamedObject<DataReferenceProvider>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(DataReferenceProvider loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<DataReferenceProvider>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("ClassName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.classname = val;
            }


            //
            // Object connections
            //

            // AssemblyPackages
            loadObj.assemblypackages = AssemblyPackageCollection<DataReferenceProvider>.CreateFromReader(loadObj, reader, c);
            // DataReferenceStores
            loadObj.datareferencestores = DataReferenceStoreCollection<DataReferenceProvider>.CreateFromReader(loadObj, "Provider", "DataReferenceStore", reader, c);
        }

        public static DataReferenceProvider Load(Guid id, Connection c)
        {
            return Load<DataReferenceProvider>(id, c, DataReferenceProvider.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL DataReferenceProviders from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all DataReferenceProviders in the system</returns>
        public static List<DataReferenceProvider> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<DataReferenceProvider>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(DataReferenceProvider)], 
                DataReferenceProvider.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all DataReferenceProviders that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataReferenceProviders</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<DataReferenceProvider> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<DataReferenceProvider>(owner, DataReferenceProvider.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all DataReferenceProviders that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the DataReferenceProviders</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<DataReferenceProvider> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<DataReferenceProvider>(owner, src, DataReferenceProvider.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches DataReferenceProviders by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of DataReferenceProviders that match the criteria</returns>
        public static List<DataReferenceProvider> Search(string text, Connection c)
        {
            return LoadAll<DataReferenceProvider>(Connection.Action.Search, text, DataReferenceProvider.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.StringField ClassName = new FieldDefs.StringField("ClassName");
                public static FieldDefs.RelationSimpleField<AssemblyPackage> AssemblyPackage = new FieldDefs.RelationSimpleField<AssemblyPackage>("AssemblyPackage", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause ClassName(StringField.Condition op, System.String value) { return Fields.ClassName.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyPackage(RelationSimpleField<AssemblyPackage>.Condition op, AssemblyPackage value) { return Fields.AssemblyPackage.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<DataReferenceProvider> Search(DataReferenceProvider.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.DataReferenceProvider, Connection.Action.Search, ref paramList, DataReferenceProvider.CreateFromDataStore, out results);
            return results.ConvertAll<DataReferenceProvider>(BasicObject.ConvertFromIObject<DataReferenceProvider>);
        }
		

        /// <summary>
        /// Saves the DataReferenceProvider object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.classname));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the DataReferenceProvider and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<DataReferenceProvider> updPipe = new PipelineParameter<DataReferenceProvider>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.assemblypackages.Refresh();
            this.datareferencestores.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.assemblypackages.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, DataReferenceProvider datareferenceprovider)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, datareferenceprovider.description));
                 mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, datareferenceprovider.classname));

                PipelineParameter<DataReferenceProvider> pipe = new PipelineParameter<DataReferenceProvider>(CreateFromDataStore);
                IObject newObj = datareferenceprovider.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
