/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
        
    
    /// <summary>
    /// Interface for the UI Resource strings.
    /// </summary>
    public interface ISRGlobalSettingUIResources
    {        
        string DataproductText { get; }
            
    }
    
    /// <summary>
    /// Defines the GlobalSetting object.
    /// </summary>
    public interface ISRGlobalSetting 
    {
		        System.String Dataproduct { get; set; }
 
		ISRGlobalSettingUIResources UIResources { get; }				
    }
        
    /// <summary>
    /// GlobalSetting
    /// </summary>
    [Serializable]
    public partial class GlobalSetting : BasicObject, ISRGlobalSetting
    {       
        
        private System.String dataproduct;
        
        private static GlobalSetting instance = null;
        private ISRGlobalSettingUIResources uiresources;
        
        # region UIResources
        
        /// <summary>
		/// Contains the UI Resource strings to be displayed.
		/// </summary>
		public class UIDisplayResources : ISRGlobalSettingUIResources
        {
                           private string uidataproductlocres = "Properties.Resource1.DataProductText";
               private string dataproductnolocrestxt = "Data Product Settings";

            
				#region ISRGlobalSettingUIResources Members

            				public string DataproductText
				{
					get { return FetchUIDisplayString(uidataproductlocres, dataproductnolocrestxt); }
				}
 
            
				#endregion

				private string FetchUIDisplayString(string locResource, string noLocText)
				{                
					try
					{
						string locString = Properties.Resource1.ResourceManager.GetString(locResource.Substring(locResource.LastIndexOf('.') + 1));
						if (!String.IsNullOrEmpty(locString))
						{
							return locString;
						}
					}
					catch
					{
					}
					return noLocText;                
				}

        }	
        
        # endregion

        /// <summary>
        /// Description of the GlobalSetting
        /// </summary>
        public System.String Dataproduct
        {
            get { return dataproduct; }
            set
            {
                dataproduct = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public ISRGlobalSettingUIResources UIResources
        {
            get { return uiresources; }
        }
        
        
        
		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public GlobalSetting(Connection c)
            : base(SRStorage.GlobalSetting, c)
        {
        }
        
        /// <summary>
        /// Gets a singleton instance of the object
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public static GlobalSetting Get(Connection c)
        {
            if (instance == null)
            {
                try
                {   
                    List<GlobalSetting> objList = LoadAll(c);
                    if (objList.Count > 0)
                    {
                       instance = objList[0];
                                               instance.uiresources = new UIDisplayResources();
	
                    }                    
                }
                catch (RecordNotFoundException)
                {
                    throw new ApplicationException("GlobalSetting not initialized");
                }
            }            
            return instance;            
        }

        /// <summary>
        /// Resets this instance.
        /// </summary>
        public static void Reset()
        {
            instance = null;
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static void Initialize(System.String dataproduct, Connection c)
        {
            GlobalSetting newObj = new GlobalSetting(c);
            try
			{
				List<GlobalSetting> objList = LoadAll(c);                                  
				throw new ApplicationException("GlobalSetting already initialized");                 
			}
            catch (RecordNotFoundException)
            {
				newObj.ObjID = Guid.Empty;
				newObj.isNew = true;
            newObj.dataproduct = dataproduct;
			
				
				newObj.OnConstructor();

				if (c.AutoSave)
                newObj.Save();
            }
        }

        /// <summary>
        /// Creates a GlobalSetting object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>GlobalSetting object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            GlobalSetting loadObj = new GlobalSetting(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(GlobalSetting loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Dataproduct");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.dataproduct = val;
            }

        }

        public static GlobalSetting Load(Guid id, Connection c)
        {
            return Load<GlobalSetting>(id, c, GlobalSetting.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL GlobalSettings from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all GlobalSettings in the system</returns>
        public static List<GlobalSetting> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<GlobalSetting>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(GlobalSetting)], 
                GlobalSetting.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all GlobalSettings that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the GlobalSettings</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<GlobalSetting> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<GlobalSetting>(owner, GlobalSetting.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all GlobalSettings that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the GlobalSettings</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<GlobalSetting> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<GlobalSetting>(owner, src, GlobalSetting.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches GlobalSettings by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of GlobalSettings that match the criteria</returns>
        public static List<GlobalSetting> Search(string text, Connection c)
        {
            return LoadAll<GlobalSetting>(Connection.Action.Search, text, GlobalSetting.CreateFromDataStore, c);
        }


		

        /// <summary>
        /// Saves the GlobalSetting object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("Dataproduct", Parameter.ParamType.String, Parameter.ParamDirection.In, this.dataproduct));

            Save(mydata);
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the GlobalSetting and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<GlobalSetting> updPipe = new PipelineParameter<GlobalSetting>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);
            
            
        }
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, GlobalSetting globalsetting)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Dataproduct", Parameter.ParamType.String, Parameter.ParamDirection.In, globalsetting.dataproduct));

                PipelineParameter<GlobalSetting> pipe = new PipelineParameter<GlobalSetting>(CreateFromDataStore);
                IObject newObj = globalsetting.SaveTo(mydata, store, pipe);

                return newObj;
            }


        }        
        
        
    }
}
