/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Groups that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Group collection</typeparam>
    public class GroupCollection<O> : SyncCollection<O, Group>
        where O : IObject
    {
        public GroupCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Group>.DelayLoadCallback(GroupCollection_OnDelayLoad);
        }

        public GroupCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Group>.DelayLoadCallback(GroupCollection_OnDelayLoadRef);
        }

        List<Group> GroupCollection_OnDelayLoad(Connection c)
        {
            return Group.LoadAll(this.Owner, c);
        }

        List<Group> GroupCollection_OnDelayLoadRef(Connection c)
        {
            return Group.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static GroupCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            GroupCollection<O> objList = new GroupCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static GroupCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            GroupCollection<O> objList = new GroupCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Group
    /// </summary>
    [Serializable]
    public partial class Group : NamedObject<Group>, ISecurityPrincipal
    {
        private System.String description;
        private System.Boolean enabled;
        private System.Boolean isdeleted;
        private System.Boolean isbuiltin;
        
        private UserCollection<Group> users;
        private GroupCredentialCollection<Group> groupcredentials;
        private SystemRoleCollection<Group> systemroles;

        /// <summary>
        /// Description of the Group
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Group
        /// </summary>
        public System.Boolean Enabled
        {
            get { return enabled; }
            set
            {
                enabled = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Group
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Group
        /// </summary>
        public System.Boolean IsBuiltin
        {
            get { return isbuiltin; }
            set
            {
                isbuiltin = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public UserCollection<Group> Users { get { return users; } }
        protected GroupCredentialCollection<Group> GroupCredentials { get { return groupcredentials; } }
        public SystemRoleCollection<Group> SystemRoles { get { return systemroles; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Group(Connection c)
            : base(SRStorage.Group, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new Group Create(string name, Connection c)
        {
            Group newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.users = new UserCollection<Group>(newObj, c);
            newObj.groupcredentials = new GroupCredentialCollection<Group>(newObj, "Group", "GroupCredential", c);
            newObj.systemroles = new SystemRoleCollection<Group>(newObj, "MemberGroupPrincipal", "SystemRole", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Group Load(string name, Connection c)
        {
            return NamedObject<Group>.Load(name, c, Group.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Group object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Group object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Group loadObj = (Group)NamedObject<Group>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Group loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Group>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("Enabled");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.enabled = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("IsBuiltin");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isbuiltin = val;
            }


            //
            // Object connections
            //

            // Users
            loadObj.users = UserCollection<Group>.CreateFromReader(loadObj, reader, c);
            // GroupCredentials
            loadObj.groupcredentials = GroupCredentialCollection<Group>.CreateFromReader(loadObj, "Group", "GroupCredential", reader, c);
            // SystemRoles
            loadObj.systemroles = SystemRoleCollection<Group>.CreateFromReader(loadObj, "MemberGroupPrincipal", "SystemRole", reader, c);
        }

        public static Group Load(Guid id, Connection c)
        {
            return Load<Group>(id, c, Group.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Groups from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Groups in the system</returns>
        public static List<Group> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Group>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Group)], 
                Group.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Groups that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Groups</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Group> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Group>(owner, Group.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Groups that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Groups</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Group> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Group>(owner, src, Group.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Groups by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Groups that match the criteria</returns>
        public static List<Group> Search(string text, Connection c)
        {
            return LoadAll<Group>(Connection.Action.Search, text, Group.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.BooleanField Enabled = new FieldDefs.BooleanField("Enabled");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.BooleanField IsBuiltin = new FieldDefs.BooleanField("IsBuiltin");
                public static FieldDefs.RelationSimpleField<User> User = new FieldDefs.RelationSimpleField<User>("User", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause Enabled(BooleanField.Condition op, System.Boolean value) { return Fields.Enabled.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause IsBuiltin(BooleanField.Condition op, System.Boolean value) { return Fields.IsBuiltin.CreateSearchClause(op, value); }
            public static ISearchClause User(RelationSimpleField<User>.Condition op, User value) { return Fields.User.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Group> Search(Group.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Group, Connection.Action.Search, ref paramList, Group.CreateFromDataStore, out results);
            return results.ConvertAll<Group>(BasicObject.ConvertFromIObject<Group>);
        }
		

        /// <summary>
        /// Saves the Group object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("Enabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.enabled));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("IsBuiltin", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isbuiltin));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Group and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Group> updPipe = new PipelineParameter<Group>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.users.Refresh();
            this.groupcredentials.Refresh();
            this.systemroles.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.users.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, Group group)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, group.description));
                 mydata.Add(new Parameter("Enabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, group.enabled));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, group.isdeleted));
                 mydata.Add(new Parameter("IsBuiltin", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, group.isbuiltin));

                PipelineParameter<Group> pipe = new PipelineParameter<Group>(CreateFromDataStore);
                IObject newObj = group.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
       		#region ISecurityPrincipal Members

        public ISecurityCredentialCollection Credentials
        {
            get { return GroupCredentials; }
        }

        #endregion       
    }
}
