/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the GroupCredentials that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the GroupCredential collection</typeparam>
    public class GroupCredentialCollection<O> : SyncCollection<O, GroupCredential>, ISecurityCredentialCollection
        where O : IObject
    {
        public GroupCredentialCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, GroupCredential>.DelayLoadCallback(GroupCredentialCollection_OnDelayLoad);
        }

        public GroupCredentialCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, GroupCredential>.DelayLoadCallback(GroupCredentialCollection_OnDelayLoadRef);
        }

        List<GroupCredential> GroupCredentialCollection_OnDelayLoad(Connection c)
        {
            return GroupCredential.LoadAll(this.Owner, c);
        }

        List<GroupCredential> GroupCredentialCollection_OnDelayLoadRef(Connection c)
        {
            return GroupCredential.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static GroupCredentialCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            GroupCredentialCollection<O> objList = new GroupCredentialCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static GroupCredentialCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            GroupCredentialCollection<O> objList = new GroupCredentialCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       		#region ICollection<ISecurityCredential> Members

        void ICollection<ISecurityCredential>.Add(ISecurityCredential item)
        {
            if (item is GroupCredential)
            {
                base.Add(item as GroupCredential);
            }
        }

        void ICollection<ISecurityCredential>.Clear()
        {
            base.Clear();
        }

        bool ICollection<ISecurityCredential>.Contains(ISecurityCredential item)
        {
            if (item is GroupCredential)
            {
                return base.Contains(item as GroupCredential);
            }
            else
            {
                return false;
            }
        }

        void ICollection<ISecurityCredential>.CopyTo(ISecurityCredential[] array, int arrayIndex)
        {
            if (array is GroupCredential[])
            {
                base.CopyTo(array as GroupCredential[], arrayIndex);
            }
        }

        int ICollection<ISecurityCredential>.Count
        {
            get { return base.Count; }
        }

        bool ICollection<ISecurityCredential>.IsReadOnly
        {
            get { return base.IsReadOnly; }
        }

        bool ICollection<ISecurityCredential>.Remove(ISecurityCredential item)
        {
            if (item is GroupCredential)
            {
                return base.Remove(item as GroupCredential);
            }
            else
            {
                return false;
            }
        }

        #endregion

        #region IEnumerable<ISecurityCredential> Members

        IEnumerator<ISecurityCredential> IEnumerable<ISecurityCredential>.GetEnumerator()
        {
            return new SecurityCredentialEnumerator<GroupCredential>(this.GetEnumerator());
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return base.GetEnumerator();
        }

        #endregion
    }

    /// <summary>
    /// GroupCredential
    /// </summary>
    [Serializable]
    public partial class GroupCredential : BasicObject, ISecurityCredential
    {
        private System.String credential;
        private System.String displayname;
        private CredentialType type;
        private Guid groupID;
        private Group group;
        

        /// <summary>
        /// Description of the GroupCredential
        /// </summary>
        public System.String Credential
        {
            get { return credential; }
            set
            {
                credential = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the GroupCredential
        /// </summary>
        public System.String DisplayName
        {
            get { return displayname; }
            set
            {
                displayname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the GroupCredential
        /// </summary>
        public CredentialType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Group Group
        {
            get
            {
                lock (this)
                {
                    if (group == null && groupID != Guid.Empty)
                        group = Group.Load(groupID, Conn);
                }
                return group;
            }

            set
            {
                lock (this)
                {
                    group = value;                   
                    groupID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public GroupCredential(Connection c)
            : base(SRStorage.GroupCredential, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static GroupCredential Create(System.String credential, CredentialType type, Group group, Connection c)
        {
            GroupCredential newObj = new GroupCredential(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.credential = credential;
            newObj.type = type;
            newObj.group = group;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a GroupCredential object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>GroupCredential object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            GroupCredential loadObj = new GroupCredential(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(GroupCredential loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Credential");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.credential = val;
            }

            index = reader.GetOrdinal("DisplayName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.displayname = val;
            }

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (CredentialType)Enum.Parse(typeof(CredentialType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("GroupID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.groupID = val;
            }


            //
            // Object connections
            //

        }

        public static GroupCredential Load(Guid id, Connection c)
        {
            return Load<GroupCredential>(id, c, GroupCredential.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL GroupCredentials from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all GroupCredentials in the system</returns>
        public static List<GroupCredential> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<GroupCredential>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(GroupCredential)], 
                GroupCredential.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all GroupCredentials that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the GroupCredentials</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<GroupCredential> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<GroupCredential>(owner, GroupCredential.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all GroupCredentials that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the GroupCredentials</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<GroupCredential> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<GroupCredential>(owner, src, GroupCredential.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches GroupCredentials by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of GroupCredentials that match the criteria</returns>
        public static List<GroupCredential> Search(string text, Connection c)
        {
            return LoadAll<GroupCredential>(Connection.Action.Search, text, GroupCredential.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Credential = new FieldDefs.StringField("Credential");
                public static FieldDefs.StringField DisplayName = new FieldDefs.StringField("DisplayName");
                public static FieldDefs.EnumField<CredentialType> Type = new FieldDefs.EnumField<CredentialType>("Type");
                public static FieldDefs.ObjectField<Group> Group = new FieldDefs.ObjectField<Group>("Group");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Credential(StringField.Condition op, System.String value) { return Fields.Credential.CreateSearchClause(op, value); }
            public static ISearchClause DisplayName(StringField.Condition op, System.String value) { return Fields.DisplayName.CreateSearchClause(op, value); }
            public static ISearchClause Type(EnumField<CredentialType>.Condition op, CredentialType value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause Group(ObjectField<Group>.Condition op, Group value) { return Fields.Group.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<GroupCredential> Search(GroupCredential.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.GroupCredential, Connection.Action.Search, ref paramList, GroupCredential.CreateFromDataStore, out results);
            return results.ConvertAll<GroupCredential>(BasicObject.ConvertFromIObject<GroupCredential>);
        }
		

        /// <summary>
        /// Saves the GroupCredential object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Credential", Parameter.ParamType.String, Parameter.ParamDirection.In, this.credential));

            mydata.Add(new Parameter("DisplayName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.displayname));

            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
            mydata.Add(new Parameter("GroupID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.groupID == Guid.Empty ?
                (this.Group == null ? Guid.Empty : ((IObject)this.Group).ID)
                : this.groupID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the GroupCredential and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<GroupCredential> updPipe = new PipelineParameter<GroupCredential>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Group group)
            {
                this.group=group;

            }

            public IObject CopyTo(Connection target, GroupCredential groupcredential)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Credential", Parameter.ParamType.String, Parameter.ParamDirection.In, groupcredential.credential));
                 mydata.Add(new Parameter("DisplayName", Parameter.ParamType.String, Parameter.ParamDirection.In, groupcredential.displayname));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, groupcredential.type.ToString()));
			     mydata.Add(new Parameter("GroupID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.group == null ? Guid.Empty : ((IObject)this.group).ID)));

                PipelineParameter<GroupCredential> pipe = new PipelineParameter<GroupCredential>(CreateFromDataStore);
                IObject newObj = groupcredential.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Group group;

        }
        
       
    }
}
