/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the HealthChecks that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the HealthCheck collection</typeparam>
    public class HealthCheckCollection<O> : SyncCollection<O, HealthCheck>
        where O : IObject
    {
        public HealthCheckCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, HealthCheck>.DelayLoadCallback(HealthCheckCollection_OnDelayLoad);
        }

        public HealthCheckCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, HealthCheck>.DelayLoadCallback(HealthCheckCollection_OnDelayLoadRef);
        }

        List<HealthCheck> HealthCheckCollection_OnDelayLoad(Connection c)
        {
            return HealthCheck.LoadAll(this.Owner, c);
        }

        List<HealthCheck> HealthCheckCollection_OnDelayLoadRef(Connection c)
        {
            return HealthCheck.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static HealthCheckCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            HealthCheckCollection<O> objList = new HealthCheckCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static HealthCheckCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            HealthCheckCollection<O> objList = new HealthCheckCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// HealthCheck
    /// </summary>
    [Serializable]
    public partial class HealthCheck : BasicObject
    {
        private System.DateTime lastpolltime;
        private System.String executorstatusmessage;
        private System.String schedulerstatusmessage;
        private SchedulerStatus schedulerstatus;
        private MachineStatus executorstatus;
        private Guid nodeID;
        private Machine node;
        

        /// <summary>
        /// Description of the HealthCheck
        /// </summary>
        public System.DateTime LastPollTime
        {
            get { return lastpolltime; }
            set
            {
                lastpolltime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the HealthCheck
        /// </summary>
        public System.String ExecutorStatusMessage
        {
            get { return executorstatusmessage; }
            set
            {
                executorstatusmessage = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the HealthCheck
        /// </summary>
        public System.String SchedulerStatusMessage
        {
            get { return schedulerstatusmessage; }
            set
            {
                schedulerstatusmessage = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the HealthCheck
        /// </summary>
        public SchedulerStatus SchedulerStatus
        {
            get { return schedulerstatus; }
            set
            {
                schedulerstatus = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the HealthCheck
        /// </summary>
        public MachineStatus ExecutorStatus
        {
            get { return executorstatus; }
            set
            {
                executorstatus = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Machine Node
        {
            get
            {
                lock (this)
                {
                    if (node == null && nodeID != Guid.Empty)
                        node = Machine.Load(nodeID, Conn);
                }
                return node;
            }

            set
            {
                lock (this)
                {
                    node = value;                   
                    nodeID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public HealthCheck(Connection c)
            : base(SRStorage.HealthCheck, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static HealthCheck Create(Machine node, Connection c)
        {
            HealthCheck newObj = new HealthCheck(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.node = node;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a HealthCheck object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>HealthCheck object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            HealthCheck loadObj = new HealthCheck(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(HealthCheck loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("LastPollTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.lastpolltime = val;
            }

            index = reader.GetOrdinal("ExecutorStatusMessage");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.executorstatusmessage = val;
            }

            index = reader.GetOrdinal("SchedulerStatusMessage");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.schedulerstatusmessage = val;
            }

            index = reader.GetOrdinal("SchedulerStatus");
            if (!reader.IsDBNull(index))
                loadObj.schedulerstatus = (SchedulerStatus)Enum.Parse(typeof(SchedulerStatus), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ExecutorStatus");
            if (!reader.IsDBNull(index))
                loadObj.executorstatus = (MachineStatus)Enum.Parse(typeof(MachineStatus), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("NodeID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.nodeID = val;
            }


            //
            // Object connections
            //

        }

        public static HealthCheck Load(Guid id, Connection c)
        {
            return Load<HealthCheck>(id, c, HealthCheck.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL HealthChecks from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all HealthChecks in the system</returns>
        public static List<HealthCheck> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<HealthCheck>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(HealthCheck)], 
                HealthCheck.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all HealthChecks that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the HealthChecks</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<HealthCheck> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<HealthCheck>(owner, HealthCheck.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all HealthChecks that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the HealthChecks</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<HealthCheck> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<HealthCheck>(owner, src, HealthCheck.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches HealthChecks by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of HealthChecks that match the criteria</returns>
        public static List<HealthCheck> Search(string text, Connection c)
        {
            return LoadAll<HealthCheck>(Connection.Action.Search, text, HealthCheck.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.DateTimeField LastPollTime = new FieldDefs.DateTimeField("LastPollTime");
                public static FieldDefs.StringField ExecutorStatusMessage = new FieldDefs.StringField("ExecutorStatusMessage");
                public static FieldDefs.StringField SchedulerStatusMessage = new FieldDefs.StringField("SchedulerStatusMessage");
                public static FieldDefs.EnumField<SchedulerStatus> SchedulerStatus = new FieldDefs.EnumField<SchedulerStatus>("SchedulerStatus");
                public static FieldDefs.EnumField<MachineStatus> ExecutorStatus = new FieldDefs.EnumField<MachineStatus>("ExecutorStatus");
                public static FieldDefs.ObjectField<Machine> Node = new FieldDefs.ObjectField<Machine>("Node");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause LastPollTime(DateTimeField.Condition op, System.DateTime value) { return Fields.LastPollTime.CreateSearchClause(op, value); }
            public static ISearchClause ExecutorStatusMessage(StringField.Condition op, System.String value) { return Fields.ExecutorStatusMessage.CreateSearchClause(op, value); }
            public static ISearchClause SchedulerStatusMessage(StringField.Condition op, System.String value) { return Fields.SchedulerStatusMessage.CreateSearchClause(op, value); }
            public static ISearchClause SchedulerStatus(EnumField<SchedulerStatus>.Condition op, SchedulerStatus value) { return Fields.SchedulerStatus.CreateSearchClause(op, value); }
            public static ISearchClause ExecutorStatus(EnumField<MachineStatus>.Condition op, MachineStatus value) { return Fields.ExecutorStatus.CreateSearchClause(op, value); }
            public static ISearchClause Node(ObjectField<Machine>.Condition op, Machine value) { return Fields.Node.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<HealthCheck> Search(HealthCheck.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.HealthCheck, Connection.Action.Search, ref paramList, HealthCheck.CreateFromDataStore, out results);
            return results.ConvertAll<HealthCheck>(BasicObject.ConvertFromIObject<HealthCheck>);
        }
		

        /// <summary>
        /// Saves the HealthCheck object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("LastPollTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.lastpolltime));

            mydata.Add(new Parameter("ExecutorStatusMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, this.executorstatusmessage));

            mydata.Add(new Parameter("SchedulerStatusMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, this.schedulerstatusmessage));

            mydata.Add(new Parameter("SchedulerStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, this.schedulerstatus.ToString()));
            mydata.Add(new Parameter("ExecutorStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, this.executorstatus.ToString()));
            mydata.Add(new Parameter("NodeID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.nodeID == Guid.Empty ?
                (this.Node == null ? Guid.Empty : ((IObject)this.Node).ID)
                : this.nodeID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the HealthCheck and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<HealthCheck> updPipe = new PipelineParameter<HealthCheck>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Machine node)
            {
                this.node=node;

            }

            public IObject CopyTo(Connection target, HealthCheck healthcheck)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("LastPollTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, healthcheck.lastpolltime));
                 mydata.Add(new Parameter("ExecutorStatusMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, healthcheck.executorstatusmessage));
                 mydata.Add(new Parameter("SchedulerStatusMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, healthcheck.schedulerstatusmessage));
                 mydata.Add(new Parameter("SchedulerStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, healthcheck.schedulerstatus.ToString()));
                 mydata.Add(new Parameter("ExecutorStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, healthcheck.executorstatus.ToString()));
			     mydata.Add(new Parameter("NodeID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.node == null ? Guid.Empty : ((IObject)this.node).ID)));

                PipelineParameter<HealthCheck> pipe = new PipelineParameter<HealthCheck>(CreateFromDataStore);
                IObject newObj = healthcheck.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Machine node;

        }
        
       
    }
}
