/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the InputOutputs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the InputOutput collection</typeparam>
    public class InputOutputCollection<O> : SyncCollection<O, InputOutput>
        where O : IObject
    {
        public InputOutputCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, InputOutput>.DelayLoadCallback(InputOutputCollection_OnDelayLoad);
        }

        public InputOutputCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, InputOutput>.DelayLoadCallback(InputOutputCollection_OnDelayLoadRef);
        }

        List<InputOutput> InputOutputCollection_OnDelayLoad(Connection c)
        {
            return InputOutput.LoadAll(this.Owner, c);
        }

        List<InputOutput> InputOutputCollection_OnDelayLoadRef(Connection c)
        {
            return InputOutput.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static InputOutputCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            InputOutputCollection<O> objList = new InputOutputCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static InputOutputCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            InputOutputCollection<O> objList = new InputOutputCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// InputOutput
    /// </summary>
    [Serializable]
    public partial class InputOutput : NamedObject<InputOutput>
    {
        private System.String propertyname;
        private System.String propertyvalue;
        private System.String type;
        private System.Int32 eventorder;
        private System.DateTime publishedtime;
        private DirectionType direction;
        private Guid provenanceID;
        private ProvenanceDetail provenance;
        

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public System.String PropertyName
        {
            get { return propertyname; }
            set
            {
                propertyname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public System.String PropertyValue
        {
            get { return propertyvalue; }
            set
            {
                propertyvalue = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public System.String Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public System.Int32 EventOrder
        {
            get { return eventorder; }
            set
            {
                eventorder = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public System.DateTime PublishedTime
        {
            get { return publishedtime; }
            set
            {
                publishedtime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the InputOutput
        /// </summary>
        public DirectionType Direction
        {
            get { return direction; }
            set
            {
                direction = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public ProvenanceDetail Provenance
        {
            get
            {
                lock (this)
                {
                    if (provenance == null && provenanceID != Guid.Empty)
                        provenance = ProvenanceDetail.Load(provenanceID, Conn);
                }
                return provenance;
            }

            set
            {
                lock (this)
                {
                    provenance = value;                   
                    provenanceID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public InputOutput(Connection c)
            : base(SRStorage.InputOutput, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static InputOutput Create(string name, System.String type, DirectionType direction, Connection c)
        {
            InputOutput newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;
            newObj.direction = direction;

			

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static InputOutput Load(string name, Connection c)
        {
            return NamedObject<InputOutput>.Load(name, c, InputOutput.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a InputOutput object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>InputOutput object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            InputOutput loadObj = (InputOutput)NamedObject<InputOutput>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(InputOutput loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<InputOutput>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("PropertyName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.propertyname = val;
            }

            index = reader.GetOrdinal("PropertyValue");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.propertyvalue = val;
            }

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.type = val;
            }

            index = reader.GetOrdinal("EventOrder");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.eventorder = val;
            }

            index = reader.GetOrdinal("PublishedTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.publishedtime = val;
            }

            index = reader.GetOrdinal("Direction");
            if (!reader.IsDBNull(index))
                loadObj.direction = (DirectionType)Enum.Parse(typeof(DirectionType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ProvenanceID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.provenanceID = val;
            }


            //
            // Object connections
            //

        }

        public static InputOutput Load(Guid id, Connection c)
        {
            return Load<InputOutput>(id, c, InputOutput.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL InputOutputs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all InputOutputs in the system</returns>
        public static List<InputOutput> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<InputOutput>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(InputOutput)], 
                InputOutput.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all InputOutputs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the InputOutputs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<InputOutput> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<InputOutput>(owner, InputOutput.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all InputOutputs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the InputOutputs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<InputOutput> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<InputOutput>(owner, src, InputOutput.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches InputOutputs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of InputOutputs that match the criteria</returns>
        public static List<InputOutput> Search(string text, Connection c)
        {
            return LoadAll<InputOutput>(Connection.Action.Search, text, InputOutput.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField PropertyName = new FieldDefs.StringField("PropertyName");
                public static FieldDefs.StringField PropertyValue = new FieldDefs.StringField("PropertyValue");
                public static FieldDefs.StringField Type = new FieldDefs.StringField("Type");
                public static FieldDefs.IntegerField EventOrder = new FieldDefs.IntegerField("EventOrder");
                public static FieldDefs.DateTimeField PublishedTime = new FieldDefs.DateTimeField("PublishedTime");
                public static FieldDefs.EnumField<DirectionType> Direction = new FieldDefs.EnumField<DirectionType>("Direction");
                public static FieldDefs.ObjectField<ProvenanceDetail> Provenance = new FieldDefs.ObjectField<ProvenanceDetail>("Provenance");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause PropertyName(StringField.Condition op, System.String value) { return Fields.PropertyName.CreateSearchClause(op, value); }
            public static ISearchClause PropertyValue(StringField.Condition op, System.String value) { return Fields.PropertyValue.CreateSearchClause(op, value); }
            public static ISearchClause Type(StringField.Condition op, System.String value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause EventOrder(IntegerField.Condition op, System.Int32 value) { return Fields.EventOrder.CreateSearchClause(op, value); }
            public static ISearchClause PublishedTime(DateTimeField.Condition op, System.DateTime value) { return Fields.PublishedTime.CreateSearchClause(op, value); }
            public static ISearchClause Direction(EnumField<DirectionType>.Condition op, DirectionType value) { return Fields.Direction.CreateSearchClause(op, value); }
            public static ISearchClause Provenance(ObjectField<ProvenanceDetail>.Condition op, ProvenanceDetail value) { return Fields.Provenance.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<InputOutput> Search(InputOutput.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.InputOutput, Connection.Action.Search, ref paramList, InputOutput.CreateFromDataStore, out results);
            return results.ConvertAll<InputOutput>(BasicObject.ConvertFromIObject<InputOutput>);
        }
		

        /// <summary>
        /// Saves the InputOutput object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("PropertyName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.propertyname));

            mydata.Add(new Parameter("PropertyValue", Parameter.ParamType.String, Parameter.ParamDirection.In, this.propertyvalue));

            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type));

            mydata.Add(new Parameter("EventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.eventorder));

            mydata.Add(new Parameter("PublishedTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.publishedtime));

            mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, this.direction.ToString()));
            mydata.Add(new Parameter("ProvenanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.provenanceID == Guid.Empty ?
                (this.Provenance == null ? Guid.Empty : ((IObject)this.Provenance).ID)
                : this.provenanceID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the InputOutput and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<InputOutput> updPipe = new PipelineParameter<InputOutput>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ProvenanceDetail provenance)
            {
                this.provenance=provenance;

            }

            public IObject CopyTo(Connection target, InputOutput inputoutput)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("PropertyName", Parameter.ParamType.String, Parameter.ParamDirection.In, inputoutput.propertyname));
                 mydata.Add(new Parameter("PropertyValue", Parameter.ParamType.String, Parameter.ParamDirection.In, inputoutput.propertyvalue));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, inputoutput.type));
                 mydata.Add(new Parameter("EventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, inputoutput.eventorder));
                 mydata.Add(new Parameter("PublishedTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, inputoutput.publishedtime));
                 mydata.Add(new Parameter("Direction", Parameter.ParamType.String, Parameter.ParamDirection.In, inputoutput.direction.ToString()));
			     mydata.Add(new Parameter("ProvenanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.provenance == null ? Guid.Empty : ((IObject)this.provenance).ID)));

                PipelineParameter<InputOutput> pipe = new PipelineParameter<InputOutput>(CreateFromDataStore);
                IObject newObj = inputoutput.SaveTo(mydata, store, pipe);

                return newObj;
            }

            ProvenanceDetail provenance;

        } 
        
              
    }
}
