/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Jobs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Job collection</typeparam>
    public class JobCollection<O> : SyncCollection<O, Job>
        where O : IObject
    {
        public JobCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Job>.DelayLoadCallback(JobCollection_OnDelayLoad);
        }

        public JobCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Job>.DelayLoadCallback(JobCollection_OnDelayLoadRef);
        }

        List<Job> JobCollection_OnDelayLoad(Connection c)
        {
            return Job.LoadAll(this.Owner, c);
        }

        List<Job> JobCollection_OnDelayLoadRef(Connection c)
        {
            return Job.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static JobCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            JobCollection<O> objList = new JobCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static JobCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            JobCollection<O> objList = new JobCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Job
    /// </summary>
    [Serializable]
    public partial class Job : NamedObject<Job>
    {
        private System.Int32 completeperc;
        private System.Boolean exclusive;
        private System.DateTime starttime;
        private System.DateTime stoptime;
        private System.Boolean success;
        private System.String errormessage;
        private System.Boolean isdeleted;
        private System.String notes;
        private System.Boolean istemplate;
        private System.Boolean isdebug;
        private JobStatus status;
        private JobPriority priority;
        private Guid scheduledbyID;
        private User scheduledby;
        
        private MachineCollection<Job> machines;
        private ActivityInstanceCollection<Job> activityinstances;
        private JobScheduleCollection<Job> schedules;
        private AdditionalParameterCollection<Job> additionalparameters;

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Int32 CompletePerc
        {
            get { return completeperc; }
            set
            {
                completeperc = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Boolean Exclusive
        {
            get { return exclusive; }
            set
            {
                exclusive = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.DateTime StartTime
        {
            get { return starttime; }
            set
            {
                starttime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.DateTime StopTime
        {
            get { return stoptime; }
            set
            {
                stoptime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Boolean Success
        {
            get { return success; }
            set
            {
                success = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.String ErrorMessage
        {
            get { return errormessage; }
            set
            {
                errormessage = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.String Notes
        {
            get { return notes; }
            set
            {
                notes = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Boolean IsTemplate
        {
            get { return istemplate; }
            set
            {
                istemplate = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public System.Boolean IsDebug
        {
            get { return isdebug; }
            set
            {
                isdebug = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public JobStatus Status
        {
            get { return status; }
            set
            {
                status = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Job
        /// </summary>
        public JobPriority Priority
        {
            get { return priority; }
            set
            {
                priority = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User ScheduledBy
        {
            get
            {
                lock (this)
                {
                    if (scheduledby == null && scheduledbyID != Guid.Empty)
                        scheduledby = User.Load(scheduledbyID, Conn);
                }
                return scheduledby;
            }

            set
            {
                lock (this)
                {
                    scheduledby = value;                   
                    scheduledbyID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public MachineCollection<Job> Machines { get { return machines; } }
        public ActivityInstanceCollection<Job> ActivityInstances { get { return activityinstances; } }
        public JobScheduleCollection<Job> Schedules { get { return schedules; } }
        public AdditionalParameterCollection<Job> AdditionalParameters { get { return additionalparameters; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Job(Connection c)
            : base(SRStorage.Job, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static Job Create(string name, System.Boolean istemplate, Connection c)
        {
            Job newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.istemplate = istemplate;

			
            // Empty collections
            newObj.machines = new MachineCollection<Job>(newObj, c);
            newObj.activityinstances = new ActivityInstanceCollection<Job>(newObj, c);
            newObj.schedules = new JobScheduleCollection<Job>(newObj, "Template", "Schedule", c);
            newObj.additionalparameters = new AdditionalParameterCollection<Job>(newObj, "Job", "AdditionalParameter", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Job Load(string name, Connection c)
        {
            return NamedObject<Job>.Load(name, c, Job.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Job object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Job object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Job loadObj = (Job)NamedObject<Job>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Job loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Job>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("CompletePerc");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.completeperc = val;
            }

            index = reader.GetOrdinal("Exclusive");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.exclusive = val;
            }

            index = reader.GetOrdinal("StartTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.starttime = val;
            }

            index = reader.GetOrdinal("StopTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.stoptime = val;
            }

            index = reader.GetOrdinal("Success");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.success = val;
            }

            index = reader.GetOrdinal("ErrorMessage");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.errormessage = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("Notes");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.notes = val;
            }

            index = reader.GetOrdinal("IsTemplate");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.istemplate = val;
            }

            index = reader.GetOrdinal("IsDebug");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdebug = val;
            }

            index = reader.GetOrdinal("Status");
            if (!reader.IsDBNull(index))
                loadObj.status = (JobStatus)Enum.Parse(typeof(JobStatus), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Priority");
            if (!reader.IsDBNull(index))
                loadObj.priority = (JobPriority)Enum.Parse(typeof(JobPriority), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ScheduledByID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.scheduledbyID = val;
            }


            //
            // Object connections
            //

            // Machines
            loadObj.machines = MachineCollection<Job>.CreateFromReader(loadObj, reader, c);
            // ActivityInstances
            loadObj.activityinstances = ActivityInstanceCollection<Job>.CreateFromReader(loadObj, reader, c);
            // Schedules
            loadObj.schedules = JobScheduleCollection<Job>.CreateFromReader(loadObj, "Template", "Schedule", reader, c);
            // AdditionalParameters
            loadObj.additionalparameters = AdditionalParameterCollection<Job>.CreateFromReader(loadObj, "Job", "AdditionalParameter", reader, c);
        }

        public static Job Load(Guid id, Connection c)
        {
            return Load<Job>(id, c, Job.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Jobs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Jobs in the system</returns>
        public static List<Job> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Job>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Job)], 
                Job.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Jobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Jobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Job> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Job>(owner, Job.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Jobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Jobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Job> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Job>(owner, src, Job.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Jobs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Jobs that match the criteria</returns>
        public static List<Job> Search(string text, Connection c)
        {
            return LoadAll<Job>(Connection.Action.Search, text, Job.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.IntegerField CompletePerc = new FieldDefs.IntegerField("CompletePerc");
                public static FieldDefs.BooleanField Exclusive = new FieldDefs.BooleanField("Exclusive");
                public static FieldDefs.DateTimeField StartTime = new FieldDefs.DateTimeField("StartTime");
                public static FieldDefs.DateTimeField StopTime = new FieldDefs.DateTimeField("StopTime");
                public static FieldDefs.BooleanField Success = new FieldDefs.BooleanField("Success");
                public static FieldDefs.StringField ErrorMessage = new FieldDefs.StringField("ErrorMessage");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.StringField Notes = new FieldDefs.StringField("Notes");
                public static FieldDefs.BooleanField IsTemplate = new FieldDefs.BooleanField("IsTemplate");
                public static FieldDefs.BooleanField IsDebug = new FieldDefs.BooleanField("IsDebug");
                public static FieldDefs.EnumField<JobStatus> Status = new FieldDefs.EnumField<JobStatus>("Status");
                public static FieldDefs.EnumField<JobPriority> Priority = new FieldDefs.EnumField<JobPriority>("Priority");
                public static FieldDefs.ObjectField<User> ScheduledBy = new FieldDefs.ObjectField<User>("ScheduledBy");
                public static FieldDefs.RelationSimpleField<Machine> Machine = new FieldDefs.RelationSimpleField<Machine>("Machine", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<ActivityInstance> ActivityInstance = new FieldDefs.RelationSimpleField<ActivityInstance>("ActivityInstance", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause CompletePerc(IntegerField.Condition op, System.Int32 value) { return Fields.CompletePerc.CreateSearchClause(op, value); }
            public static ISearchClause Exclusive(BooleanField.Condition op, System.Boolean value) { return Fields.Exclusive.CreateSearchClause(op, value); }
            public static ISearchClause StartTime(DateTimeField.Condition op, System.DateTime value) { return Fields.StartTime.CreateSearchClause(op, value); }
            public static ISearchClause StopTime(DateTimeField.Condition op, System.DateTime value) { return Fields.StopTime.CreateSearchClause(op, value); }
            public static ISearchClause Success(BooleanField.Condition op, System.Boolean value) { return Fields.Success.CreateSearchClause(op, value); }
            public static ISearchClause ErrorMessage(StringField.Condition op, System.String value) { return Fields.ErrorMessage.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause Notes(StringField.Condition op, System.String value) { return Fields.Notes.CreateSearchClause(op, value); }
            public static ISearchClause IsTemplate(BooleanField.Condition op, System.Boolean value) { return Fields.IsTemplate.CreateSearchClause(op, value); }
            public static ISearchClause IsDebug(BooleanField.Condition op, System.Boolean value) { return Fields.IsDebug.CreateSearchClause(op, value); }
            public static ISearchClause Status(EnumField<JobStatus>.Condition op, JobStatus value) { return Fields.Status.CreateSearchClause(op, value); }
            public static ISearchClause Priority(EnumField<JobPriority>.Condition op, JobPriority value) { return Fields.Priority.CreateSearchClause(op, value); }
            public static ISearchClause ScheduledBy(ObjectField<User>.Condition op, User value) { return Fields.ScheduledBy.CreateSearchClause(op, value); }
            public static ISearchClause Machine(RelationSimpleField<Machine>.Condition op, Machine value) { return Fields.Machine.CreateSearchClause(op, value); }
            public static ISearchClause ActivityInstance(RelationSimpleField<ActivityInstance>.Condition op, ActivityInstance value) { return Fields.ActivityInstance.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Job> Search(Job.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Job, Connection.Action.Search, ref paramList, Job.CreateFromDataStore, out results);
            return results.ConvertAll<Job>(BasicObject.ConvertFromIObject<Job>);
        }
		

        /// <summary>
        /// Saves the Job object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("CompletePerc", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.completeperc));

            mydata.Add(new Parameter("Exclusive", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.exclusive));

            mydata.Add(new Parameter("StartTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.starttime));

            mydata.Add(new Parameter("StopTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.stoptime));

            mydata.Add(new Parameter("Success", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.success));

            mydata.Add(new Parameter("ErrorMessage", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.errormessage));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("Notes", Parameter.ParamType.String, Parameter.ParamDirection.In, this.notes));

            mydata.Add(new Parameter("IsTemplate", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.istemplate));

            mydata.Add(new Parameter("IsDebug", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdebug));

            mydata.Add(new Parameter("Status", Parameter.ParamType.String, Parameter.ParamDirection.In, this.status.ToString()));
            mydata.Add(new Parameter("Priority", Parameter.ParamType.String, Parameter.ParamDirection.In, this.priority.ToString()));
            mydata.Add(new Parameter("ScheduledByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.scheduledbyID == Guid.Empty ?
                (this.ScheduledBy == null ? Guid.Empty : ((IObject)this.ScheduledBy).ID)
                : this.scheduledbyID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Job and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Job> updPipe = new PipelineParameter<Job>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.machines.Refresh();
            this.activityinstances.Refresh();
            this.schedules.Refresh();
            this.additionalparameters.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.machines.Clear();
            this.activityinstances.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User scheduledby)
            {
                this.scheduledby=scheduledby;

            }

            public IObject CopyTo(Connection target, Job job)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("CompletePerc", Parameter.ParamType.Int, Parameter.ParamDirection.In, job.completeperc));
                 mydata.Add(new Parameter("Exclusive", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, job.exclusive));
                 mydata.Add(new Parameter("StartTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, job.starttime));
                 mydata.Add(new Parameter("StopTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, job.stoptime));
                 mydata.Add(new Parameter("Success", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, job.success));
                 mydata.Add(new Parameter("ErrorMessage", Parameter.ParamType.Text, Parameter.ParamDirection.In, job.errormessage));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, job.isdeleted));
                 mydata.Add(new Parameter("Notes", Parameter.ParamType.String, Parameter.ParamDirection.In, job.notes));
                 mydata.Add(new Parameter("IsTemplate", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, job.istemplate));
                 mydata.Add(new Parameter("IsDebug", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, job.isdebug));
                 mydata.Add(new Parameter("Status", Parameter.ParamType.String, Parameter.ParamDirection.In, job.status.ToString()));
                 mydata.Add(new Parameter("Priority", Parameter.ParamType.String, Parameter.ParamDirection.In, job.priority.ToString()));
			     mydata.Add(new Parameter("ScheduledByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.scheduledby == null ? Guid.Empty : ((IObject)this.scheduledby).ID)));

                PipelineParameter<Job> pipe = new PipelineParameter<Job>(CreateFromDataStore);
                IObject newObj = job.SaveTo(mydata, store, pipe);

                return newObj;
            }

            User scheduledby;

        } 
        
              
    }
}
