/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the JobSchedules that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the JobSchedule collection</typeparam>
    public class JobScheduleCollection<O> : SyncCollection<O, JobSchedule>
        where O : IObject
    {
        public JobScheduleCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, JobSchedule>.DelayLoadCallback(JobScheduleCollection_OnDelayLoad);
        }

        public JobScheduleCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, JobSchedule>.DelayLoadCallback(JobScheduleCollection_OnDelayLoadRef);
        }

        List<JobSchedule> JobScheduleCollection_OnDelayLoad(Connection c)
        {
            return JobSchedule.LoadAll(this.Owner, c);
        }

        List<JobSchedule> JobScheduleCollection_OnDelayLoadRef(Connection c)
        {
            return JobSchedule.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static JobScheduleCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            JobScheduleCollection<O> objList = new JobScheduleCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static JobScheduleCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            JobScheduleCollection<O> objList = new JobScheduleCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// JobSchedule
    /// </summary>
    [Serializable]
    public partial class JobSchedule : BasicObject
    {
        private System.String name;
        private System.DateTime starttime;
        private System.DateTime stoptime;
        private System.Boolean isexpireenable;
        private System.Int32 recurrence;
        private System.Int32 days;
        private System.String description;
        private ScheduleStatus status;
        private ScheduleType schedule;
        private Guid scheduledbyID;
        private User scheduledby;
        private Guid templateID;
        private Job template;
        

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.String Name
        {
            get { return name; }
            set
            {
                name = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.DateTime StartTime
        {
            get { return starttime; }
            set
            {
                starttime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.DateTime StopTime
        {
            get { return stoptime; }
            set
            {
                stoptime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.Boolean IsExpireEnable
        {
            get { return isexpireenable; }
            set
            {
                isexpireenable = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.Int32 Recurrence
        {
            get { return recurrence; }
            set
            {
                recurrence = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.Int32 Days
        {
            get { return days; }
            set
            {
                days = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public ScheduleStatus Status
        {
            get { return status; }
            set
            {
                status = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the JobSchedule
        /// </summary>
        public ScheduleType Schedule
        {
            get { return schedule; }
            set
            {
                schedule = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User ScheduledBy
        {
            get
            {
                lock (this)
                {
                    if (scheduledby == null && scheduledbyID != Guid.Empty)
                        scheduledby = User.Load(scheduledbyID, Conn);
                }
                return scheduledby;
            }

            set
            {
                lock (this)
                {
                    scheduledby = value;                   
                    scheduledbyID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Job Template
        {
            get
            {
                lock (this)
                {
                    if (template == null && templateID != Guid.Empty)
                        template = Job.Load(templateID, Conn);
                }
                return template;
            }

            set
            {
                lock (this)
                {
                    template = value;                   
                    templateID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public JobSchedule(Connection c)
            : base(SRStorage.JobSchedule, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static JobSchedule Create(System.String name, Job template, Connection c)
        {
            JobSchedule newObj = new JobSchedule(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.name = name;
            newObj.template = template;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a JobSchedule object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>JobSchedule object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            JobSchedule loadObj = new JobSchedule(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(JobSchedule loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Name");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.name = val;
            }

            index = reader.GetOrdinal("StartTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.starttime = val;
            }

            index = reader.GetOrdinal("StopTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.stoptime = val;
            }

            index = reader.GetOrdinal("IsExpireEnable");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isexpireenable = val;
            }

            index = reader.GetOrdinal("Recurrence");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.recurrence = val;
            }

            index = reader.GetOrdinal("Days");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.days = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("Status");
            if (!reader.IsDBNull(index))
                loadObj.status = (ScheduleStatus)Enum.Parse(typeof(ScheduleStatus), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Schedule");
            if (!reader.IsDBNull(index))
                loadObj.schedule = (ScheduleType)Enum.Parse(typeof(ScheduleType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ScheduledByID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.scheduledbyID = val;
            }

            index = reader.GetOrdinal("TemplateID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.templateID = val;
            }


            //
            // Object connections
            //

        }

        public static JobSchedule Load(Guid id, Connection c)
        {
            return Load<JobSchedule>(id, c, JobSchedule.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL JobSchedules from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all JobSchedules in the system</returns>
        public static List<JobSchedule> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<JobSchedule>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(JobSchedule)], 
                JobSchedule.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all JobSchedules that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the JobSchedules</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<JobSchedule> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<JobSchedule>(owner, JobSchedule.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all JobSchedules that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the JobSchedules</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<JobSchedule> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<JobSchedule>(owner, src, JobSchedule.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches JobSchedules by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of JobSchedules that match the criteria</returns>
        public static List<JobSchedule> Search(string text, Connection c)
        {
            return LoadAll<JobSchedule>(Connection.Action.Search, text, JobSchedule.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField StartTime = new FieldDefs.DateTimeField("StartTime");
                public static FieldDefs.DateTimeField StopTime = new FieldDefs.DateTimeField("StopTime");
                public static FieldDefs.BooleanField IsExpireEnable = new FieldDefs.BooleanField("IsExpireEnable");
                public static FieldDefs.IntegerField Recurrence = new FieldDefs.IntegerField("Recurrence");
                public static FieldDefs.IntegerField Days = new FieldDefs.IntegerField("Days");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.EnumField<ScheduleStatus> Status = new FieldDefs.EnumField<ScheduleStatus>("Status");
                public static FieldDefs.EnumField<ScheduleType> Schedule = new FieldDefs.EnumField<ScheduleType>("Schedule");
                public static FieldDefs.ObjectField<User> ScheduledBy = new FieldDefs.ObjectField<User>("ScheduledBy");
                public static FieldDefs.ObjectField<Job> Template = new FieldDefs.ObjectField<Job>("Template");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause StartTime(DateTimeField.Condition op, System.DateTime value) { return Fields.StartTime.CreateSearchClause(op, value); }
            public static ISearchClause StopTime(DateTimeField.Condition op, System.DateTime value) { return Fields.StopTime.CreateSearchClause(op, value); }
            public static ISearchClause IsExpireEnable(BooleanField.Condition op, System.Boolean value) { return Fields.IsExpireEnable.CreateSearchClause(op, value); }
            public static ISearchClause Recurrence(IntegerField.Condition op, System.Int32 value) { return Fields.Recurrence.CreateSearchClause(op, value); }
            public static ISearchClause Days(IntegerField.Condition op, System.Int32 value) { return Fields.Days.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause Status(EnumField<ScheduleStatus>.Condition op, ScheduleStatus value) { return Fields.Status.CreateSearchClause(op, value); }
            public static ISearchClause Schedule(EnumField<ScheduleType>.Condition op, ScheduleType value) { return Fields.Schedule.CreateSearchClause(op, value); }
            public static ISearchClause ScheduledBy(ObjectField<User>.Condition op, User value) { return Fields.ScheduledBy.CreateSearchClause(op, value); }
            public static ISearchClause Template(ObjectField<Job>.Condition op, Job value) { return Fields.Template.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<JobSchedule> Search(JobSchedule.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.JobSchedule, Connection.Action.Search, ref paramList, JobSchedule.CreateFromDataStore, out results);
            return results.ConvertAll<JobSchedule>(BasicObject.ConvertFromIObject<JobSchedule>);
        }
		

        /// <summary>
        /// Saves the JobSchedule object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Name", Parameter.ParamType.String, Parameter.ParamDirection.In, this.name));

            mydata.Add(new Parameter("StartTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.starttime));

            mydata.Add(new Parameter("StopTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.stoptime));

            mydata.Add(new Parameter("IsExpireEnable", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isexpireenable));

            mydata.Add(new Parameter("Recurrence", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.recurrence));

            mydata.Add(new Parameter("Days", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.days));

            mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("Status", Parameter.ParamType.String, Parameter.ParamDirection.In, this.status.ToString()));
            mydata.Add(new Parameter("Schedule", Parameter.ParamType.String, Parameter.ParamDirection.In, this.schedule.ToString()));
            mydata.Add(new Parameter("ScheduledByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.scheduledbyID == Guid.Empty ?
                (this.ScheduledBy == null ? Guid.Empty : ((IObject)this.ScheduledBy).ID)
                : this.scheduledbyID)));
            mydata.Add(new Parameter("TemplateID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.templateID == Guid.Empty ?
                (this.Template == null ? Guid.Empty : ((IObject)this.Template).ID)
                : this.templateID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the JobSchedule and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<JobSchedule> updPipe = new PipelineParameter<JobSchedule>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User scheduledby,Job template)
            {
                this.scheduledby=scheduledby;
                this.template=template;

            }

            public IObject CopyTo(Connection target, JobSchedule jobschedule)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Name", Parameter.ParamType.String, Parameter.ParamDirection.In, jobschedule.name));
                 mydata.Add(new Parameter("StartTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, jobschedule.starttime));
                 mydata.Add(new Parameter("StopTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, jobschedule.stoptime));
                 mydata.Add(new Parameter("IsExpireEnable", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, jobschedule.isexpireenable));
                 mydata.Add(new Parameter("Recurrence", Parameter.ParamType.Int, Parameter.ParamDirection.In, jobschedule.recurrence));
                 mydata.Add(new Parameter("Days", Parameter.ParamType.Int, Parameter.ParamDirection.In, jobschedule.days));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, jobschedule.description));
                 mydata.Add(new Parameter("Status", Parameter.ParamType.String, Parameter.ParamDirection.In, jobschedule.status.ToString()));
                 mydata.Add(new Parameter("Schedule", Parameter.ParamType.String, Parameter.ParamDirection.In, jobschedule.schedule.ToString()));
			     mydata.Add(new Parameter("ScheduledByID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.scheduledby == null ? Guid.Empty : ((IObject)this.scheduledby).ID)));
			     mydata.Add(new Parameter("TemplateID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.template == null ? Guid.Empty : ((IObject)this.template).ID)));

                PipelineParameter<JobSchedule> pipe = new PipelineParameter<JobSchedule>(CreateFromDataStore);
                IObject newObj = jobschedule.SaveTo(mydata, store, pipe);

                return newObj;
            }

            User scheduledby;
            Job template;

        }
        
       
    }
}
