/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Keywords that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Keyword collection</typeparam>
    public class KeywordCollection<O> : SyncCollection<O, Keyword>
        where O : IObject
    {
        public KeywordCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Keyword>.DelayLoadCallback(KeywordCollection_OnDelayLoad);
        }

        public KeywordCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Keyword>.DelayLoadCallback(KeywordCollection_OnDelayLoadRef);
        }

        List<Keyword> KeywordCollection_OnDelayLoad(Connection c)
        {
            return Keyword.LoadAll(this.Owner, c);
        }

        List<Keyword> KeywordCollection_OnDelayLoadRef(Connection c)
        {
            return Keyword.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static KeywordCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            KeywordCollection<O> objList = new KeywordCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static KeywordCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            KeywordCollection<O> objList = new KeywordCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Keyword
    /// </summary>
    [Serializable]
    public partial class Keyword : NamedObject<Keyword>
    {
        
        private NamespaceCollection<Keyword> m_namespaces;
        private ServiceCollection<Keyword> services;
        private TagCollection<Keyword> tags;

        
        public NamespaceCollection<Keyword> Namespaces { get { return m_namespaces; } }
        public ServiceCollection<Keyword> Services { get { return services; } }
        public TagCollection<Keyword> Tags { get { return tags; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Keyword(Connection c)
            : base(SRStorage.Keyword, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new Keyword Create(string name, Connection c)
        {
            Keyword newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.m_namespaces = new NamespaceCollection<Keyword>(newObj, c);
            newObj.services = new ServiceCollection<Keyword>(newObj, c);
            newObj.tags = new TagCollection<Keyword>(newObj, c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Keyword Load(string name, Connection c)
        {
            return NamedObject<Keyword>.Load(name, c, Keyword.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Keyword object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Keyword object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Keyword loadObj = (Keyword)NamedObject<Keyword>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Keyword loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Keyword>.LoadFromDataStore(loadObj, reader, c);


            //
            // Object data
            //


            //
            // Object connections
            //

            // Namespaces
            loadObj.m_namespaces = NamespaceCollection<Keyword>.CreateFromReader(loadObj, reader, c);
            // Services
            loadObj.services = ServiceCollection<Keyword>.CreateFromReader(loadObj, reader, c);
            // Tags
            loadObj.tags = TagCollection<Keyword>.CreateFromReader(loadObj, reader, c);
        }

        public static Keyword Load(Guid id, Connection c)
        {
            return Load<Keyword>(id, c, Keyword.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Keywords from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Keywords in the system</returns>
        public static List<Keyword> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Keyword>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Keyword)], 
                Keyword.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Keywords that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Keywords</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Keyword> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Keyword>(owner, Keyword.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Keywords that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Keywords</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Keyword> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Keyword>(owner, src, Keyword.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Keywords by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Keywords that match the criteria</returns>
        public static List<Keyword> Search(string text, Connection c)
        {
            return LoadAll<Keyword>(Connection.Action.Search, text, Keyword.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.RelationSimpleField<Namespace> Namespace = new FieldDefs.RelationSimpleField<Namespace>("Namespace", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Service> Service = new FieldDefs.RelationSimpleField<Service>("Service", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Tag> Tag = new FieldDefs.RelationSimpleField<Tag>("Tag", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Namespace(RelationSimpleField<Namespace>.Condition op, Namespace value) { return Fields.Namespace.CreateSearchClause(op, value); }
            public static ISearchClause Service(RelationSimpleField<Service>.Condition op, Service value) { return Fields.Service.CreateSearchClause(op, value); }
            public static ISearchClause Tag(RelationSimpleField<Tag>.Condition op, Tag value) { return Fields.Tag.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Keyword> Search(Keyword.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Keyword, Connection.Action.Search, ref paramList, Keyword.CreateFromDataStore, out results);
            return results.ConvertAll<Keyword>(BasicObject.ConvertFromIObject<Keyword>);
        }
		

        /// <summary>
        /// Saves the Keyword object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Keyword and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Keyword> updPipe = new PipelineParameter<Keyword>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.m_namespaces.Refresh();
            this.services.Refresh();
            this.tags.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.m_namespaces.Clear();
            this.services.Clear();
            this.tags.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, Keyword keyword)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();

                PipelineParameter<Keyword> pipe = new PipelineParameter<Keyword>(CreateFromDataStore);
                IObject newObj = keyword.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
