/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Machines that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Machine collection</typeparam>
    public class MachineCollection<O> : SyncCollection<O, Machine>
        where O : IObject
    {
        public MachineCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Machine>.DelayLoadCallback(MachineCollection_OnDelayLoad);
        }

        public MachineCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Machine>.DelayLoadCallback(MachineCollection_OnDelayLoadRef);
        }

        List<Machine> MachineCollection_OnDelayLoad(Connection c)
        {
            return Machine.LoadAll(this.Owner, c);
        }

        List<Machine> MachineCollection_OnDelayLoadRef(Connection c)
        {
            return Machine.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static MachineCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            MachineCollection<O> objList = new MachineCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static MachineCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            MachineCollection<O> objList = new MachineCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Machine
    /// </summary>
    [Serializable]
    public partial class Machine : NamedObject<Machine>
    {
        private System.String address;
        private System.String location;
        private System.String description;
        private System.String errormessage;
        private System.Boolean isdeleted;
        private System.Int32 maxconcurrentjobs;
        private System.Boolean isinteractiveexecution;
        private System.String computeinstalleddirectory;
        private System.String clusteruser;
        private System.String clusterpassword;
        private ExecutorAvailabiltiy availability;
        private MachineType type;
        private Guid parentID;
        private Machine parent;
        
        private JobCollection<Machine> jobs;
        private MachineCollection<Machine> children;
        private HealthCheckCollection<Machine> healthchecks;

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String Address
        {
            get { return address; }
            set
            {
                address = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String Location
        {
            get { return location; }
            set
            {
                location = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String ErrorMessage
        {
            get { return errormessage; }
            set
            {
                errormessage = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.Int32 MaxConcurrentJobs
        {
            get { return maxconcurrentjobs; }
            set
            {
                maxconcurrentjobs = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.Boolean IsInteractiveExecution
        {
            get { return isinteractiveexecution; }
            set
            {
                isinteractiveexecution = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String ComputeInstalledDirectory
        {
            get { return computeinstalleddirectory; }
            set
            {
                computeinstalleddirectory = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String ClusterUser
        {
            get { return clusteruser; }
            set
            {
                clusteruser = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public System.String ClusterPassword
        {
            get { return clusterpassword; }
            set
            {
                clusterpassword = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public ExecutorAvailabiltiy Availability
        {
            get { return availability; }
            set
            {
                availability = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Machine
        /// </summary>
        public MachineType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Machine Parent
        {
            get
            {
                lock (this)
                {
                    if (parent == null && parentID != Guid.Empty)
                        parent = Machine.Load(parentID, Conn);
                }
                return parent;
            }

            set
            {
                lock (this)
                {
                    parent = value;                   
                    parentID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public JobCollection<Machine> Jobs { get { return jobs; } }
        public MachineCollection<Machine> Children { get { return children; } }
        public HealthCheckCollection<Machine> HealthChecks { get { return healthchecks; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Machine(Connection c)
            : base(SRStorage.Machine, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static Machine Create(string name, MachineType type, Connection c)
        {
            Machine newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.type = type;

			
            // Empty collections
            newObj.jobs = new JobCollection<Machine>(newObj, c);
            newObj.children = new MachineCollection<Machine>(newObj, "Parent", "Children", c);
            newObj.healthchecks = new HealthCheckCollection<Machine>(newObj, "Node", "HealthCheck", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Machine Load(string name, Connection c)
        {
            return NamedObject<Machine>.Load(name, c, Machine.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Machine object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Machine object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Machine loadObj = (Machine)NamedObject<Machine>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Machine loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Machine>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Address");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.address = val;
            }

            index = reader.GetOrdinal("Location");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.location = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("ErrorMessage");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.errormessage = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("MaxConcurrentJobs");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.maxconcurrentjobs = val;
            }

            index = reader.GetOrdinal("IsInteractiveExecution");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isinteractiveexecution = val;
            }

            index = reader.GetOrdinal("ComputeInstalledDirectory");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.computeinstalleddirectory = val;
            }

            index = reader.GetOrdinal("ClusterUser");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.clusteruser = val;
            }

            index = reader.GetOrdinal("ClusterPassword");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.clusterpassword = val;
            }

            index = reader.GetOrdinal("Availability");
            if (!reader.IsDBNull(index))
                loadObj.availability = (ExecutorAvailabiltiy)Enum.Parse(typeof(ExecutorAvailabiltiy), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (MachineType)Enum.Parse(typeof(MachineType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ParentID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.parentID = val;
            }


            //
            // Object connections
            //

            // Jobs
            loadObj.jobs = JobCollection<Machine>.CreateFromReader(loadObj, reader, c);
            // Children
            loadObj.children = MachineCollection<Machine>.CreateFromReader(loadObj, "Parent", "Children", reader, c);
            // HealthChecks
            loadObj.healthchecks = HealthCheckCollection<Machine>.CreateFromReader(loadObj, "Node", "HealthCheck", reader, c);
        }

        public static Machine Load(Guid id, Connection c)
        {
            return Load<Machine>(id, c, Machine.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Machines from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Machines in the system</returns>
        public static List<Machine> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Machine>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Machine)], 
                Machine.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Machines that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Machines</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Machine> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Machine>(owner, Machine.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Machines that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Machines</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Machine> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Machine>(owner, src, Machine.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Machines by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Machines that match the criteria</returns>
        public static List<Machine> Search(string text, Connection c)
        {
            return LoadAll<Machine>(Connection.Action.Search, text, Machine.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Address = new FieldDefs.StringField("Address");
                public static FieldDefs.StringField Location = new FieldDefs.StringField("Location");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.StringField ErrorMessage = new FieldDefs.StringField("ErrorMessage");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.IntegerField MaxConcurrentJobs = new FieldDefs.IntegerField("MaxConcurrentJobs");
                public static FieldDefs.BooleanField IsInteractiveExecution = new FieldDefs.BooleanField("IsInteractiveExecution");
                public static FieldDefs.StringField ComputeInstalledDirectory = new FieldDefs.StringField("ComputeInstalledDirectory");
                public static FieldDefs.StringField ClusterUser = new FieldDefs.StringField("ClusterUser");
                public static FieldDefs.StringField ClusterPassword = new FieldDefs.StringField("ClusterPassword");
                public static FieldDefs.EnumField<ExecutorAvailabiltiy> Availability = new FieldDefs.EnumField<ExecutorAvailabiltiy>("Availability");
                public static FieldDefs.EnumField<MachineType> Type = new FieldDefs.EnumField<MachineType>("Type");
                public static FieldDefs.ObjectField<Machine> Parent = new FieldDefs.ObjectField<Machine>("Parent");
                public static FieldDefs.RelationSimpleField<Job> Job = new FieldDefs.RelationSimpleField<Job>("Job", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Address(StringField.Condition op, System.String value) { return Fields.Address.CreateSearchClause(op, value); }
            public static ISearchClause Location(StringField.Condition op, System.String value) { return Fields.Location.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause ErrorMessage(StringField.Condition op, System.String value) { return Fields.ErrorMessage.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause MaxConcurrentJobs(IntegerField.Condition op, System.Int32 value) { return Fields.MaxConcurrentJobs.CreateSearchClause(op, value); }
            public static ISearchClause IsInteractiveExecution(BooleanField.Condition op, System.Boolean value) { return Fields.IsInteractiveExecution.CreateSearchClause(op, value); }
            public static ISearchClause ComputeInstalledDirectory(StringField.Condition op, System.String value) { return Fields.ComputeInstalledDirectory.CreateSearchClause(op, value); }
            public static ISearchClause ClusterUser(StringField.Condition op, System.String value) { return Fields.ClusterUser.CreateSearchClause(op, value); }
            public static ISearchClause ClusterPassword(StringField.Condition op, System.String value) { return Fields.ClusterPassword.CreateSearchClause(op, value); }
            public static ISearchClause Availability(EnumField<ExecutorAvailabiltiy>.Condition op, ExecutorAvailabiltiy value) { return Fields.Availability.CreateSearchClause(op, value); }
            public static ISearchClause Type(EnumField<MachineType>.Condition op, MachineType value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause Parent(ObjectField<Machine>.Condition op, Machine value) { return Fields.Parent.CreateSearchClause(op, value); }
            public static ISearchClause Job(RelationSimpleField<Job>.Condition op, Job value) { return Fields.Job.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Machine> Search(Machine.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Machine, Connection.Action.Search, ref paramList, Machine.CreateFromDataStore, out results);
            return results.ConvertAll<Machine>(BasicObject.ConvertFromIObject<Machine>);
        }
		

        /// <summary>
        /// Saves the Machine object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Address", Parameter.ParamType.String, Parameter.ParamDirection.In, this.address));

            mydata.Add(new Parameter("Location", Parameter.ParamType.String, Parameter.ParamDirection.In, this.location));

            mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("ErrorMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, this.errormessage));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("MaxConcurrentJobs", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.maxconcurrentjobs));

            mydata.Add(new Parameter("IsInteractiveExecution", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isinteractiveexecution));

            mydata.Add(new Parameter("ComputeInstalledDirectory", Parameter.ParamType.String, Parameter.ParamDirection.In, this.computeinstalleddirectory));

            mydata.Add(new Parameter("ClusterUser", Parameter.ParamType.String, Parameter.ParamDirection.In, this.clusteruser));

            mydata.Add(new Parameter("ClusterPassword", Parameter.ParamType.String, Parameter.ParamDirection.In, this.clusterpassword));

            mydata.Add(new Parameter("Availability", Parameter.ParamType.String, Parameter.ParamDirection.In, this.availability.ToString()));
            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
            mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.parentID == Guid.Empty ?
                (this.Parent == null ? Guid.Empty : ((IObject)this.Parent).ID)
                : this.parentID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Machine and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Machine> updPipe = new PipelineParameter<Machine>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.jobs.Refresh();
            this.children.Refresh();
            this.healthchecks.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.jobs.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Machine parent)
            {
                this.parent=parent;

            }

            public IObject CopyTo(Connection target, Machine machine)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Address", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.address));
                 mydata.Add(new Parameter("Location", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.location));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.description));
                 mydata.Add(new Parameter("ErrorMessage", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.errormessage));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, machine.isdeleted));
                 mydata.Add(new Parameter("MaxConcurrentJobs", Parameter.ParamType.Int, Parameter.ParamDirection.In, machine.maxconcurrentjobs));
                 mydata.Add(new Parameter("IsInteractiveExecution", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, machine.isinteractiveexecution));
                 mydata.Add(new Parameter("ComputeInstalledDirectory", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.computeinstalleddirectory));
                 mydata.Add(new Parameter("ClusterUser", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.clusteruser));
                 mydata.Add(new Parameter("ClusterPassword", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.clusterpassword));
                 mydata.Add(new Parameter("Availability", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.availability.ToString()));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, machine.type.ToString()));
			     mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.parent == null ? Guid.Empty : ((IObject)this.parent).ID)));

                PipelineParameter<Machine> pipe = new PipelineParameter<Machine>(CreateFromDataStore);
                IObject newObj = machine.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Machine parent;

        } 
        
              
    }
}
