/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Methods that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Method collection</typeparam>
    public class MethodCollection<O> : SyncCollection<O, Method>
        where O : IObject
    {
        public MethodCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Method>.DelayLoadCallback(MethodCollection_OnDelayLoad);
        }

        public MethodCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Method>.DelayLoadCallback(MethodCollection_OnDelayLoadRef);
        }

        List<Method> MethodCollection_OnDelayLoad(Connection c)
        {
            return Method.LoadAll(this.Owner, c);
        }

        List<Method> MethodCollection_OnDelayLoadRef(Connection c)
        {
            return Method.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static MethodCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            MethodCollection<O> objList = new MethodCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static MethodCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            MethodCollection<O> objList = new MethodCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Method
    /// </summary>
    [Serializable]
    public partial class Method : NamedObject<Method>
    {
        private RegistryDataType returns;
        private WSDL.SOAP.OperationStyle callstyle;
        private WSDL.SOAP.BodyUse inputencoding;
        private WSDL.SOAP.BodyUse outputencoding;
        private Guid serviceID;
        private Service service;
        
        private ArtifactCollection<Method> artifacts;

        /// <summary>
        /// Description of the Method
        /// </summary>
        public RegistryDataType Returns
        {
            get { return returns; }
            set
            {
                returns = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Method
        /// </summary>
        public WSDL.SOAP.OperationStyle CallStyle
        {
            get { return callstyle; }
            set
            {
                callstyle = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Method
        /// </summary>
        public WSDL.SOAP.BodyUse InputEncoding
        {
            get { return inputencoding; }
            set
            {
                inputencoding = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Method
        /// </summary>
        public WSDL.SOAP.BodyUse OutputEncoding
        {
            get { return outputencoding; }
            set
            {
                outputencoding = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Service Service
        {
            get
            {
                lock (this)
                {
                    if (service == null && serviceID != Guid.Empty)
                        service = Service.Load(serviceID, Conn);
                }
                return service;
            }

            set
            {
                lock (this)
                {
                    service = value;                   
                    serviceID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public ArtifactCollection<Method> Artifacts { get { return artifacts; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Method(Connection c)
            : base(SRStorage.Method, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static Method Create(string name, RegistryDataType returns, Service service, Connection c)
        {
            Method newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.returns = returns;
            newObj.service = service;

			
            newObj.artifacts = new ArtifactCollection<Method>(newObj, "Method", "Artifact", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Method Load(string name, Connection c)
        {
            return NamedObject<Method>.Load(name, c, Method.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Method object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Method object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Method loadObj = (Method)NamedObject<Method>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Method loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Method>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("ReturnType");
            if (!reader.IsDBNull(index))
                loadObj.returns = (RegistryDataType)Enum.Parse(typeof(RegistryDataType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("CallStyle");
            if (!reader.IsDBNull(index))
                loadObj.callstyle = (WSDL.SOAP.OperationStyle)Enum.Parse(typeof(WSDL.SOAP.OperationStyle), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("InputEncoding");
            if (!reader.IsDBNull(index))
                loadObj.inputencoding = (WSDL.SOAP.BodyUse)Enum.Parse(typeof(WSDL.SOAP.BodyUse), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("OutputEncoding");
            if (!reader.IsDBNull(index))
                loadObj.outputencoding = (WSDL.SOAP.BodyUse)Enum.Parse(typeof(WSDL.SOAP.BodyUse), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ServiceID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.serviceID = val;
            }


            //
            // Object connections
            //

            // Artifacts
            loadObj.artifacts = ArtifactCollection<Method>.CreateFromReader(loadObj, "Method", "Artifact", reader, c);
        }

        public static Method Load(Guid id, Connection c)
        {
            return Load<Method>(id, c, Method.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Methods from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Methods in the system</returns>
        public static List<Method> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Method>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Method)], 
                Method.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Methods that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Methods</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Method> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Method>(owner, Method.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Methods that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Methods</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Method> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Method>(owner, src, Method.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Methods by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Methods that match the criteria</returns>
        public static List<Method> Search(string text, Connection c)
        {
            return LoadAll<Method>(Connection.Action.Search, text, Method.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.EnumField<RegistryDataType> Returns = new FieldDefs.EnumField<RegistryDataType>("Returns");
                public static FieldDefs.EnumField<WSDL.SOAP.OperationStyle> CallStyle = new FieldDefs.EnumField<WSDL.SOAP.OperationStyle>("CallStyle");
                public static FieldDefs.EnumField<WSDL.SOAP.BodyUse> InputEncoding = new FieldDefs.EnumField<WSDL.SOAP.BodyUse>("InputEncoding");
                public static FieldDefs.EnumField<WSDL.SOAP.BodyUse> OutputEncoding = new FieldDefs.EnumField<WSDL.SOAP.BodyUse>("OutputEncoding");
                public static FieldDefs.ObjectField<Service> Service = new FieldDefs.ObjectField<Service>("Service");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Returns(EnumField<RegistryDataType>.Condition op, RegistryDataType value) { return Fields.Returns.CreateSearchClause(op, value); }
            public static ISearchClause CallStyle(EnumField<WSDL.SOAP.OperationStyle>.Condition op, WSDL.SOAP.OperationStyle value) { return Fields.CallStyle.CreateSearchClause(op, value); }
            public static ISearchClause InputEncoding(EnumField<WSDL.SOAP.BodyUse>.Condition op, WSDL.SOAP.BodyUse value) { return Fields.InputEncoding.CreateSearchClause(op, value); }
            public static ISearchClause OutputEncoding(EnumField<WSDL.SOAP.BodyUse>.Condition op, WSDL.SOAP.BodyUse value) { return Fields.OutputEncoding.CreateSearchClause(op, value); }
            public static ISearchClause Service(ObjectField<Service>.Condition op, Service value) { return Fields.Service.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Method> Search(Method.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Method, Connection.Action.Search, ref paramList, Method.CreateFromDataStore, out results);
            return results.ConvertAll<Method>(BasicObject.ConvertFromIObject<Method>);
        }
		

        /// <summary>
        /// Saves the Method object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("ReturnType", Parameter.ParamType.String, Parameter.ParamDirection.In, this.returns.ToString()));
            mydata.Add(new Parameter("CallStyle", Parameter.ParamType.String, Parameter.ParamDirection.In, this.callstyle.ToString()));
            mydata.Add(new Parameter("InputEncoding", Parameter.ParamType.String, Parameter.ParamDirection.In, this.inputencoding.ToString()));
            mydata.Add(new Parameter("OutputEncoding", Parameter.ParamType.String, Parameter.ParamDirection.In, this.outputencoding.ToString()));
            mydata.Add(new Parameter("ServiceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.serviceID == Guid.Empty ?
                (this.Service == null ? Guid.Empty : ((IObject)this.Service).ID)
                : this.serviceID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Method and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Method> updPipe = new PipelineParameter<Method>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.artifacts.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Service service)
            {
                this.service=service;

            }

            public IObject CopyTo(Connection target, Method method)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("ReturnType", Parameter.ParamType.String, Parameter.ParamDirection.In, method.returns.ToString()));
                 mydata.Add(new Parameter("CallStyle", Parameter.ParamType.String, Parameter.ParamDirection.In, method.callstyle.ToString()));
                 mydata.Add(new Parameter("InputEncoding", Parameter.ParamType.String, Parameter.ParamDirection.In, method.inputencoding.ToString()));
                 mydata.Add(new Parameter("OutputEncoding", Parameter.ParamType.String, Parameter.ParamDirection.In, method.outputencoding.ToString()));
			     mydata.Add(new Parameter("ServiceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.service == null ? Guid.Empty : ((IObject)this.service).ID)));

                PipelineParameter<Method> pipe = new PipelineParameter<Method>(CreateFromDataStore);
                IObject newObj = method.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Service service;

        } 
        
              
    }
}
