/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Namespaces that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Namespace collection</typeparam>
    public class NamespaceCollection<O> : SyncCollection<O, Namespace>
        where O : IObject
    {
        public NamespaceCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Namespace>.DelayLoadCallback(NamespaceCollection_OnDelayLoad);
        }

        public NamespaceCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Namespace>.DelayLoadCallback(NamespaceCollection_OnDelayLoadRef);
        }

        List<Namespace> NamespaceCollection_OnDelayLoad(Connection c)
        {
            return Namespace.LoadAll(this.Owner, c);
        }

        List<Namespace> NamespaceCollection_OnDelayLoadRef(Connection c)
        {
            return Namespace.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static NamespaceCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            NamespaceCollection<O> objList = new NamespaceCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static NamespaceCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            NamespaceCollection<O> objList = new NamespaceCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Namespace
    /// </summary>
    [Serializable]
    public partial class Namespace : NamedObject<Namespace>
    {
        private System.String label;
        private System.String description;
        private System.Drawing.Color editorcolor;
        private System.Drawing.Image icon;
        private bool iconLoaded = false;
        private bool iconChanged = false;
        private System.Int32 iconsize;
        private System.Boolean iseditable;
        private Guid userID;
        private User user;
        private Guid parentID;
        private Namespace parent;
        
        private TagCollection<Namespace> tags;
        private KeywordCollection<Namespace> keywords;
        private ActivityCollection<Namespace> activitys;
        private NamespaceCollection<Namespace> children;
        private NamespaceIconBlobCollection<Namespace> iconstores;
        private ServiceCollection<Namespace> services;

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.String Label
        {
            get { return label; }
            set
            {
                label = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.Drawing.Color EditorColor
        {
            get { return editorcolor; }
            set
            {
                editorcolor = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public BlobBase.TransferProgressHandler OnIconTransfer;

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public BlobBase.BeginClearStoreProgressHandler OnIconClearBegin;

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public BlobBase.EndClearStoreProgressHandler OnIconClearEnd;

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.Drawing.Image Icon
        {
            get 
            { 
                if (iconLoaded)
                {
                    // Uses cached version
                    return icon;
                }
                
                System.IO.Stream bStream = null;
				
				//
                // Load from BLOB storage
                //
                icon = null;
                iconLoaded = true;

                int count = this.IconStores.Count;

                if (count == 0)
                    return null;

                List<IBlob> list = new List<IBlob>();
                foreach (NamespaceIconBlob blob in this.IconStores)
                {
                    list.Add(blob);
                }
                
                bStream = BlobBase.FetchBlobs<NamespaceIconBlob, List<IBlob>>(list);

                icon = System.Drawing.Image.FromStream(bStream);

                bStream.Close();
                
                return icon;
            }
            set
            {
				icon = value;
                iconLoaded = true;
                iconChanged = true;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.Int32 IconSize
        {
            get { return iconsize; }
            set
            {
                iconsize = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Namespace
        /// </summary>
        public System.Boolean IsEditable
        {
            get { return iseditable; }
            set
            {
                iseditable = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User User
        {
            get
            {
                lock (this)
                {
                    if (user == null && userID != Guid.Empty)
                        user = User.Load(userID, Conn);
                }
                return user;
            }

            set
            {
                lock (this)
                {
                    user = value;                   
                    userID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Namespace Parent
        {
            get
            {
                lock (this)
                {
                    if (parent == null && parentID != Guid.Empty)
                        parent = Namespace.Load(parentID, Conn);
                }
                return parent;
            }

            set
            {
                lock (this)
                {
                    parent = value;                   
                    parentID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public TagCollection<Namespace> Tags { get { return tags; } }
        public KeywordCollection<Namespace> Keywords { get { return keywords; } }
        public ActivityCollection<Namespace> Activitys { get { return activitys; } }
        public NamespaceCollection<Namespace> Children { get { return children; } }
        protected NamespaceIconBlobCollection<Namespace> IconStores { get { return iconstores; } }
        public ServiceCollection<Namespace> Services { get { return services; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Namespace(Connection c)
            : base(SRStorage.Namespace, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new Namespace Create(string name, Connection c)
        {
            Namespace newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.tags = new TagCollection<Namespace>(newObj, c);
            newObj.keywords = new KeywordCollection<Namespace>(newObj, c);
            newObj.activitys = new ActivityCollection<Namespace>(newObj, c);
            newObj.children = new NamespaceCollection<Namespace>(newObj, "Parent", "Children", c);
            newObj.iconstores = new NamespaceIconBlobCollection<Namespace>(newObj, "Namespace", "IconStore", c);
            newObj.services = new ServiceCollection<Namespace>(newObj, "Parent", "Service", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Namespace Load(string name, Connection c)
        {
            return NamedObject<Namespace>.Load(name, c, Namespace.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Namespace object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Namespace object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Namespace loadObj = (Namespace)NamedObject<Namespace>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Namespace loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Namespace>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Label");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.label = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("EditorColor");
            if (!reader.IsDBNull(index))
            {
                Int32 valStore = reader.GetInt32(index);
                System.Drawing.Color val = System.Drawing.Color.FromArgb(valStore);
                loadObj.editorcolor = val;
            }

            index = reader.GetOrdinal("IconSize");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.iconsize = val;
            }

            index = reader.GetOrdinal("IsEditable");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.iseditable = val;
            }

            index = reader.GetOrdinal("OwnerID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.userID = val;
            }

            index = reader.GetOrdinal("ParentID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.parentID = val;
            }


            //
            // Object connections
            //

            // Tags
            loadObj.tags = TagCollection<Namespace>.CreateFromReader(loadObj, reader, c);
            // Keywords
            loadObj.keywords = KeywordCollection<Namespace>.CreateFromReader(loadObj, reader, c);
            // Activitys
            loadObj.activitys = ActivityCollection<Namespace>.CreateFromReader(loadObj, reader, c);
            // Children
            loadObj.children = NamespaceCollection<Namespace>.CreateFromReader(loadObj, "Parent", "Children", reader, c);
            // IconStores
            loadObj.iconstores = NamespaceIconBlobCollection<Namespace>.CreateFromReader(loadObj, "Namespace", "IconStore", reader, c);
            // Services
            loadObj.services = ServiceCollection<Namespace>.CreateFromReader(loadObj, "Parent", "Service", reader, c);
        }

        public static Namespace Load(Guid id, Connection c)
        {
            return Load<Namespace>(id, c, Namespace.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Namespaces from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Namespaces in the system</returns>
        public static List<Namespace> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Namespace>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Namespace)], 
                Namespace.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Namespaces that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Namespaces</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Namespace> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Namespace>(owner, Namespace.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Namespaces that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Namespaces</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Namespace> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Namespace>(owner, src, Namespace.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Namespaces by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Namespaces that match the criteria</returns>
        public static List<Namespace> Search(string text, Connection c)
        {
            return LoadAll<Namespace>(Connection.Action.Search, text, Namespace.CreateFromDataStore, c);
        }

        private void SaveIconBlob(Connection c)
        {
            if (!this.iconChanged)
			   return;
			   
            // Clear previous version
            foreach (NamespaceIconBlob b in this.IconStores)
            {
                b.Delete();
            }

			// Notify begin of store clear
			BlobBase.FireOnAnyBeginClearStore(this, "Icon", c);
			if (OnIconClearBegin != null)
				OnIconClearBegin(this, "Icon", c);

            this.IconStores.Refresh();
            this.IconStores.Clear();

			// Notify end of store clear
			if (OnIconClearEnd != null)
				OnIconClearEnd(this, "Icon", c);
			BlobBase.FireOnAnyEndClearStore(this, "Icon", c);

            // Reset changed bit
            this.iconChanged = false;
            
            // Save the size (starts with 0)
            this.iconsize = 0;
            
            if (icon == null)
                return;

            // Serialize image and save to store
            System.IO.MemoryStream saveStore = new System.IO.MemoryStream();
            icon.Save(saveStore, System.Drawing.Imaging.ImageFormat.Png);
            byte[] __cnv_contents = saveStore.GetBuffer();
            this.iconsize = __cnv_contents.Length;
            List<NamespaceIconBlob> iconBlobs = BlobBase.SaveBlobs<NamespaceIconBlob, Namespace>(this, icon, "Icon", __cnv_contents, 
				CreateIconBlob, OnIconTransfer, c);
            this.IconStores.Load(iconBlobs);
            
            // Update cache size
            Save();
        }

        public static NamespaceIconBlob CreateIconBlob(Guid streamId, int index, int total, Guid revisionId, Namespace src, Connection c)
        {
            return NamespaceIconBlob.Create(streamId, index, total, revisionId, src, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Label = new FieldDefs.StringField("Label");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.IntegerField IconSize = new FieldDefs.IntegerField("IconSize");
                public static FieldDefs.BooleanField IsEditable = new FieldDefs.BooleanField("IsEditable");
                public static FieldDefs.ObjectField<User> User = new FieldDefs.ObjectField<User>("User");
                public static FieldDefs.ObjectField<Namespace> Parent = new FieldDefs.ObjectField<Namespace>("Parent");
                public static FieldDefs.RelationSimpleField<Tag> Tag = new FieldDefs.RelationSimpleField<Tag>("Tag", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Keyword> Keyword = new FieldDefs.RelationSimpleField<Keyword>("Keyword", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Activity> Activity = new FieldDefs.RelationSimpleField<Activity>("Activity", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Label(StringField.Condition op, System.String value) { return Fields.Label.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause IconSize(IntegerField.Condition op, System.Int32 value) { return Fields.IconSize.CreateSearchClause(op, value); }
            public static ISearchClause IsEditable(BooleanField.Condition op, System.Boolean value) { return Fields.IsEditable.CreateSearchClause(op, value); }
            public static ISearchClause User(ObjectField<User>.Condition op, User value) { return Fields.User.CreateSearchClause(op, value); }
            public static ISearchClause Parent(ObjectField<Namespace>.Condition op, Namespace value) { return Fields.Parent.CreateSearchClause(op, value); }
            public static ISearchClause Tag(RelationSimpleField<Tag>.Condition op, Tag value) { return Fields.Tag.CreateSearchClause(op, value); }
            public static ISearchClause Keyword(RelationSimpleField<Keyword>.Condition op, Keyword value) { return Fields.Keyword.CreateSearchClause(op, value); }
            public static ISearchClause Activity(RelationSimpleField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Namespace> Search(Namespace.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Namespace, Connection.Action.Search, ref paramList, Namespace.CreateFromDataStore, out results);
            return results.ConvertAll<Namespace>(BasicObject.ConvertFromIObject<Namespace>);
        }
		

        /// <summary>
        /// Saves the Namespace object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, this.label));

            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("EditorColor", Parameter.ParamType.Color, Parameter.ParamDirection.In, this.editorcolor.ToArgb()));

            mydata.Add(new Parameter("IconSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.iconsize));

            mydata.Add(new Parameter("IsEditable", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.iseditable));

            mydata.Add(new Parameter("OwnerID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.userID == Guid.Empty ?
                (this.User == null ? Guid.Empty : ((IObject)this.User).ID)
                : this.userID)));
            mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.parentID == Guid.Empty ?
                (this.Parent == null ? Guid.Empty : ((IObject)this.Parent).ID)
                : this.parentID)));
            
            Save(mydata);
            
            SaveIconBlob(store);

        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Namespace and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Namespace> updPipe = new PipelineParameter<Namespace>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.tags.Refresh();
            this.keywords.Refresh();
            this.activitys.Refresh();
            this.children.Refresh();
            this.iconstores.Refresh();
            this.services.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.tags.Clear();
            this.keywords.Clear();
            this.activitys.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User user,Namespace parent)
            {
                this.user=user;
                this.parent=parent;

            }

            public IObject CopyTo(Connection target, Namespace m_namespace)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Label", Parameter.ParamType.String, Parameter.ParamDirection.In, m_namespace.label));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, m_namespace.description));
                 mydata.Add(new Parameter("EditorColor", Parameter.ParamType.Color, Parameter.ParamDirection.In, m_namespace.editorcolor.ToArgb()));
                 mydata.Add(new Parameter("IconSize", Parameter.ParamType.Int, Parameter.ParamDirection.In, m_namespace.iconsize));
                 mydata.Add(new Parameter("IsEditable", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, m_namespace.iseditable));
			     mydata.Add(new Parameter("OwnerID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.user == null ? Guid.Empty : ((IObject)this.user).ID)));
			     mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.parent == null ? Guid.Empty : ((IObject)this.parent).ID)));

                PipelineParameter<Namespace> pipe = new PipelineParameter<Namespace>(CreateFromDataStore);
                IObject newObj = m_namespace.SaveTo(mydata, store, pipe);
                 m_namespace.SaveIconBlob(store);

                return newObj;
            }

            User user;
            Namespace parent;

        } 
        
              
    }
}
