/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the NamespaceIconBlobs that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the NamespaceIconBlob collection</typeparam>
    public class NamespaceIconBlobCollection<O> : SyncCollection<O, NamespaceIconBlob>
        where O : IObject
    {
        public NamespaceIconBlobCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, NamespaceIconBlob>.DelayLoadCallback(NamespaceIconBlobCollection_OnDelayLoad);
        }

        public NamespaceIconBlobCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, NamespaceIconBlob>.DelayLoadCallback(NamespaceIconBlobCollection_OnDelayLoadRef);
        }

        List<NamespaceIconBlob> NamespaceIconBlobCollection_OnDelayLoad(Connection c)
        {
            return NamespaceIconBlob.LoadAll(this.Owner, c);
        }

        List<NamespaceIconBlob> NamespaceIconBlobCollection_OnDelayLoadRef(Connection c)
        {
            return NamespaceIconBlob.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static NamespaceIconBlobCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            NamespaceIconBlobCollection<O> objList = new NamespaceIconBlobCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static NamespaceIconBlobCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            NamespaceIconBlobCollection<O> objList = new NamespaceIconBlobCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// NamespaceIconBlob
    /// </summary>
    [Serializable]
    public partial class NamespaceIconBlob : BasicObject, IBlob
    {
        private System.Guid packageid;
        private System.Int32 index;
        private System.Int32 chunks;
        private System.String contents;
        private System.Guid revisionid;
        private Guid m_namespaceID;
        private Namespace m_namespace;
        private Guid previousID;
        private NamespaceIconBlob previous;
        private Guid nextID;
        private NamespaceIconBlob next;
        

        /// <summary>
        /// Description of the NamespaceIconBlob
        /// </summary>
        public System.Guid PackageID
        {
            get { return packageid; }
            set
            {
                packageid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the NamespaceIconBlob
        /// </summary>
        public System.Int32 Index
        {
            get { return index; }
            set
            {
                index = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the NamespaceIconBlob
        /// </summary>
        public System.Int32 Chunks
        {
            get { return chunks; }
            set
            {
                chunks = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the NamespaceIconBlob
        /// </summary>
        public System.String Contents
        {
            get { return contents; }
            set
            {
                contents = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the NamespaceIconBlob
        /// </summary>
        public System.Guid RevisionID
        {
            get { return revisionid; }
            set
            {
                revisionid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Namespace Namespace
        {
            get
            {
                lock (this)
                {
                    if (m_namespace == null && m_namespaceID != Guid.Empty)
                        m_namespace = Namespace.Load(m_namespaceID, Conn);
                }
                return m_namespace;
            }

            set
            {
                lock (this)
                {
                    m_namespace = value;                   
                    m_namespaceID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public NamespaceIconBlob Previous
        {
            get
            {
                lock (this)
                {
                    if (previous == null && previousID != Guid.Empty)
                        previous = NamespaceIconBlob.Load(previousID, Conn);
                }
                return previous;
            }

            set
            {
                lock (this)
                {
                    previous = value;                   
                    previousID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public NamespaceIconBlob Next
        {
            get
            {
                lock (this)
                {
                    if (next == null && nextID != Guid.Empty)
                        next = NamespaceIconBlob.Load(nextID, Conn);
                }
                return next;
            }

            set
            {
                lock (this)
                {
                    next = value;                   
                    nextID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public NamespaceIconBlob(Connection c)
            : base(SRStorage.NamespaceIconBlob, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static NamespaceIconBlob Create(System.Guid packageid, System.Int32 index, System.Int32 chunks, System.Guid revisionid, Namespace m_namespace, Connection c)
        {
            NamespaceIconBlob newObj = new NamespaceIconBlob(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.packageid = packageid;
            newObj.index = index;
            newObj.chunks = chunks;
            newObj.revisionid = revisionid;
            newObj.m_namespace = m_namespace;
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a NamespaceIconBlob object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>NamespaceIconBlob object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            NamespaceIconBlob loadObj = new NamespaceIconBlob(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(NamespaceIconBlob loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("PackageID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.packageid = val;
            }

            index = reader.GetOrdinal("Index");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.index = val;
            }

            index = reader.GetOrdinal("Chunks");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.chunks = val;
            }

            index = reader.GetOrdinal("Contents");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.contents = val;
            }

            index = reader.GetOrdinal("RevisionID");
            if (!reader.IsDBNull(index))
            {
                System.Guid val = reader.GetGuid(index);
                loadObj.revisionid = val;
            }

            index = reader.GetOrdinal("NamespaceID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.m_namespaceID = val;
            }

            index = reader.GetOrdinal("PreviousID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.previousID = val;
            }

            index = reader.GetOrdinal("NextID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.nextID = val;
            }


            //
            // Object connections
            //

        }

        public static NamespaceIconBlob Load(Guid id, Connection c)
        {
            return Load<NamespaceIconBlob>(id, c, NamespaceIconBlob.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL NamespaceIconBlobs from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all NamespaceIconBlobs in the system</returns>
        public static List<NamespaceIconBlob> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<NamespaceIconBlob>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(NamespaceIconBlob)], 
                NamespaceIconBlob.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all NamespaceIconBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the NamespaceIconBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<NamespaceIconBlob> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<NamespaceIconBlob>(owner, NamespaceIconBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all NamespaceIconBlobs that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the NamespaceIconBlobs</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<NamespaceIconBlob> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<NamespaceIconBlob>(owner, src, NamespaceIconBlob.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches NamespaceIconBlobs by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of NamespaceIconBlobs that match the criteria</returns>
        public static List<NamespaceIconBlob> Search(string text, Connection c)
        {
            return LoadAll<NamespaceIconBlob>(Connection.Action.Search, text, NamespaceIconBlob.CreateFromDataStore, c);
        }



		

        /// <summary>
        /// Saves the NamespaceIconBlob object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.packageid));

            mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.index));

            mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.chunks));

            mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, this.contents));

            mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.revisionid));

            mydata.Add(new Parameter("NamespaceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.m_namespaceID == Guid.Empty ?
                (this.Namespace == null ? Guid.Empty : ((IObject)this.Namespace).ID)
                : this.m_namespaceID)));
            mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.previousID == Guid.Empty ?
                (this.Previous == null ? Guid.Empty : ((IObject)this.Previous).ID)
                : this.previousID)));
            mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.nextID == Guid.Empty ?
                (this.Next == null ? Guid.Empty : ((IObject)this.Next).ID)
                : this.nextID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the NamespaceIconBlob and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<NamespaceIconBlob> updPipe = new PipelineParameter<NamespaceIconBlob>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Namespace m_namespace,NamespaceIconBlob previous,NamespaceIconBlob next)
            {
                this.m_namespace=m_namespace;
                this.previous=previous;
                this.next=next;

            }

            public IObject CopyTo(Connection target, NamespaceIconBlob namespaceiconblob)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("PackageID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, namespaceiconblob.packageid));
                 mydata.Add(new Parameter("Index", Parameter.ParamType.Int, Parameter.ParamDirection.In, namespaceiconblob.index));
                 mydata.Add(new Parameter("Chunks", Parameter.ParamType.Int, Parameter.ParamDirection.In, namespaceiconblob.chunks));
                 mydata.Add(new Parameter("Contents", Parameter.ParamType.String, Parameter.ParamDirection.In, namespaceiconblob.contents));
                 mydata.Add(new Parameter("RevisionID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, namespaceiconblob.revisionid));
			     mydata.Add(new Parameter("NamespaceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.m_namespace == null ? Guid.Empty : ((IObject)this.m_namespace).ID)));
			     mydata.Add(new Parameter("PreviousID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.previous == null ? Guid.Empty : ((IObject)this.previous).ID)));
			     mydata.Add(new Parameter("NextID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.next == null ? Guid.Empty : ((IObject)this.next).ID)));

                PipelineParameter<NamespaceIconBlob> pipe = new PipelineParameter<NamespaceIconBlob>(CreateFromDataStore);
                IObject newObj = namespaceiconblob.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Namespace m_namespace;
            NamespaceIconBlob previous;
            NamespaceIconBlob next;

        }
        
       
    }
}
