/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ParameterAssignments that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ParameterAssignment collection</typeparam>
    public class ParameterAssignmentCollection<O> : SyncCollection<O, ParameterAssignment>
        where O : IObject
    {
        public ParameterAssignmentCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ParameterAssignment>.DelayLoadCallback(ParameterAssignmentCollection_OnDelayLoad);
        }

        public ParameterAssignmentCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ParameterAssignment>.DelayLoadCallback(ParameterAssignmentCollection_OnDelayLoadRef);
        }

        List<ParameterAssignment> ParameterAssignmentCollection_OnDelayLoad(Connection c)
        {
            return ParameterAssignment.LoadAll(this.Owner, c);
        }

        List<ParameterAssignment> ParameterAssignmentCollection_OnDelayLoadRef(Connection c)
        {
            return ParameterAssignment.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ParameterAssignmentCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ParameterAssignmentCollection<O> objList = new ParameterAssignmentCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ParameterAssignmentCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ParameterAssignmentCollection<O> objList = new ParameterAssignmentCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ParameterAssignment
    /// </summary>
    [Serializable]
    public partial class ParameterAssignment : BasicObject
    {
        private System.String boundtopath;
        private System.Boolean requiredforworkflow;
        private System.String currentvalue;
        private System.String outputlabel;
        private System.Boolean isfinal;
        private System.String type;
        private Guid activityparameterID;
        private ActivityParameter activityparameter;
        private Guid instanceID;
        private ActivitySequence instance;
        private Guid boundtoID;
        private ParameterAssignment boundto;
        
        private DataProductCollection<ParameterAssignment> dataproducts;
        private ParameterAssignmentCollection<ParameterAssignment> boundfroms;

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.String BoundToPath
        {
            get { return boundtopath; }
            set
            {
                boundtopath = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.Boolean RequiredForWorkflow
        {
            get { return requiredforworkflow; }
            set
            {
                requiredforworkflow = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.String CurrentValue
        {
            get { return currentvalue; }
            set
            {
                currentvalue = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.String OutputLabel
        {
            get { return outputlabel; }
            set
            {
                outputlabel = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.Boolean IsFinal
        {
            get { return isfinal; }
            set
            {
                isfinal = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ParameterAssignment
        /// </summary>
        public System.String Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public ActivityParameter ActivityParameter
        {
            get
            {
                lock (this)
                {
                    if (activityparameter == null && activityparameterID != Guid.Empty)
                        activityparameter = ActivityParameter.Load(activityparameterID, Conn);
                }
                return activityparameter;
            }

            set
            {
                lock (this)
                {
                    activityparameter = value;                   
                    activityparameterID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ActivitySequence Instance
        {
            get
            {
                lock (this)
                {
                    if (instance == null && instanceID != Guid.Empty)
                        instance = ActivitySequence.Load(instanceID, Conn);
                }
                return instance;
            }

            set
            {
                lock (this)
                {
                    instance = value;                   
                    instanceID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public ParameterAssignment BoundTo
        {
            get
            {
                lock (this)
                {
                    if (boundto == null && boundtoID != Guid.Empty)
                        boundto = ParameterAssignment.Load(boundtoID, Conn);
                }
                return boundto;
            }

            set
            {
                lock (this)
                {
                    boundto = value;                   
                    boundtoID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }


        public DataProductCollection<ParameterAssignment> DataProducts { get { return dataproducts; } }
        public ParameterAssignmentCollection<ParameterAssignment> BoundFroms { get { return boundfroms; } }

		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ParameterAssignment(Connection c)
            : base(SRStorage.ParameterAssignment, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ParameterAssignment Create(ActivityParameter activityparameter, ActivitySequence instance, Connection c)
        {
            ParameterAssignment newObj = new ParameterAssignment(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.activityparameter = activityparameter;
            newObj.instance = instance;
	
            newObj.dataproducts = new DataProductCollection<ParameterAssignment>(newObj, "CreatorParameter", "DataProduct", c);
            newObj.boundfroms = new ParameterAssignmentCollection<ParameterAssignment>(newObj, "BoundTo", "BoundFrom", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ParameterAssignment object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ParameterAssignment object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ParameterAssignment loadObj = new ParameterAssignment(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ParameterAssignment loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("BoundToPath");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.boundtopath = val;
            }

            index = reader.GetOrdinal("RequiredForWorkflow");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.requiredforworkflow = val;
            }

            index = reader.GetOrdinal("CurrentValue");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.currentvalue = val;
            }

            index = reader.GetOrdinal("OutputLabel");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.outputlabel = val;
            }

            index = reader.GetOrdinal("IsFinal");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isfinal = val;
            }

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.type = val;
            }

            index = reader.GetOrdinal("ActivityParameterID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityparameterID = val;
            }

            index = reader.GetOrdinal("InstanceID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.instanceID = val;
            }

            index = reader.GetOrdinal("BoundToID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.boundtoID = val;
            }


            //
            // Object connections
            //

            // DataProducts
            loadObj.dataproducts = DataProductCollection<ParameterAssignment>.CreateFromReader(loadObj, "CreatorParameter", "DataProduct", reader, c);
            // BoundFroms
            loadObj.boundfroms = ParameterAssignmentCollection<ParameterAssignment>.CreateFromReader(loadObj, "BoundTo", "BoundFrom", reader, c);
        }

        public static ParameterAssignment Load(Guid id, Connection c)
        {
            return Load<ParameterAssignment>(id, c, ParameterAssignment.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ParameterAssignments from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ParameterAssignments in the system</returns>
        public static List<ParameterAssignment> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ParameterAssignment>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ParameterAssignment)], 
                ParameterAssignment.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ParameterAssignments that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ParameterAssignments</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ParameterAssignment> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ParameterAssignment>(owner, ParameterAssignment.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ParameterAssignments that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ParameterAssignments</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ParameterAssignment> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ParameterAssignment>(owner, src, ParameterAssignment.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ParameterAssignments by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ParameterAssignments that match the criteria</returns>
        public static List<ParameterAssignment> Search(string text, Connection c)
        {
            return LoadAll<ParameterAssignment>(Connection.Action.Search, text, ParameterAssignment.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField BoundToPath = new FieldDefs.StringField("BoundToPath");
                public static FieldDefs.BooleanField RequiredForWorkflow = new FieldDefs.BooleanField("RequiredForWorkflow");
                public static FieldDefs.StringField CurrentValue = new FieldDefs.StringField("CurrentValue");
                public static FieldDefs.StringField OutputLabel = new FieldDefs.StringField("OutputLabel");
                public static FieldDefs.BooleanField IsFinal = new FieldDefs.BooleanField("IsFinal");
                public static FieldDefs.StringField Type = new FieldDefs.StringField("Type");
                public static FieldDefs.ObjectField<ActivityParameter> ActivityParameter = new FieldDefs.ObjectField<ActivityParameter>("ActivityParameter");
                public static FieldDefs.ObjectField<ActivitySequence> Instance = new FieldDefs.ObjectField<ActivitySequence>("Instance");
                public static FieldDefs.ObjectField<ParameterAssignment> BoundTo = new FieldDefs.ObjectField<ParameterAssignment>("BoundTo");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause BoundToPath(StringField.Condition op, System.String value) { return Fields.BoundToPath.CreateSearchClause(op, value); }
            public static ISearchClause RequiredForWorkflow(BooleanField.Condition op, System.Boolean value) { return Fields.RequiredForWorkflow.CreateSearchClause(op, value); }
            public static ISearchClause CurrentValue(StringField.Condition op, System.String value) { return Fields.CurrentValue.CreateSearchClause(op, value); }
            public static ISearchClause OutputLabel(StringField.Condition op, System.String value) { return Fields.OutputLabel.CreateSearchClause(op, value); }
            public static ISearchClause IsFinal(BooleanField.Condition op, System.Boolean value) { return Fields.IsFinal.CreateSearchClause(op, value); }
            public static ISearchClause Type(StringField.Condition op, System.String value) { return Fields.Type.CreateSearchClause(op, value); }
            public static ISearchClause ActivityParameter(ObjectField<ActivityParameter>.Condition op, ActivityParameter value) { return Fields.ActivityParameter.CreateSearchClause(op, value); }
            public static ISearchClause Instance(ObjectField<ActivitySequence>.Condition op, ActivitySequence value) { return Fields.Instance.CreateSearchClause(op, value); }
            public static ISearchClause BoundTo(ObjectField<ParameterAssignment>.Condition op, ParameterAssignment value) { return Fields.BoundTo.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ParameterAssignment> Search(ParameterAssignment.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ParameterAssignment, Connection.Action.Search, ref paramList, ParameterAssignment.CreateFromDataStore, out results);
            return results.ConvertAll<ParameterAssignment>(BasicObject.ConvertFromIObject<ParameterAssignment>);
        }
		

        /// <summary>
        /// Saves the ParameterAssignment object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("BoundToPath", Parameter.ParamType.String, Parameter.ParamDirection.In, this.boundtopath));

            mydata.Add(new Parameter("RequiredForWorkflow", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.requiredforworkflow));

            mydata.Add(new Parameter("CurrentValue", Parameter.ParamType.String, Parameter.ParamDirection.In, this.currentvalue));

            mydata.Add(new Parameter("OutputLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, this.outputlabel));

            mydata.Add(new Parameter("IsFinal", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isfinal));

            mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type));

            mydata.Add(new Parameter("ActivityParameterID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityparameterID == Guid.Empty ?
                (this.ActivityParameter == null ? Guid.Empty : ((IObject)this.ActivityParameter).ID)
                : this.activityparameterID)));
            mydata.Add(new Parameter("InstanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.instanceID == Guid.Empty ?
                (this.Instance == null ? Guid.Empty : ((IObject)this.Instance).ID)
                : this.instanceID)));
            mydata.Add(new Parameter("BoundToID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.boundtoID == Guid.Empty ?
                (this.BoundTo == null ? Guid.Empty : ((IObject)this.BoundTo).ID)
                : this.boundtoID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ParameterAssignment and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ParameterAssignment> updPipe = new PipelineParameter<ParameterAssignment>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.dataproducts.Refresh();
            this.boundfroms.Refresh();
        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ActivityParameter activityparameter,ActivitySequence instance,ParameterAssignment boundto)
            {
                this.activityparameter=activityparameter;
                this.instance=instance;
                this.boundto=boundto;

            }

            public IObject CopyTo(Connection target, ParameterAssignment parameterassignment)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("BoundToPath", Parameter.ParamType.String, Parameter.ParamDirection.In, parameterassignment.boundtopath));
                 mydata.Add(new Parameter("RequiredForWorkflow", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, parameterassignment.requiredforworkflow));
                 mydata.Add(new Parameter("CurrentValue", Parameter.ParamType.String, Parameter.ParamDirection.In, parameterassignment.currentvalue));
                 mydata.Add(new Parameter("OutputLabel", Parameter.ParamType.String, Parameter.ParamDirection.In, parameterassignment.outputlabel));
                 mydata.Add(new Parameter("IsFinal", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, parameterassignment.isfinal));
                 mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, parameterassignment.type));
			     mydata.Add(new Parameter("ActivityParameterID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activityparameter == null ? Guid.Empty : ((IObject)this.activityparameter).ID)));
			     mydata.Add(new Parameter("InstanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.instance == null ? Guid.Empty : ((IObject)this.instance).ID)));
			     mydata.Add(new Parameter("BoundToID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.boundto == null ? Guid.Empty : ((IObject)this.boundto).ID)));

                PipelineParameter<ParameterAssignment> pipe = new PipelineParameter<ParameterAssignment>(CreateFromDataStore);
                IObject newObj = parameterassignment.SaveTo(mydata, store, pipe);

                return newObj;
            }

            ActivityParameter activityparameter;
            ActivitySequence instance;
            ParameterAssignment boundto;

        }
        
       
    }
}
