/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the PerformanceDetails that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the PerformanceDetail collection</typeparam>
    public class PerformanceDetailCollection<O> : SyncCollection<O, PerformanceDetail>
        where O : IObject
    {
        public PerformanceDetailCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, PerformanceDetail>.DelayLoadCallback(PerformanceDetailCollection_OnDelayLoad);
        }

        public PerformanceDetailCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, PerformanceDetail>.DelayLoadCallback(PerformanceDetailCollection_OnDelayLoadRef);
        }

        List<PerformanceDetail> PerformanceDetailCollection_OnDelayLoad(Connection c)
        {
            return PerformanceDetail.LoadAll(this.Owner, c);
        }

        List<PerformanceDetail> PerformanceDetailCollection_OnDelayLoadRef(Connection c)
        {
            return PerformanceDetail.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static PerformanceDetailCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            PerformanceDetailCollection<O> objList = new PerformanceDetailCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static PerformanceDetailCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            PerformanceDetailCollection<O> objList = new PerformanceDetailCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// PerformanceDetail
    /// </summary>
    [Serializable]
    public partial class PerformanceDetail : NamedObject<PerformanceDetail>
    {
        private System.Int32 countervalue;
        private System.DateTime publishedtime;
        private PerformanceCounter counter;
        private Guid provenanceID;
        private ProvenanceDetail provenance;
        

        /// <summary>
        /// Description of the PerformanceDetail
        /// </summary>
        public System.Int32 CounterValue
        {
            get { return countervalue; }
            set
            {
                countervalue = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the PerformanceDetail
        /// </summary>
        public System.DateTime PublishedTime
        {
            get { return publishedtime; }
            set
            {
                publishedtime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the PerformanceDetail
        /// </summary>
        public PerformanceCounter Counter
        {
            get { return counter; }
            set
            {
                counter = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public ProvenanceDetail Provenance
        {
            get
            {
                lock (this)
                {
                    if (provenance == null && provenanceID != Guid.Empty)
                        provenance = ProvenanceDetail.Load(provenanceID, Conn);
                }
                return provenance;
            }

            set
            {
                lock (this)
                {
                    provenance = value;                   
                    provenanceID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public PerformanceDetail(Connection c)
            : base(SRStorage.PerformanceDetail, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new PerformanceDetail Create(string name, Connection c)
        {
            PerformanceDetail newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static PerformanceDetail Load(string name, Connection c)
        {
            return NamedObject<PerformanceDetail>.Load(name, c, PerformanceDetail.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a PerformanceDetail object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>PerformanceDetail object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            PerformanceDetail loadObj = (PerformanceDetail)NamedObject<PerformanceDetail>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(PerformanceDetail loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<PerformanceDetail>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("CounterValue");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.countervalue = val;
            }

            index = reader.GetOrdinal("PublishedTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.publishedtime = val;
            }

            index = reader.GetOrdinal("Counter");
            if (!reader.IsDBNull(index))
                loadObj.counter = (PerformanceCounter)Enum.Parse(typeof(PerformanceCounter), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("ProvenanceID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.provenanceID = val;
            }


            //
            // Object connections
            //

        }

        public static PerformanceDetail Load(Guid id, Connection c)
        {
            return Load<PerformanceDetail>(id, c, PerformanceDetail.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL PerformanceDetails from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all PerformanceDetails in the system</returns>
        public static List<PerformanceDetail> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<PerformanceDetail>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(PerformanceDetail)], 
                PerformanceDetail.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all PerformanceDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the PerformanceDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<PerformanceDetail> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<PerformanceDetail>(owner, PerformanceDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all PerformanceDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the PerformanceDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<PerformanceDetail> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<PerformanceDetail>(owner, src, PerformanceDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches PerformanceDetails by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of PerformanceDetails that match the criteria</returns>
        public static List<PerformanceDetail> Search(string text, Connection c)
        {
            return LoadAll<PerformanceDetail>(Connection.Action.Search, text, PerformanceDetail.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.IntegerField CounterValue = new FieldDefs.IntegerField("CounterValue");
                public static FieldDefs.DateTimeField PublishedTime = new FieldDefs.DateTimeField("PublishedTime");
                public static FieldDefs.EnumField<PerformanceCounter> Counter = new FieldDefs.EnumField<PerformanceCounter>("Counter");
                public static FieldDefs.ObjectField<ProvenanceDetail> Provenance = new FieldDefs.ObjectField<ProvenanceDetail>("Provenance");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause CounterValue(IntegerField.Condition op, System.Int32 value) { return Fields.CounterValue.CreateSearchClause(op, value); }
            public static ISearchClause PublishedTime(DateTimeField.Condition op, System.DateTime value) { return Fields.PublishedTime.CreateSearchClause(op, value); }
            public static ISearchClause Counter(EnumField<PerformanceCounter>.Condition op, PerformanceCounter value) { return Fields.Counter.CreateSearchClause(op, value); }
            public static ISearchClause Provenance(ObjectField<ProvenanceDetail>.Condition op, ProvenanceDetail value) { return Fields.Provenance.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<PerformanceDetail> Search(PerformanceDetail.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.PerformanceDetail, Connection.Action.Search, ref paramList, PerformanceDetail.CreateFromDataStore, out results);
            return results.ConvertAll<PerformanceDetail>(BasicObject.ConvertFromIObject<PerformanceDetail>);
        }
		

        /// <summary>
        /// Saves the PerformanceDetail object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("CounterValue", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.countervalue));

            mydata.Add(new Parameter("PublishedTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.publishedtime));

            mydata.Add(new Parameter("Counter", Parameter.ParamType.String, Parameter.ParamDirection.In, this.counter.ToString()));
            mydata.Add(new Parameter("ProvenanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.provenanceID == Guid.Empty ?
                (this.Provenance == null ? Guid.Empty : ((IObject)this.Provenance).ID)
                : this.provenanceID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the PerformanceDetail and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<PerformanceDetail> updPipe = new PipelineParameter<PerformanceDetail>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ProvenanceDetail provenance)
            {
                this.provenance=provenance;

            }

            public IObject CopyTo(Connection target, PerformanceDetail performancedetail)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("CounterValue", Parameter.ParamType.Int, Parameter.ParamDirection.In, performancedetail.countervalue));
                 mydata.Add(new Parameter("PublishedTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, performancedetail.publishedtime));
                 mydata.Add(new Parameter("Counter", Parameter.ParamType.String, Parameter.ParamDirection.In, performancedetail.counter.ToString()));
			     mydata.Add(new Parameter("ProvenanceID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.provenance == null ? Guid.Empty : ((IObject)this.provenance).ID)));

                PipelineParameter<PerformanceDetail> pipe = new PipelineParameter<PerformanceDetail>(CreateFromDataStore);
                IObject newObj = performancedetail.SaveTo(mydata, store, pipe);

                return newObj;
            }

            ProvenanceDetail provenance;

        } 
        
              
    }
}
