/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ProvenanceDetails that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ProvenanceDetail collection</typeparam>
    public class ProvenanceDetailCollection<O> : SyncCollection<O, ProvenanceDetail>
        where O : IObject
    {
        public ProvenanceDetailCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ProvenanceDetail>.DelayLoadCallback(ProvenanceDetailCollection_OnDelayLoad);
        }

        public ProvenanceDetailCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ProvenanceDetail>.DelayLoadCallback(ProvenanceDetailCollection_OnDelayLoadRef);
        }

        List<ProvenanceDetail> ProvenanceDetailCollection_OnDelayLoad(Connection c)
        {
            return ProvenanceDetail.LoadAll(this.Owner, c);
        }

        List<ProvenanceDetail> ProvenanceDetailCollection_OnDelayLoadRef(Connection c)
        {
            return ProvenanceDetail.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ProvenanceDetailCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ProvenanceDetailCollection<O> objList = new ProvenanceDetailCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ProvenanceDetailCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            ProvenanceDetailCollection<O> objList = new ProvenanceDetailCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// ProvenanceDetail
    /// </summary>
    [Serializable]
    public partial class ProvenanceDetail : BasicObject
    {
        private System.String currentindex;
        private System.Int32 starteventorder;
        private System.Int32 endeventorder;
        private System.Boolean iscompleted;
        private Guid provenanceinfoID;
        private ProvenanceInfo provenanceinfo;
        
        private ProcessingStatusCollection<ProvenanceDetail> processingstatuss;
        private PerformanceDetailCollection<ProvenanceDetail> performancedetails;
        private PerformanceStatCollection<ProvenanceDetail> performancestats;
        private InputOutputCollection<ProvenanceDetail> inputoutputs;
        private DataProductDetailCollection<ProvenanceDetail> dataproductdetails;

        /// <summary>
        /// Description of the ProvenanceDetail
        /// </summary>
        public System.String CurrentIndex
        {
            get { return currentindex; }
            set
            {
                currentindex = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceDetail
        /// </summary>
        public System.Int32 StartEventOrder
        {
            get { return starteventorder; }
            set
            {
                starteventorder = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceDetail
        /// </summary>
        public System.Int32 EndEventOrder
        {
            get { return endeventorder; }
            set
            {
                endeventorder = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceDetail
        /// </summary>
        public System.Boolean IsCompleted
        {
            get { return iscompleted; }
            set
            {
                iscompleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public ProvenanceInfo ProvenanceInfo
        {
            get
            {
                lock (this)
                {
                    if (provenanceinfo == null && provenanceinfoID != Guid.Empty)
                        provenanceinfo = ProvenanceInfo.Load(provenanceinfoID, Conn);
                }
                return provenanceinfo;
            }

            set
            {
                lock (this)
                {
                    provenanceinfo = value;                   
                    provenanceinfoID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }


        public ProcessingStatusCollection<ProvenanceDetail> ProcessingStatuss { get { return processingstatuss; } }
        public PerformanceDetailCollection<ProvenanceDetail> PerformanceDetails { get { return performancedetails; } }
        public PerformanceStatCollection<ProvenanceDetail> PerformanceStats { get { return performancestats; } }
        public InputOutputCollection<ProvenanceDetail> InputOutputs { get { return inputoutputs; } }
        public DataProductDetailCollection<ProvenanceDetail> DataProductDetails { get { return dataproductdetails; } }

		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ProvenanceDetail(Connection c)
            : base(SRStorage.ProvenanceDetail, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ProvenanceDetail Create(Connection c)
        {
            ProvenanceDetail newObj = new ProvenanceDetail(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

	
            newObj.processingstatuss = new ProcessingStatusCollection<ProvenanceDetail>(newObj, "Provenance", "ProcessingStatus", c);
            newObj.performancedetails = new PerformanceDetailCollection<ProvenanceDetail>(newObj, "Provenance", "PerformanceDetail", c);
            newObj.performancestats = new PerformanceStatCollection<ProvenanceDetail>(newObj, "Provenance", "PerformanceStat", c);
            newObj.inputoutputs = new InputOutputCollection<ProvenanceDetail>(newObj, "Provenance", "InputOutput", c);
            newObj.dataproductdetails = new DataProductDetailCollection<ProvenanceDetail>(newObj, "ProvenanceDetail", "DataProductDetail", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a ProvenanceDetail object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ProvenanceDetail object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ProvenanceDetail loadObj = new ProvenanceDetail(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(ProvenanceDetail loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("CurrentIndex");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.currentindex = val;
            }

            index = reader.GetOrdinal("StartEventOrder");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.starteventorder = val;
            }

            index = reader.GetOrdinal("EndEventOrder");
            if (!reader.IsDBNull(index))
            {
                System.Int32 val = reader.GetInt32(index);
                loadObj.endeventorder = val;
            }

            index = reader.GetOrdinal("IsCompleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.iscompleted = val;
            }

            index = reader.GetOrdinal("ProvenanceInfoID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.provenanceinfoID = val;
            }


            //
            // Object connections
            //

            // ProcessingStatuss
            loadObj.processingstatuss = ProcessingStatusCollection<ProvenanceDetail>.CreateFromReader(loadObj, "Provenance", "ProcessingStatus", reader, c);
            // PerformanceDetails
            loadObj.performancedetails = PerformanceDetailCollection<ProvenanceDetail>.CreateFromReader(loadObj, "Provenance", "PerformanceDetail", reader, c);
            // PerformanceStats
            loadObj.performancestats = PerformanceStatCollection<ProvenanceDetail>.CreateFromReader(loadObj, "Provenance", "PerformanceStat", reader, c);
            // InputOutputs
            loadObj.inputoutputs = InputOutputCollection<ProvenanceDetail>.CreateFromReader(loadObj, "Provenance", "InputOutput", reader, c);
            // DataProductDetails
            loadObj.dataproductdetails = DataProductDetailCollection<ProvenanceDetail>.CreateFromReader(loadObj, "ProvenanceDetail", "DataProductDetail", reader, c);
        }

        public static ProvenanceDetail Load(Guid id, Connection c)
        {
            return Load<ProvenanceDetail>(id, c, ProvenanceDetail.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ProvenanceDetails from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ProvenanceDetails in the system</returns>
        public static List<ProvenanceDetail> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ProvenanceDetail>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ProvenanceDetail)], 
                ProvenanceDetail.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ProvenanceDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ProvenanceDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ProvenanceDetail> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ProvenanceDetail>(owner, ProvenanceDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ProvenanceDetails that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ProvenanceDetails</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ProvenanceDetail> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ProvenanceDetail>(owner, src, ProvenanceDetail.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ProvenanceDetails by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ProvenanceDetails that match the criteria</returns>
        public static List<ProvenanceDetail> Search(string text, Connection c)
        {
            return LoadAll<ProvenanceDetail>(Connection.Action.Search, text, ProvenanceDetail.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class IntegerField : ER.IntegerField
                {
                    internal IntegerField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, int value)
                    {
                        return new SearchClause(this, IntegerField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField CurrentIndex = new FieldDefs.StringField("CurrentIndex");
                public static FieldDefs.IntegerField StartEventOrder = new FieldDefs.IntegerField("StartEventOrder");
                public static FieldDefs.IntegerField EndEventOrder = new FieldDefs.IntegerField("EndEventOrder");
                public static FieldDefs.BooleanField IsCompleted = new FieldDefs.BooleanField("IsCompleted");
                public static FieldDefs.ObjectField<ProvenanceInfo> ProvenanceInfo = new FieldDefs.ObjectField<ProvenanceInfo>("ProvenanceInfo");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause CurrentIndex(StringField.Condition op, System.String value) { return Fields.CurrentIndex.CreateSearchClause(op, value); }
            public static ISearchClause StartEventOrder(IntegerField.Condition op, System.Int32 value) { return Fields.StartEventOrder.CreateSearchClause(op, value); }
            public static ISearchClause EndEventOrder(IntegerField.Condition op, System.Int32 value) { return Fields.EndEventOrder.CreateSearchClause(op, value); }
            public static ISearchClause IsCompleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsCompleted.CreateSearchClause(op, value); }
            public static ISearchClause ProvenanceInfo(ObjectField<ProvenanceInfo>.Condition op, ProvenanceInfo value) { return Fields.ProvenanceInfo.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ProvenanceDetail> Search(ProvenanceDetail.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ProvenanceDetail, Connection.Action.Search, ref paramList, ProvenanceDetail.CreateFromDataStore, out results);
            return results.ConvertAll<ProvenanceDetail>(BasicObject.ConvertFromIObject<ProvenanceDetail>);
        }
		

        /// <summary>
        /// Saves the ProvenanceDetail object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("CurrentIndex", Parameter.ParamType.String, Parameter.ParamDirection.In, this.currentindex));

            mydata.Add(new Parameter("StartEventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.starteventorder));

            mydata.Add(new Parameter("EndEventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, this.endeventorder));

            mydata.Add(new Parameter("IsCompleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.iscompleted));

            mydata.Add(new Parameter("ProvenanceInfoID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.provenanceinfoID == Guid.Empty ?
                (this.ProvenanceInfo == null ? Guid.Empty : ((IObject)this.ProvenanceInfo).ID)
                : this.provenanceinfoID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ProvenanceDetail and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ProvenanceDetail> updPipe = new PipelineParameter<ProvenanceDetail>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.processingstatuss.Refresh();
            this.performancedetails.Refresh();
            this.performancestats.Refresh();
            this.inputoutputs.Refresh();
            this.dataproductdetails.Refresh();
        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(ProvenanceInfo provenanceinfo)
            {
                this.provenanceinfo=provenanceinfo;

            }

            public IObject CopyTo(Connection target, ProvenanceDetail provenancedetail)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("CurrentIndex", Parameter.ParamType.String, Parameter.ParamDirection.In, provenancedetail.currentindex));
                 mydata.Add(new Parameter("StartEventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, provenancedetail.starteventorder));
                 mydata.Add(new Parameter("EndEventOrder", Parameter.ParamType.Int, Parameter.ParamDirection.In, provenancedetail.endeventorder));
                 mydata.Add(new Parameter("IsCompleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, provenancedetail.iscompleted));
			     mydata.Add(new Parameter("ProvenanceInfoID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.provenanceinfo == null ? Guid.Empty : ((IObject)this.provenanceinfo).ID)));

                PipelineParameter<ProvenanceDetail> pipe = new PipelineParameter<ProvenanceDetail>(CreateFromDataStore);
                IObject newObj = provenancedetail.SaveTo(mydata, store, pipe);

                return newObj;
            }

            ProvenanceInfo provenanceinfo;

        }
        
       
    }
}
