/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the ProvenanceInfos that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the ProvenanceInfo collection</typeparam>
    public class ProvenanceInfoCollection<O> : SyncCollection<O, ProvenanceInfo>
        where O : IObject
    {
        public ProvenanceInfoCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ProvenanceInfo>.DelayLoadCallback(ProvenanceInfoCollection_OnDelayLoad);
        }

        public ProvenanceInfoCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, ProvenanceInfo>.DelayLoadCallback(ProvenanceInfoCollection_OnDelayLoadRef);
        }

        List<ProvenanceInfo> ProvenanceInfoCollection_OnDelayLoad(Connection c)
        {
            return ProvenanceInfo.LoadAll(this.Owner, c);
        }

        List<ProvenanceInfo> ProvenanceInfoCollection_OnDelayLoadRef(Connection c)
        {
            return ProvenanceInfo.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ProvenanceInfoCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ProvenanceInfoCollection<O> objList = new ProvenanceInfoCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ProvenanceInfoCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            ProvenanceInfoCollection<O> objList = new ProvenanceInfoCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// ProvenanceInfo
    /// </summary>
    [Serializable]
    public partial class ProvenanceInfo : NamedObject<ProvenanceInfo>
    {
        private System.String jobid;
        private System.String activityname;
        private System.String workflowname;
        private System.DateTime executiontime;
        
        private ProvenanceDetailCollection<ProvenanceInfo> provenancedetails;

        /// <summary>
        /// Description of the ProvenanceInfo
        /// </summary>
        public System.String JobId
        {
            get { return jobid; }
            set
            {
                jobid = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceInfo
        /// </summary>
        public System.String ActivityName
        {
            get { return activityname; }
            set
            {
                activityname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceInfo
        /// </summary>
        public System.String WorkflowName
        {
            get { return workflowname; }
            set
            {
                workflowname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the ProvenanceInfo
        /// </summary>
        public System.DateTime ExecutionTime
        {
            get { return executiontime; }
            set
            {
                executiontime = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public ProvenanceDetailCollection<ProvenanceInfo> ProvenanceDetails { get { return provenancedetails; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public ProvenanceInfo(Connection c)
            : base(SRStorage.ProvenanceInfo, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new ProvenanceInfo Create(string name, Connection c)
        {
            ProvenanceInfo newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            newObj.provenancedetails = new ProvenanceDetailCollection<ProvenanceInfo>(newObj, "ProvenanceInfo", "ProvenanceDetail", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static ProvenanceInfo Load(string name, Connection c)
        {
            return NamedObject<ProvenanceInfo>.Load(name, c, ProvenanceInfo.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a ProvenanceInfo object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>ProvenanceInfo object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            ProvenanceInfo loadObj = (ProvenanceInfo)NamedObject<ProvenanceInfo>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(ProvenanceInfo loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<ProvenanceInfo>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("JobId");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.jobid = val;
            }

            index = reader.GetOrdinal("ActivityName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.activityname = val;
            }

            index = reader.GetOrdinal("WorkflowName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.workflowname = val;
            }

            index = reader.GetOrdinal("ExecutionTime");
            if (!reader.IsDBNull(index))
            {
                System.DateTime val = reader.GetDateTime(index);
                loadObj.executiontime = val;
            }


            //
            // Object connections
            //

            // ProvenanceDetails
            loadObj.provenancedetails = ProvenanceDetailCollection<ProvenanceInfo>.CreateFromReader(loadObj, "ProvenanceInfo", "ProvenanceDetail", reader, c);
        }

        public static ProvenanceInfo Load(Guid id, Connection c)
        {
            return Load<ProvenanceInfo>(id, c, ProvenanceInfo.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL ProvenanceInfos from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all ProvenanceInfos in the system</returns>
        public static List<ProvenanceInfo> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<ProvenanceInfo>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(ProvenanceInfo)], 
                ProvenanceInfo.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all ProvenanceInfos that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ProvenanceInfos</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<ProvenanceInfo> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<ProvenanceInfo>(owner, ProvenanceInfo.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all ProvenanceInfos that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the ProvenanceInfos</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<ProvenanceInfo> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<ProvenanceInfo>(owner, src, ProvenanceInfo.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches ProvenanceInfos by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of ProvenanceInfos that match the criteria</returns>
        public static List<ProvenanceInfo> Search(string text, Connection c)
        {
            return LoadAll<ProvenanceInfo>(Connection.Action.Search, text, ProvenanceInfo.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField JobId = new FieldDefs.StringField("JobId");
                public static FieldDefs.StringField ActivityName = new FieldDefs.StringField("ActivityName");
                public static FieldDefs.StringField WorkflowName = new FieldDefs.StringField("WorkflowName");
                public static FieldDefs.DateTimeField ExecutionTime = new FieldDefs.DateTimeField("ExecutionTime");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause JobId(StringField.Condition op, System.String value) { return Fields.JobId.CreateSearchClause(op, value); }
            public static ISearchClause ActivityName(StringField.Condition op, System.String value) { return Fields.ActivityName.CreateSearchClause(op, value); }
            public static ISearchClause WorkflowName(StringField.Condition op, System.String value) { return Fields.WorkflowName.CreateSearchClause(op, value); }
            public static ISearchClause ExecutionTime(DateTimeField.Condition op, System.DateTime value) { return Fields.ExecutionTime.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<ProvenanceInfo> Search(ProvenanceInfo.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.ProvenanceInfo, Connection.Action.Search, ref paramList, ProvenanceInfo.CreateFromDataStore, out results);
            return results.ConvertAll<ProvenanceInfo>(BasicObject.ConvertFromIObject<ProvenanceInfo>);
        }
		

        /// <summary>
        /// Saves the ProvenanceInfo object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("JobId", Parameter.ParamType.String, Parameter.ParamDirection.In, this.jobid));

            mydata.Add(new Parameter("ActivityName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.activityname));

            mydata.Add(new Parameter("WorkflowName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.workflowname));

            mydata.Add(new Parameter("ExecutionTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, this.executiontime));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the ProvenanceInfo and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<ProvenanceInfo> updPipe = new PipelineParameter<ProvenanceInfo>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.provenancedetails.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, ProvenanceInfo provenanceinfo)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("JobId", Parameter.ParamType.String, Parameter.ParamDirection.In, provenanceinfo.jobid));
                 mydata.Add(new Parameter("ActivityName", Parameter.ParamType.String, Parameter.ParamDirection.In, provenanceinfo.activityname));
                 mydata.Add(new Parameter("WorkflowName", Parameter.ParamType.String, Parameter.ParamDirection.In, provenanceinfo.workflowname));
                 mydata.Add(new Parameter("ExecutionTime", Parameter.ParamType.DateTime, Parameter.ParamDirection.In, provenanceinfo.executiontime));

                PipelineParameter<ProvenanceInfo> pipe = new PipelineParameter<ProvenanceInfo>(CreateFromDataStore);
                IObject newObj = provenanceinfo.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
