/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Services that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Service collection</typeparam>
    public class ServiceCollection<O> : SyncCollection<O, Service>
        where O : IObject
    {
        public ServiceCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Service>.DelayLoadCallback(ServiceCollection_OnDelayLoad);
        }

        public ServiceCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Service>.DelayLoadCallback(ServiceCollection_OnDelayLoadRef);
        }

        List<Service> ServiceCollection_OnDelayLoad(Connection c)
        {
            return Service.LoadAll(this.Owner, c);
        }

        List<Service> ServiceCollection_OnDelayLoadRef(Connection c)
        {
            return Service.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static ServiceCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            ServiceCollection<O> objList = new ServiceCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static ServiceCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            ServiceCollection<O> objList = new ServiceCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Service
    /// </summary>
    [Serializable]
    public partial class Service : NamedObject<Service>
    {
        private System.String classname;
        private System.Uri location;
        private System.String description;
        private Guid userID;
        private User user;
        private Guid parentID;
        private Namespace parent;
        
        private TagCollection<Service> tags;
        private KeywordCollection<Service> keywords;
        private MethodCollection<Service> methods;

        /// <summary>
        /// Description of the Service
        /// </summary>
        public System.String ClassName
        {
            get { return classname; }
            set
            {
                classname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Service
        /// </summary>
        public System.Uri Location
        {
            get { return location; }
            set
            {
                location = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the Service
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User User
        {
            get
            {
                lock (this)
                {
                    if (user == null && userID != Guid.Empty)
                        user = User.Load(userID, Conn);
                }
                return user;
            }

            set
            {
                lock (this)
                {
                    user = value;                   
                    userID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Namespace Parent
        {
            get
            {
                lock (this)
                {
                    if (parent == null && parentID != Guid.Empty)
                        parent = Namespace.Load(parentID, Conn);
                }
                return parent;
            }

            set
            {
                lock (this)
                {
                    parent = value;                   
                    parentID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public TagCollection<Service> Tags { get { return tags; } }
        public KeywordCollection<Service> Keywords { get { return keywords; } }
        public MethodCollection<Service> Methods { get { return methods; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Service(Connection c)
            : base(SRStorage.Service, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new Service Create(string name, Connection c)
        {
            Service newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.tags = new TagCollection<Service>(newObj, c);
            newObj.keywords = new KeywordCollection<Service>(newObj, c);
            newObj.methods = new MethodCollection<Service>(newObj, "Service", "Method", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Service Load(string name, Connection c)
        {
            return NamedObject<Service>.Load(name, c, Service.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Service object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Service object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Service loadObj = (Service)NamedObject<Service>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Service loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Service>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("ClassName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.classname = val;
            }

            index = reader.GetOrdinal("Location");
            if (!reader.IsDBNull(index))
            {
                System.Uri val = new Uri(reader.GetString(index));
                loadObj.location = val;
            }

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("OwnerID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.userID = val;
            }

            index = reader.GetOrdinal("ParentID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.parentID = val;
            }


            //
            // Object connections
            //

            // Tags
            loadObj.tags = TagCollection<Service>.CreateFromReader(loadObj, reader, c);
            // Keywords
            loadObj.keywords = KeywordCollection<Service>.CreateFromReader(loadObj, reader, c);
            // Methods
            loadObj.methods = MethodCollection<Service>.CreateFromReader(loadObj, "Service", "Method", reader, c);
        }

        public static Service Load(Guid id, Connection c)
        {
            return Load<Service>(id, c, Service.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Services from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Services in the system</returns>
        public static List<Service> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Service>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Service)], 
                Service.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Services that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Services</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Service> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Service>(owner, Service.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Services that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Services</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Service> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Service>(owner, src, Service.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Services by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Services that match the criteria</returns>
        public static List<Service> Search(string text, Connection c)
        {
            return LoadAll<Service>(Connection.Action.Search, text, Service.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class URIField : ER.URIField
                {
                    internal URIField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, Uri value)
                    {
                        return new SearchClause(this, URIField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField ClassName = new FieldDefs.StringField("ClassName");
                public static FieldDefs.URIField Location = new FieldDefs.URIField("Location");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.ObjectField<User> User = new FieldDefs.ObjectField<User>("User");
                public static FieldDefs.ObjectField<Namespace> Parent = new FieldDefs.ObjectField<Namespace>("Parent");
                public static FieldDefs.RelationSimpleField<Tag> Tag = new FieldDefs.RelationSimpleField<Tag>("Tag", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Keyword> Keyword = new FieldDefs.RelationSimpleField<Keyword>("Keyword", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause ClassName(StringField.Condition op, System.String value) { return Fields.ClassName.CreateSearchClause(op, value); }
            public static ISearchClause Location(URIField.Condition op, System.Uri value) { return Fields.Location.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause User(ObjectField<User>.Condition op, User value) { return Fields.User.CreateSearchClause(op, value); }
            public static ISearchClause Parent(ObjectField<Namespace>.Condition op, Namespace value) { return Fields.Parent.CreateSearchClause(op, value); }
            public static ISearchClause Tag(RelationSimpleField<Tag>.Condition op, Tag value) { return Fields.Tag.CreateSearchClause(op, value); }
            public static ISearchClause Keyword(RelationSimpleField<Keyword>.Condition op, Keyword value) { return Fields.Keyword.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Service> Search(Service.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Service, Connection.Action.Search, ref paramList, Service.CreateFromDataStore, out results);
            return results.ConvertAll<Service>(BasicObject.ConvertFromIObject<Service>);
        }
		

        /// <summary>
        /// Saves the Service object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.classname));

            mydata.Add(new Parameter("Location", Parameter.ParamType.String, Parameter.ParamDirection.In, this.location == null ? null : this.location.ToString()));

            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("OwnerID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.userID == Guid.Empty ?
                (this.User == null ? Guid.Empty : ((IObject)this.User).ID)
                : this.userID)));
            mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.parentID == Guid.Empty ?
                (this.Parent == null ? Guid.Empty : ((IObject)this.Parent).ID)
                : this.parentID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Service and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Service> updPipe = new PipelineParameter<Service>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.tags.Refresh();
            this.keywords.Refresh();
            this.methods.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.tags.Clear();
            this.keywords.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User user,Namespace parent)
            {
                this.user=user;
                this.parent=parent;

            }

            public IObject CopyTo(Connection target, Service service)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, service.classname));
                 mydata.Add(new Parameter("Location", Parameter.ParamType.String, Parameter.ParamDirection.In, service.location == null ? null : service.location.ToString()));
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, service.description));
			     mydata.Add(new Parameter("OwnerID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.user == null ? Guid.Empty : ((IObject)this.user).ID)));
			     mydata.Add(new Parameter("ParentID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.parent == null ? Guid.Empty : ((IObject)this.parent).ID)));

                PipelineParameter<Service> pipe = new PipelineParameter<Service>(CreateFromDataStore);
                IObject newObj = service.SaveTo(mydata, store, pipe);

                return newObj;
            }

            User user;
            Namespace parent;

        } 
        
              
    }
}
