/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Builtin roles defined in the system.
    /// Items beloging to this interface are defined if <Role type="xxxx"> in Data Layer, 
    /// where xxxx != custom
    /// </summary>
    public interface ISRBuiltinSecurityRoles
    {
                ISecurityPrincipalColection Users { get; }
         ISecurityPrincipalColection Administrators { get; }
         ISecurityPrincipalColection Guests { get; }
         ISecurityPrincipalColection Services { get; }

    }  
    
    
    /// <summary>
    /// Interface for the UI Resource strings.
    /// </summary>
    public interface ISRSystemPolicyUIResources
    {        
        string AutoCreateUserIfGroupMatchText { get; }
        string AnonymousEnabledText { get; }
        string TridentUsersText { get; }
        string TridentAdministratorsText { get; }
        string TridentGuestsText { get; }
        string TridentServicesText { get; }
            
    }
    
    /// <summary>
    /// Defines the SystemPolicy object.
    /// </summary>
    public interface ISRSystemPolicy : ISystemSecurityPolicy
    {
		        System.Boolean AutoCreateUserIfGroupMatch { get; set; }
        System.Boolean AnonymousEnabled { get; set; }
        ISecurityPrincipalColection TridentUsers { get; }
        ISecurityPrincipalColection TridentAdministrators { get; }
        ISecurityPrincipalColection TridentGuests { get; }
        ISecurityPrincipalColection TridentServices { get; }
        Group Everyone { get; }
        ISRBuiltinSecurityRoles Builtin { get; }
 
		ISRSystemPolicyUIResources UIResources { get; }				
    }
        
    /// <summary>
    /// SystemPolicy
    /// </summary>
    [Serializable]
    public partial class SystemPolicy : BasicObject, ISRSystemPolicy
    {       
        
        private System.Boolean autocreateuserifgroupmatch;
        private System.Boolean anonymousenabled;
        private ISecurityPrincipalColection tridentusers;
        private ISecurityPrincipalColection tridentadministrators;
        private ISecurityPrincipalColection tridentguests;
        private ISecurityPrincipalColection tridentservices;
        private Group everyone;
        private ISRBuiltinSecurityRoles builtin;
        
        private static SystemPolicy instance = null;
        private ISRSystemPolicyUIResources uiresources;
        
        # region UIResources
        
        /// <summary>
		/// Contains the UI Resource strings to be displayed.
		/// </summary>
		public class UIDisplayResources : ISRSystemPolicyUIResources
        {
                           private string uiautocreateuserifgroupmatchlocres = "Properties.Resource1.AutoCreateText";
               private string autocreateuserifgroupmatchnolocrestxt = "Automatically create user if group matched?";
               private string uianonymousenabledlocres = "Properties.Resource1.AnonymousEnabledText";
               private string anonymousenablednolocrestxt = "Anonymous Access Enabled?";
               private string uitridentuserslocres = "Properties.Resource1.UsersRoleText";
               private string tridentusersnolocrestxt = "Security principals that have limited user privileges";
               private string uitridentadministratorslocres = "Properties.Resource1.AdminRoleText";
               private string tridentadministratorsnolocrestxt = "Security principals that have admin user privileges";
               private string uitridentguestslocres = "Properties.Resource1.GuestRoleText";
               private string tridentguestsnolocrestxt = "Security principals that have guest privileges";
               private string uitridentserviceslocres = "Properties.Resource1.ServiceRoleText";
               private string tridentservicesnolocrestxt = "Security principals that have service privileges";

            
				#region ISRSystemPolicyUIResources Members

            				public string AutoCreateUserIfGroupMatchText
				{
					get { return FetchUIDisplayString(uiautocreateuserifgroupmatchlocres, autocreateuserifgroupmatchnolocrestxt); }
				}
				public string AnonymousEnabledText
				{
					get { return FetchUIDisplayString(uianonymousenabledlocres, anonymousenablednolocrestxt); }
				}
				public string TridentUsersText
				{
					get { return FetchUIDisplayString(uitridentuserslocres, tridentusersnolocrestxt); }
				}
				public string TridentAdministratorsText
				{
					get { return FetchUIDisplayString(uitridentadministratorslocres, tridentadministratorsnolocrestxt); }
				}
				public string TridentGuestsText
				{
					get { return FetchUIDisplayString(uitridentguestslocres, tridentguestsnolocrestxt); }
				}
				public string TridentServicesText
				{
					get { return FetchUIDisplayString(uitridentserviceslocres, tridentservicesnolocrestxt); }
				}
 
            
				#endregion

				private string FetchUIDisplayString(string locResource, string noLocText)
				{                
					try
					{
						string locString = Properties.Resource1.ResourceManager.GetString(locResource.Substring(locResource.LastIndexOf('.') + 1));
						if (!String.IsNullOrEmpty(locString))
						{
							return locString;
						}
					}
					catch
					{
					}
					return noLocText;                
				}

        }	
        
        # endregion

        /// <summary>
        /// Description of the SystemPolicy
        /// </summary>
        public System.Boolean AutoCreateUserIfGroupMatch
        {
            get { return autocreateuserifgroupmatch; }
            set
            {
                autocreateuserifgroupmatch = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the SystemPolicy
        /// </summary>
        public System.Boolean AnonymousEnabled
        {
            get { return anonymousenabled; }
            set
            {
                anonymousenabled = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

		/// <summary>
        /// Description of the TridentUsers
        /// </summary>
        public ISecurityPrincipalColection TridentUsers
        {
            get { return tridentusers; }            
        }
		/// <summary>
        /// Description of the TridentAdministrators
        /// </summary>
        public ISecurityPrincipalColection TridentAdministrators
        {
            get { return tridentadministrators; }            
        }
		/// <summary>
        /// Description of the TridentGuests
        /// </summary>
        public ISecurityPrincipalColection TridentGuests
        {
            get { return tridentguests; }            
        }
		/// <summary>
        /// Description of the TridentServices
        /// </summary>
        public ISecurityPrincipalColection TridentServices
        {
            get { return tridentservices; }            
        }
		/// <summary>
        /// Description of the Everyone
        /// </summary>
        public Group Everyone
        {
            get { return everyone; }            
        }
		/// <summary>
        /// Description of the Builtin
        /// </summary>
        public ISRBuiltinSecurityRoles Builtin
        {
            get { return builtin; }            
        }
        
        public ISRSystemPolicyUIResources UIResources
        {
            get { return uiresources; }
        }
        
        		#region BuiltinSecurityRoles
		
        /// <summary>
        /// Fetches the built-in roles defined in the system.
        /// </summary>
        public class BuiltinSecurityRoles : ISRBuiltinSecurityRoles
        {
            /// <summary>
            /// The system policy object.
            /// </summary>
            private SystemPolicy obj;

            #region ISRBuiltinSecurityRoles Members

            public BuiltinSecurityRoles(SystemPolicy obj)
            {
                this.obj = obj;                
            }

					/// <summary>
        /// Description of the Users
        /// </summary>
        public ISecurityPrincipalColection Users
        {
            get { return obj.TridentUsers; }            
        }
		/// <summary>
        /// Description of the Administrators
        /// </summary>
        public ISecurityPrincipalColection Administrators
        {
            get { return obj.TridentAdministrators; }            
        }
		/// <summary>
        /// Description of the Guests
        /// </summary>
        public ISecurityPrincipalColection Guests
        {
            get { return obj.TridentGuests; }            
        }
		/// <summary>
        /// Description of the Services
        /// </summary>
        public ISecurityPrincipalColection Services
        {
            get { return obj.TridentServices; }            
        }

			            
            #endregion
        }
        
        #endregion

        
		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public SystemPolicy(Connection c)
            : base(SRStorage.SystemPolicy, c)
        {
        }
        
        /// <summary>
        /// Gets a singleton instance of the object
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public static SystemPolicy Get(Connection c)
        {
            if (instance == null)
            {
                try
                {   
                    List<SystemPolicy> objList = LoadAll(c);
                    if (objList.Count > 0)
                    {
                       instance = objList[0];
                                               instance.tridentusers = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentUsers, c), SystemBuiltinRoleType.Users, SystemRoleType.TridentUsers, c);
                       instance.tridentadministrators = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentAdministrators, c), SystemBuiltinRoleType.Administrators, SystemRoleType.TridentAdministrators, c);
                       instance.tridentguests = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentGuests, c), SystemBuiltinRoleType.Guests, SystemRoleType.TridentGuests, c);
                       instance.tridentservices = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentServices, c), SystemBuiltinRoleType.Services, SystemRoleType.TridentServices, c);
                       instance.everyone = Group.Load("Everyone", c);
                       instance.builtin = new BuiltinSecurityRoles(instance);
                       instance.uiresources = new UIDisplayResources();
	
                    }                    
                }
                catch (RecordNotFoundException)
                {
                    throw new ApplicationException("SystemPolicy not initialized");
                }
            }            
            return instance;            
        }

        /// <summary>
        /// Resets this instance.
        /// </summary>
        public static void Reset()
        {
            instance = null;
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static void Initialize(System.Boolean autocreateuserifgroupmatch, System.Boolean anonymousenabled, Connection c)
        {
            SystemPolicy newObj = new SystemPolicy(c);
            try
			{
				List<SystemPolicy> objList = LoadAll(c);                                  
				throw new ApplicationException("SystemPolicy already initialized");                 
			}
            catch (RecordNotFoundException)
            {
				newObj.ObjID = Guid.Empty;
				newObj.isNew = true;
            newObj.autocreateuserifgroupmatch = autocreateuserifgroupmatch;
            newObj.anonymousenabled = anonymousenabled;
			
				
				newObj.OnConstructor();

				if (c.AutoSave)
                newObj.Save();
            }
        }

        /// <summary>
        /// Creates a SystemPolicy object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>SystemPolicy object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            SystemPolicy loadObj = new SystemPolicy(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(SystemPolicy loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("AutoCreateUserIfGroupMatch");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.autocreateuserifgroupmatch = val;
            }

            index = reader.GetOrdinal("AnonymousEnabled");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.anonymousenabled = val;
            }

        }

        public static SystemPolicy Load(Guid id, Connection c)
        {
            return Load<SystemPolicy>(id, c, SystemPolicy.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL SystemPolicys from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all SystemPolicys in the system</returns>
        public static List<SystemPolicy> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<SystemPolicy>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(SystemPolicy)], 
                SystemPolicy.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all SystemPolicys that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the SystemPolicys</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<SystemPolicy> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<SystemPolicy>(owner, SystemPolicy.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all SystemPolicys that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the SystemPolicys</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<SystemPolicy> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<SystemPolicy>(owner, src, SystemPolicy.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches SystemPolicys by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of SystemPolicys that match the criteria</returns>
        public static List<SystemPolicy> Search(string text, Connection c)
        {
            return LoadAll<SystemPolicy>(Connection.Action.Search, text, SystemPolicy.CreateFromDataStore, c);
        }


		

        /// <summary>
        /// Saves the SystemPolicy object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("AutoCreateUserIfGroupMatch", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.autocreateuserifgroupmatch));

            mydata.Add(new Parameter("AnonymousEnabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.anonymousenabled));

            Save(mydata);
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the SystemPolicy and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<SystemPolicy> updPipe = new PipelineParameter<SystemPolicy>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);
            
                                   this.tridentusers = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentUsers, Conn), SystemBuiltinRoleType.Users, SystemRoleType.TridentUsers, Conn);
                       this.tridentadministrators = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentAdministrators, Conn), SystemBuiltinRoleType.Administrators, SystemRoleType.TridentAdministrators, Conn);
                       this.tridentguests = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentGuests, Conn), SystemBuiltinRoleType.Guests, SystemRoleType.TridentGuests, Conn);
                       this.tridentservices = new SecurityPrincipalCollection(LoadRoleCollection(SystemRoleType.TridentServices, Conn), SystemBuiltinRoleType.Services, SystemRoleType.TridentServices, Conn);

        }
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, SystemPolicy systempolicy)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("AutoCreateUserIfGroupMatch", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, systempolicy.autocreateuserifgroupmatch));
                 mydata.Add(new Parameter("AnonymousEnabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, systempolicy.anonymousenabled));

                PipelineParameter<SystemPolicy> pipe = new PipelineParameter<SystemPolicy>(CreateFromDataStore);
                IObject newObj = systempolicy.SaveTo(mydata, store, pipe);

                return newObj;
            }


        }        
        
        		/// <summary>
        /// Loads the ISecurityPrincipal collection from the registry based on the role-type specified.
        /// </summary>
        /// <param name="roleType">The role type.</param>
        /// <param name="c">The connection object.</param>
        /// <returns></returns>
		private static List<ISecurityPrincipal> LoadRoleCollection(SystemRoleType roleType, Connection c)
        {            
            List<ISecurityPrincipal> roleColl = new List<ISecurityPrincipal>();
            try
            {            
					SystemRole.ISearch searchQuery = SystemRole.ISearch.Create();
					searchQuery.Query = SystemRole.ISearch.Role(EnumFieldBase.Condition.Equals, roleType);
					List<SystemRole> sysRoleList = SystemRole.Search(searchQuery, c);
										 
					foreach (SystemRole sysRole in sysRoleList)
					{
						if (sysRole.MemberUserPrincipal != null && sysRole.MemberUserPrincipal.Enabled && !sysRole.MemberUserPrincipal.IsDeleted)
							{
								roleColl.Add(sysRole.MemberUserPrincipal);
							}
							
                     else if (sysRole.MemberGroupPrincipal != null && sysRole.MemberGroupPrincipal.Enabled && !sysRole.MemberGroupPrincipal.IsDeleted)
							{
								roleColl.Add(sysRole.MemberGroupPrincipal);
							}
							
							
					}
            }
            catch (Exception)
            {
            }
            return roleColl;
        }

        
    }
}
