/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the SystemRoles that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the SystemRole collection</typeparam>
    public class SystemRoleCollection<O> : SyncCollection<O, SystemRole>
        where O : IObject
    {
        public SystemRoleCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, SystemRole>.DelayLoadCallback(SystemRoleCollection_OnDelayLoad);
        }

        public SystemRoleCollection(O o, string src, string srcRev, Connection c)
            : base(o, src, srcRev, c)
        {
            this.OnDelayLoad += new SyncCollection<O, SystemRole>.DelayLoadCallback(SystemRoleCollection_OnDelayLoadRef);
        }

        List<SystemRole> SystemRoleCollection_OnDelayLoad(Connection c)
        {
            return SystemRole.LoadAll(this.Owner, c);
        }

        List<SystemRole> SystemRoleCollection_OnDelayLoadRef(Connection c)
        {
            return SystemRole.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static SystemRoleCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            SystemRoleCollection<O> objList = new SystemRoleCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static SystemRoleCollection<O> CreateFromReader(O o, string key, string keyRev, DbDataReader reader, Connection c)
        {
            SystemRoleCollection<O> objList = new SystemRoleCollection<O>(o, key, keyRev, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
        
       
    }

    /// <summary>
    /// SystemRole
    /// </summary>
    [Serializable]
    public partial class SystemRole : BasicObject
    {
        private SystemRoleType role;
        private SystemBuiltinRoleType builtinrole;
        private Guid memberuserprincipalID;
        private User memberuserprincipal;
        private Guid membergroupprincipalID;
        private Group membergroupprincipal;
        

        /// <summary>
        /// Description of the SystemRole
        /// </summary>
        public SystemRoleType Role
        {
            get { return role; }
            set
            {
                role = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the SystemRole
        /// </summary>
        public SystemBuiltinRoleType BuiltinRole
        {
            get { return builtinrole; }
            set
            {
                builtinrole = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public User MemberUserPrincipal
        {
            get
            {
                lock (this)
                {
                    if (memberuserprincipal == null && memberuserprincipalID != Guid.Empty)
                        memberuserprincipal = User.Load(memberuserprincipalID, Conn);
                }
                return memberuserprincipal;
            }

            set
            {
                lock (this)
                {
                    memberuserprincipal = value;                   
                    memberuserprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Group MemberGroupPrincipal
        {
            get
            {
                lock (this)
                {
                    if (membergroupprincipal == null && membergroupprincipalID != Guid.Empty)
                        membergroupprincipal = Group.Load(membergroupprincipalID, Conn);
                }
                return membergroupprincipal;
            }

            set
            {
                lock (this)
                {
                    membergroupprincipal = value;                   
                    membergroupprincipalID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }



		
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public SystemRole(Connection c)
            : base(SRStorage.SystemRole, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static SystemRole Create(SystemRoleType role, SystemBuiltinRoleType builtinrole, ISecurityPrincipal member, Connection c)
        {
            SystemRole newObj = new SystemRole(c);
            newObj.ObjID = Guid.Empty;
            newObj.isNew = true;

            newObj.role = role;
            newObj.builtinrole = builtinrole;
			if (member is User)
            {
                 newObj.memberuserprincipal = (User)member;
            }
                     else 			if (member is Group)
            {
                 newObj.membergroupprincipal = (Group)member;
            }
	

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        /// <summary>
        /// Creates a SystemRole object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>SystemRole object</returns>
        protected static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            SystemRole loadObj = new SystemRole(c);
            
            loadObj.ObjID = reader.GetGuid(reader.GetOrdinal("ID"));
            loadObj.isNew = false;
            loadObj.Created = new EntryChange(
                reader.GetString(reader.GetOrdinal("CreatedBy")),
                reader.GetDateTime(reader.GetOrdinal("CreatedDate")));
            loadObj.Updated = new EntryChange(
                reader.GetString(reader.GetOrdinal("UpdatedBy")),
                reader.GetDateTime(reader.GetOrdinal("UpdatedDate")));
            
            LoadFromDataStore(loadObj, reader, c);
						
            loadObj.OnConstructor();
            
            return loadObj;            
        }
            
        protected static void LoadFromDataStore(SystemRole loadObj, DbDataReader reader, Connection c)
        {
            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Role");
            if (!reader.IsDBNull(index))
                loadObj.role = (SystemRoleType)Enum.Parse(typeof(SystemRoleType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("BuiltinRole");
            if (!reader.IsDBNull(index))
                loadObj.builtinrole = (SystemBuiltinRoleType)Enum.Parse(typeof(SystemBuiltinRoleType), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("MemberUserPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.memberuserprincipalID = val;
            }

            index = reader.GetOrdinal("MemberGroupPrincipalID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.membergroupprincipalID = val;
            }


            //
            // Object connections
            //

        }

        public static SystemRole Load(Guid id, Connection c)
        {
            return Load<SystemRole>(id, c, SystemRole.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL SystemRoles from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all SystemRoles in the system</returns>
        public static List<SystemRole> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<SystemRole>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(SystemRole)], 
                SystemRole.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all SystemRoles that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the SystemRoles</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<SystemRole> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<SystemRole>(owner, SystemRole.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all SystemRoles that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the SystemRoles</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<SystemRole> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<SystemRole>(owner, src, SystemRole.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches SystemRoles by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of SystemRoles that match the criteria</returns>
        public static List<SystemRole> Search(string text, Connection c)
        {
            return LoadAll<SystemRole>(Connection.Action.Search, text, SystemRole.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.EnumField<SystemRoleType> Role = new FieldDefs.EnumField<SystemRoleType>("Role");
                public static FieldDefs.EnumField<SystemBuiltinRoleType> BuiltinRole = new FieldDefs.EnumField<SystemBuiltinRoleType>("BuiltinRole");
                public static FieldDefs.ObjectField<User> MemberUserPrincipal = new FieldDefs.ObjectField<User>("MemberUserPrincipal");
                public static FieldDefs.ObjectField<Group> MemberGroupPrincipal = new FieldDefs.ObjectField<Group>("MemberGroupPrincipal");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Role(EnumField<SystemRoleType>.Condition op, SystemRoleType value) { return Fields.Role.CreateSearchClause(op, value); }
            public static ISearchClause BuiltinRole(EnumField<SystemBuiltinRoleType>.Condition op, SystemBuiltinRoleType value) { return Fields.BuiltinRole.CreateSearchClause(op, value); }
            public static ISearchClause MemberUserPrincipal(ObjectField<User>.Condition op, User value) { return Fields.MemberUserPrincipal.CreateSearchClause(op, value); }
            public static ISearchClause MemberGroupPrincipal(ObjectField<Group>.Condition op, Group value) { return Fields.MemberGroupPrincipal.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<SystemRole> Search(SystemRole.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.SystemRole, Connection.Action.Search, ref paramList, SystemRole.CreateFromDataStore, out results);
            return results.ConvertAll<SystemRole>(BasicObject.ConvertFromIObject<SystemRole>);
        }
		

        /// <summary>
        /// Saves the SystemRole object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Role", Parameter.ParamType.String, Parameter.ParamDirection.In, this.role.ToString()));
            mydata.Add(new Parameter("BuiltinRole", Parameter.ParamType.String, Parameter.ParamDirection.In, this.builtinrole.ToString()));
            mydata.Add(new Parameter("MemberUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.memberuserprincipalID == Guid.Empty ?
                (this.MemberUserPrincipal == null ? Guid.Empty : ((IObject)this.MemberUserPrincipal).ID)
                : this.memberuserprincipalID)));
            mydata.Add(new Parameter("MemberGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.membergroupprincipalID == Guid.Empty ?
                (this.MemberGroupPrincipal == null ? Guid.Empty : ((IObject)this.MemberGroupPrincipal).ID)
                : this.membergroupprincipalID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);            
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the SystemRole and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<SystemRole> updPipe = new PipelineParameter<SystemRole>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
       
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(User memberuserprincipal,Group membergroupprincipal)
            {
                this.memberuserprincipal=memberuserprincipal;
                this.membergroupprincipal=membergroupprincipal;

            }

            public IObject CopyTo(Connection target, SystemRole systemrole)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Role", Parameter.ParamType.String, Parameter.ParamDirection.In, systemrole.role.ToString()));
                 mydata.Add(new Parameter("BuiltinRole", Parameter.ParamType.String, Parameter.ParamDirection.In, systemrole.builtinrole.ToString()));
			     mydata.Add(new Parameter("MemberUserPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.memberuserprincipal == null ? Guid.Empty : ((IObject)this.memberuserprincipal).ID)));
			     mydata.Add(new Parameter("MemberGroupPrincipalID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.membergroupprincipal == null ? Guid.Empty : ((IObject)this.membergroupprincipal).ID)));

                PipelineParameter<SystemRole> pipe = new PipelineParameter<SystemRole>(CreateFromDataStore);
                IObject newObj = systemrole.SaveTo(mydata, store, pipe);

                return newObj;
            }

            User memberuserprincipal;
            Group membergroupprincipal;

        }
        
       
    }
}
