/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Tags that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the Tag collection</typeparam>
    public class TagCollection<O> : SyncCollection<O, Tag>
        where O : IObject
    {
        public TagCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Tag>.DelayLoadCallback(TagCollection_OnDelayLoad);
        }

        public TagCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, Tag>.DelayLoadCallback(TagCollection_OnDelayLoadRef);
        }

        List<Tag> TagCollection_OnDelayLoad(Connection c)
        {
            return Tag.LoadAll(this.Owner, c);
        }

        List<Tag> TagCollection_OnDelayLoadRef(Connection c)
        {
            return Tag.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static TagCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            TagCollection<O> objList = new TagCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static TagCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            TagCollection<O> objList = new TagCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Tag
    /// </summary>
    [Serializable]
    public partial class Tag : NamedObject<Tag>
    {
        private System.String description;
        
        private NamespaceCollection<Tag> m_namespaces;
        private ServiceCollection<Tag> services;
        private KeywordCollection<Tag> keywords;
        private ActivityCollection<Tag> activitys;
        private ActivityParameterCollection<Tag> activityparameters;

        /// <summary>
        /// Description of the Tag
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public NamespaceCollection<Tag> Namespaces { get { return m_namespaces; } }
        public ServiceCollection<Tag> Services { get { return services; } }
        public KeywordCollection<Tag> Keywords { get { return keywords; } }
        public ActivityCollection<Tag> Activitys { get { return activitys; } }
        public ActivityParameterCollection<Tag> ActivityParameters { get { return activityparameters; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public Tag(Connection c)
            : base(SRStorage.Tag, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new Tag Create(string name, Connection c)
        {
            Tag newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.m_namespaces = new NamespaceCollection<Tag>(newObj, c);
            newObj.services = new ServiceCollection<Tag>(newObj, c);
            newObj.keywords = new KeywordCollection<Tag>(newObj, c);
            newObj.activitys = new ActivityCollection<Tag>(newObj, c);
            newObj.activityparameters = new ActivityParameterCollection<Tag>(newObj, c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static Tag Load(string name, Connection c)
        {
            return NamedObject<Tag>.Load(name, c, Tag.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a Tag object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>Tag object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Tag loadObj = (Tag)NamedObject<Tag>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(Tag loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<Tag>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }


            //
            // Object connections
            //

            // Namespaces
            loadObj.m_namespaces = NamespaceCollection<Tag>.CreateFromReader(loadObj, reader, c);
            // Services
            loadObj.services = ServiceCollection<Tag>.CreateFromReader(loadObj, reader, c);
            // Keywords
            loadObj.keywords = KeywordCollection<Tag>.CreateFromReader(loadObj, reader, c);
            // Activitys
            loadObj.activitys = ActivityCollection<Tag>.CreateFromReader(loadObj, reader, c);
            // ActivityParameters
            loadObj.activityparameters = ActivityParameterCollection<Tag>.CreateFromReader(loadObj, reader, c);
        }

        public static Tag Load(Guid id, Connection c)
        {
            return Load<Tag>(id, c, Tag.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Tags from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Tags in the system</returns>
        public static List<Tag> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<Tag>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(Tag)], 
                Tag.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Tags that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Tags</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<Tag> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<Tag>(owner, Tag.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Tags that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Tags</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<Tag> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<Tag>(owner, src, Tag.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Tags by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Tags that match the criteria</returns>
        public static List<Tag> Search(string text, Connection c)
        {
            return LoadAll<Tag>(Connection.Action.Search, text, Tag.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.RelationSimpleField<Namespace> Namespace = new FieldDefs.RelationSimpleField<Namespace>("Namespace", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Service> Service = new FieldDefs.RelationSimpleField<Service>("Service", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Keyword> Keyword = new FieldDefs.RelationSimpleField<Keyword>("Keyword", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<Activity> Activity = new FieldDefs.RelationSimpleField<Activity>("Activity", RelationFieldBase.RelationshipType.Simple);
                public static FieldDefs.RelationSimpleField<ActivityParameter> ActivityParameter = new FieldDefs.RelationSimpleField<ActivityParameter>("ActivityParameter", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause Namespace(RelationSimpleField<Namespace>.Condition op, Namespace value) { return Fields.Namespace.CreateSearchClause(op, value); }
            public static ISearchClause Service(RelationSimpleField<Service>.Condition op, Service value) { return Fields.Service.CreateSearchClause(op, value); }
            public static ISearchClause Keyword(RelationSimpleField<Keyword>.Condition op, Keyword value) { return Fields.Keyword.CreateSearchClause(op, value); }
            public static ISearchClause Activity(RelationSimpleField<Activity>.Condition op, Activity value) { return Fields.Activity.CreateSearchClause(op, value); }
            public static ISearchClause ActivityParameter(RelationSimpleField<ActivityParameter>.Condition op, ActivityParameter value) { return Fields.ActivityParameter.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<Tag> Search(Tag.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.Tag, Connection.Action.Search, ref paramList, Tag.CreateFromDataStore, out results);
            return results.ConvertAll<Tag>(BasicObject.ConvertFromIObject<Tag>);
        }
		

        /// <summary>
        /// Saves the Tag object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the Tag and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<Tag> updPipe = new PipelineParameter<Tag>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.m_namespaces.Refresh();
            this.services.Refresh();
            this.keywords.Refresh();
            this.activitys.Refresh();
            this.activityparameters.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.m_namespaces.Clear();
            this.services.Clear();
            this.keywords.Clear();
            this.activitys.Clear();
            this.activityparameters.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, Tag tag)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, tag.description));

                PipelineParameter<Tag> pipe = new PipelineParameter<Tag>(CreateFromDataStore);
                IObject newObj = tag.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
