/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the TridentTypeInfos that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the TridentTypeInfo collection</typeparam>
    public class TridentTypeInfoCollection<O> : SyncCollection<O, TridentTypeInfo>
        where O : IObject
    {
        public TridentTypeInfoCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, TridentTypeInfo>.DelayLoadCallback(TridentTypeInfoCollection_OnDelayLoad);
        }

        public TridentTypeInfoCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, TridentTypeInfo>.DelayLoadCallback(TridentTypeInfoCollection_OnDelayLoadRef);
        }

        List<TridentTypeInfo> TridentTypeInfoCollection_OnDelayLoad(Connection c)
        {
            return TridentTypeInfo.LoadAll(this.Owner, c);
        }

        List<TridentTypeInfo> TridentTypeInfoCollection_OnDelayLoadRef(Connection c)
        {
            return TridentTypeInfo.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static TridentTypeInfoCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            TridentTypeInfoCollection<O> objList = new TridentTypeInfoCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static TridentTypeInfoCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            TridentTypeInfoCollection<O> objList = new TridentTypeInfoCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// TridentTypeInfo
    /// </summary>
    [Serializable]
    public partial class TridentTypeInfo : NamedObject<TridentTypeInfo>
    {
        private System.String typename;
        
        private TypeInitializerCollection<TridentTypeInfo> initializers;

        /// <summary>
        /// Description of the TridentTypeInfo
        /// </summary>
        public System.String TypeName
        {
            get { return typename; }
            set
            {
                typename = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        public TypeInitializerCollection<TridentTypeInfo> Initializers { get { return initializers; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public TridentTypeInfo(Connection c)
            : base(SRStorage.TridentTypeInfo, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new TridentTypeInfo Create(string name, Connection c)
        {
            TridentTypeInfo newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            newObj.initializers = new TypeInitializerCollection<TridentTypeInfo>(newObj, "RelatedType", "Initializer", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static TridentTypeInfo Load(string name, Connection c)
        {
            return NamedObject<TridentTypeInfo>.Load(name, c, TridentTypeInfo.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a TridentTypeInfo object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>TridentTypeInfo object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            TridentTypeInfo loadObj = (TridentTypeInfo)NamedObject<TridentTypeInfo>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(TridentTypeInfo loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<TridentTypeInfo>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("TypeName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.typename = val;
            }


            //
            // Object connections
            //

            // Initializers
            loadObj.initializers = TypeInitializerCollection<TridentTypeInfo>.CreateFromReader(loadObj, "RelatedType", "Initializer", reader, c);
        }

        public static TridentTypeInfo Load(Guid id, Connection c)
        {
            return Load<TridentTypeInfo>(id, c, TridentTypeInfo.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL TridentTypeInfos from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all TridentTypeInfos in the system</returns>
        public static List<TridentTypeInfo> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<TridentTypeInfo>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(TridentTypeInfo)], 
                TridentTypeInfo.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all TridentTypeInfos that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the TridentTypeInfos</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<TridentTypeInfo> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<TridentTypeInfo>(owner, TridentTypeInfo.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all TridentTypeInfos that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the TridentTypeInfos</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<TridentTypeInfo> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<TridentTypeInfo>(owner, src, TridentTypeInfo.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches TridentTypeInfos by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of TridentTypeInfos that match the criteria</returns>
        public static List<TridentTypeInfo> Search(string text, Connection c)
        {
            return LoadAll<TridentTypeInfo>(Connection.Action.Search, text, TridentTypeInfo.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField TypeName = new FieldDefs.StringField("TypeName");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause TypeName(StringField.Condition op, System.String value) { return Fields.TypeName.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<TridentTypeInfo> Search(TridentTypeInfo.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.TridentTypeInfo, Connection.Action.Search, ref paramList, TridentTypeInfo.CreateFromDataStore, out results);
            return results.ConvertAll<TridentTypeInfo>(BasicObject.ConvertFromIObject<TridentTypeInfo>);
        }
		

        /// <summary>
        /// Saves the TridentTypeInfo object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("TypeName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.typename));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the TridentTypeInfo and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<TridentTypeInfo> updPipe = new PipelineParameter<TridentTypeInfo>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.initializers.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, TridentTypeInfo tridenttypeinfo)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("TypeName", Parameter.ParamType.String, Parameter.ParamDirection.In, tridenttypeinfo.typename));

                PipelineParameter<TridentTypeInfo> pipe = new PipelineParameter<TridentTypeInfo>(CreateFromDataStore);
                IObject newObj = tridenttypeinfo.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
