/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the TypeInitializers that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the TypeInitializer collection</typeparam>
    public class TypeInitializerCollection<O> : SyncCollection<O, TypeInitializer>
        where O : IObject
    {
        public TypeInitializerCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, TypeInitializer>.DelayLoadCallback(TypeInitializerCollection_OnDelayLoad);
        }

        public TypeInitializerCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, TypeInitializer>.DelayLoadCallback(TypeInitializerCollection_OnDelayLoadRef);
        }

        List<TypeInitializer> TypeInitializerCollection_OnDelayLoad(Connection c)
        {
            return TypeInitializer.LoadAll(this.Owner, c);
        }

        List<TypeInitializer> TypeInitializerCollection_OnDelayLoadRef(Connection c)
        {
            return TypeInitializer.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static TypeInitializerCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            TypeInitializerCollection<O> objList = new TypeInitializerCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static TypeInitializerCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            TypeInitializerCollection<O> objList = new TypeInitializerCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// TypeInitializer
    /// </summary>
    [Serializable]
    public partial class TypeInitializer : NamedObject<TypeInitializer>
    {
        private System.String assemblyname;
        private System.String classname;
        private System.String qualifiedname;
        private System.String author;
        private System.Boolean isdeleted;
        private Runtime runtimetype;
        private Guid relatedtypeID;
        private TridentTypeInfo relatedtype;
        
        private AssemblyPackageCollection<TypeInitializer> assemblypackages;

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public System.String AssemblyName
        {
            get { return assemblyname; }
            set
            {
                assemblyname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public System.String ClassName
        {
            get { return classname; }
            set
            {
                classname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public System.String QualifiedName
        {
            get { return qualifiedname; }
            set
            {
                qualifiedname = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public System.String Author
        {
            get { return author; }
            set
            {
                author = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the TypeInitializer
        /// </summary>
        public Runtime RuntimeType
        {
            get { return runtimetype; }
            set
            {
                runtimetype = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public TridentTypeInfo RelatedType
        {
            get
            {
                lock (this)
                {
                    if (relatedtype == null && relatedtypeID != Guid.Empty)
                        relatedtype = TridentTypeInfo.Load(relatedtypeID, Conn);
                }
                return relatedtype;
            }

            set
            {
                lock (this)
                {
                    relatedtype = value;                   
                    relatedtypeID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public AssemblyPackageCollection<TypeInitializer> AssemblyPackages { get { return assemblypackages; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public TypeInitializer(Connection c)
            : base(SRStorage.TypeInitializer, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static TypeInitializer Create(string name, Runtime runtimetype, TridentTypeInfo relatedtype, Connection c)
        {
            TypeInitializer newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;

            newObj.runtimetype = runtimetype;
            newObj.relatedtype = relatedtype;

			
            // Empty collections
            newObj.assemblypackages = new AssemblyPackageCollection<TypeInitializer>(newObj, c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static TypeInitializer Load(string name, Connection c)
        {
            return NamedObject<TypeInitializer>.Load(name, c, TypeInitializer.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a TypeInitializer object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>TypeInitializer object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            TypeInitializer loadObj = (TypeInitializer)NamedObject<TypeInitializer>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(TypeInitializer loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<TypeInitializer>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("AssemblyName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.assemblyname = val;
            }

            index = reader.GetOrdinal("ClassName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.classname = val;
            }

            index = reader.GetOrdinal("QualifiedName");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.qualifiedname = val;
            }

            index = reader.GetOrdinal("Author");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.author = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("RuntimeType");
            if (!reader.IsDBNull(index))
                loadObj.runtimetype = (Runtime)Enum.Parse(typeof(Runtime), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("RelatedTypeID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.relatedtypeID = val;
            }


            //
            // Object connections
            //

            // AssemblyPackages
            loadObj.assemblypackages = AssemblyPackageCollection<TypeInitializer>.CreateFromReader(loadObj, reader, c);
        }

        public static TypeInitializer Load(Guid id, Connection c)
        {
            return Load<TypeInitializer>(id, c, TypeInitializer.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL TypeInitializers from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all TypeInitializers in the system</returns>
        public static List<TypeInitializer> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<TypeInitializer>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(TypeInitializer)], 
                TypeInitializer.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all TypeInitializers that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the TypeInitializers</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<TypeInitializer> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<TypeInitializer>(owner, TypeInitializer.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all TypeInitializers that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the TypeInitializers</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<TypeInitializer> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<TypeInitializer>(owner, src, TypeInitializer.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches TypeInitializers by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of TypeInitializers that match the criteria</returns>
        public static List<TypeInitializer> Search(string text, Connection c)
        {
            return LoadAll<TypeInitializer>(Connection.Action.Search, text, TypeInitializer.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField AssemblyName = new FieldDefs.StringField("AssemblyName");
                public static FieldDefs.StringField ClassName = new FieldDefs.StringField("ClassName");
                public static FieldDefs.StringField QualifiedName = new FieldDefs.StringField("QualifiedName");
                public static FieldDefs.StringField Author = new FieldDefs.StringField("Author");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.EnumField<Runtime> RuntimeType = new FieldDefs.EnumField<Runtime>("RuntimeType");
                public static FieldDefs.ObjectField<TridentTypeInfo> RelatedType = new FieldDefs.ObjectField<TridentTypeInfo>("RelatedType");
                public static FieldDefs.RelationSimpleField<AssemblyPackage> AssemblyPackage = new FieldDefs.RelationSimpleField<AssemblyPackage>("AssemblyPackage", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyName(StringField.Condition op, System.String value) { return Fields.AssemblyName.CreateSearchClause(op, value); }
            public static ISearchClause ClassName(StringField.Condition op, System.String value) { return Fields.ClassName.CreateSearchClause(op, value); }
            public static ISearchClause QualifiedName(StringField.Condition op, System.String value) { return Fields.QualifiedName.CreateSearchClause(op, value); }
            public static ISearchClause Author(StringField.Condition op, System.String value) { return Fields.Author.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause RuntimeType(EnumField<Runtime>.Condition op, Runtime value) { return Fields.RuntimeType.CreateSearchClause(op, value); }
            public static ISearchClause RelatedType(ObjectField<TridentTypeInfo>.Condition op, TridentTypeInfo value) { return Fields.RelatedType.CreateSearchClause(op, value); }
            public static ISearchClause AssemblyPackage(RelationSimpleField<AssemblyPackage>.Condition op, AssemblyPackage value) { return Fields.AssemblyPackage.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<TypeInitializer> Search(TypeInitializer.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.TypeInitializer, Connection.Action.Search, ref paramList, TypeInitializer.CreateFromDataStore, out results);
            return results.ConvertAll<TypeInitializer>(BasicObject.ConvertFromIObject<TypeInitializer>);
        }
		

        /// <summary>
        /// Saves the TypeInitializer object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("AssemblyName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.assemblyname));

            mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.classname));

            mydata.Add(new Parameter("QualifiedName", Parameter.ParamType.String, Parameter.ParamDirection.In, this.qualifiedname));

            mydata.Add(new Parameter("Author", Parameter.ParamType.String, Parameter.ParamDirection.In, this.author));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("RuntimeType", Parameter.ParamType.String, Parameter.ParamDirection.In, this.runtimetype.ToString()));
            mydata.Add(new Parameter("RelatedTypeID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.relatedtypeID == Guid.Empty ?
                (this.RelatedType == null ? Guid.Empty : ((IObject)this.RelatedType).ID)
                : this.relatedtypeID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the TypeInitializer and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<TypeInitializer> updPipe = new PipelineParameter<TypeInitializer>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.assemblypackages.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.assemblypackages.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(TridentTypeInfo relatedtype)
            {
                this.relatedtype=relatedtype;

            }

            public IObject CopyTo(Connection target, TypeInitializer typeinitializer)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("AssemblyName", Parameter.ParamType.String, Parameter.ParamDirection.In, typeinitializer.assemblyname));
                 mydata.Add(new Parameter("ClassName", Parameter.ParamType.String, Parameter.ParamDirection.In, typeinitializer.classname));
                 mydata.Add(new Parameter("QualifiedName", Parameter.ParamType.String, Parameter.ParamDirection.In, typeinitializer.qualifiedname));
                 mydata.Add(new Parameter("Author", Parameter.ParamType.String, Parameter.ParamDirection.In, typeinitializer.author));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, typeinitializer.isdeleted));
                 mydata.Add(new Parameter("RuntimeType", Parameter.ParamType.String, Parameter.ParamDirection.In, typeinitializer.runtimetype.ToString()));
			     mydata.Add(new Parameter("RelatedTypeID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.relatedtype == null ? Guid.Empty : ((IObject)this.relatedtype).ID)));

                PipelineParameter<TypeInitializer> pipe = new PipelineParameter<TypeInitializer>(CreateFromDataStore);
                IObject newObj = typeinitializer.SaveTo(mydata, store, pipe);

                return newObj;
            }

            TridentTypeInfo relatedtype;

        } 
        
              
    }
}
