/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the Users that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the User collection</typeparam>
    public class UserCollection<O> : SyncCollection<O, User>
        where O : IObject
    {
        public UserCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, User>.DelayLoadCallback(UserCollection_OnDelayLoad);
        }

        public UserCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, User>.DelayLoadCallback(UserCollection_OnDelayLoadRef);
        }

        List<User> UserCollection_OnDelayLoad(Connection c)
        {
            return User.LoadAll(this.Owner, c);
        }

        List<User> UserCollection_OnDelayLoadRef(Connection c)
        {
            return User.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static UserCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            UserCollection<O> objList = new UserCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static UserCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            UserCollection<O> objList = new UserCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// User
    /// </summary>
    [Serializable]
    public partial class User : NamedObject<User>, ISecurityPrincipal
    {
        private System.String description;
        private System.Boolean enabled;
        private System.Boolean isdeleted;
        private System.Boolean isbuiltin;
        private EEmployeeStatus employeestatus;
        private Guid workflowrootID;
        private Namespace workflowroot;
        private Guid activityrootID;
        private Namespace activityroot;
        private Guid uncategorizedworkflowsID;
        private Namespace uncategorizedworkflows;
        
        private GroupCollection<User> groups;
        private UserCredentialCollection<User> usercredentials;
        private NamespaceCollection<User> m_namespaces;
        private ServiceCollection<User> services;
        private SystemRoleCollection<User> systemroles;

        /// <summary>
        /// Description of the User
        /// </summary>
        public System.String Description
        {
            get { return description; }
            set
            {
                description = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the User
        /// </summary>
        public System.Boolean Enabled
        {
            get { return enabled; }
            set
            {
                enabled = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the User
        /// </summary>
        public System.Boolean IsDeleted
        {
            get { return isdeleted; }
            set
            {
                isdeleted = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the User
        /// </summary>
        public System.Boolean IsBuiltin
        {
            get { return isbuiltin; }
            set
            {
                isbuiltin = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the User
        /// </summary>
        public EEmployeeStatus EmployeeStatus
        {
            get { return employeestatus; }
            set
            {
                employeestatus = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        public Namespace WorkflowRoot
        {
            get
            {
                lock (this)
                {
                    if (workflowroot == null && workflowrootID != Guid.Empty)
                        workflowroot = Namespace.Load(workflowrootID, Conn);
                }
                return workflowroot;
            }

            set
            {
                lock (this)
                {
                    workflowroot = value;                   
                    workflowrootID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Namespace ActivityRoot
        {
            get
            {
                lock (this)
                {
                    if (activityroot == null && activityrootID != Guid.Empty)
                        activityroot = Namespace.Load(activityrootID, Conn);
                }
                return activityroot;
            }

            set
            {
                lock (this)
                {
                    activityroot = value;                   
                    activityrootID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        public Namespace UncategorizedWorkflows
        {
            get
            {
                lock (this)
                {
                    if (uncategorizedworkflows == null && uncategorizedworkflowsID != Guid.Empty)
                        uncategorizedworkflows = Namespace.Load(uncategorizedworkflowsID, Conn);
                }
                return uncategorizedworkflows;
            }

            set
            {
                lock (this)
                {
                    uncategorizedworkflows = value;                   
                    uncategorizedworkflowsID = (value == null ? Guid.Empty : ((IObject)value).ID);

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        
        public GroupCollection<User> Groups { get { return groups; } }
        protected UserCredentialCollection<User> UserCredentials { get { return usercredentials; } }
        public NamespaceCollection<User> Namespaces { get { return m_namespaces; } }
        public ServiceCollection<User> Services { get { return services; } }
        public SystemRoleCollection<User> SystemRoles { get { return systemroles; } }

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public User(Connection c)
            : base(SRStorage.User, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new User Create(string name, Connection c)
        {
            User newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			
            // Empty collections
            newObj.groups = new GroupCollection<User>(newObj, c);
            newObj.usercredentials = new UserCredentialCollection<User>(newObj, "User", "UserCredential", c);
            newObj.m_namespaces = new NamespaceCollection<User>(newObj, "Owner", "Namespace", c);
            newObj.services = new ServiceCollection<User>(newObj, "Owner", "Service", c);
            newObj.systemroles = new SystemRoleCollection<User>(newObj, "MemberUserPrincipal", "SystemRole", c);

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static User Load(string name, Connection c)
        {
            return NamedObject<User>.Load(name, c, User.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a User object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>User object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            User loadObj = (User)NamedObject<User>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(User loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<User>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.description = val;
            }

            index = reader.GetOrdinal("Enabled");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.enabled = val;
            }

            index = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isdeleted = val;
            }

            index = reader.GetOrdinal("IsBuiltin");
            if (!reader.IsDBNull(index))
            {
                System.Boolean val = reader.GetBoolean(index);
                loadObj.isbuiltin = val;
            }

            index = reader.GetOrdinal("EmployeeStatus");
            if (!reader.IsDBNull(index))
                loadObj.employeestatus = (EEmployeeStatus)Enum.Parse(typeof(EEmployeeStatus), reader.GetString(index).Trim(), true);

            index = reader.GetOrdinal("WorkflowRootID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.workflowrootID = val;
            }

            index = reader.GetOrdinal("ActivityRootID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.activityrootID = val;
            }

            index = reader.GetOrdinal("UncategorizedWorkflowsID");
            if (!reader.IsDBNull(index))
            {
                Guid val = reader.GetGuid(index);
                loadObj.uncategorizedworkflowsID = val;
            }


            //
            // Object connections
            //

            // Groups
            loadObj.groups = GroupCollection<User>.CreateFromReader(loadObj, reader, c);
            // UserCredentials
            loadObj.usercredentials = UserCredentialCollection<User>.CreateFromReader(loadObj, "User", "UserCredential", reader, c);
            // Namespaces
            loadObj.m_namespaces = NamespaceCollection<User>.CreateFromReader(loadObj, "Owner", "Namespace", reader, c);
            // Services
            loadObj.services = ServiceCollection<User>.CreateFromReader(loadObj, "Owner", "Service", reader, c);
            // SystemRoles
            loadObj.systemroles = SystemRoleCollection<User>.CreateFromReader(loadObj, "MemberUserPrincipal", "SystemRole", reader, c);
        }

        public static User Load(Guid id, Connection c)
        {
            return Load<User>(id, c, User.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL Users from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all Users in the system</returns>
        public static List<User> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<User>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(User)], 
                User.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all Users that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Users</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<User> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<User>(owner, User.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all Users that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the Users</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<User> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<User>(owner, src, User.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches Users by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of Users that match the criteria</returns>
        public static List<User> Search(string text, Connection c)
        {
            return LoadAll<User>(Connection.Action.Search, text, User.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class BooleanField : ER.BooleanField
                {
                    internal BooleanField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, bool value)
                    {
                        return new SearchClause(this, BooleanField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class EnumField<T> : ER.EnumField<T>
                {
                    internal EnumField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, EnumField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class ObjectField<T> : ER.ObjectField<T>
                    where T : IObject
                {
                    internal ObjectField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
                        return new SearchClause(this, ObjectField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class RelationSimpleField<T> : ER.RelationSimpleField<T>
                    where T : IObject
                {
                     internal RelationSimpleField(string myName, RelationshipType relType)
					: base(myName, relType)
                    {
                    }
                    public ISearchClause CreateSearchClause(Condition cond, T value)
                    {
					    return new SearchClause(this, RelationSimpleField<T>.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField Description = new FieldDefs.StringField("Description");
                public static FieldDefs.BooleanField Enabled = new FieldDefs.BooleanField("Enabled");
                public static FieldDefs.BooleanField IsDeleted = new FieldDefs.BooleanField("IsDeleted");
                public static FieldDefs.BooleanField IsBuiltin = new FieldDefs.BooleanField("IsBuiltin");
                public static FieldDefs.EnumField<EEmployeeStatus> EmployeeStatus = new FieldDefs.EnumField<EEmployeeStatus>("EmployeeStatus");
                public static FieldDefs.ObjectField<Namespace> WorkflowRoot = new FieldDefs.ObjectField<Namespace>("WorkflowRoot");
                public static FieldDefs.ObjectField<Namespace> ActivityRoot = new FieldDefs.ObjectField<Namespace>("ActivityRoot");
                public static FieldDefs.ObjectField<Namespace> UncategorizedWorkflows = new FieldDefs.ObjectField<Namespace>("UncategorizedWorkflows");
                public static FieldDefs.RelationSimpleField<Group> Group = new FieldDefs.RelationSimpleField<Group>("Group", RelationFieldBase.RelationshipType.Simple);
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause Description(StringField.Condition op, System.String value) { return Fields.Description.CreateSearchClause(op, value); }
            public static ISearchClause Enabled(BooleanField.Condition op, System.Boolean value) { return Fields.Enabled.CreateSearchClause(op, value); }
            public static ISearchClause IsDeleted(BooleanField.Condition op, System.Boolean value) { return Fields.IsDeleted.CreateSearchClause(op, value); }
            public static ISearchClause IsBuiltin(BooleanField.Condition op, System.Boolean value) { return Fields.IsBuiltin.CreateSearchClause(op, value); }
            public static ISearchClause EmployeeStatus(EnumField<EEmployeeStatus>.Condition op, EEmployeeStatus value) { return Fields.EmployeeStatus.CreateSearchClause(op, value); }
            public static ISearchClause WorkflowRoot(ObjectField<Namespace>.Condition op, Namespace value) { return Fields.WorkflowRoot.CreateSearchClause(op, value); }
            public static ISearchClause ActivityRoot(ObjectField<Namespace>.Condition op, Namespace value) { return Fields.ActivityRoot.CreateSearchClause(op, value); }
            public static ISearchClause UncategorizedWorkflows(ObjectField<Namespace>.Condition op, Namespace value) { return Fields.UncategorizedWorkflows.CreateSearchClause(op, value); }
            public static ISearchClause Group(RelationSimpleField<Group>.Condition op, Group value) { return Fields.Group.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<User> Search(User.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.User, Connection.Action.Search, ref paramList, User.CreateFromDataStore, out results);
            return results.ConvertAll<User>(BasicObject.ConvertFromIObject<User>);
        }
		

        /// <summary>
        /// Saves the User object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, this.description));

            mydata.Add(new Parameter("Enabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.enabled));

            mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isdeleted));

            mydata.Add(new Parameter("IsBuiltin", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, this.isbuiltin));

            mydata.Add(new Parameter("EmployeeStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, this.employeestatus.ToString()));
            mydata.Add(new Parameter("WorkflowRootID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.workflowrootID == Guid.Empty ?
                (this.WorkflowRoot == null ? Guid.Empty : ((IObject)this.WorkflowRoot).ID)
                : this.workflowrootID)));
            mydata.Add(new Parameter("ActivityRootID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.activityrootID == Guid.Empty ?
                (this.ActivityRoot == null ? Guid.Empty : ((IObject)this.ActivityRoot).ID)
                : this.activityrootID)));
            mydata.Add(new Parameter("UncategorizedWorkflowsID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
                (this.uncategorizedworkflowsID == Guid.Empty ?
                (this.UncategorizedWorkflows == null ? Guid.Empty : ((IObject)this.UncategorizedWorkflows).ID)
                : this.uncategorizedworkflowsID)));
            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the User and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<User> updPipe = new PipelineParameter<User>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

            this.groups.Refresh();
            this.usercredentials.Refresh();
            this.m_namespaces.Refresh();
            this.services.Refresh();
            this.systemroles.Refresh();
        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        
            this.groups.Clear();

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target,CopyHelper helper)
		{

            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper(Namespace workflowroot,Namespace activityroot,Namespace uncategorizedworkflows)
            {
                this.workflowroot=workflowroot;
                this.activityroot=activityroot;
                this.uncategorizedworkflows=uncategorizedworkflows;

            }

            public IObject CopyTo(Connection target, User user)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("Description", Parameter.ParamType.Text, Parameter.ParamDirection.In, user.description));
                 mydata.Add(new Parameter("Enabled", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, user.enabled));
                 mydata.Add(new Parameter("IsDeleted", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, user.isdeleted));
                 mydata.Add(new Parameter("IsBuiltin", Parameter.ParamType.Boolean, Parameter.ParamDirection.In, user.isbuiltin));
                 mydata.Add(new Parameter("EmployeeStatus", Parameter.ParamType.String, Parameter.ParamDirection.In, user.employeestatus.ToString()));
			     mydata.Add(new Parameter("WorkflowRootID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.workflowroot == null ? Guid.Empty : ((IObject)this.workflowroot).ID)));
			     mydata.Add(new Parameter("ActivityRootID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.activityroot == null ? Guid.Empty : ((IObject)this.activityroot).ID)));
			     mydata.Add(new Parameter("UncategorizedWorkflowsID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, 
				    (this.uncategorizedworkflows == null ? Guid.Empty : ((IObject)this.uncategorizedworkflows).ID)));

                PipelineParameter<User> pipe = new PipelineParameter<User>(CreateFromDataStore);
                IObject newObj = user.SaveTo(mydata, store, pipe);

                return newObj;
            }

            Namespace workflowroot;
            Namespace activityroot;
            Namespace uncategorizedworkflows;

        } 
        
       		#region ISecurityPrincipal Members

        public ISecurityCredentialCollection Credentials
        {
            get { return UserCredentials; }
        }

        #endregion       
    }
}
