/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using ER = Microsoft.Research.DataLayer;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents all the WebServiceLocations that an object has
    /// </summary>
    /// <typeparam name="O">Type of object that owns the WebServiceLocation collection</typeparam>
    public class WebServiceLocationCollection<O> : SyncCollection<O, WebServiceLocation>
        where O : IObject
    {
        public WebServiceLocationCollection(O o, Connection c)
            : base(o, c)
        {
            this.OnDelayLoad += new SyncCollection<O, WebServiceLocation>.DelayLoadCallback(WebServiceLocationCollection_OnDelayLoad);
        }

        public WebServiceLocationCollection(O o, string src, string revKey, Connection c)
            : base(o, src, revKey, c)
        {
            this.OnDelayLoad += new SyncCollection<O, WebServiceLocation>.DelayLoadCallback(WebServiceLocationCollection_OnDelayLoadRef);
        }

        List<WebServiceLocation> WebServiceLocationCollection_OnDelayLoad(Connection c)
        {
            return WebServiceLocation.LoadAll(this.Owner, c);
        }

        List<WebServiceLocation> WebServiceLocationCollection_OnDelayLoadRef(Connection c)
        {
            return WebServiceLocation.LoadAll(this.Owner, this.SourceKey, c);
        }

        public static WebServiceLocationCollection<O> CreateFromReader(O o, DbDataReader reader, Connection c)
        {
            WebServiceLocationCollection<O> objList = new WebServiceLocationCollection<O>(o, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }

        public static WebServiceLocationCollection<O> CreateFromReader(O o, string key, string revKey, DbDataReader reader, Connection c)
        {
            WebServiceLocationCollection<O> objList = new WebServiceLocationCollection<O>(o, key, revKey, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// WebServiceLocation
    /// </summary>
    [Serializable]
    public partial class WebServiceLocation : NamedObject<WebServiceLocation>
    {
        private System.String silverlighturi;
        private System.String webserviceuri;
        

        /// <summary>
        /// Description of the WebServiceLocation
        /// </summary>
        public System.String SilverlightURI
        {
            get { return silverlighturi; }
            set
            {
                silverlighturi = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        /// <summary>
        /// Description of the WebServiceLocation
        /// </summary>
        public System.String WebServiceURI
        {
            get { return webserviceuri; }
            set
            {
                webserviceuri = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        

        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        public WebServiceLocation(Connection c)
            : base(SRStorage.WebServiceLocation, c)
        {
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static new WebServiceLocation Create(string name, Connection c)
        {
            WebServiceLocation newObj = New(c);
            newObj.ObjID = Guid.Empty;
            newObj.ObjName = name;
            newObj.isNew = true;


			

            newObj.OnConstructor();

            if (c.AutoSave)
                newObj.Save();

            return newObj;
        }

        public static WebServiceLocation Load(string name, Connection c)
        {
            return NamedObject<WebServiceLocation>.Load(name, c, WebServiceLocation.CreateFromDataStore);
        }

        /// <summary>
        /// Creates a WebServiceLocation object from data retrieved from the storage backend
        /// </summary>
        /// <param name="reader">DbDataReader that holds the object data</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>WebServiceLocation object</returns>
        protected new static IObject CreateFromDataStore(DbDataReader reader, Connection c)
        {
            WebServiceLocation loadObj = (WebServiceLocation)NamedObject<WebServiceLocation>.CreateFromDataStore(reader, c);
            LoadFromDataStore(loadObj, reader, c);

            loadObj.OnConstructor();

            return loadObj;
        }


        protected new static void LoadFromDataStore(WebServiceLocation loadObj, DbDataReader reader, Connection c)
        {
            NamedObject<WebServiceLocation>.LoadFromDataStore(loadObj, reader, c);

            int index;

            //
            // Object data
            //

            index = reader.GetOrdinal("SilverlightURI");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.silverlighturi = val;
            }

            index = reader.GetOrdinal("WebServiceURI");
            if (!reader.IsDBNull(index))
            {
                System.String val = reader.GetString(index);
                loadObj.webserviceuri = val;
            }


            //
            // Object connections
            //

        }

        public static WebServiceLocation Load(Guid id, Connection c)
        {
            return Load<WebServiceLocation>(id, c, WebServiceLocation.CreateFromDataStore);
        }

        /// <summary>
        /// Retrieves ALL WebServiceLocations from the system
        /// </summary>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of all WebServiceLocations in the system</returns>
        public static List<WebServiceLocation> LoadAll(Connection c)
        {
            List<Parameter> mydata = new List<Parameter>();
            return LoadAll<WebServiceLocation>(Connection.Action.GetAll, Connection.TypeStoreMap[typeof(WebServiceLocation)], 
                WebServiceLocation.CreateFromDataStore, ref mydata, c);
        }

        /// <summary>
        /// Retrieves all WebServiceLocations that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the WebServiceLocations</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns></returns>
        public static List<WebServiceLocation> LoadAll(IObject owner, Connection c)
        {
            return LoadAll<WebServiceLocation>(owner, WebServiceLocation.CreateFromDataStore, c);
        }

        /// <summary>
        /// Retrieves all WebServiceLocations that an object has asssigned to it
        /// </summary>
        /// <param name="owner">Object that owns the WebServiceLocations</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <param name="src">Key to search for</param>
        /// <returns></returns>
        public static List<WebServiceLocation> LoadAll(IObject owner, string src, Connection c)
        {
            return LoadAll<WebServiceLocation>(owner, src, WebServiceLocation.CreateFromDataStore, c);
        }

        /// <summary>
        /// Searches WebServiceLocations by text
        /// </summary>
        /// <param name="text">Text to search on</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>List of WebServiceLocations that match the criteria</returns>
        public static List<WebServiceLocation> Search(string text, Connection c)
        {
            return LoadAll<WebServiceLocation>(Connection.Action.Search, text, WebServiceLocation.CreateFromDataStore, c);
        }



        #region Compiler-Time Search
        [Serializable]
        public class ISearch : SearchQuery
        {
            #region Public Interfaces
            public interface ISearchClause : ER.ISearchClause
            {
            }

            public interface ISearchGroup : ISearchClause
            {
            }
            #endregion

            #region Search Grouping
            [Serializable]
            public class SearchGroup : ISearchGroup, ER.ISearchGroup
            {
                /// <summary>
                /// Represents a group condition that is unary
                /// </summary>
                [Serializable]
                public class SearchGroupUnary : ER.SearchGroupUnary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupUnary(SearchRelUnary op, ISearchClause p1)
                        : base(op, p1)
                    {
                    }
                }

                [Serializable]
                public class SearchGroupBinary : ER.SearchGroupBinary, ISearchClause, ISearchGroup
                {
                    internal SearchGroupBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                        : base(p1, op, p2)
                    {
                    }

                    internal SearchGroupBinary(SearchRelBinary op, params ISearchClause[] pArray)
                        : base(op, pArray)
                    {
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(ER.ISearchClause p1, SearchRelBinary op, ER.ISearchClause p2)
                    {
                        return new SearchGroupBinary((ISearchClause)p1, op, (ISearchClause)p2);
                    }

                    protected override ER.SearchGroupBinary CreateSearchGroup(SearchRelBinary op, params ER.ISearchClause[] pArray)
                    {
                        return new SearchGroupBinary(op, (ISearchClause[])pArray);
                    }

                    protected override ER.ISearchClause[] AllocClauseArray(int size)
                    {
                        return new ISearchClause[size];
                    }
                }

                public static SearchGroupUnary CreateUnary(SearchRelUnary op, ISearchClause p2)
                {
                    return new SearchGroupUnary(op, p2);
                }

                public static SearchGroupBinary CreateBinary(ISearchClause p1, SearchRelBinary op, ISearchClause p2)
                {
                    return new SearchGroupBinary(p1, op, p2);
                }

                public static SearchGroupBinary CreateBinary(SearchRelBinary op, params ISearchClause[] pArray)
                {
                    return new SearchGroupBinary(op, pArray);
                }
            }
            #endregion

            #region Field Definitions
            [Serializable]
            public static class FieldDefs
            {
                [Serializable]
                public class SearchClause : SearchClauseWrapper, ISearchClause
                {
                    public SearchClause(ER.BaseField field, ER.ISearchClause clause)
                        : base(field, clause)
                    {
                    }
                }

                [Serializable]
                public class StringField : ER.StringField
                {
                    internal StringField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, string value)
                    {
                        return new SearchClause(this, StringField.CreateSearchClause(Name, cond, value));
                    }
                }
                [Serializable]
                public class DateTimeField : ER.DateTimeField
                {
                    internal DateTimeField(string myName)
                        : base(myName)
                    {
                    }

                    public ISearchClause CreateSearchClause(Condition cond, DateTime value)
                    {
                        return new SearchClause(this, DateTimeField.CreateSearchClause(Name, cond, value));
                    }
                }
            }
            #endregion

            #region Field Declarations
            [Serializable]
            public static class Fields
            {
                public static FieldDefs.StringField Name = new FieldDefs.StringField("Name");
                public static FieldDefs.DateTimeField CreatedDate = new FieldDefs.DateTimeField("CreatedDate");
                public static FieldDefs.StringField CreatedBy = new FieldDefs.StringField("CreatedBy");
                public static FieldDefs.DateTimeField UpdatedDate = new FieldDefs.DateTimeField("UpdatedDate");
                public static FieldDefs.StringField UpdatedBy = new FieldDefs.StringField("UpdatedBy");
                public static FieldDefs.StringField SilverlightURI = new FieldDefs.StringField("SilverlightURI");
                public static FieldDefs.StringField WebServiceURI = new FieldDefs.StringField("WebServiceURI");
            }
            #endregion

            #region Predicate operation (AND, OR, NOT, ...)
            public static SearchGroup.SearchGroupBinary AND(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.And, p2);
            }

            public static SearchGroup.SearchGroupBinary AND(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.And, pArray);
            }

            public static SearchGroup.SearchGroupBinary OR(ISearchClause p1, ISearchClause p2)
            {
                return SearchGroup.CreateBinary(p1, SearchRelBinary.Or, p2);
            }

            public static SearchGroup.SearchGroupBinary OR(params ISearchClause[] pArray)
            {
                return SearchGroup.CreateBinary(SearchRelBinary.Or, pArray);
            }

            public static SearchGroup.SearchGroupUnary NOT(ISearchClause p1)
            {
                return SearchGroup.CreateUnary(SearchRelUnary.Not, p1);
            }
            #endregion

            #region Field Helpers
            public static ISearchClause Name(StringField.Condition op, System.String value) { return Fields.Name.CreateSearchClause(op, value); }
            public static ISearchClause CreatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.CreatedDate.CreateSearchClause(op, value); }
            public static ISearchClause CreatedBy(StringField.Condition op, System.String value) { return Fields.CreatedBy.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedDate(DateTimeField.Condition op, System.DateTime value) { return Fields.UpdatedDate.CreateSearchClause(op, value); }
            public static ISearchClause UpdatedBy(StringField.Condition op, System.String value) { return Fields.UpdatedBy.CreateSearchClause(op, value); }
            public static ISearchClause SilverlightURI(StringField.Condition op, System.String value) { return Fields.SilverlightURI.CreateSearchClause(op, value); }
            public static ISearchClause WebServiceURI(StringField.Condition op, System.String value) { return Fields.WebServiceURI.CreateSearchClause(op, value); }
            #endregion

            #region Constructors
            private ISearch()
            {
            }

            public static ISearch Create()
            {
                return new ISearch();
            }
            #endregion

            #region Properties and Members
            private ISearchClause query;

            public ISearchClause Query
            {
                get { return query; }
                set { query = value; }
            }
            #endregion

            #region SearchQuery implementation
            public override ER.ISearchClause GetQuery()
            {
                return query;
            }
            #endregion
        }
        #endregion

        public static List<WebServiceLocation> Search(WebServiceLocation.ISearch query, Connection conn)
        {
            List<IObject> results;
            List<Parameter> paramList = new List<Parameter>();
            paramList.Add(new Parameter("Query", Parameter.ParamType.Query, Parameter.ParamDirection.In, query));
            conn.Object(SRStorage.WebServiceLocation, Connection.Action.Search, ref paramList, WebServiceLocation.CreateFromDataStore, out results);
            return results.ConvertAll<WebServiceLocation>(BasicObject.ConvertFromIObject<WebServiceLocation>);
        }
		

        /// <summary>
        /// Saves the WebServiceLocation object to the storage backend
        /// </summary>
        public override void Save()
        {
			Connection store = Conn;
            List<Parameter> mydata = new List<Parameter>();
            
            
            mydata.Add(new Parameter("SilverlightURI", Parameter.ParamType.String, Parameter.ParamDirection.In, this.silverlighturi));

            mydata.Add(new Parameter("WebServiceURI", Parameter.ParamType.String, Parameter.ParamDirection.In, this.webserviceuri));

            
            Save(mydata);
            
        }

        protected IObject RefreshMe(DbDataReader input, Connection c)
        {
            LoadFromDataStore(this, input, c);
            return this;
        }

        /// <summary>
        /// Retrieves a fresh copy of the WebServiceLocation and relationships from the backend
        /// </summary>
        public override void Refresh()
        {
            List<Parameter> mydata = new List<Parameter>();
            mydata.Add(new Parameter("ID", Parameter.ParamType.Guid, Parameter.ParamDirection.In, this.ObjID));

            PipelineParameter<WebServiceLocation> updPipe = new PipelineParameter<WebServiceLocation>(RefreshMe);
            mydata.Add(updPipe);

            Conn.Object(this.ObjType, Connection.Action.GetByID, ref mydata);

        }
        
        public override void Delete()
        {
			OnBeforeDelete();
        

            // Delete the record itself
            base.Delete();
        }        
        
		public IObject CopyTo(Connection target)
		{
         CopyHelper helper = new CopyHelper();
            return helper.CopyTo(target, this);
		}
		        
        public class CopyHelper
        {
            public CopyHelper()
            {

            }

            public IObject CopyTo(Connection target, WebServiceLocation webservicelocation)
            {
                Connection store = target;
                List<Parameter> mydata = new List<Parameter>();
                 mydata.Add(new Parameter("SilverlightURI", Parameter.ParamType.String, Parameter.ParamDirection.In, webservicelocation.silverlighturi));
                 mydata.Add(new Parameter("WebServiceURI", Parameter.ParamType.String, Parameter.ParamDirection.In, webservicelocation.webserviceuri));

                PipelineParameter<WebServiceLocation> pipe = new PipelineParameter<WebServiceLocation>(CreateFromDataStore);
                IObject newObj = webservicelocation.SaveTo(mydata, store, pipe);

                return newObj;
            }


        } 
        
              
    }
}
