/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents a set of ActivityVersions placed by a Activity on a given object
    /// </summary>
    /// <typeparam name="O">Object where the ActivityVersions are being placed on</typeparam>
    public class ActivityVersionCollection<O> : SyncCollectionSelf<O, ActivityVersion>
        where O : IObject
    {
        public ActivityVersionCollection(O o, string src, string srcRev, string fieldName, Connection c)
            : base(o, src, srcRev, fieldName, c)
        {
            this.OnDelayLoad2 += new SyncCollectionSelf<O, ActivityVersion>.DelayLoadCallback2(ActivityVersionCollection_OnDelayLoad);
        }
        
        List<ActivityVersion> ActivityVersionCollection_OnDelayLoad(Connection c, string fieldName)
        {
            List<ActivityVersion> fromDB = ActivityVersion.LoadAll(Connection.Action.GetByObject, this.Owner, fieldName, c);
            return fromDB;
        }

        /// <summary>
        /// Creates an instance of the ActivityVersion collection (in memory) from data read from the
        /// storage
        /// </summary>
        /// <param name="o">Object ActivityVersion belongs to</param>
        /// <param name="reader">DbDataReader that contains data about the ActivityVersion</param>
        /// <param name="c">Valid connection to the data backend</param>
        /// <returns></returns>
        public static ActivityVersionCollection<O> CreateFromReader(O o, string key, string keyRev, string fieldName, DbDataReader reader, Connection c)
        {
            ActivityVersionCollection<O> objList = new ActivityVersionCollection<O>(o, key, keyRev, fieldName, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Represents a ActivityVersion placed by an Activity on a given object
    /// </summary>
    [Serializable]
    public partial class ActivityVersion : IObject, IExtraRelationData
    {
        protected Activity Activity_2Obj;
        protected Activity Activity_1Obj;
        protected Guid Activity_2ID;
        protected Guid Activity_1ID;
    
        /// <summary>
        /// Activity that created the ActivityVersion
        /// </summary>
        public Activity Activity_2
        {
            get
            {
                lock (this)
                {
                    if (Activity_2Obj == null && Activity_2ID != Guid.Empty)
                        Activity_2Obj = Activity.Load(Activity_2ID, Conn);
                }

                return Activity_2Obj;
            }

            set
            {
                lock (this)
                {
                    Activity_2Obj = value;
                    Activity_2ID = ((IObject)value).ID;

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }
               
        /// <summary>
        /// Activity that created the ActivityVersion
        /// </summary>
        public Activity Activity_1
        {
            get
            {
                lock (this)
                {
                    if (Activity_1Obj == null && Activity_1ID != Guid.Empty)
                        Activity_1Obj = Activity.Load(Activity_1ID, Conn);
                }

                return Activity_1Obj;
            }

            set
            {
                lock (this)
                {
                    Activity_1Obj = value;
                    Activity_1ID = ((IObject)value).ID;

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        // Connection type
        protected Connection.Storage objType = SRStorage.ActivityVersion;

        private VersionRelationshipType type;
        
        /// <summary>
        /// Description of the ActivityVersion
        /// </summary>
        public VersionRelationshipType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        private Connection Conn;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="u">Activity placing the ActivityVersion</param>
        /// <param name="c">Valid connection to the data backend</param>
        protected ActivityVersion(Activity one, Activity two, Connection c)
        {
            this.Activity_1Obj = one;
            this.Activity_1ID = ((IObject)one).ID;
            this.Activity_2Obj = two;
            this.Activity_2ID = ((IObject)two).ID;
            this.Conn = c;
        }

        protected ActivityVersion(Guid oneGuid, Guid twoGuid, Connection c)
        {
            this.Activity_1ID = oneGuid;
            this.Activity_2ID = twoGuid;
            this.Conn = c;
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static ActivityVersion Create(Activity one, Activity two, VersionRelationshipType type, Connection c)
        {
            ActivityVersion newObj = new ActivityVersion(one, two, c);

            newObj.type = type;

			
            return newObj;
        }

        public static List<ActivityVersion> LoadAll(Connection.Action action, object key, string fieldName, Connection c)
        {
            switch (action)
            {
                case Connection.Action.GetByObject:
                    List<IObject> results;
                    c.Relation(Connection.Action.GetByObject, (IObject)key, fieldName, SRStorage.ActivityVersion,
                        ActivityVersion.CreateFromDataStore, out results);
                    return results.ConvertAll<ActivityVersion>(BasicObject.ConvertFromIObject<ActivityVersion>);
                default:
                    throw new NotImplementedException();
            }
        }

        protected static ActivityVersion CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Guid oneID = reader.GetGuid(reader.GetOrdinal(string.Format("{0}ID", "Activity_1")));
            Guid twoID = reader.GetGuid(reader.GetOrdinal(string.Format("{0}ID", "Activity_2")));

            ActivityVersion loadObj = new ActivityVersion(oneID, twoID, c);
            int index;

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (VersionRelationshipType)Enum.Parse(typeof(VersionRelationshipType), reader.GetString(index).Trim(), true);


            return loadObj;
        }

 

        #region IExtraRelationData Members

        /// <summary>
        /// Provides extra data to be placed in the relationship object
        /// (Object -- ActivityVersion -- Activity)
        /// </summary>
        public List<Parameter> ExtraData
        {
            get
            {
                List<Parameter> mydata = new List<Parameter>();
                mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
                return mydata;
            }
        }

        /// <summary>
        /// Returns the ID of the Activity that placed the ActivityVersion
        /// </summary>
        public Guid ParentID
        {
            get { return ((IObject)Activity_1).ID; }
        }

        /// <summary>
        /// Returns the ID of the Activity that placed the ActivityVersion
        /// </summary>
        public Guid ChildID
        {
            get { return ((IObject)Activity_2).ID; }
        }

        /// <summary>
        /// Returns the Activity that placed the ActivityVersion
        /// </summary>
        public IObject ParentObj
        {
            get { return ((IObject)Activity_1); }
        }

        /// <summary>
        /// Returns the Activity that placed the ActivityVersion
        /// </summary>
        public IObject ChildObj
        {
            get { return ((IObject)Activity_2); }
        }

        /// <summary>
        /// Returns Connection.Storage.Activity
        /// </summary>
        public Connection.Storage ChildType
        {
            get { return Activity_2.ObjType; }
        }
        
        public IObject CopyTo(Connection target, IObject targetParent, IObject targetChild)
        {
            IObject wrapper = new ExtraRelationDataBridge(SRStorage.ActivityVersion, targetParent, targetChild, this);

            target.Relation(Connection.Action.Add, targetParent, wrapper);

            //
            // We fetch the object from the target store
            //
            Parameter oneID = new Parameter(string.Format("{0}ID", "Activity_1"), Parameter.ParamType.Guid, Parameter.ParamDirection.In, targetParent.ID);
            Parameter twoID = new Parameter(string.Format("{0}ID", "Activity_2"), Parameter.ParamType.Guid, Parameter.ParamDirection.In, targetChild.ID);

            List<Parameter> mydataNew = new List<Parameter>();
            mydataNew.Add(oneID);
            mydataNew.Add(twoID);

            List<IObject> results;
            target.Relation(Connection.Action.GetByObject, targetParent, SRStorage.ActivityVersion, CreateFromDataStore, out results);

            foreach (IExtraRelationData obj in results)
            {
                if (obj.ChildID.Equals(targetChild.ID))
                    return (IObject)obj;
            }

            throw new RecordNotFoundException("Object just added could not be found in the store");
        }

        #endregion

        #region IObject Members

        /// <summary>
        /// Returns the ID of the ActivityVersion
        /// </summary>
        public Guid ID
        {
            get { return Guid.Empty; }
        }

        /// <summary>
        /// Returns the type of the object (Connection.Storage.ActivityVersion)
        /// </summary>
        public Connection.Storage ObjType
        {
            get { return SRStorage.ActivityVersion; }
        }

        /// <summary>
        /// Saves the ActivityVersion to the data backend
        /// </summary>
        public void Save()
        {
            Conn.Relation(Connection.Action.Update, this.Activity_1, this);
        }

		public IObject CopyTo(Connection target)
		{
			throw new NotSupportedException("Use CopyTo(target, destParent, destChild) function instead");
		}

        /// <summary>
        /// Deletes the ActivityVersion from the data backend
        /// </summary>
        public void Delete()
        {
            throw new NotSupportedException();
        }

        /// <summary>
        /// Updates the ActivityVersion (in memory) with a fresh copy from the data backend
        /// </summary>
        public void Refresh()
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
