/***************************************************************/
/* THIS CODE WAS AUTOMATICALLY GENERATED. DO NOT EDIT MANUALLY */
/***************************************************************/

//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Microsoft.Research.DataLayer
{
    /// <summary>
    /// Represents a set of AssemblyImageVersions placed by a AssemblyImage on a given object
    /// </summary>
    /// <typeparam name="O">Object where the AssemblyImageVersions are being placed on</typeparam>
    public class AssemblyImageVersionCollection<O> : SyncCollectionSelf<O, AssemblyImageVersion>
        where O : IObject
    {
        public AssemblyImageVersionCollection(O o, string src, string srcRev, string fieldName, Connection c)
            : base(o, src, srcRev, fieldName, c)
        {
            this.OnDelayLoad2 += new SyncCollectionSelf<O, AssemblyImageVersion>.DelayLoadCallback2(AssemblyImageVersionCollection_OnDelayLoad);
        }
        
        List<AssemblyImageVersion> AssemblyImageVersionCollection_OnDelayLoad(Connection c, string fieldName)
        {
            List<AssemblyImageVersion> fromDB = AssemblyImageVersion.LoadAll(Connection.Action.GetByObject, this.Owner, fieldName, c);
            return fromDB;
        }

        /// <summary>
        /// Creates an instance of the AssemblyImageVersion collection (in memory) from data read from the
        /// storage
        /// </summary>
        /// <param name="o">Object AssemblyImageVersion belongs to</param>
        /// <param name="reader">DbDataReader that contains data about the AssemblyImageVersion</param>
        /// <param name="c">Valid connection to the data backend</param>
        /// <returns></returns>
        public static AssemblyImageVersionCollection<O> CreateFromReader(O o, string key, string keyRev, string fieldName, DbDataReader reader, Connection c)
        {
            AssemblyImageVersionCollection<O> objList = new AssemblyImageVersionCollection<O>(o, key, keyRev, fieldName, c);
            objList.LoadCollectionFromReader(reader);
            return objList;
        }
    }

    /// <summary>
    /// Represents a AssemblyImageVersion placed by an AssemblyImage on a given object
    /// </summary>
    [Serializable]
    public partial class AssemblyImageVersion : IObject, IExtraRelationData
    {
        protected AssemblyImage AssemblyImage_2Obj;
        protected AssemblyImage AssemblyImage_1Obj;
        protected Guid AssemblyImage_2ID;
        protected Guid AssemblyImage_1ID;
    
        /// <summary>
        /// AssemblyImage that created the AssemblyImageVersion
        /// </summary>
        public AssemblyImage AssemblyImage_2
        {
            get
            {
                lock (this)
                {
                    if (AssemblyImage_2Obj == null && AssemblyImage_2ID != Guid.Empty)
                        AssemblyImage_2Obj = AssemblyImage.Load(AssemblyImage_2ID, Conn);
                }

                return AssemblyImage_2Obj;
            }

            set
            {
                lock (this)
                {
                    AssemblyImage_2Obj = value;
                    AssemblyImage_2ID = ((IObject)value).ID;

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }
               
        /// <summary>
        /// AssemblyImage that created the AssemblyImageVersion
        /// </summary>
        public AssemblyImage AssemblyImage_1
        {
            get
            {
                lock (this)
                {
                    if (AssemblyImage_1Obj == null && AssemblyImage_1ID != Guid.Empty)
                        AssemblyImage_1Obj = AssemblyImage.Load(AssemblyImage_1ID, Conn);
                }

                return AssemblyImage_1Obj;
            }

            set
            {
                lock (this)
                {
                    AssemblyImage_1Obj = value;
                    AssemblyImage_1ID = ((IObject)value).ID;

                    if (Conn.AutoSave)
                        Save();
                }
            }
        }

        // Connection type
        protected Connection.Storage objType = SRStorage.AssemblyImageVersion;

        private VersionRelationshipType type;
        
        /// <summary>
        /// Description of the AssemblyImageVersion
        /// </summary>
        public VersionRelationshipType Type
        {
            get { return type; }
            set
            {
                type = value;

                if (Conn.AutoSave)
                    Save();
            }
        }

        
        private Connection Conn;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="u">AssemblyImage placing the AssemblyImageVersion</param>
        /// <param name="c">Valid connection to the data backend</param>
        protected AssemblyImageVersion(AssemblyImage one, AssemblyImage two, Connection c)
        {
            this.AssemblyImage_1Obj = one;
            this.AssemblyImage_1ID = ((IObject)one).ID;
            this.AssemblyImage_2Obj = two;
            this.AssemblyImage_2ID = ((IObject)two).ID;
            this.Conn = c;
        }

        protected AssemblyImageVersion(Guid oneGuid, Guid twoGuid, Connection c)
        {
            this.AssemblyImage_1ID = oneGuid;
            this.AssemblyImage_2ID = twoGuid;
            this.Conn = c;
        }

        /// <summary>
        /// Creates a new object
        /// </summary>
        /// <param name="name">Name of the object</param>
        /// <param name="c">Valid connection to the data store</param>
        /// <returns>In-memory version of the object</returns>
        public static AssemblyImageVersion Create(AssemblyImage one, AssemblyImage two, VersionRelationshipType type, Connection c)
        {
            AssemblyImageVersion newObj = new AssemblyImageVersion(one, two, c);

            newObj.type = type;

			
            return newObj;
        }

        public static List<AssemblyImageVersion> LoadAll(Connection.Action action, object key, string fieldName, Connection c)
        {
            switch (action)
            {
                case Connection.Action.GetByObject:
                    List<IObject> results;
                    c.Relation(Connection.Action.GetByObject, (IObject)key, fieldName, SRStorage.AssemblyImageVersion,
                        AssemblyImageVersion.CreateFromDataStore, out results);
                    return results.ConvertAll<AssemblyImageVersion>(BasicObject.ConvertFromIObject<AssemblyImageVersion>);
                default:
                    throw new NotImplementedException();
            }
        }

        protected static AssemblyImageVersion CreateFromDataStore(DbDataReader reader, Connection c)
        {
            Guid oneID = reader.GetGuid(reader.GetOrdinal(string.Format("{0}ID", "AssemblyImage_1")));
            Guid twoID = reader.GetGuid(reader.GetOrdinal(string.Format("{0}ID", "AssemblyImage_2")));

            AssemblyImageVersion loadObj = new AssemblyImageVersion(oneID, twoID, c);
            int index;

            index = reader.GetOrdinal("Type");
            if (!reader.IsDBNull(index))
                loadObj.type = (VersionRelationshipType)Enum.Parse(typeof(VersionRelationshipType), reader.GetString(index).Trim(), true);


            return loadObj;
        }

 

        #region IExtraRelationData Members

        /// <summary>
        /// Provides extra data to be placed in the relationship object
        /// (Object -- AssemblyImageVersion -- AssemblyImage)
        /// </summary>
        public List<Parameter> ExtraData
        {
            get
            {
                List<Parameter> mydata = new List<Parameter>();
                mydata.Add(new Parameter("Type", Parameter.ParamType.String, Parameter.ParamDirection.In, this.type.ToString()));
                return mydata;
            }
        }

        /// <summary>
        /// Returns the ID of the AssemblyImage that placed the AssemblyImageVersion
        /// </summary>
        public Guid ParentID
        {
            get { return ((IObject)AssemblyImage_1).ID; }
        }

        /// <summary>
        /// Returns the ID of the AssemblyImage that placed the AssemblyImageVersion
        /// </summary>
        public Guid ChildID
        {
            get { return ((IObject)AssemblyImage_2).ID; }
        }

        /// <summary>
        /// Returns the AssemblyImage that placed the AssemblyImageVersion
        /// </summary>
        public IObject ParentObj
        {
            get { return ((IObject)AssemblyImage_1); }
        }

        /// <summary>
        /// Returns the AssemblyImage that placed the AssemblyImageVersion
        /// </summary>
        public IObject ChildObj
        {
            get { return ((IObject)AssemblyImage_2); }
        }

        /// <summary>
        /// Returns Connection.Storage.AssemblyImage
        /// </summary>
        public Connection.Storage ChildType
        {
            get { return AssemblyImage_2.ObjType; }
        }
        
        public IObject CopyTo(Connection target, IObject targetParent, IObject targetChild)
        {
            IObject wrapper = new ExtraRelationDataBridge(SRStorage.AssemblyImageVersion, targetParent, targetChild, this);

            target.Relation(Connection.Action.Add, targetParent, wrapper);

            //
            // We fetch the object from the target store
            //
            Parameter oneID = new Parameter(string.Format("{0}ID", "AssemblyImage_1"), Parameter.ParamType.Guid, Parameter.ParamDirection.In, targetParent.ID);
            Parameter twoID = new Parameter(string.Format("{0}ID", "AssemblyImage_2"), Parameter.ParamType.Guid, Parameter.ParamDirection.In, targetChild.ID);

            List<Parameter> mydataNew = new List<Parameter>();
            mydataNew.Add(oneID);
            mydataNew.Add(twoID);

            List<IObject> results;
            target.Relation(Connection.Action.GetByObject, targetParent, SRStorage.AssemblyImageVersion, CreateFromDataStore, out results);

            foreach (IExtraRelationData obj in results)
            {
                if (obj.ChildID.Equals(targetChild.ID))
                    return (IObject)obj;
            }

            throw new RecordNotFoundException("Object just added could not be found in the store");
        }

        #endregion

        #region IObject Members

        /// <summary>
        /// Returns the ID of the AssemblyImageVersion
        /// </summary>
        public Guid ID
        {
            get { return Guid.Empty; }
        }

        /// <summary>
        /// Returns the type of the object (Connection.Storage.AssemblyImageVersion)
        /// </summary>
        public Connection.Storage ObjType
        {
            get { return SRStorage.AssemblyImageVersion; }
        }

        /// <summary>
        /// Saves the AssemblyImageVersion to the data backend
        /// </summary>
        public void Save()
        {
            Conn.Relation(Connection.Action.Update, this.AssemblyImage_1, this);
        }

		public IObject CopyTo(Connection target)
		{
			throw new NotSupportedException("Use CopyTo(target, destParent, destChild) function instead");
		}

        /// <summary>
        /// Deletes the AssemblyImageVersion from the data backend
        /// </summary>
        public void Delete()
        {
            throw new NotSupportedException();
        }

        /// <summary>
        /// Updates the AssemblyImageVersion (in memory) with a fresh copy from the data backend
        /// </summary>
        public void Refresh()
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
