//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ProvenanceCommon.Model
{
    using System;

    public class WorkflowSummaryModel
    {
        /// <summary>
        /// Get and set workflow name
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Get and sets AuthoredBy
        /// </summary>
        public string AuthoredBy { get; set; }

        /// <summary>
        /// Get and set JobName
        /// </summary>
        public string JobName { get; set; }

        /// <summary>
        /// Get and set ScheduledBy
        /// </summary>
        public string ScheduledBy { get; set; }

        /// <summary>
        ///Get and set Node Name
        /// </summary>
        public string Node { get; set; }

        /// <summary>
        /// Get and set StartDateTime
        /// </summary>
        public string StartDateTime { get; set; }

        /// <summary>
        /// Get and set Duration
        /// </summary>
        public string Duration { get; set; }

        /// <summary>
        /// Gets or sets the version.
        /// </summary>
        /// <value>The version.</value>
        public int Version { get; set; }

        /// <summary>
        /// Overridden tostring method. For automation Ids.
        /// </summary>
        /// <returns>The string representation of the object.</returns>
        public override string ToString()
        {
            if (!string.IsNullOrEmpty(this.JobName))
            {
                return this.JobName;
            }
            return base.ToString();
        }
    }
}
