//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ProvenanceCommon
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Research.DataLayer;

    public class ProvenanceEventArgs : EventArgs
    {
        /// <summary>
        /// Get or set RegistryConnection
        /// </summary>
        public Connection RegistryConnection { get; set; }

        /// <summary>
        /// Get or set ProvenanceConnection
        /// </summary>
        public Connection ProvenanceConnection { get; set; }

        /// <summary>
        /// get or set Job Id
        /// </summary>
        public Guid JobId { get; set; }

        /// <summary>
        /// Empty Constructor
        /// </summary>
        public ProvenanceEventArgs()
        { }
    }
}
