//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.Provenance.Controls
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Research.ProvenanceInterfaces;
    using Microsoft.Research.ProvenanceCommon;
    using Microsoft.Research.ProvenanceCommon.Model;
    using SR = Microsoft.Research.DataLayer;
    using System.Collections.ObjectModel;
    using Microsoft.Practices.Unity;
    using Microsoft.Research.DataLayer;
    using Microsoft.Research.ScientificWorkflow.TridentUtilities;

    public class Provenance : IProvenance
    {
         /// <summary>
        /// Initializes a new instance of the ProvenanceService class
        /// </summary>
        public Provenance()
        {
            this.Start(Guid.Empty);
        }

        public void Start(Guid jobId)
        {
            if (this.GetData != null)
            {
                this.GetData.Invoke(this, new EventArgs());
            }
        }

        public event EventHandler<EventArgs> GetData;

    }
}
