//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.Provenance.Controls.View
{
    using System.Windows.Controls;
    using Microsoft.Research.Provenance.Controls.Presenter;

    /// <summary>
    /// Interaction logic for ActivityPerformanceView.xaml
    /// </summary>
    public partial class ActivityPerformanceView : UserControl
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public ActivityPerformanceView()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Gets or sets the ActivityPerformancePresenter Model to the view's data context.
        /// </summary>
        public ActivityPerformancePresenter Model
        {
            get { return this.DataContext as ActivityPerformancePresenter; }
            set { this.DataContext = value; }
        }
    }
}
