//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ProvenanceInterfaces
{
    using System;
    using Microsoft.Research.ProvenanceCommon;
    using Microsoft.Research.ProvenanceCommon.Model;
    using System.Collections.ObjectModel;

    public interface IProvenance
    {
        event EventHandler<EventArgs> GetData;

        /// <summary>
        /// Start the subscriber if not already started.
        /// </summary>
        /// <param name="jobId">Job id</param>
        void Start(Guid jobId);
    }
}
