//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ProvenanceSubscriberCommon
{
    using System;
    using Microsoft.Research.ProvenanceSubscriberCommon.Models;

    /// <summary>
    /// Abstraction for ProvenanceModel event notification.
    /// </summary>
    public class ProvenanceModelEventArgs : EventArgs
    {
        /// <summary>
        /// ProvenanceInformationModel.
        /// </summary>
        private ProvenanceInformationModel provenanceInformationModel;

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="provenanceInformationModel">ProvenanceInformationModel.</param>
        public ProvenanceModelEventArgs(ProvenanceInformationModel provenanceInformationModel)
        {
            this.provenanceInformationModel = provenanceInformationModel;
        }

        /// <summary>
        /// Gets ProvenanceInformationModel.
        /// </summary>
        public ProvenanceInformationModel ProvenanceInformationModel
        {
            get { return this.provenanceInformationModel; }
        }
    }
}
