//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Blackboard.Interfaces
{
    using System;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// Implementers of this interface provide code that allows the 
    /// Blackboard to send a BlackboardMessage to a specific subscriber.
    /// </summary>
    public interface INotificationMessageSender
    {
        /// <summary>
        /// Notifies the subscriber at the specified address of a new BlackboardMessage.
        /// </summary>
        /// <param name="address">The subscriber's address.</param>
        /// <param name="message">The outgoing BlackboardMessage.</param>
        void Notify(Uri address, BlackboardMessage message);
    }
}
