//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Blackboard.Interfaces
{
    using System;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// Implementers of this interface provide code that allows the Blackboard to
    /// notify a publisher of changes to its subscription profile.
    /// </summary>
    public interface IPublisherSubscriptionSender
    {
        /// <summary>
        /// Notifies the publisher at the specified address of updates in 
        /// the subscription profile.
        /// </summary>
        /// <param name="address">The address of the publisher.</param>
        /// <param name="profile">The new subscription profile.</param>
        void UpdateSubscriptionProfile(Uri address, SubscriptionProfile profile);
    }
}
