//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Blackboard.Interfaces
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Arguments for the PublisherUnregistering event.
    /// </summary>
    public class PublisherUnregisteringEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PublisherUnregisteringEventArgs"/> class.
        /// </summary>
        /// <param name="returnAddress">The return address.</param>
        public PublisherUnregisteringEventArgs(Uri returnAddress)
            : base()
        {
            this.IncomingReturnAddress = returnAddress;
        }

        /// <summary>
        /// Gets the return address of the unregistering publisher.
        /// </summary>
        /// <value>The return address.</value>
        public Uri IncomingReturnAddress { get; private set; }
    }
}
