//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Blackboard.Wcf
{
    using System;
    using System.ServiceModel;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// The WCF-exposed interface for the <see cref="WcfNotificationSubscriptionService"/>.
    /// </summary>
    [ServiceContract]
    public interface IWcfNotificationSubscriptionService
    {
        /// <summary>
        /// Subscribes the specified return address of the subscriber with the specified subscription profile.
        /// </summary>
        /// <param name="returnAddress">The return address of the subscriber.</param>
        /// <param name="profile">The subscription profile.</param>
        [OperationContract(IsOneWay = true)]
        void Subscribe(Uri returnAddress, SubscriptionProfile profile);

        /// <summary>
        /// Unsubscribes the specified return address of the subscriber.
        /// </summary>
        /// <param name="returnAddress">The return address of the subscriber.</param>
        [OperationContract(IsOneWay = true)]
        void Unsubscribe(Uri returnAddress);
    }
}
