//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Common.Logging
{
    using System;

    /// <summary>
    /// Implement this interface if the object can raise logging events.
    /// </summary>
    public interface ILoggable
    {
        /// <summary>
        /// Fired when a log message is received.
        /// </summary>
        event EventHandler<LogEventArgs> LogMessageReceived;
    }
}
