//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Publisher.Interfaces
{
    using System;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// Arguments for the PublisherSubscriptionChanged event.
    /// </summary>
    public class PublisherSubscriptionChangedEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PublisherSubscriptionChangedEventArgs"/> class.
        /// </summary>
        /// <param name="profile">The profile.</param>
        public PublisherSubscriptionChangedEventArgs(SubscriptionProfile profile)
            : base()
        {
            this.IncomingSubscriptionProfile = profile;
        } 

        /// <summary>
        /// Gets the incoming subscription profile.
        /// </summary>
        /// <value>The incoming subscription profile.</value>
        public SubscriptionProfile IncomingSubscriptionProfile { get; private set; } 
    }
}
