//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Publisher.Wcf
{
    using System.ServiceModel;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// The WCF-exposed interface for the <see cref="WcfPublisherSubscriptionService"/> service.
    /// </summary>
    [ServiceContract]
    public interface IWcfPublisherSubscriptionService
    {
        /// <summary>
        /// Allows the blackboard to instruct the publisher to use a new subscription profile.
        /// </summary>
        /// <param name="profile">The new subscription profile.</param>
        [OperationContract(IsOneWay = true)]
        void UpdateSubscriptionProfile(SubscriptionProfile profile);
    }
}
