//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.RuntimeServices.Blackboard
{
    using System;

    public static class BlackboardServiceExtensions
    {
        public static IBlackboardService GetBlackboardService(this IServiceProvider serviceProvider)
        {
            IBlackboardService service = (IBlackboardService)serviceProvider.GetService(typeof(IBlackboardService));
            if (service == null)
            {
                string message = "An IBlackboardService could not be found in the runtime's list of services.";
                throw new InvalidOperationException(message);
            }

            return service;
        }

        public static bool TryGetBlackboardService(this IServiceProvider serviceProvider, out IBlackboardService service)
        {
            service = (IBlackboardService)serviceProvider.GetService(typeof(IBlackboardService));
            return service == null ? false : true;
        }
    }
}
