//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.RuntimeServices.Logging
{
    using System;

    public static class ILoggingServiceExtensions
    {
        public static ILoggingService GetLoggingService(this IServiceProvider serviceProvider)
        {
            ILoggingService service = (ILoggingService)serviceProvider.GetService(typeof(ILoggingService));
            if (service == null)
            {
                string message = "An ILoggingService could not be found in the runtime's list of services.";
                throw new InvalidOperationException(message);
            }

            return service;
        }
    }
}
