//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.RuntimeServices.Monitoring
{
    using System;
    using System.Threading;

    public class MonitorRecord
    {
        public MonitorRecord(string activityName, Type activityType, string conceptName, Timer timer, IResourceMonitor resourceMonitor)
        {
            this.ActivityName = activityName;
            this.ActivityType = activityType;
            this.ConceptName = conceptName;
            this.Timer = timer;
            this.ResourceMonitor = resourceMonitor;
        }

        public string ActivityName { get; private set; }
        public Type ActivityType { get; private set; }
        public string ConceptName { get; private set; }
        public Timer Timer { get; private set; }
        public IResourceMonitor ResourceMonitor { get; private set; }
    }
}
