//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.RuntimeServices.Monitoring
{
    using Microsoft.Research.eResearch.RuntimeServices.Blackboard;

    public class MonitorTimerState
    {
        public MonitorTimerState(IBlackboardService blackboardService, IResourceMonitor monitor, string concept, string workflowInstanceId, string activityName, string activityType)
        {
            this.BlackboardService = blackboardService;
            this.Monitor = monitor;
            this.Concept = concept;
            this.WorkflowInstanceId = workflowInstanceId;
            this.ActivityName = activityName;
            this.ActivityType = activityType;
        }

        public IBlackboardService BlackboardService { get; private set; }
        public IResourceMonitor Monitor { get; private set; }
        public string Concept { get; private set; }
        public string WorkflowInstanceId { get; private set; }
        public string ActivityName { get; private set; }
        public string ActivityType { get; private set; }
    }
}
