//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.RuntimeServices.Ontology
{
    using System.Collections.Generic;
    using System.Workflow.Runtime.Hosting;
    using Microsoft.Research.eResearch.Ontology.Lookup;
    using Microsoft.Research.eResearch.Ontology.Mapping;

    public class OntologyMappingService : WorkflowRuntimeService
    {
        private OntologicalTypeMapperManager mapper;

        public List<List<ConceptValuePair>> PerformMapping(object input)
        {
            return mapper.PerformMapping(input);
        }

        protected override void Start()
        {
            base.Start();
            mapper = new OntologicalTypeMapperManager();
        }

        protected override void OnStarted()
        {
            base.OnStarted();
        }

        protected override void Stop()
        {
            base.Stop();
            mapper = null;
        }

        protected override void OnStopped()
        {
            base.OnStopped();
        }
    }
}
