//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Subscriber.Interfaces
{
    using System;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// Arguments for the BlackboardMessageReceived event.
    /// </summary>
    public class BlackboardMessageReceivedEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BlackboardMessageReceivedEventArgs"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public BlackboardMessageReceivedEventArgs(BlackboardMessage message)
            : base()
        {
            this.IncomingMessage = message;
        } 

        /// <summary>
        /// Gets the incoming blackboard message.
        /// </summary>
        /// <value>The incoming blackboard message.</value>
        public BlackboardMessage IncomingMessage { get; private set; } 
    }
}
