//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.eResearch.Subscriber.Wcf
{
    using System.ServiceModel;
    using Microsoft.Research.eResearch.Blackboard.Common;

    /// <summary>
    /// The WCF-exposed interface for the <see cref="WcfNotificationMessageService"/>.
    /// </summary>
    [ServiceContract]
    public interface IWcfNotificationMessageService
    {
        /// <summary>
        /// Notifies the subscriber of a new blackboard message.
        /// </summary>
        /// <param name="message">The new blackboard message.</param>
        [OperationContract(IsOneWay = true)]
        void Notify(BlackboardMessage message);
    }
}
