//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Research.ScientificWorkflow.NetCDF.CSharpAPI {
    internal class NetCDFAttribute<T> : INetCDFAttribute{
        T[] values;
        string name;
        NetCDFDataType dataType;
        public NetCDFAttribute(string aName, T[] theValues, NetCDFDataType theDataType) {
            this.values = theValues;
            this.name = aName;
            this.dataType = theDataType;
        }

        #region INetCDFAttribute Members

        public uint Length {
            get { return (uint)this.values.Length; }
        }

        public NetCDFDataType DataType {
            get { return this.dataType; }
        }

        public object Value {
            get { return this.values; }
        }

        #endregion
    }
}
