//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Research.ScientificWorkflow.NetCDF.CSharpAPI {
    internal class NetCDFDimension : INetCDFDimension{
        string name;
        uint size;

        public NetCDFDimension(string aName, uint theSize) {
            this.name = aName;
            this.size = theSize;
        }

        #region INetCDFDimension Members

        public string Name {
            get { return this.name; }
        }

        public uint Length {
            get { return this.size; }
        }

        /// <summary>
        /// Returns true if the Dimension is a Record Dimension.
        /// </summary>
        public bool IsRecordDimension
        {
            get
            {
                return (this.Length == 0) ? true : false;
            }
        }

        #endregion
    }
}
