//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.Authentication
{

    public class Credentials : ICredentials
    {
        public Credentials(string name, string displayName, CredentialType type)
        {
            this.Name = name;
            this.DisplayName = displayName;
            this.CredentialType = type;
        }

        public Credentials(string name, string userName, string domainName, CredentialType type)
        {
            this.Name = name;
            this.DomainName = domainName;
            this.UserName = userName;
            this.CredentialType = type;
        }

        public Credentials(string name, string userName, string displayName, string domainName, CredentialType type)
        {
            this.Name = name;
            this.DomainName = domainName;
            this.DisplayName = displayName;
            this.UserName = userName;
            this.CredentialType = type;
        }

        public Credentials(string name, CredentialType type)
        {
            this.Name = name;
            this.CredentialType = type;
        }

        #region ICredentials Members

        public string Name
        {
            get;
            set;
        }

        public string UserName
        {
            get;
            set;
        }

        public string DisplayName
        {
            get;
            set;
        }

        public string DomainName
        {
            get;
            set;
        }

        public CredentialType CredentialType
        {
            get;
            set;
        }

        #endregion
    }
}
