//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Text;
using System.Diagnostics.CodeAnalysis;


[module: SuppressMessage("Microsoft.Design", "CA1014:MarkAssembliesWithClsCompliant", Justification="Some fields are non-cls compliant in this assembly.")]

[module: SuppressMessage("Microsoft.Performance", "CA1804:RemoveUnusedLocals", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.WorkflowComposer..ctor(Microsoft.Research.eResearch.Connection,System.Workflow.ComponentModel.Compiler.TypeProvider,Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer)", MessageId = "typename",  Justification="This is a hack needed for loading the WorkflowCommon library into appdomain.")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.IsAssemblyPackageAvailable(Microsoft.Research.eResearch.AssemblyPackageCollection`1<Microsoft.Research.eResearch.Activity>,Microsoft.Research.eResearch.AssemblyPackage):System.Boolean", Justification="Passing namedobject as a parameter is not required")]

[module: SuppressMessage("Microsoft.Design", "CA1059:MembersShouldNotExposeCertainConcreteTypes", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.DataTypesComposer.#CreateDataTypesFromXml(System.Xml.XmlDocument,System.Collections.Generic.Dictionary`2<System.String,Microsoft.Research.ScientificWorkflow.TridentModel.DataTypeModel>,System.Boolean,System.Boolean)", MessageId = "System.Xml.XmlNode", Justification = "XmlNode has certain functionality which cannot be replicated using IXpathNavigable.")]

[module: SuppressMessage("Microsoft.Design", "CA1059:MembersShouldNotExposeCertainConcreteTypes", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.DataTypesComposer.#SaveCustomDataTypesToXml(System.Collections.Generic.Dictionary`2<System.String,Microsoft.Research.ScientificWorkflow.TridentModel.DataTypeModel>)", MessageId = "System.Xml.XmlNode", Justification = "XmlNode has certain functionality which cannot be replicated using IXpathNavigable.")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#IsAssemblyImageAvailable(Microsoft.Research.eResearch.AssemblyImageCollection`1<Microsoft.Research.eResearch.AssemblyPackage>,Microsoft.Research.eResearch.AssemblyImage)", Justification="Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateCompModelActivity(Microsoft.Research.ScientificWorkflow.TridentModel.CompositeActivityModel,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>)", Justification ="Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateActivitiesFromSubsection(System.Workflow.ComponentModel.CompositeActivity,Microsoft.Research.ScientificWorkflow.TridentModel.TridentSubsectionModel,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>,System.Int32)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateCompModelActivity(Microsoft.Research.ScientificWorkflow.TridentModel.CompositeActivityModel,System.Workflow.ComponentModel.Activity,System.ComponentModel.Design.ServiceContainer,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateCompModelActivity(Microsoft.Research.ScientificWorkflow.TridentModel.SimpleActivityModel,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateCompModelActivity(Microsoft.Research.ScientificWorkflow.TridentModel.SimpleBlackboxModel,System.Workflow.ComponentModel.Activity,System.ComponentModel.Design.ServiceContainer)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateActivitiesFromSubsection(System.Workflow.ComponentModel.CompositeActivity,Microsoft.Research.ScientificWorkflow.TridentModel.TridentSubsectionModel,System.Workflow.ComponentModel.Activity,System.ComponentModel.Design.ServiceContainer,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>,System.Int32)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#CreateCompModelActivity(Microsoft.Research.ScientificWorkflow.TridentModel.CompositeBlackboxModel,System.Workflow.ComponentModel.Activity,System.ComponentModel.Design.ServiceContainer,System.Collections.ObjectModel.Collection`1<System.Reflection.Assembly>)", Justification = "Need to pass the derived type")]

[module: SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.TridentComposer.ActivityComposer.#IsAssemblyPackageAvailable(System.Collections.ObjectModel.Collection`1<Microsoft.Research.eResearch.AssemblyPackage>,Microsoft.Research.eResearch.AssemblyPackage)", Justification = "Need to pass the derived type")]
