//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.TridentModel
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Eventargs for removal of subsections.
    /// </summary>
    public class RemoveSubsectionEventArgs : EventArgs
    {
        /// <summary>
        /// Gets and sets the removal of subsection eventargs.
        /// </summary>
        public TridentSubsectionModel SubsectionModelToRemove
        {
            get;
            set;
        }

        /// <summary>
        /// Removal event args.
        /// </summary>
        /// <param name="subsectionModelToRemove">
        /// The subsection to remove.
        /// </param>
        public RemoveSubsectionEventArgs(TridentSubsectionModel subsectionModelToRemove)
        {
            this.SubsectionModelToRemove = subsectionModelToRemove;
        }
    }
}
