//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.TridentUtilities
{
    /// <summary>
    /// Enum for specifying the type of a parameter.
    /// </summary>
    public enum ParameterFlowType
    {
        /// <summary>
        /// Input parameter.
        /// </summary>
        InputParameter,

        /// <summary>
        /// Output parameter.
        /// </summary>
        OutputParameter
    }

    public static class ActivityUtilities
    {
        /// <summary>
        /// Unique counter for the controls. Needed to give unique names for the activities and controls(for automation).
        /// </summary>
        private static int uniqueCounter = 1;

        /// <summary>
        /// Unique counter for the Ui and the activity name.
        /// </summary>
        public static int UniqueCounter
        {
            get { return ActivityUtilities.uniqueCounter++; }
            set { ActivityUtilities.uniqueCounter = value; }
        }
    }
}
