//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.Research.ScientificWorkflow.TridentUtilities
{
    /// <summary>
    /// Holds constants for the TridentUtilities project
    /// </summary>
    public static class Constants
    {
        #region General

        public const int EXECUTION_SERVICE_TIMEOUT_PERIOD = 180;

        public const int REGISTRY_READ_WAIT_PERIOD = 500;

        public const string SystemUserName = "System";

        public const string AnonymousUserName = "Anonymous";
        /// <summary>
        /// System Group Name "Everyone"
        /// </summary>
        public const string EVERYONEGROUP = "Everyone";

        #endregion General

        #region Product Setting Constants

        /// <summary>
        /// Registry path location of Trident workflow version in the Windows registry.
        /// </summary>
        public const string PRODUCT_VERSION_REGISTRY_PATH = "Software\\Microsoft\\Microsoft Project Trident - A Scientific Workflow Workbench";

        /// <summary>
        /// Registry key location of Trident workflow version in the Windows registry.
        /// </summary>
        public const string PRODUCT_VERSION_REGISTRY_KEY = "Build Version";

        #endregion

        #region Management Studio Constants
        /// <summary>
        /// Width in pixels of the Browse Icon Image
        /// </summary>
        public const int BROWSEICONWIDTH = 50;
        #endregion
    }
}
