//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.TridentUtilities
{
    #region using directives
    using System;
    using System.Text;
    #endregion

    /// <summary>
    /// EventArgs overriden for passing the info.
    /// </summary>
    public class TridentMessageBoxEventArgs : EventArgs
    {
        /// <summary>
        /// gets or sets the result.
        /// </summary>
        public TridentMsgBoxResult Result
        {
            get;
            private set;
        }

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="result">Result.</param>
        public TridentMessageBoxEventArgs(TridentMsgBoxResult result)
        {
            this.Result = result;
        }
    }
}
