//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.TridentUtilities
{
    public enum TridentMsgBoxResult
    {
        /// <summary>
        /// Nothing is returned from the Trident Message Box. This means that the modal dialog
        ///    continues running.
        /// </summary>
        None,
        
        /// <summary>
        /// The Trident Message Box return value is OK (usually sent from a button labeled OK).
        /// </summary>
        Ok,
        
        /// <summary>
        /// The Trident Message Box return value is Cancel (usually sent from a button labeled
        ///    Cancel).
        /// </summary>
        Cancel,
        
        /// <summary>
        /// The Trident Message Box return value is Abort (usually sent from a button labeled
        ///    Abort).
        /// </summary>
        Abort,
        
        /// <summary>
        /// The Trident Message Box return value is Retry (usually sent from a button labeled
        ///    Retry).
        /// </summary>
        Retry,
             
        /// <summary>
        /// The Trident Message Box return value is Ignore (usually sent from a button labeled
        ///    Ignore).
        /// </summary>
        Ignore,

        /// <summary>
        /// The Trident Message Box return value is Yes To All (usually sent from a button labeled
        ///     Yes to All).
        /// </summary>
        YesAll,

        /// <summary>
        /// The Trident Message Box return value is Yes (usually sent from a button labeled Yes).
        /// </summary>
        Yes,

        /// <summary>
        /// The Trident Message Box return value is No To All (usually sent from a button labeled
        ///     No to All).
        /// </summary>
        NoAll,

        /// <summary>
        /// The Trident Message Box return value is No (usually sent from a button labeled No).
        /// </summary>
        No,
    }
}
