//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Research.ScientificWorkflow.TridentModel;
    using Microsoft.Research.ScientificWorkflow.TridentUtilities;

    public class ConditionParameter : ActivityParameterDesigner
    {
        private ParameterFlowType parameterType;
        public ParameterFlowType ParamType
        {
            get
            {
                return this.parameterType;
            }
        }

        public ConditionParameter(ParameterDescriptionModel parameterModel, ParameterFlowType parameterType, BaseModel activityModel, TridentUIActivityElement parentElement)
            : base(parameterModel, parameterType, activityModel)
        {

            this.parameterType = parameterType;
            this.ParentActivityElement = parentElement;
            this.AddConditionParameterShape();
            this.ToolTip = ActivityParameterDesigner.CreateParameterTooltip(parameterModel);

        }

        public ConditionParameter(ParameterDescriptionModel parameterModel, ParameterFlowType parameterType, BaseModel activityModel)
            : base(parameterModel, parameterType, activityModel)
        {
            this.parameterType = parameterType;
            this.AddConditionParameterShape();
            this.ToolTip = ActivityParameterDesigner.CreateParameterTooltip(parameterModel);
        }
    }
}