//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Research.ScientificWorkflow.TridentModel;

    /// <summary>
    /// Event args encapsulating the model.
    /// </summary>
    public class ModelEventArgs : EventArgs
    {
        /// <summary>
        /// Gets or sets the model.
        /// </summary>
        /// <value>The model.</value>
        public BaseModel Model { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="ModelEventArgs"/> class.
        /// </summary>
        /// <param name="model">The model.</param>
        public ModelEventArgs(BaseModel model)
        {
            this.Model = model;
        }
    }
}
