//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{  
    #region using directives
    using System;
    using System.Text;
    using Microsoft.Research.ScientificWorkflow.TridentModel;
using System.Windows; 
    #endregion

    public class ParameterBindingEventArgs : EventArgs
    {
        /// <summary>
        /// Activity model of the parent activity.
        /// </summary>
        private BaseModel parentModel;

        private Visibility parameterBindingVisibility;

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="infoEntered">
        /// activitymodel for which the Parameter should be hidden/Shown.
        /// </param>
        public ParameterBindingEventArgs(BaseModel parentModel, Visibility activityParameterBindingVisibility)
        {
            this.parentModel = parentModel;
            this.parameterBindingVisibility = activityParameterBindingVisibility;
        }

        /// <summary>
        /// Gets activity model.
        /// </summary>
        public BaseModel ParentActivityModel
        {
            get
            {
                return this.parentModel;
            }
        }

        public Visibility ParameterBindingVisibility
        {
            get
            {
                return this.parameterBindingVisibility;
            }
        }
    }
}
