//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;

    /// <summary>
    /// Encapsulates the wait message.
    /// </summary>
    public class WaitMessageEventArgs : EventArgs
    {
        /// <summary>
        /// Gets or sets the wait message.
        /// </summary>
        public string WaitMessage { get; set; }

        /// <summary>
        /// WaitMessageEventArgs
        /// </summary>
        /// <param name="waitMsg">
        /// The wait message.
        /// </param>
        public WaitMessageEventArgs(string waitMsg)
        {
            this.WaitMessage = waitMsg;
        }
    }
}
