//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.CodeAnalysis;

// Unused private fields warning has been suppressed. The fields are xaml entities, and these require naming due to automation testing purposes.
[module: SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ConditionConnector.#_CreateDelegate(System.Type,System.String)")]
[module: SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.PerformancePresentationModel.#OnClearEvent(System.Object,System.EventArgs)")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonbg1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#rectangle2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#header")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#rectangle1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#ClosedIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#grdExecStatus")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#FaultingIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonbg3")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#ExecutingIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonbg2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#rectangle")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonshade1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonshade2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowStackHeader.#playbuttonshade3")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubSectionCollapsedCtrl.#imgSubSectionIndicator")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubSectionCollapsedCtrl.#brdrMainDisp")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubSectionCollapsedCtrl.#grdMainSubSection")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SimpleBlackboxActivityBody.#outputPanel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SimpleBlackboxActivityBody.#inputPanel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SimpleBlackboxActivityBody.#activityModel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkFlowMetaPopup.#brdrMain")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkFlowMetaPopup.#LayoutRoot")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkFlowMetaPopup.#ErrorLabel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.CategoryPicker.#usrCtrlCategoryPicker")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.CategoryPicker.#grd")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.CategoryPicker.#brdrMain")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.CategoryPicker.#txtBlkMainHeader")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#brdrHeader")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#dckCategory")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#dckWfDesc")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#LayoutRoot")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#PropertiesPanePopUp")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.PropertiesPane.#dckWfName")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubsectionExpandedCtrl.#grdMainHolder")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubsectionExpandedCtrl.#grdDataHolder")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ExecutionInfo.#txtBlkInfoText1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ExecutionInfo.#txtBlkInfoText2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ExecutionInfo.#txtBlkMainHeader")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WellFormedConditionalTreeInfo.#ownerIfElseCondition")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WellFormedConditionalTreeInfo.#parent")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ConditionConnector.#conditionOutput")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ConditionConnector.#dropGrid")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ConditionConnector.#DropPanel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ConditionConnector.#connectorpath")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonbg1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#rectangle2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonshade2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#ClosedIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#grdExecStatus")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonbg3")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#FaultingIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#rectangle")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#rectangle1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#ExecutingIcon")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonbg2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonshade1")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ActivityHeader.#playbuttonshade3")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#WorkflowSpaceScaleTransform")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#zoom")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#grdSplitterComposerPropPane")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#seperator2")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#dataTypes")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#WorkflowSpaceTranslateTransform")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.ComposerControl.#grdColPropPane")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.IFElseUIElement.#ifElseModel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.DataTypesLegendCtrl.#DataTypeKeyPanel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.DataTypesLegendCtrl.#ucDataTypeHolder")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorModule.#monitorLoggingService")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorModule.#executionVizualizerPresentationModel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#level_WarningCheckBox")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#events_User")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#level_ErrorCheckBox")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#level_InformationCheckBox")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#Window")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor.MonitorSettingsWindow.#LayoutRoot")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowMetaPopup.#brdrMain")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowMetaPopup.#LayoutRoot")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WorkflowMetaPopup.#ErrorLabel")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubsectionCollapsedCtrl.#imgSubSectionIndicator")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubsectionCollapsedCtrl.#brdrMainDisp")]
[module: SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields", Scope = "member", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.SubsectionCollapsedCtrl.#grdMainSubSection")]

// Namespaces of few types. Warning suppressed as some are generated by xaml.
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.WpfComposite")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow.TridentUtilities")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "XamlGeneratedNamespace")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Commands")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow.UIDesigner.Controls")]
[module: SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Research.ScientificWorkflow.Validators")]
