//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Practices.Unity;

    /// <summary>
    /// Static Class for TridentClipBoardService
    /// </summary>
    public static class TridentClipboardService
    {
        /// <summary>
        /// Get the Wether Clipboard is having data
        /// Returns True if tridentClipboard service is having data
        /// </summary>
        public static bool HasData
        {
            get { return (Data != null); }
        }

        /// <summary>
        /// Get and Set Data for Trident Clipboard
        /// </summary>
        public static object Data { get; set; }

        /// <summary>
        /// Clears the Trident Clipboard
        /// </summary>
        public static void Clear()
        {
            Data = null;
        }
    }
}
