//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Windows;
    using Microsoft.Research.ScientificWorkflow.TridentModel;

    public interface ISubsectionControl : ICompositeUIElement
    {
        #region Public Properties

        /// <summary>
        /// Gets the subsection model.
        /// </summary>
        TridentSubsectionModel ContainedSubsectionModel
        {
            get;
        }

        #endregion Public Properties

        #region Events

        /// <summary>
        /// Fired when the user wants to remove the subsection and keep the contents.
        /// </summary>
        event EventHandler<RemoveSubsectionEventArgs> RemoveSubsection;

        #endregion Events
    }
}
