//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner
{
    using System;
    using Microsoft.Research.ScientificWorkflow.TridentUtilities;
    using System.Windows;
    using Microsoft.Research.ScientificWorkflow.TridentModel;

    public interface ITridentUIElement : IBindingEndpoint
    {
        void ApplySelectedStyle();
        void ApplyUnselectedStyle();
        void CreateContextMenu();
        event EventHandler DeleteElement;
        int FetchUIElementPosition();
        BaseModel Model { get; }
        event EventHandler SelectElement;
        event EventHandler ShowProperties;
        event EventHandler InsertIntoSubsection;
        event EventHandler<ModelEventArgs> UpdateClick;
        FrameworkElement LeftControlFlowConnectionElement { get; }
        FrameworkElement RightControlFlowConnectionElement { get; }

        event EventHandler<ProvenanceModeEventArgs> ProvenanceMenuClick;
    }
}
