//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Collections.ObjectModel;

   public class DataProductEventArgs:EventArgs
    {
       /// <summary>
        /// Get the DataProductItem Collection
       /// </summary>
        public ObservableCollection<DataProductItem> ReceivedDataProduct { get; private set; }

       /// <summary>
       /// Get the Activity Nmae
       /// </summary>
        public string ActivityName { get; private set; }

        /// <summary>
        /// Get the Activity Nmae
        /// </summary>
        public string ActivityLabel { get; private set; }

       /// <summary>
       /// Constructor
       /// </summary>
        /// <param name="activityName">string</param>
        public DataProductEventArgs(string activityName,string activityLabel)
        {
            this.ActivityName = activityName;
            this.ActivityLabel = activityLabel;
            this.ReceivedDataProduct = new ObservableCollection<DataProductItem>();
        }
    }
}
