//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.Collections.ObjectModel;

namespace Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor
{
    /// <summary>
    /// This class contains the data for a particular iteration.
    /// </summary>
    public class DataProductIterationViewModel
    {
        /// <summary>
        /// The label to show to the user.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// The order of the event occurance.
        /// </summary>
        public int EventOrder { get; set; }

        /// <summary>
        /// The list of activities executed in the iteration.
        /// </summary>
        public ObservableCollection<DataProductViewModel> DataProductViewModels { get; private set; }

        /// <summary>
        /// Initilizes a new instance of the Dataproduct Iteration model.
        /// </summary>
        public DataProductIterationViewModel()
        {
            this.DataProductViewModels = new ObservableCollection<DataProductViewModel>();
        }
    }
}
