//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.UIDesigner.Monitor
{
    using System;

    /// <summary>
    /// Data model for processing status monitor tab binding
    /// </summary>
    public class ProcessingStatus
    {
        /// <summary>
        /// Gets or sets workflow, or activity name
        /// </summary>
        public string Activity { get; set; }

        /// <summary>
        /// Gets or sets workflow, activity, or user event name
        /// </summary>
        public string Event { get; set; }

        /// <summary>
        /// Gets or sets long timestamp when the event is raised in the workflow runtime
        /// </summary>
        public DateTime Time { get; set; }

        /// <summary>
        /// Gets or sets details if any
        /// </summary>
        public string Details { get; set; }
    }
}
