//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace WorkflowApplication.Interfaces
{
    using System.Windows.Controls;
    using System;
    using Microsoft.Research.ScientificWorkflow.TridentModel;

    /// <summary>
    /// Interface for the center pane presenter.
    /// </summary>
    public interface ICenterPanePresenter
    {
        /// <summary>
        /// Gets or sets a value indicating whether this instance is initialized.
        /// </summary>
        /// <value>
        /// 	<c>true</c> if this instance is initialized; otherwise, <c>false</c>.
        /// </value>
        bool IsInitialized { get; set; }

        /// <summary>
        /// Gets or sets the content view.
        /// </summary>
        /// <value>The content view.</value>
        UserControl ContentView { get; set; }

        /// <summary>
        /// Gets or sets the current workflow model.
        /// </summary>
        /// <value>The current workflow model.</value>
        TridentWorkflowModel CurrentWorkflowModel { get; set; }
    }
}
