//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Research.DataLayer;
using Microsoft.Research.ActivitiesSyncLibrary;

namespace RegistryInit
{
    class Program
    {
        static void Main(string[] args)
        {
            SR_Connection.Init();

            ConnectionManager mgr = ConnectionManager.Create(ConnectionManager.CancelBehavior.ThrowException);
            Connection conn = mgr.PickConnection(ConnectionManagerBase.ConnectionUI.AlwaysShowUI);

            SyncActivites sync = new SyncActivites(conn);
            sync.SyncActivitiesToRegistry(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location));
        }
    }
}
