//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow
{
    using System;

    /// <summary>
    /// Base implementation of completed event arguments.
    /// </summary>
    public class CompletedEventArgs : System.EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CompletedEventArgs"/> class.
        /// </summary>
        /// <param name="userState">State of the user.</param>
        public CompletedEventArgs(object userState)
        {
            this.UserState = userState;
        }

        /// <summary>
        /// Gets or sets the error.
        /// </summary>
        /// <value>The error.</value>
        public Exception Error { get; set; }

        /// <summary>
        /// Gets or sets the state of the user.
        /// </summary>
        /// <value>The state of the user.</value>
        public object UserState { get; set; }
    }
}
