//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow
{
    using System.Collections.Generic;
    using Microsoft.Research.ScientificWorkflow.TridentModelSL;

    /// <summary>
    /// 
    /// </summary>
    public class GetAllSharedWorkflowsForCurrentUserCompletedEventArgs : CompletedEventArgs
    {
        /// <summary>
        /// Gets or sets the categories.
        /// </summary>
        /// <value>The categories.</value>
        public ICollection<CategoryModel> Categories { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="GetAllSharedWorkflowsForCurrentUserCompletedEventArgs"/> class.
        /// </summary>
        /// <param name="userState">State of the user.</param>
        public GetAllSharedWorkflowsForCurrentUserCompletedEventArgs(object userState)
            : base(userState)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GetAllSharedWorkflowsForCurrentUserCompletedEventArgs"/> class.
        /// </summary>
        public GetAllSharedWorkflowsForCurrentUserCompletedEventArgs()
            : base(null)
        {
        }
    }
}
