//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow
{
    using System.Collections.Generic;
    using Microsoft.Research.ScientificWorkflow.TridentModelSL;

    /// <summary>
    /// 
    /// </summary>
    public class GetOutputsCompletedEventArgs : CompletedEventArgs
    {
        /// <summary>
        /// Gets or sets the outputs.
        /// </summary>
        /// <value>The outputs.</value>
        public ICollection<WorkflowOutputModel> Outputs { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="GetOutputsCompletedEventArgs"/> class.
        /// </summary>
        /// <param name="userState">State of the user.</param>
        public GetOutputsCompletedEventArgs(object userState)
            : base(userState)
        {
            Outputs = new List<WorkflowOutputModel>();
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GetOutputsCompletedEventArgs"/> class.
        /// </summary>
        public GetOutputsCompletedEventArgs()
            : base(null)
        {
            Outputs = new List<WorkflowOutputModel>();
        }
    }
}
