//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.Windows.Controls;

namespace Microsoft.Research.ScientificWorkflow.TridentModelSL.Controls
{
    /// <summary>
    /// Represents a Status bar in the workflow application
    /// </summary>
    public partial class StatusBar : UserControl
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StatusBar"/> class.
        /// </summary>
        public StatusBar()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Gets or sets the message to be displayed in the status bar.
        /// </summary>
        /// <value>The message.</value>
        public string Message
        {
            get
            {
                return this.tbkStatusMessage.Text;
            }
            set
            {
                this.tbkStatusMessage.Text = value;
            }
        }
    }
}
