//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

using System.Windows;
using System;

namespace Microsoft.Research.ScientificWorkflow.WebClient.Views
{
    /// <summary>
    /// Base interface for all the views in the silverlight webclient
    /// </summary>
    public interface IView
    {
        /// <summary>
        /// Gets the view.
        /// </summary>
        /// <value>The view.</value>
        FrameworkElement View { get; }

        /// <summary>
        /// Initializes this view.
        /// </summary>
        void Initialize();

        /// <summary>
        /// Fired for launching of the wait screen.
        /// </summary>
        event EventHandler LaunchWaitScreen;

        /// <summary>
        /// Fired for removing of the wait screen.
        /// </summary>
        event EventHandler RemoveWaitScreen;
    }
}
