//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

namespace Microsoft.Research.ScientificWorkflow.WorkflowApplicationCommonSL
{
    public static class Constants
    {
        /// <summary>
        /// System user name
        /// </summary>
        public const string SystemUserName = "System";

        /// <summary>
        /// Anonymous user name
        /// </summary>
        public const string AnonymousUserName = "NT Authority\\NETWORK SERVICE";

        /// <summary>
        /// Sign in page name
        /// </summary>
        public const string SignInPageName = "Default.aspx?Authenticate=true";

        /// <summary>
        /// Signout page name
        /// </summary>
        public const string SignOutPageName = "Default.aspx?Authenticate=false";

        /// <summary>
        /// data products service page name
        /// </summary>
        public const string DateProductsServicePageName = "DataProductsServices.aspx";

        /// <summary>
        /// Web service page name
        /// </summary>
        public const string WebServicePageName = "GetWebService.asmx";

        /// <summary>
        /// Uri separator
        /// </summary>
        public const string UriSeparator = "/";

        /// <summary>
        /// Javascript method name for clearing the authentication cache
        /// </summary>
        public const string JavaScriptClearAuthCache = "clearAuthenticationCache";

    }
}
