//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

namespace Microsoft.TridentWordAddIn.Common
{
    /// <summary>
    /// Exposes method to invalidate a control on the Ribbon
    /// </summary>
    public interface IRibbonInvalidator
    {
        /// <summary>
        /// Invalidates the control.
        /// </summary>
        /// <param name="controlId">The control id.</param>
        void InvalidateControl(string controlId);

        /// <summary>
        /// Invalidates the ribbon.
        /// </summary>
        void Invalidate();
    }
}