//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.TridentWordAddIn.Common
{
    public class ComplexInitializer
    {
        public string Label { get; set; }
        public string Value { get; set; }
        public bool IsRoot { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="ComplexInitializer"/> class.
        /// </summary>
        /// <param name="label">The label.</param>
        /// <param name="value">The value.</param>
        /// <param name="isRoot">if set to <c>true</c> [is root].</param>
        public ComplexInitializer(string label, string value, bool isRoot)
        {
            this.Label = label;
            this.Value = value;
            this.IsRoot = isRoot;
        }
    }
}
