//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using System.Collections.Generic;

namespace Microsoft.TridentWordAddIn.Common
{
    public class JobParameter : DomainBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="JobParameters"/> class.
        /// </summary>
        public JobParameter()
        {
        }

        /// <summary>
        /// Gets or sets the name of the activity.
        /// </summary>
        /// <value>The name of the activity.</value>
        public string ActivityName { get; set; }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the value.
        /// </summary>
        /// <value>The value.</value>
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets the type.
        /// </summary>
        /// <value>The type.</value>
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the complex parsed value.
        /// </summary>
        /// <value>The complex parsed value.</value>
        public string ComplexParsedValue { get; set; }
    }

    public class JobParameterCollection : List<JobParameter>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="JobParameterCollection"/> class.
        /// </summary>
        public JobParameterCollection()
        {
        }
    }
}
