//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.TridentWordAddIn.Common
{
    public class ShallowJobOutput : DomainBase
    {
        /// <summary>
        /// Gets or sets the ID.
        /// </summary>
        /// <value>The ID.</value>
        public Guid Id { get; set; }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the extension.
        /// </summary>
        /// <value>The extension.</value>
        public string Extension { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether this instance is workflow.
        /// </summary>
        /// <value>
        /// 	<c>true</c> if this instance is workflow; otherwise, <c>false</c>.
        /// </value>
        public bool IsDataProduct { get; set; }
    }

    public class ShallowJobOutputCollection : List<ShallowJobOutput>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="JobOutputCollection"/> class.
        /// </summary>
        public ShallowJobOutputCollection()
        {
        }
    }
}
