//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 


namespace Microsoft.TridentWordAddIn.Common
{
    /// <summary>
    /// Connection Parameters for Web Service
    /// </summary>
    public class TridentWebServiceConnectionParameters : DomainBase
    {
        /// <summary>
        /// Gets or sets the access key.
        /// </summary>
        /// <value>The access key.</value>
        public string AccessKey { get; set; }

        /// <summary>
        /// Gets or sets the secret key.
        /// </summary>
        /// <value>The secret key.</value>
        public string SecretKey { get; set; }

        /// <summary>
        /// Gets or sets the bucket.
        /// </summary>
        /// <value>The bucket.</value>
        public string Bucket { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether [public objects].
        /// </summary>
        /// <value><c>true</c> if [public objects]; otherwise, <c>false</c>.</value>
        public bool PublicObjects { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether [encrypt password].
        /// </summary>
        /// <value><c>true</c> if [encrypt password]; otherwise, <c>false</c>.</value>
        public bool EncryptPassword { get; set; }
    }
}
