//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using Microsoft.TridentWordAddIn.Common;

namespace Microsoft.TridentWordAddIn.Presentation
{
    internal class GetButtonPressedCommand : RibbonCommand
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetButtonPressedCommand"/> class.
        /// </summary>
        /// <param name="controller">The controller.</param>
        public GetButtonPressedCommand(IController controller)
            : base(controller)
        {
        }

        /// <summary>
        /// Invokes the command.
        /// </summary>
        /// <param name="controlId">The originating control id.</param>
        public override void Invoke(string controlId)
        {
        }

        /// <summary>
        /// Invokes the specified is pressed.
        /// </summary>
        /// <param name="isPressed">if set to <c>true</c> [is pressed].</param>
        public override void Invoke(bool isPressed)
        {
        }

        /// <summary>
        /// Gets the button pressed.
        /// </summary>
        /// <param name="controlId">The control id.</param>
        /// <returns>bool</returns>
        public bool GetButtonPressed(string controlId)
        {
            return this.ControllerInstance.IsTaskPaneVisible(controlId);
        }
    }
}
