//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Microsoft.TridentWordAddIn.Presentation
{
    internal partial class ExportLinkedWorkflow : Form
    {
        private static ExportLinkedWorkflow customDialog;

        /// <summary>
        /// Gets or sets a value indicating whether [download from associated server].
        /// </summary>
        /// <value>
        /// 	<c>true</c> if [download from associated server]; otherwise, <c>false</c>.
        /// </value>
        public static bool DownloadFromAssociatedServer { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="ExportLinkedWorkflow"/> class.
        /// </summary>
        private ExportLinkedWorkflow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Shows this instance.
        /// </summary>
        /// <returns>DialogResult</returns>
        public static DialogResult ShowMessage()
        {
            customDialog = new ExportLinkedWorkflow();
            DialogResult result = customDialog.ShowDialog();
            DownloadFromAssociatedServer = customDialog.chkDownloadServer.Checked;
            return result;
        }

        /// <summary>
        /// Handles the Click event of the btnYes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void btnYes_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Handles the Click event of the btnNo control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void btnNo_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
