//*********************************************************
//
//    Copyright (c) Microsoft. All rights reserved.
//    This code is licensed under the Apache License, Version 2.0.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//********************************************************* 

using System.Windows.Forms;

namespace Microsoft.TridentWordAddIn.Presentation
{
    internal partial class AnnotationUserControl : UserControl
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AnnotationUserControl"/> class.
        /// </summary>
        public AnnotationUserControl()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Gets the name of the association.
        /// </summary>
        /// <value>The name of the association.</value>
        public string AssociationName
        {
            get
            {
                return this.txtAssociationName.Text;
            }
            set
            {
                this.txtAssociationName.Text = value;
            }
        }

        /// <summary>
        /// Gets the annotation.
        /// </summary>
        /// <value>The annotation.</value>
        public string Annotation
        {
            get
            {
                return this.txtAnnotation.Text;
            }
            set
            {
                this.txtAnnotation.Text = value;
            }
        }
    }
}
