echo Generating Trident setup...

set buildtarget=x86

pushd trident\product\setup

del .\trident*.msi

call make

ren Trident.msi Trident-x86.msi

popd

rem check whether the build failed
IF %BUILDERR% NEQ 0 GOTO ERROR



rem *****************************************************************************************
rem *****************************************************************************************
rem 		COPYING SYMBOLS, BINARIES & MSI TO TARGET
rem *****************************************************************************************
rem *****************************************************************************************

echo copying symbols
mkdir %BuildDrop%\symbols\%BuildType%\
XCopy /s /y /i %BUILDTARGETROOT%\%BuildType%\*.pdb %BuildDrop%\symbols\%BuildType%\*.pdb
echo copying Binaries
mkdir %BuildDrop%\Binaries\%BuildType%\
XCopy /s /y /i %BUILDTARGETROOT%\%BuildType%\*.svc %BuildDrop%\Binaries\%BuildType%\*.svc
XCopy /s /y /i %BUILDTARGETROOT%\%BuildType%\*.dll %BuildDrop%\Binaries\%BuildType%\*.dll
XCopy /s /y /i %BUILDTARGETROOT%\%BuildType%\*.exe %BuildDrop%\Binaries\%BuildType%\*.exe
XCopy /s /y /i %BUILDTARGETROOT%\%BuildType%\*.config %BuildDrop%\Binaries\%BuildType%\*.config
echo Copying setup
mkdir %BuildDrop%\setup\%BuildType%\
copy .\trident\product\setup\Trident-X86.msi %BuildDrop%\setup\%BuildType%\Trident-x86.msi
set BUILDERR=%ERRORLEVEL%
IF %BUILDERR% NEQ 0 GOTO ERROR


rem *****************************************************************************************
rem *****************************************************************************************
rem 		BUILDING TRIDENT SETUP
rem *****************************************************************************************
rem *****************************************************************************************
echo Generating Trident setup...
set buildtarget=x64
pushd trident\product\setup
call make
ren Trident.msi Trident-x64.msi
popd

rem check whether the build failed
IF %BUILDERR% NEQ 0 GOTO ERROR


echo Copying setup
copy trident\product\setup\Trident-x64.msi %BuildDrop%\setup\%BuildType%\Trident-x64.msi
set BUILDERR=%ERRORLEVEL%
IF %BUILDERR% NEQ 0 GOTO ERROR


rem *****************************************************************************************
rem *****************************************************************************************
rem 		COPYING LIGHT WEIGHT EXECUTOR TO TARGET
rem *****************************************************************************************
rem *****************************************************************************************
echo copying Light Weight Executor Binaries

mkdir %BuildDrop%\Binaries\LightWeightExecutor\

Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.EnterpriseLibrary.Common.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.EnterpriseLibrary.Common.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.EnterpriseLibrary.Logging.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.EnterpriseLibrary.Logging.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.ObjectBuilder2.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.ObjectBuilder2.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.Unity.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.Unity.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.ServiceLocation.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.ServiceLocation.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Practices.Unity.Interception.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Practices.Unity.Interception.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.DataLayerCommon.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.DataLayerCommon.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.DataLayerSecurity.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.DataLayerSecurity.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.DataProvider.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.DataProvider.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.DataProviders.Microsoft.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.DataProviders.Microsoft.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.DataProvidersSecurity.Activity.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.DataProvidersSecurity.Activity.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.DataLayer.ServiceRegistry.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.DataLayer.ServiceRegistry.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.eResearch.Common.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.eResearch.Common.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.eResearch.Ontology.Lookup.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.eResearch.Ontology.Lookup.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.eResearch.Ontology.Mapping.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.eResearch.Ontology.Mapping.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.eResearch.RuntimeServices.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.eResearch.RuntimeServices.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.ScientificWorkflow.TridentComposer.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.ScientificWorkflow.TridentComposer.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.ScientificWorkflow.TridentModel.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.ScientificWorkflow.TridentModel.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.ScientificWorkflow.TridentScheduleCommon.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.ScientificWorkflow.TridentScheduleCommon.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.ScientificWorkflow.TridentUtilities.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.ScientificWorkflow.TridentUtilities.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.ScientificWorkflow.WFExecutor.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.ScientificWorkflow.WFExecutor.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.TridentAPI.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.TridentAPI.dll
Copy %BUILDTARGETROOT%\%BuildType%\Microsoft.Research.TridentAuthentication.dll %BuildDrop%\Binaries\LightWeightExecutor\Microsoft.Research.TridentAuthentication.dll
Copy %BUILDTARGETROOT%\%BuildType%\ScientificWorkflow.TridentWorkflowCommon.dll %BuildDrop%\Binaries\LightWeightExecutor\ScientificWorkflow.TridentWorkflowCommon.dll
Copy %BUILDTARGETROOT%\%BuildType%\TridentContext.dll %BuildDrop%\Binaries\LightWeightExecutor\TridentContext.dll
Copy %BUILDTARGETROOT%\%BuildType%\LightweightExecutor.exe %BuildDrop%\Binaries\LightWeightExecutor\LightweightExecutor.exe  
Copy %BUILDTARGETROOT%\%BuildType%\LightweightExecutor.exe.config %BuildDrop%\Binaries\LightWeightExecutor\LightweightExecutor.exe.config

set BUILDERR=%ERRORLEVEL%
IF %BUILDERR% NEQ 0 GOTO ERROR

rem *****************************************************************************************
rem *****************************************************************************************
rem 		SIGN TRIDENT SETUP
rem *****************************************************************************************
rem *****************************************************************************************
IF "%Build.Sign%" == "Disabled" GOTO SKIPSIGNMSI64
SET Product.Name=Trident
call build\sign2.cmd build\sign.files.msi.txt msi.%BUILDTYPE%.%BUILDTARGET%
tools\build\signcoderun build\copysignedmsi.cmd

ren %BuildDrop%\setup\%BuildType%\Trident-x86.msi %BuildDrop%\setup\%BuildType%\Trident-x86-Unsigned.msi
ren %BuildDrop%\setup\%BuildType%\Trident-x64.msi %BuildDrop%\setup\%BuildType%\Trident-x64-Unsigned.msi

:SKIPSIGNMSI64
echo Full build %BuildNumber% ended!
goto EOF

:ERROR

echo *** BUILD FAILED ***
goto EOF

:EOF
